## ./anal_base.R
##
## Basic setup for counterfactual analysis
##
## "actual" indicates that the central government's weights are based on estimated parameters and observed transfers
## "ninv" indicates that the central government's weights are based on reported costs, removing "investment" items
## "equal" indicates that the central government's weights are equal per capita
## "b34" indicates that the central government's weights are equal, and true cost is equal to reported costs

proj.home <- "/home/fas/weese/egw5/japan_qe_final/"
#proj.tmp <- "/home/fas/weese/egw5/scratch/japan_qe/"

fname <- paste(proj.home, "anal_base_a.R", sep="")
source(fname)

p.graph <- p.graph.l[[p]]

pop.muni <- d.h13[V(p.graph)$name, "pop"]
if(VAR) {
    var.muni <- rnorm(vcount(p.graph)) * sqrt(2)/sqrt(pop.muni - 1)
    mean.muni <- rnorm(vcount(p.graph)) * 1/sqrt(pop.muni)
}

graph <- p.graph - E(p.graph)

e <- E(p.graph)[1]
graph.try <- graph + edges(V(p.graph)[ adj(E(p.graph)[13]) ])
E(graph.try)

g.l <- decompose.graph(graph.try)

library("orloca")
library("sp")

munis <- row.names(df.h13)
if(!VARONLY) {
    d.l <- lapply(munis, calc.dat)
    d <- do.call("rbind", d.l)
    library("numDeriv")
    T.actual <- v.m.new(d=d, b=b, time=0, ret="T", T0subsidy=FALSE)
    dudT <- grad(v.m.new, T.actual, ret="v", d=d, b=b, time=0, ninv=ninv, T0subsidy=FALSE) * d[,"pop"]
    weight.pc <- 1/dudT
    if(type == "equal" || type == "b34") weight.pc <- weight.pc * 0 + weighted.mean(weight.pc, d[,"pop"])
} else {
    weight.pc <- rep(0.1, length(munis))
    names(weight.pc) <- munis
}
