TAX.FLOOR <- TRUE  # use the model in Column I from Table 2

options(echo=TRUE)

VAR <- TRUE  # should the idiosyncratic shock be included in the calculation?
VARONLY <- FALSE

tmp <- commandArgs(trailingOnly=TRUE)
tmp

type <- tmp[1]
type
if(is.na(type)) {
    warning('using type = "actual"')
    type <- "actual"
}
stopifnot(type %in% c("actual", "ninv", "equal", "b34"))
ninv <- type == "ninv"
p <- as.numeric(tmp[2])
if(is.na(p)) {
    p <- as.numeric(Sys.getenv("LSB_JOBINDEX"))
}
p
cpf <- 1  # cost of public funds (normalization)

CORES <- as.numeric(Sys.getenv("LSB_DJOB_NUMPROC")) - 1
if(is.na(CORES) || CORES < 2) CORES <- 1
options(mc.cores=CORES)

par.calibrated <- c(B0=NA, B1=NA, B2=NA, B3=1, B4=1)
par.calibrated["tau.bar"] <- 0.084 * 4/3
par.calibrated["r"] <- 0.02
par.calibrated["disc.santei.h13"] <- par.calibrated["r"] * sum(c(1/(1+par.calibrated["r"])^(1:5), c(.9, .7, .5, .3, .1)/(1+par.calibrated["r"])^(6:10)))
par.calibrated["disc.santei.h20"] <- par.calibrated["r"] * sum(c(1/(1+par.calibrated["r"])^(1:10), c(.9, .7, .5, .3, .1)/(1+par.calibrated["r"])^(11:15)))
par.calibrated["disc.tokurei"] <- par.calibrated["r"] * sum(1/(1+par.calibrated["r"])^(1:10)) * 0.95 * 0.70 * (sum(1/(1+par.calibrated["r"])^(1:20))/20) / 10


if(type == "b34") {
    par.estimated <- c(B2=0.2164504, B0=219.5554103, B1=5.0432098, B4=1, B3=1)
} else {
    par.estimated <- c(B2=0.2164504, B0=219.5554103, B1=5.0432098, B4=0.4882909, B3=1.0446544)
}

b <- par.calibrated
b[names(par.estimated)] <- par.estimated

fname <- paste(proj.home, "h13.RData", sep="")
load(fname)
rownames(d.h13) <- as.character(as.numeric(rownames(d.h13)))

fname <- paste(proj.home, "v.R", sep="")
source(fname)

fname <- paste(proj.home, "H9.RData", sep="")
load(fname)
dimnames(cross)[[1]] <- substring(dimnames(cross)[[1]], first=1, last=5)
ritou.tmp <- general[,37]
names(ritou.tmp) <- substring(general[,3], first=1, last=5)
ritou <- as.character(as.numeric(names(which(ritou.tmp==1))))

fname <- paste(proj.home, "fin_h13.RData", sep="")
load(fname)
rownames(df.h13) <- as.character(as.numeric(rownames(df.h13)))
rownames(num.units) <- as.character(as.numeric(rownames(num.units)))

fname <- paste(proj.home, "mesh.RData", sep="")
load(fname)
rm(fname)

fname <- paste(proj.home, "hosei.R", sep="")
source(fname)

fname <- paste(proj.home, "toku_inv.R", sep="")
source(fname)

fname <- paste(proj.home, "calc_dat.R", sep="")
source(fname)

library("igraph") #ONE-BASED indexing
fname <- paste(proj.home, "pgraph.RData", sep="")
load(fname)
