## Rscript --verbose /home/fas/weese/egw5/japan_qe_final/card.R 
## Produce financial data:  fin_h13.RData

options(echo=TRUE)

proj.home <- "/home/fas/weese/egw5/japan_qe_final/"
s.dir <- "/home/fas/weese/egw5/scratch/soumushou"

fname <- paste(s.dir, "/H13.RData", sep="")
load(fname)

name <- general[,"団体名"]

#ok, now the trick is matching these to the 1995 data for the shapefile...
name[general[,"団体コード "] == "013692"] <- "北檜山町"  #unsimplify some characters
name[general[,"団体コード "] == "023051"] <- "平舘村"
name[general[,"団体コード "] == "042030"] <- "塩竈市"
name[general[,"団体コード "] == "045276"] <- "鶯沢町"
name[general[,"団体コード "] == "073644"] <- "檜枝岐村"
name[general[,"団体コード "] == "075647"] <- "飯舘村"
name[general[,"団体コード "] == "103225"] <- "倉淵村"
name[general[,"団体コード "] == "104833"] <- "藪塚本町"
name[general[,"団体コード "] == "133078"] <- "檜原村"
name[general[,"団体コード "] == "153079"] <- "聖籠町"
name[general[,"団体コード "] == "155438"] <- "頸城村"
name[general[,"団体コード "] == "162086"] <- "砺波市"
name[general[,"団体コード "] == "204111"] <- "下條村"
name[general[,"団体コード "] == "204137"] <- "天龍村"
name[general[,"団体コード "] == "204218"] <- "木曽福島町"
name[general[,"団体コード "] == "204234"] <- "南木曽町"
name[general[,"団体コード "] == "336041"] <- "上齋原村"
name[general[,"団体コード "] == "394050"] <- "檮原町"
name[general[,"団体コード "] == "405230"] <- "三潴町"
name[general[,"団体コード "] == "422045"] <- "諫早市"
name[general[,"団体コード "] == "445029"] <- "本耶馬渓町"

name[general[,"団体コード "] == "023213"] <- "鰺ヶ沢町"  # big to small
name[general[,"団体コード "] == "023680"] <- "碇ヶ関村"
name[general[,"団体コード "] == "024112"] <- "六ヶ所村"
name[general[,"団体コード "] == "043028"] <- "七ヶ宿町"
name[general[,"団体コード "] == "044041"] <- "七ヶ浜町"
name[general[,"団体コード "] == "112267"] <- "鳩ヶ谷市"
name[general[,"団体コード "] == "112411"] <- "鶴ヶ島市"
name[general[,"団体コード "] == "134023"] <- "青ヶ島村"
name[general[,"団体コード "] == "142077"] <- "茅ヶ崎市"
name[general[,"団体コード "] == "153028"] <- "京ヶ瀬村"
name[general[,"団体コード "] == "202100"] <- "駒ヶ根市"
name[general[,"団体コード "] == "223280"] <- "天城湯ヶ島町"
name[general[,"団体コード "] == "244821"] <- "島ヶ原村"
name[general[,"団体コード "] == "293016"] <- "月ヶ瀬村"
name[general[,"団体コード "] == "454435"] <- "五ヶ瀬町"


name[general[,"団体コード "] == "084247"] <- "北浦村"  # reverse upgrade to town
name[general[,"団体コード "] == "084468"] <- "新利根村"
name[general[,"団体コード "] == "084476"] <- "河内村"
name[general[,"団体コード "] == "084492"] <- "東村"
name[general[,"団体コード "] == "084611"] <- "出島村" #this one changed its name completely
name[general[,"団体コード "] == "085421"] <- "五霞村"
name[general[,"団体コード "] == "105228"] <- "明和村"
name[general[,"団体コード "] == "114235"] <- "川里村"
name[general[,"団体コード "] == "153231"] <- "横越村"
name[general[,"団体コード "] == "433454"] <- "豊野村"

name[general[,"団体コード "] == "103098"] <- "東村"  # eliminate county identifier (don't need it for this, and have checked manually anyways)
name[general[,"団体コード "] == "104221"] <- "東村"
name[general[,"団体コード "] == "104621"] <- "東村"
name[general[,"団体コード "] == "285234"] <- "一宮町"
name[general[,"団体コード "] == "286842"] <- "一宮町"
name[general[,"団体コード "] == "345440"] <- "三和町"
name[general[,"団体コード "] == "345865"] <- "三和町"


jis.tmp <- substring(general[,"団体コード "], first=1, last=5)
is.muni <- substring(jis.tmp, first=3, last=3) %in% as.character(1:7)

jis <- rep(NA, nrow(general))
jis[is.muni] <- as.character(as.numeric(jis.tmp[is.muni]))

library("maptools")
fname <- paste(proj.home, "shp.RData", sep="")
load(fname)

jis[general[,"団体コード "] == "012343"] <- rownames(shp@data)[shp@data[,"pref"]=="北海道" & shp@data[,"muni"]=="広島町"]
name[general[,"団体コード "] == "012343"] <- "広島町"
jis[general[,"団体コード "] == "012351"] <- rownames(shp@data)[shp@data[,"pref"]=="北海道" & shp@data[,"muni"]=="石狩町"]
name[general[,"団体コード "] == "012351"] <- "石狩町"
jis[general[,"団体コード "] == "082244"] <- rownames(shp@data)[shp@data[,"pref"]=="茨城県" & shp@data[,"muni"]=="守谷町"]
name[general[,"団体コード "] == "082244"] <- "守谷町"
jis[general[,"団体コード "] == "112437"] <- rownames(shp@data)[shp@data[,"pref"]=="埼玉県" & shp@data[,"muni"]=="吉川町"]
name[general[,"団体コード "] == "112437"] <- "吉川町"
jis[general[,"団体コード "] == "122319"] <- rownames(shp@data)[shp@data[,"pref"]=="千葉県" & shp@data[,"muni"]=="印西町"]
name[general[,"団体コード "] == "122319"] <- "印西町"
jis[general[,"団体コード "] == "122327"] <- rownames(shp@data)[shp@data[,"pref"]=="千葉県" & shp@data[,"muni"]=="白井町"]
name[general[,"団体コード "] == "122327"] <- "白井町"
jis[general[,"団体コード "] == "252085"] <- rownames(shp@data)[shp@data[,"pref"]=="滋賀県" & shp@data[,"muni"]=="栗東町"]
name[general[,"団体コード "] == "252085"] <- "栗東町"
jis[general[,"団体コード "] == "262111"] <- rownames(shp@data)[shp@data[,"pref"]=="京都府" & shp@data[,"muni"]=="田辺町"]
name[general[,"団体コード "] == "262111"] <- "田辺町"
jis[general[,"団体コード "] == "402231"] <- rownames(shp@data)[shp@data[,"pref"]=="福岡県" & shp@data[,"muni"]=="古賀町"]
name[general[,"団体コード "] == "402231"] <- "古賀町"


##found <- jis %in% rownames(shp@data)
#tmp <- match(jis, rownames(shp@data))
#match.chk <- cbind(general, name, shp@data[tmp,])[!is.na(tmp),]
#stopifnot(match.chk[,"県名"] == match.chk[,"pref"])
#stopifnot(match.chk[,"name"] == match.chk[,"muni"])
#summary(tmp[is.muni])
#general[is.na(tmp) & is.muni,]

fname <- paste(proj.home, "gappei.RData", sep="")
load(fname)
already.merged <- unlist(gappei[gappei[,"date"] < "2002-01-01", "merger"])

tmp <- match(rownames(shp@data), jis)
stopifnot(rownames(shp@data)[which(is.na(tmp))] %in% already.merged)


fname <- paste(proj.home, "japan01.txt", sep="")
card.tmp <- read.table(file(fname, encoding="UTF-16"), header=TRUE, sep="\t", stringsAsFactors=FALSE, na.strings="-")

card.tmp[card.tmp[,"都道府県"] == "宮城県" & card.tmp[,"市区町村"] == "塩竈市", "市区町村"] <- "塩竃市"
card.tmp[card.tmp[,"都道府県"] == "福島県" & card.tmp[,"市区町村"] == "檜枝岐村", "市区町村"] <- "桧枝岐村"
card.tmp[card.tmp[,"都道府県"] == "福島県" & card.tmp[,"市区町村"] == "飯舘村", "市区町村"] <- "飯館村"
card.tmp[card.tmp[,"都道府県"] == "新潟県" & card.tmp[,"市区町村"] == "聖籠町", "市区町村"] <- "聖篭町"
card.tmp[card.tmp[,"都道府県"] == "富山県" & card.tmp[,"市区町村"] == "砺波市", "市区町村"] <- "礪波市"

match.chk <- cbind(general[is.muni,], card.tmp)

stopifnot(match.chk[,"県名"] == match.chk[,"都道府県"])
stopifnot(match.chk[,"団体名"] == match.chk[,"市区町村"])

ruigata <- card.tmp[,"市町村類型"]
names(ruigata) <- jis[is.muni]

cols.drop <- colnames(card.tmp) %in% c("市町村類型", "都道府県", "市区町村")

card <- cbind(jis=as.numeric(jis[is.muni]), as.matrix(card.tmp[, !cols.drop]))
rownames(card) <- general[is.muni, "団体コード "]

fname <- paste(proj.home, "card.RData", sep="")
save(ruigata, card, file=fname)

debt.exp <- cross[, "011:一般財源等", "九　公債費"]
lat.regular <- sainyuu[, "016:普通交付税"]
rev.excluded <- rowSums(sainyuu[, c("002:地方譲与税", "018:交通安全対策特別交付金")])

cnames <- c("debt.exp", "lat", "rev.excluded", "kisai", "sfr", "sfn", "sfs", "sfn.exsub", "sfn.struct.h13", "sfn.struct.h20", "sfn.struct.one")
fin.h13 <- matrix(NA, nrow=nrow(shp@data), ncol=length(cnames), dimnames=list(rownames(shp@data), cnames))

idx <- match(rownames(fin.h13), card[,"jis"])
fin.h13[,"debt.exp"] <- debt.exp[rownames(card)][idx]
fin.h13[,"lat"] <- lat.regular[rownames(card)][idx]
fin.h13[,"rev.excluded"] <- rev.excluded[rownames(card)][idx]

fin.h13[,"kisai"] <- card[idx,"起債制限比率.財政指標等"]

### substitute in from H8 (pretty far away...)

fname <- paste(proj.home, "fin.RData", sep="")
load(fname)
na.h13 <- rownames(fin.h13)[is.na(fin.h13[,"debt.exp"])]
fin.tmp <- rbind(shi[,c("SF.need", "SF.rev", "起債制限比率")], machi[,c("SF.need", "SF.rev", "起債制限比率")])
fin.h13[na.h13, "lat"] <- pmax(0, fin[na.h13, "SF.need"] - fin[na.h13, "SF.rev"])
fin.h13[na.h13, "kisai"] <- fin.tmp[na.h13, "起債制限比率"]

fname <- paste(s.dir, "/H8.RData", sep="")
load(fname)
dimnames(cross)[[1]] <- as.character(as.numeric(substring(dimnames(cross)[[1]], first=1, last=5)))
fin.h13[na.h13, "debt.exp"] <- cross[na.h13, "011:一般財源等", "九　公債費"]
rownames(sainyuu) <- as.character(as.numeric(substring(rownames(sainyuu), first=1, last=5)))
fin.h13[na.h13, "lat"] <- sainyuu[na.h13, "015:普通交付税"]
fin.h13[na.h13, "rev.excluded"] <- rowSums(sainyuu[na.h13, c("002:地方譲与税", "017:交通安全対策特別交付金")])
rm(cross, sainyuu, kikin)  #to avoid using H8 later by mistake

fname <- paste(proj.home, "h13.RData", sep="")
load(fname)
fin.h13[as.character(as.numeric(rownames(d.h13))), "sfr"] <- d.h13[,"sfr"]
fin.h13[as.character(as.numeric(rownames(d.h13))), "sfn"] <- d.h13[,"sfn"]

fin.h13[,"sfs"] <- (fin.h13[,"sfr"] - fin.h13[,"rev.excluded"])/.75 + fin.h13[,"lat"] + fin.h13[,"rev.excluded"]

subsidy <- (fin.h13[,"debt.exp"] - fin.h13[,"kisai"]/100 * fin.h13[,"sfs"])/(1-fin.h13[,"kisai"]/100)
#sub.rate <- subsidy/fin.h13[,"debt.exp"]
#summary(sub.rate)
#summary(sub.rate < 0)
fin.h13[, "sfn.exsub"] <- fin.h13[,"sfn"] - subsidy

fname <- paste(proj.home, "hosei.R", sep="")
source(fname)
fname <- paste(proj.home, "unit_costs.txt", sep="")
tmp <- read.table(file(fname, encoding="UTF-16"), header=TRUE, row.names=1, sep="\t")
fname <- paste(proj.home, "trinity.txt", sep="")
trinity <- read.table(file(fname, encoding="UTF-16"), header=TRUE, row.names=1, sep="\t")
unit.cost <- tmp[,1:8] - trinity[,1:8] #I can't keep track of treasury transfers, so subtract in an attempt to make them constant...


df.h13 <- data.frame(d.h13)
df.h13$density <- df.h13$pop / df.h13$area * 100
df.h13$classes.elementary <- pmax(3 * df.h13$schools.elementary, ceiling(df.h13$students.elementary/40))
df.h13$classes.middle <- pmax(3 * df.h13$schools.middle, ceiling(df.h13$students.middle/40))
df.h13$families.farm <- df.h13$families.farm.commercial + df.h13$families.farm.personal
df.h13$employees.primary <- df.h13$employees.forestry + df.h13$employees.fishing + df.h13$employees.mining

calc.coef <- expression(cbind(
    sapply(pop, firefighting.pop) * sapply(density, firefighting.density),
    rep(1, length(road.length)),
    rep(1, length(pop)), #parks
    sapply(pop, parks.investment.type),
    rep(10, length(area.parks)), #area is off by an order of magnitude for some reason
    rep(1, length(pop)), #sewers
    rep(1, length(pop)), #sewers.investment
    sapply(pop, otherland.pop),
    sapply(pop, otherland.investment.type),
    rep(1, length(students.elementary)),
    rep(1, length(classes.elementary)),
    rep(1, length(classes.elementary)), #investment
    rep(1, length(schools.elementary)),
    rep(1, length(students.middle)),
    rep(1, length(classes.middle)),
    rep(1, length(classes.middle)), #investment
    rep(1, length(schools.middle)),
    sapply(pop, othereducation.pop) * sapply(density, othereducation.density),
    sapply(pop, othereducation.investment.adj),
    rep(1, length(students.nursery)), #actually kindergarten
    sapply(pop, welfare.pop),
    sapply(pop, welfare.investment.adj),
    sapply(pop, hygiene.pop),
    sapply(pop.over65, over65.pop),
    sapply(pop.over65, elderly.investment.adj),
    rep(1, length(pop.over70)),
    rep(1, length(pop)), #sanitation
    rep(1, length(pop)), #sanitation.investment
    sapply(families.farm, agriculture.pop),
    rep(1, length(families.farm)), #investment
    sapply(pop, commerce.pop),
    mapply(primary.type, employees.primary, employees.forestry, employees.fishing, employees.mining),
    mapply(primary.investment.type, employees.primary, employees.forestry, employees.fishing, employees.mining),
    sapply(pop, planning.pop),
    mapply(planning.investment.adj, pop, pop.over65),
    sapply(families, taxcollection.pop) * sapply(density, taxcollection.density),
    sapply(families * 40000/39000, registration.pop.koseki) * sapply(density, registration.density.koseki),
    sapply(families, registration.pop.setai) * sapply(density, registration.density.setai),
    sapply(pop, other.pop) * sapply(density, other.density),
    sapply(pop, other.investment.adj),
    sapply(pop, revival.pop) * mapply(revival.type, employees.primary, pop.over65, pop),
    sapply(pop, general.pop),
    rep(1, length(pop)))) #ganbaru chihou

#coef.h9 <- with(d.h15, with(f.h9, eval(calc.coef)))

coef.h13 <- with(df.h13, with(hosei[["H13"]], eval(calc.coef)))
coef.h20 <- with(df.h13, with(hosei[["H20"]], eval(calc.coef)))

num.units <- df.h13[,c(
                      "pop",  #firefighting
                      "road.length",
                      "pop",  #parks
                      "pop",  #parks.investment
                      "area.parks",
                      "pop",  #sewers
                      "pop",  #sewers.investment
                      "pop",  #otherland
                      "pop",  #otherland.investment
                      "students.elementary",
                      "classes.elementary",
                      "classes.elementary", #investment
                      "schools.elementary",
                      "students.middle",
                      "classes.middle",
                      "classes.middle", #investment
                      "schools.middle",
                      "pop", #othereducation
                      "pop", #othereducation.investment
                      "students.nursery", #kindergarten
                      "pop", #welfare
                      "pop", #welfare.investment
                      "pop", #hygiene
                      "pop.over65",
                      "pop.over65", #investment
                      "pop.over70",
                      "pop", #sanitation
                      "pop", #sanitation.investment
                      "families.farm",
                      "families.farm", #investment
                      "pop", #commerce
                      "employees.primary",
                      "employees.primary", #investment
                      "pop", #planning
                      "pop", #planning.investment
                      "families", #taxcollection
                      "families", #registration
                      "families", #registration.investment
                      "pop", #other
                      "pop", #other.investment
                      "pop", #revival
                      "pop", #general
                      "pop")]#ganbaru

h13.unit.cost <- t(unit.cost)["平成１３年度",]
h20.unit.cost <- t(unit.cost)["平成２０年度",]

coef.one <- matrix(1, ncol=ncol(coef.h13), nrow=nrow(coef.h13))

sfn.h13 <- t(t(num.units * coef.h13) * h13.unit.cost)
colnames(sfn.h13) <- names(h13.unit.cost)
sfn.h20 <- t(t(num.units * coef.h20) * h20.unit.cost)
colnames(sfn.h20) <- names(h20.unit.cost)
sfn.one <- t(t(num.units * coef.one) * h13.unit.cost)

sfn.total.h13 <- rowSums(sfn.h13)
sfn.total.h20 <- rowSums(sfn.h20)
sfn.total.one <- rowSums(sfn.one)

fin.h13[as.character(as.numeric(names(sfn.total.h13))),"sfn.struct.h13"] <- sfn.total.h13
fin.h13[as.character(as.numeric(names(sfn.total.h20))),"sfn.struct.h20"] <- sfn.total.h20
fin.h13[as.character(as.numeric(names(sfn.total.h20))),"sfn.struct.one"] <- sfn.total.one

fname <- paste(proj.home, "fin_h13.RData", sep="")
save(fin.h13, df.h13, calc.coef, h13.unit.cost, h20.unit.cost, num.units, file=fname)

#fin.h13[which(fin.h13[,"sfn.struct.h13"] > fin.h13[,"sfn.exsub"]),]
#summary(fin.h13[,"sfn.struct.h13"]/fin.h13[,"sfn.exsub"])

reg <- lm(sfn.total.h20 ~ sfn.total.h13 + sfn.total.one, data=as.data.frame(fin.h13))
reg <- lm(sfn.total.h20 ~ sfn.total.h13 + sfn.total.one - 1, data=as.data.frame(fin.h13))

