#Rscript --verbose /home/fas/weese/egw5/japan_qe_final/fin.R

proj.home <- "/home/fas/weese/egw5/japan_qe_final/"
proj.tmp <- "/home/fas/weese/egw5/scratch/japan_qe/"
options(echo=TRUE)

do.shichouson <- function(fname, cnames, skip.n) {
  tmp <- read.delim(file(fname, encoding="UCS-2LE"), header=FALSE, col.names=cnames, skip=skip.n, colClasses="character", stringsAsFactors=FALSE)
  if(tmp[1,1] != "北海道") stop("incorrect skip?")
  tmp[,-1] <- apply(tmp[,-1], 1:2, function(x) gsub(",","",x))
  tmp[-1] <- lapply(tmp[-1],as.numeric)
  empty <- apply(tmp[,-1],1,function(x) all(is.na(x)))
  pref.row <- empty & tmp[,1]!=""
  tmp$pref <- tmp[,1]
  tmp[!pref.row,"pref"] <- NA
  tmp <- tmp[!(empty & !pref.row),]
  for(r in 1:dim(tmp)[1])
    if(is.na(tmp[r,"pref"])) tmp[r,"pref"] <- tmp[r-1, "pref"]
  empty <- apply(tmp[,-which(names(tmp) %in% c("muni", "pref"))], 1, function(x) all(is.na(x)))
  tmp <- tmp[!empty,]
  tmp <- tmp[-dim(tmp)[1],] #eliminate grand total
  total.row <- tmp$muni %in% c("合計　", "合計")
###should probably test the totals here...
##t.sum <- aggregate(tmp[!total.row,c(-1,-21)], by=list(pref=tmp[!total.row, "pref"]), sum)
##t.row <- tmp[total.row, -1]
##t.check <- merge(t.sum, t.row, by=c("pref"))
##t.check <- t.check[,sort(names(t.check))] #looks ok...
  tmp <- tmp[!total.row,]
  return(tmp)
}

fname <- paste(proj.home, "Sichouson/SKMATI1.txt", sep="")
cnames <- c("muni", "pop1997", "pop1995", "pop.grate", "ind.primary", "ind.secondary", "ind.tertiary", "area1996",
            "SF.need", "SF.rev", "SF.size", #基準財政需要額 基準財政収入額  標準財政規模
            "実質収支比率", #"Real term balance of revenue to expenditure" "Net excess of revenue / standard financial size * 100"
            "公債費負担比率", "公債費比率", "起債制限比率",
            "financial.strength",
            "経常収支比率", #"Ratio of recurring profit"
            "exp.personnel", #人件費
            "exp.debt", #公債費
            "unknown.taxbase",  #減税補てん債を経常一般財源等に加えた経常収支比率
            "empty")
machi.gen <- do.shichouson(fname, cnames, skip.n=6)
machi.gen <- machi.gen[,-which(names(machi.gen)=="empty")]

fname <- paste(proj.home, "Sichouson/SKTOSI1.txt", sep="")
shi.gen <- do.shichouson(fname, cnames, skip.n=7)
shi.gen <- shi.gen[-(694:692),]
shi.gen <- shi.gen[,-which(names(shi.gen)=="empty")]


fname <- paste(proj.home, "Sichouson/SKMATI2.txt", sep="")
cnames <- c("muni", "total.rev", "local.tax", "local.transfer.tax", "LAT.general", "LAT.special", "use.fees", "handling.fees", "national.transfers", "pref.transfers", "misc.rev", "bonds", "other", "empty")
machi.rev <- do.shichouson(fname, cnames, skip.n=3)
##rowSums(machi.rev[,3:13]) - machi.rev$total.rev             #seems to work
##rowSums(machi.rev[,3:13], na.rm=TRUE) - machi.rev$total.rev #still works, indicating that NAs are probably zeros
sum(is.na(machi.rev$total.rev))
machi.rev <- machi.rev[,-which(names(machi.rev)=="empty")]
machi.rev[is.na(machi.rev)] <- 0

## tmp <- cbind(machi.gen[,c("pref","muni")], machi.rev[,c("pref","muni")])
## tmp.same <- (tmp[,1] == tmp[,3]) & (tmp[,2] == tmp[,4])
## summary(tmp.same)  # looks like the ordering is exactly the same, so we can just use cbind...
machi.gr <- cbind(machi.gen, machi.rev[,-which(names(machi.rev)%in%c("muni","pref"))])
## library("lattice")
## xyplot((SF.rev/.75 + LAT.general) ~ SF.size, data=machi.gr)  #identity

fname <- paste(proj.home, "Sichouson/SKMATI3.txt", sep="")
cnames <- c("muni", "total.exp", "personnel.exp", "personnel.exp.wages", "equipment.exp", "maintenance.exp",
            "social.assistance.exp", # Assistance/support expense (?)
            "subsidy.exp", # more assistance expenses (?)
            "investment.exp", "investment.exp.construction", "investment.exp.construction.independent", "debt.exp", "deposit.exp", "acct_transfer.exp", "other.exp",
            "実質収支", "単年度収支", "実質単年度収支", "地方債現在高", "積立金現在高", "積立金現在高.うち財政調整基金", "債務負担行為額.翌年度以降支出予定額",
            "n.staff", "n.staff.clerical", "empty")
machi.exp <- do.shichouson(fname, cnames, skip.n=3)
##rowSums(machi.exp[,c("personnel.exp", "equipment.exp", "maintenance.exp", "social.assistance.exp", "subsidy.exp", "investment.exp", "debt.exp", "deposit.exp", "acct_transfer.exp", "other.exp")]) - machi.exp$total.exp  #looks ok...
sum(is.na(machi.exp$total.exp))
machi.exp <- machi.exp[,-which(names(machi.exp)=="empty")]
machi.exp[is.na(machi.exp)] <- 0
machi <- cbind(machi.gr, machi.exp[,-which(names(machi.exp)%in%c("muni","pref"))])
## nfin_exp <- rowSums(machi[,c("personnel.exp", "equipment.exp", "maintenance.exp", "social.assistance.exp", "subsidy.exp", "investment.exp", "other.exp")])
## xyplot(nfin_exp ~ machi$pop1997)  #still big variation...

machi[machi$pref=="青森県" & machi$muni=="鯵ケ沢町", "muni"] <- "鰺ヶ沢町"  # small counter / big counter issues...
machi[machi$pref=="青森県" & machi$muni=="碇ケ関村", "muni"] <- "碇ヶ関村"
machi[machi$pref=="青森県" & machi$muni=="六ケ所村", "muni"] <- "六ヶ所村"
machi[machi$pref=="宮城県" & machi$muni=="七ケ宿町", "muni"] <- "七ヶ宿町"
machi[machi$pref=="宮城県" & machi$muni=="七ケ浜町", "muni"] <- "七ヶ浜町"
machi[machi$pref=="三重県" & machi$muni=="島ケ原村", "muni"] <- "島ヶ原村"
machi[machi$pref=="奈良県" & machi$muni=="月ケ瀬村", "muni"] <- "月ヶ瀬村"
machi[machi$pref=="熊本県" & machi$muni=="龍ケ岳町", "muni"] <- "龍ヶ岳町"
machi[machi$pref=="大分県" & machi$muni=="本耶馬溪町", "muni"] <- "本耶馬渓町"
machi[machi$pref=="新潟県" & machi$muni=="京ケ瀬村", "muni"] <- "京ヶ瀬村"
machi[machi$pref=="東京都" & machi$muni=="青ケ島村", "muni"] <- "青ヶ島村"
machi[machi$pref=="宮崎県" & machi$muni=="五ケ瀬町", "muni"] <- "五ヶ瀬町"
machi[machi$pref=="静岡県" & machi$muni=="天城湯ケ島町", "muni"] <- "天城湯ヶ島町"

machi[machi$pref=="北海道" & machi$muni=="北桧山町", "muni"] <- "北檜山町" # other misc. spelling discrepencies...
machi[machi$pref=="宮城県" & machi$muni=="鴬沢町", "muni"] <- "鶯沢町"
machi[machi$pref=="福島県" & machi$muni=="桧枝岐村", "muni"] <- "檜枝岐村"
machi[machi$pref=="新潟県" & machi$muni=="頚城村", "muni"] <- "頸城村"
machi[machi$pref=="新潟県" & machi$muni=="横越町", "muni"] <- "横越村"
machi[machi$pref=="新潟県" & machi$muni=="聖篭町", "muni"] <- "聖籠町"
machi[machi$pref=="東京都" & machi$muni=="桧原村", "muni"] <- "檜原村"
machi[machi$pref=="群馬県" & machi$muni=="薮塚本町", "muni"] <- "藪塚本町"
machi[machi$pref=="群馬県" & machi$muni=="倉渕村", "muni"] <- "倉淵村"
machi[machi$pref=="茨城県" & machi$muni=="五霞町", "muni"] <- "五霞村"
machi[machi$pref=="茨城県" & machi$muni=="東町", "muni"] <- "東村"
machi[machi$pref=="茨城県" & machi$muni=="河内町", "muni"] <- "河内村"
machi[machi$pref=="茨城県" & machi$muni=="新利根町", "muni"] <- "新利根村"

library("methods")
load(paste(proj.home, "shp.RData", sep=""))
lookup <- paste(shp@data$pref, shp@data$muni, sep="、")

search.str <- paste(machi$pref, machi$muni, sep="、")
tmp <- match(search.str, lookup)
machi[which(is.na(tmp)),c("pref", "muni")]
#fix 東村 issues etc.: (they happen to be in the same order, conveniently)
tmp[which(machi$pref=="群馬県" & machi$muni=="東村")] <- which(shp@data$pref=="群馬県" & shp@data$muni=="東村")
tmp[which(machi$pref=="兵庫県" & machi$muni=="一宮町")] <- which(shp@data$pref=="兵庫県" & shp@data$muni=="一宮町")
tmp[which(machi$pref=="広島県" & machi$muni=="三和町")] <- which(shp@data$pref=="広島県" & shp@data$muni=="三和町")
machi[which(duplicated(tmp)),c("pref", "muni")]
row.names(machi) <- row.names(shp@data)[tmp]

#save(machi, file="machi.RData")

shi <- shi.gen

shi[shi$pref=="埼玉県" & shi$muni=="鶴ケ島市", "muni"] <- "鶴ヶ島市"
shi[shi$pref=="神奈川県" & shi$muni=="茅ケ崎市", "muni"] <- "茅ヶ崎市"
shi[shi$pref=="埼玉県" & shi$muni=="鳩ケ谷市", "muni"] <- "鳩ヶ谷市"
shi[shi$pref=="長野県" & shi$muni=="駒ケ根市", "muni"] <- "駒ヶ根市"

shi[shi$pref=="宮城県" & shi$muni=="塩竃市", "muni"] <- "塩竈市"
shi[shi$pref=="長崎県" & shi$muni=="諌早市", "muni"] <- "諫早市"
shi[shi$pref=="北海道" & shi$muni=="北広島市", "muni"] <- "広島町"
shi[shi$pref=="北海道" & shi$muni=="石狩市", "muni"] <- "石狩町"
shi[shi$pref=="埼玉県" & shi$muni=="吉川市", "muni"] <- "吉川町"
shi[shi$pref=="千葉県" & shi$muni=="印西市", "muni"] <- "印西町"

search.str <- paste(shi$pref, shi$muni, sep="、")
tmp <- match(search.str, lookup)
shi[which(is.na(tmp)),c("pref", "muni")]
shi[which(duplicated(tmp)),c("pref", "muni")]
row.names(shi) <- row.names(shp@data)[tmp]

tmp.machi <- machi[,c("pref", "muni", "pop1995", "area1996", "SF.need", "SF.rev", "SF.size")]
tmp.machi$city <- FALSE
tmp.machi$designated <- FALSE
tmp.shi <- shi[,c("pref", "muni", "pop1995", "area1996", "SF.need", "SF.rev", "SF.size")]
tmp.shi$city <- TRUE
tmp.shi$designated <- as.numeric(row.names(shi)) %% 1000 < 200

fin.tmp <- rbind(tmp.shi, tmp.machi)[row.names(shp@data),]

## ###sinfonica
## load(paste(proj.home, "sinfonica/income.RData", sep=""))
## row.names(income) <- as.numeric(row.names(income))
## row.names(income)[row.names(income) == "11243"] <- "11466" #towns that became cities around then
## row.names(income)[row.names(income) == "12231"] <- "12327"
## income.tmp <- income[row.names(shp@data),]

## ###minryoku
## tmp <- read.csv(file(paste(proj.home, "minryoku00/65.csv", sep=""), encoding="SJIS"), skip=2, stringsAsFactors=FALSE, colClasses="character")
## row.names(tmp) <- as.numeric(tmp$JIS)
## tmp$inc1997 <- as.numeric(tmp$X1997年)
## minryoku.inc <- tmp[,"inc1997",drop=FALSE]
## tmp <- read.csv(file(paste(proj.home, "minryoku00/66.csv", sep=""), encoding="SJIS"), skip=2, stringsAsFactors=FALSE, colClasses="character")
## row.names(tmp) <- as.numeric(tmp$JIS)
## tmp$inc.ineq1997 <- as.numeric(tmp$X1997年)
## minryoku.incineq <- tmp[,"inc.ineq1997",drop=FALSE]
## minryoku <- cbind(minryoku.inc, minryoku.incineq)
## row.names(minryoku)[row.names(minryoku)=="1234"] <- "1301" #reverse changes from town to city...
## row.names(minryoku)[row.names(minryoku)=="1235"] <- "1302"
## row.names(minryoku)[row.names(minryoku)=="11243"] <- "11466"
## row.names(minryoku)[row.names(minryoku)=="12231"] <- "12327"
## row.names(minryoku)[row.names(minryoku)=="26211"] <- "26342"
## row.names(minryoku)[row.names(minryoku)=="40223"] <- "40347"
## shp@data[which(is.na(match(row.names(shp@data), row.names(minryoku)))),]
## minryoku.tmp <- minryoku[row.names(shp@data),]
## row.names(minryoku.tmp)[2041:2044] <- c("28661", "28664", "28665", "28666")

## stopifnot(row.names(minryoku.tmp) == row.names(fin.tmp))  #this was messed up at one point - huge waste of time...
## stopifnot(row.names(income.tmp) == row.names(fin.tmp))
## fin <- cbind(fin.tmp, income.tmp, minryoku.tmp)
fin <- fin.tmp
fname <- paste(proj.home, "fin.RData", sep="")
save(machi, shi, fin, file=fname)
