## Figure 6

proj.home <- "/home/fas/weese/egw5/japan_qe_final/"

fname <- paste(proj.home, "fin_h13.RData", sep="")
load(fname)
rownames(df.h13) <- as.character(as.numeric(rownames(df.h13)))
rownames(num.units) <- as.character(as.numeric(rownames(num.units)))

fname <- paste(proj.home, "mesh.RData", sep="")
load(fname)

fname <- paste(proj.home, "calc_dat.R", sep="")
source(fname)

fname <- paste(proj.home, "hosei.R", sep="")
source(fname)

fname <- paste(proj.home, "toku_inv.R", sep="")
source(fname)

library("sp")

munis <- row.names(df.h13)
d.l <- lapply(munis, calc.dat)
d <- do.call("rbind", d.l)

library("lattice")
fname <- paste(proj.home, "ctilde_spurious.pdf", sep="")
pdf(file=fname)
ylab <- expression(paste(tilde(c), " (blue), and without hypothesized spurious adjustments (pink)"))
xyplot(I(d[,"sfn.struct.h13"]/d[,"pop"]) + I(d[,"sfn.struct.h13.ninv"]/d[,"pop"]) ~ d[,"pop"],
       pch=".", scales=list(x=list(log=TRUE)), xlab="Population", ylab=ylab)
dev.off()

fname <- paste(proj.home, "ctilde_spurious_bw.pdf", sep="")
pdf(file=fname)
ylab <- expression(paste(tilde(c), " (black), and without hypothesized spurious adjustments (grey)"))
xyplot(I(d[,"sfn.struct.h13"]/d[,"pop"]) + I(d[,"sfn.struct.h13.ninv"]/d[,"pop"]) ~ d[,"pop"],
       pch=".", scales=list(x=list(log=TRUE)), xlab="Population", ylab=ylab, col=c("black", "grey40"))
dev.off()
