proj.home <- "/home2/egw5/japan_qc/"
proj.tmp <- "/home2/egw5/scratch/japan_restud/"

library("igraph")
fname <- paste("/home2/egw5/japan_restud/pgraph.RData", sep="")
load(fname)

load("/home2/egw5/japan_restud/sinfonica/h13.RData")
rownames(d.h13) <- as.character(as.numeric(rownames(d.h13)))

prefs <- 1:47

dat.l <- list()
dat.l.1 <- list()
for(p in prefs) {
  p.graph <- p.graph.l[[p]]
  
  fname <- paste(proj.tmp, p, "/i_long_1_m_new.RData", sep="")
  load(fname)
  fname <- paste(proj.tmp, p, "/i_long_1_dist.RData", sep="")
  load(fname)
  colnames(avg.dist.m) <- "dist"
  dat.l[[as.character(p)]] <- cbind(m.dat, avg.dist.m)
  rownames(dat.l[[as.character(p)]]) <- V(p.graph)$name
  dat.l.1[[as.character(p)]] <- cbind(dat.l[[as.character(p)]], merger=as.numeric(V(p.graph)$name))
  rownames(dat.l.1[[as.character(p)]]) <- V(p.graph)$name
  
#  if(time == 1) {  #then include the actual mergers
    qc.dir <- paste(proj.tmp, p, "/qc/", sep="")
    r.l <- list()
    refinements <- system(paste("ls ", qc.dir, "r*_new.RData", sep=""), intern=TRUE)
    for(refinement in refinements) {
      ref.name <- as.numeric(substr(refinement, start=nchar(refinement) - 14, stop=nchar(refinement) - 10))
      r.l[[refinement]] <- new.env()
      load(refinement, envir=r.l[[refinement]])
      r.munis <- r.l[[refinement]]$muni.l[[length(r.l[[refinement]]$muni.l)]]
      r.dat <- r.l[[refinement]]$dat.l[[length(r.l[[refinement]]$dat.l)]]
      dat.l.1[[as.character(p)]][r.munis + 1, colnames(dat.l[[as.character(p)]])] <- r.dat[, colnames(dat.l[[as.character(p)]])]
      dat.l.1[[as.character(p)]][r.munis + 1, "merger"] <- ref.name
#    }
  }
}

d0 <- do.call("rbind", dat.l)
stopifnot(d0[,"sfr"] * 100 - d.h13[rownames(d0),"sfr"] < 1)  # rownames had better have lined things up correctly...


#d1 <- do.call("rbind", dat.l.1)

load("/home2/egw5/scratch/soumushou/H9.RData")
dimnames(cross)[[1]] <- substring(dimnames(cross)[[1]], first=1, last=5)
ritou.tmp <- general[,37]
names(ritou.tmp) <- substring(general[,3], first=1, last=5)
ritou.tmp2 <- as.character(as.numeric(names(which(ritou.tmp==1))))
ritou <- setdiff(ritou.tmp2, c("38353", "38354")) # classification change

pop.order <- rep(NA, 47)

pop.order[order(sapply(p.graph.l, function(p.graph) mean(d.h13[setdiff(V(p.graph)$name, ritou), "pop"] < 10000)))] <- 1:47
names(pop.order) <- names(p.graph.l)
early[order(pop.order)]
late[order(pop.order)]

pref.groups <- list()
pref.groups[[1]] <- intersect(prefs, which(pop.order <= 3))
pref.groups[[2]] <- intersect(prefs, which(pop.order > 3 & pop.order <= 39))
pref.groups[[3]] <- intersect(prefs, which(pop.order > 39))

nmunis <- sapply(1:47, function(p) vcount(p.graph.l[[p]]))
fname <- paste(proj.home, "early_mergers.R", sep="")
source(fname)
early <- colSums(early)

late <- rep(NA, 47)
load("/home2/egw5/japan_restud/gappei.RData")
for (p in prefs) {
  gappei.p <- gappei[as.numeric(substring(gappei[,"jis"], first=1, last=2)) == p,]
  late[p] <- length(unique(unlist(gappei.p[,"merger"])))
}

jis3.str <- substr(rownames(d0), start=nchar(rownames(d0)) - 2, stop=nchar(rownames(d0)) - 2)
names(jis3.str) <- rownames(d0)

pg.munis <- lapply(pref.groups, function(prefs) unlist(lapply(prefs, function(p) V(p.graph.l[[p]])$name)))
sapply(pg.munis, function(jis) sum(d.h13[jis,"pop"])/(length(jis)*100000))
sapply(pg.munis, function(jis) sqrt(var(d.h13[jis,"pop"]/100000)))
sapply(pg.munis, function(jis) sum(d.h13[jis,"area"])/(length(jis)*10000))
sapply(pg.munis, function(jis) sqrt(var(d.h13[jis,"area"]/10000)))
sapply(pg.munis, function(jis) sum(d.h13[jis,"sfn"])/(length(jis)*100000))
sapply(pg.munis, function(jis) sqrt(var((d.h13[jis,"sfn"])/100000)))
sapply(pg.munis, function(jis) sum(d.h13[jis,"sfr"])/(length(jis)*100000))
sapply(pg.munis, function(jis) sqrt(var(d.h13[jis,"sfr"]/100000)))
sapply(pg.munis, function(jis) sum(jis3.str[jis] %in% c("1", "2"))/length(jis))
sapply(pref.groups, function(p) sum(early[p])/sum(nmunis[p]))
sapply(pref.groups, function(p) sum(late[p])/sum(nmunis[p]))



sapply(pg.munis, length)
sapply(pref.groups, length)


fin.sum <- data.frame(c=fin$SF.need/100000, POPULATION=fin$pop1995/100000, AREA=fin$area1996/100, INCOME=fin$taxable.income/fin$tax.payers/100, INCOME.INEQ=fin$inc.ineq1997, CITY=fin$city)
sum.names <- c("$\\tilde c_m$ (std. fiscal need, ¥)", "POPULATION", "AREA (sq. km.)", "INCOME (per capita, ¥)", "INCOME.INEQ", "CITY (vs. town/vill.)")
sum.desc <- c("100,000,000", "100,000", "100", "100,000", "coef. of var.", "")
sum.mean <- sapply(fin.sum[!fin$designated,], mean, na.rm=TRUE)
sum.sd <- sapply(fin.sum[!fin$designated,], sd, na.rm=TRUE)
sum.tab <- data.frame(row.names=sum.names, Units=sum.desc, Mean=sum.mean, SD=sum.sd)
library(xtable)
tmp <- xtable(sum.tab, align="lrrr")
print(tmp, floating=FALSE, file=paste(proj.home, "sumstat.tex", sep=""), sanitize.text.function=function(x) x)
