## ./opt_anal.R
## Compare optimal centralized mergers to the singleton case
## (produces the figures discussed in the latter half of Section 4)

fname <- paste(proj.home, "anal_base.R", sep="")
source(fname)

part.l.l <- list()
obj.sing.l <- list()
obj.cent.l <- list()
T.sing.l <- list()
T.cent.l <- list()

for (pref in 1:47) {
    regexp <- paste("greedy_", type, "_", pref, "_.*.RData", sep="")
    part.l.l[[as.character(pref)]] <- list()
    obj.sing.l[[as.character(pref)]] <- list()
    obj.cent.l[[as.character(pref)]] <- list()
    T.sing.l[[as.character(pref)]] <- list()
    T.cent.l[[as.character(pref)]] <- list()
    for(fname in list.files(proj.tmp, regexp, full.names=TRUE)) {
        load(fname)
        part.l.l[[as.character(pref)]][[fname]] <- part.l
        obj.sing.l[[as.character(pref)]][[fname]] <- obj.singleton
        obj.cent.l[[as.character(pref)]][[fname]] <- obj.centralized
        T.sing.l[[as.character(pref)]][[fname]] <- T.singleton
        T.cent.l[[as.character(pref)]][[fname]] <- T.centralized
    }
    obj.sing.l[[as.character(pref)]] <- unlist(obj.sing.l[[as.character(pref)]])
    obj.cent.l[[as.character(pref)]] <- unlist(obj.cent.l[[as.character(pref)]])
    T.sing.l[[as.character(pref)]] <- unlist(T.sing.l[[as.character(pref)]])
    T.cent.l[[as.character(pref)]] <- unlist(T.cent.l[[as.character(pref)]])
}

length.l <- lapply(part.l.l, lapply, length)
sum(sapply(length.l, function(x) mean(unlist(x))))

sum(sapply(T.sing.l, mean) - sapply(T.cent.l, mean))
sum(sapply(obj.sing.l, mean) - sapply(obj.cent.l, mean))

### also check the actual mergers?
pop.muni <- d.h13[, "pop"]

#TIME <- 1
component.obj <- function(munis, rt="all", tm) {
    comp.dat <- calc.dat(munis)
    v <- v.m.new(d=comp.dat, b=b, time=tm, ninv=ninv) * pop.muni[munis]  # time=1 differs from greedy

    T <- v.m.new(d=comp.dat, b=b, time=tm, ret="T")
    stopifnot(T == T[1])

    ret <- sum(v * weight.pc[munis]) - cpf * T[1]

    if(rt=="all") return(ret)
    if(rt=="T") return(T[1])
}

library("parallel")
unmerged <- setdiff(rownames(df.h13), unlist(mergers.l))
unmerged.l <- as.list(unmerged)
use.l <- c(mergers.l, unmerged.l)
length(use.l)
length(unlist(use.l))

v.merged <- unlist(mclapply(use.l, component.obj, tm=1))

v.merged0 <- unlist(mclapply(use.l, component.obj, tm=0))

v.single <- unlist(mclapply(unlist(use.l), component.obj, tm=0))


T.merged <- unlist(mclapply(use.l, component.obj, tm=1, rt="T"))

T.single <- unlist(mclapply(unlist(use.l), component.obj, tm=0, rt="T"))

sum(v.merged0) - sum(v.single)  # 2219931 (actual), 2723839 (ninv), 4315124 (equal)
sum(v.merged) - sum(v.single)  # with T1:  340931 (actual), 679834 (ninv), 2929806 (equal)
