## ./individ_m.R
## Create the individual data files for the actual mergers
## Submit via

# seq 1 47 | perl -ne 'chomp($p=$_); print "Rscript --verbose /home2/egw5/japan_qc/individ_actual.R ", $p, "\n"' > individ_actual.task
# sqCreateScript -N i_actual -w 4:00:00 -n 4 -q fas_devel individ_actual.task | qsub

proj.home <- "/home2/egw5/japan_restud/"
proj.tmp <- "/home2/egw5/scratch/japan_restud/"


options(echo=TRUE)
tmp <- commandArgs(trailingOnly=TRUE)
tmp
p <- as.numeric(tmp[1])
p

library("igraph0") #legacy ZERO-BASED INDEXING
library("bigmemory")
options(bigmemory.typecast.warning=FALSE)

load(paste(proj.home, "pgraph.RData", sep=""))

p.graph <- p.graph.l[[p]]
all.munis <- V(p.graph)$name
nmuni <- length(all.munis)

fname <- paste(proj.tmp, p, "/parts_short.RData", sep="")
load(fname)

nc <- vector("numeric", 15)  #no actual mergers that are size 16
for (size in 1:15) {
  fname <- paste(proj.tmp, p, "/", size, "_short.csv", sep="")
  nc[size] <- as.numeric(system(paste("wc -l < ", fname), intern=TRUE))
}

nc.cum <- c(0, cumsum(nc))
nc.cum.p1 <- nc.cum + 1

actual.l.tmp.l <- list()
actual.dat.l.tmp.l <- list()

for (size in 1:15) {
  fname <- paste(proj.tmp, p, "/i_short_", size, "_m.RData", sep="")
  f.bytes <- file.info(fname)[,"size"]
  if(is.na(f.bytes)) next
  load(fname)
  load(paste(proj.tmp, p, "/i_short_", size, "_dist.RData", sep=""))

  fname <- paste(proj.tmp, p, "/", size, "_short.csv", sep="")
  f.bytes <- file.info(fname)[,"size"]
  if(is.na(f.bytes)) stop("missing file")
  c.mat <- if(f.bytes == 0) NULL else read.big.matrix(fname, type="short", shared=FALSE)

  for(coal in p.l[[1]]) # i = 1
    if(coal > sum(nc[0:(size-1)]) && coal <= sum(nc[0:size])) {
      actual.l.tmp.l[[as.character(coal)]] <- c.mat[coal - sum(nc[0:(size-1)]),]
      idx <- coal - sum(nc[0:(size-1)])
      tmp.m <- m.dat[rep(idx, size),,drop=FALSE]
      tmp.im <- avg.dist.m[idx,]
      actual.dat.l.tmp.l[[as.character(coal)]] <- cbind(tmp.m, tmp.im)
    }
}

actual.mat.col <- function(l.tmp) {
  ret <- rep(NA, nmuni)
  for(i in 1:length(l.tmp))
    ret[l.tmp[[i]] + 1] <- as.numeric(names(l.tmp)[i])
  return(ret)
}

actual <- actual.mat.col(actual.l.tmp.l)
stopifnot(!is.na(actual))

actual.dat.f <- function(l.tmp, l.dat.tmp) {
  dat.mat <- matrix(NA, nrow=length(actual), ncol=ncol(l.dat.tmp[[1]]) + 1)
  stopifnot(length(l.tmp) == length(l.dat.tmp))
  for(i in 1:length(l.tmp)) {
    dat.mat[l.tmp[[i]] + 1, 1] <- as.numeric(names(l.tmp)[i])
    dat.mat[l.tmp[[i]] + 1, -1] <- l.dat.tmp[[i]]
  }
  colnames(dat.mat) <- c("m", colnames(l.dat.tmp[[1]]))
  return(dat.mat)
}


actual.dat <- actual.dat.f(actual.l.tmp.l, actual.dat.l.tmp.l)

fname <- paste(proj.tmp, p, "/i_actual.RData", sep="")
save(actual, actual.dat, file=fname)
