## ./individ_m.R
## Create the individual data files.  Submit via

# qsub -N m_1 -v PREF=1,LONG=1 -t 1-16 -q fas_normal -l walltime=168:00:00 individ_m.qscript
# qsub -N m_1 -v PREF=1,LONG=0 -t 1-16 -q fas_normal -l walltime=168:00:00 individ_m.qscript

proj.home <- "/home2/egw5/japan_restud/"
proj.tmp <- "/home2/egw5/scratch/japan_restud/"



options(echo=TRUE)
tmp <- commandArgs(trailingOnly=TRUE)
tmp
p <- as.numeric(tmp[1])
p
size <- as.numeric(tmp[2])
size
long <- as.numeric(tmp[3])
long

library("igraph0")  #legacy ZERO-BASED INDEXING
library("bigmemory")
library("biganalytics")
options(bigmemory.typecast.warning=FALSE)

load(paste(proj.home, "pgraph.RData", sep=""))
load(paste(proj.home, "fin.RData", sep=""))

fname <- paste(proj.home, "fin_h13.RData", sep="")
load(fname)
rownames(df.h13) <- as.character(as.numeric(rownames(df.h13)))
rownames(num.units) <- as.character(as.numeric(rownames(num.units)))

fname <- paste(proj.home, "hosei.R", sep="")
source(fname)

fname <- paste(proj.home, "toku_inv.R", sep="")
source(fname)

fname <- paste(proj.home, "calc_dat.R", sep="")
source(fname)

p.graph <- p.graph.l[[p]]
all.munis <- V(p.graph)$name
nmuni <- length(all.munis)

if(long && size==1) {
  coals <- as.big.matrix(matrix((1:nmuni) - 1, ncol=1), type="short", shared=FALSE)
} else if (long && size==2) {
  coals <- as.big.matrix(t(sapply(as.list(0:(ecount(p.graph)-1)), function(x) get.edge(p.graph, x))), type="short", shared=FALSE)
} else {
  if(long) {
    fname <- paste(proj.tmp, p, "/", size, "_long.csv", sep="")
  } else fname <- paste(proj.tmp, p, "/", size, "_short.csv", sep="")
  f.bytes <- file.info(fname)[,"size"]
  if(is.na(f.bytes)) stop("missing file")
  coals <- if(f.bytes == 0) matrix(NA, nrow=0, ncol=size) else read.big.matrix(fname, type="short", shared=FALSE)
}
length(coals) * 2

if(long) {
  fname <- paste(proj.tmp, p, "/parts_long.RData", sep="")
} else fname <- paste(proj.tmp, p, "/parts_short.RData", sep="")
load(fname)

igraphnp1.to.jis <- V(p.graph)$name
pop.by.igraphnp1 <- fin[igraphnp1.to.jis, "pop1995"]

library("parallel")
cnames <- c("sfr", "sfn.struct.one", "sfn.struct.h13", "sfn.struct.h13.ninv", "sfn.struct.h20", "sfn.subsidy", "sfn.idio", "santei.h13", "santei.h20", "tokureisai")
if(nrow(coals) > 0) {
  system.time(tmp <- mclapply(1:nrow(coals), function(i) calc.dat(igraphnp1.to.jis[coals[i,] + 1]), mc.cores=7))
} else tmp <- list(matrix(numeric(0), nrow=0, ncol=length(cnames), dimnames=list(character(0),cnames)))
m.dat <- do.call("rbind", tmp)
stopifnot(colnames(m.dat) == cnames)

if(long) {
  fname <- paste(proj.tmp, p, "/i_long_", size, "_m_new.RData", sep="")
} else fname <- paste(proj.tmp, p, "/i_short_", size, "_m_new.RData", sep="")
tmp.fname <- paste(proj.tmp, p, "/tmp_", size, "_m_new.RData", sep="")
save(m.dat, file=tmp.fname)
system(paste("mv", tmp.fname, fname))
