proj.home <- "/home/fas/weese/egw5/japan_qe_final/"
#proj.tmp <- "/home/fas/weese/egw5/scratch/japan_restud/"

fname <- paste(proj.home, "mesh.RData", sep="")
load(fname)

fname <- paste(proj.home, "fin_h13.RData", sep="")
load(fname)
rownames(df.h13) <- as.character(as.numeric(rownames(df.h13)))
rownames(num.units) <- as.character(as.numeric(rownames(num.units)))

fname <- paste(proj.home, "hosei.R", sep="")
source(fname)

fname <- paste(proj.home, "toku_inv.R", sep="")
source(fname)

fname <- paste(proj.home, "calc_dat.R", sep="")
source(fname)


par.calibrated <- c(B0=NA, B1=NA, B2=NA, B3=1, B4=1)
par.calibrated["tau.bar"] <- 0.084 * 4/3

par.calibrated["r"] <- 0.02
#par.calibrated["disc.santei.h20"] <- par.calibrated["r"] * sum(c(1/(1+par.calibrated["r"])^(1:10), c(.9, .7, .5, .3, .1)/(1+par.calibrated["r"])^(11:15)))
par.calibrated["disc.santei.h20"] <- 1  # treat as permanent

#par.calibrated["disc.tokurei"] <- par.calibrated["r"] * sum(1/(1+par.calibrated["r"])^(1:10)) * 0.95 * 0.70 * (sum(1/(1+par.calibrated["r"])^(1:20))/20) / 10
par.calibrated["disc.tokurei"] <- 0.95 * 0.70 * (sum(1/(1+par.calibrated["r"])^(1:20))/20) / 10

calc.merger <- function(muni.jis) {
    d <- calc.dat(c(muni.jis, muni.jis))
    d.single <- calc.dat(muni.jis)
    subsidy <- d[1,"sfn.subsidy"] + pmin(0, d[1,"sfn.idio"])
    subsidy.single <- d.single[,"sfn.subsidy"] + pmin(0, d.single[,"sfn.idio"])
    zeta <- pmax(0, d[1,"sfn.idio"])
    zeta.single <- pmax(0, d.single[,"sfn.idio"])

    T.pre <- pmax(0, d[1,"sfn.struct.h13"] + zeta - d[1,"sfr"] + subsidy) - subsidy
    T.pre.single <- pmax(0, d.single[,"sfn.struct.h13"] + zeta.single - d.single[,"sfr"] + subsidy.single) - subsidy.single
    T.post <- pmax(0, d[1,"sfn.struct.h20"] + zeta - d[1,"sfr"] + par.calibrated["disc.tokurei"] * d[1,"tokureisai"] + subsidy) - subsidy + par.calibrated["disc.santei.h20"] * d[1,"santei.h20"]
    T.post.single <- pmax(0, d.single[,"sfn.struct.h20"] + zeta.single - d.single[,"sfr"] + subsidy.single) - subsidy.single
 
       return(c(pre=T.pre, post=T.post, pop=d[1,"pop"]/2, sfn.struct=d[1,"sfn.struct.h13"]+zeta, single.h13=d.single[,"sfn.struct.h13"] + zeta.single, single.h20=d.single[,"sfn.struct.h20"] + zeta.single, toku=par.calibrated["disc.tokurei"]*d[1,"tokureisai"], santei=par.calibrated["disc.santei.h20"] * d[1,"santei.h20"], pre.single=T.pre.single, post.single=T.post.single))
}

library("sp")
out <- t(sapply(row.names(df.h13), calc.merger))



ylab <- expression(paste("Fraction of ", tilde(c)))

library("lattice")

fname <- paste(proj.home, "carrot_actual.pdf", sep="")
pdf(file=fname)
xyplot(I((out[,2] - out[,1])/out[,4]) ~ out[,3], scales=list(x=list(log=TRUE)), pch=".", xlab="Population", ylab=ylab, ylim=c(-0.095, .295))
dev.off()

fname <- paste(proj.home, "carrot_actual_bw.pdf", sep="")
pdf(file=fname)
xyplot(I((out[,2] - out[,1])/out[,4]) ~ out[,3], scales=list(x=list(log=TRUE)), pch=".", xlab="Population", ylab=ylab, ylim=c(-0.095, .295), col="black")
dev.off()

fname <- paste(proj.home, "stick_actual.pdf", sep="")
pdf(file=fname)
xyplot(I((out[,6] - out[,5])/out[,5]) ~ out[,3], scales=list(x=list(log=TRUE)), xlab="Population", ylab=ylab, pch=".")
dev.off()

fname <- paste(proj.home, "stick_actual_bw.pdf", sep="")
pdf(file=fname)
xyplot(I((out[,6] - out[,5])/out[,5]) ~ out[,3], scales=list(x=list(log=TRUE)), xlab="Population", ylab=ylab, pch=".", col="black")
dev.off()

#xyplot(I((d[use,"sfn.struct.h13"] + d[use,"sfn.subsidy"] + d[use,"sfn.idio"])/d[use,"pop"]) ~ d[use,"pop"], scales=list(x=list(log=TRUE)), xlab="Population", ylab="Cost per capita (¥100,000)", pch=".")

d.l <- lapply(row.names(df.h13), calc.dat)
d <- do.call("rbind", d.l)
use <- !(row.names(d) %in% as.character(13101:13123))

fname <- paste(proj.home, "cost_govest.pdf", sep="")
pdf(file=fname)
xyplot(I((d[use,"sfn.struct.h13"] + d[use,"sfn.idio"])/d[use,"pop"]) ~ d[use,"pop"], scales=list(x=list(log=TRUE)), xlab="Population", ylab="Cost per capita (¥100,000)", pch=".")
dev.off()

fname <- paste(proj.home, "cost_govest_bw.pdf", sep="")
pdf(file=fname)
xyplot(I((d[use,"sfn.struct.h13"] + d[use,"sfn.idio"])/d[use,"pop"]) ~ d[use,"pop"], scales=list(x=list(log=TRUE)), xlab="Population", ylab="Cost per capita (¥100,000)", pch=".", col="black")
dev.off()
