# pairs.R
# Provides Figure 20 and results discussed in 5.2 and F.2

proj.home <- "/home/fas/weese/egw5/japan_qe/"
proj.tmp <- "/home/fas/weese/egw5/scratch/japan_qe/"
prefs <- 1:47

tmp.l <- list()
p <- 1
for(p in prefs) {
#    fname <- paste(proj.tmp, "opt_out5_ninv.RData", sep="")
    fname <- paste(proj.tmp, "opt_out5_ninv_", p, ".RData", sep="")
#    fname <- paste(proj.tmp, "opt_out5_fullcorr_", p, ".RData", sep="")
#    fname <- paste(proj.tmp, "opt_out5_actual_", p, ".RData", sep="")
#    fname <- paste(proj.tmp, "opt_out5_b34_", p, ".RData", sep="")
#    fname <- paste(proj.tmp, "opt_out5_equal_", p, ".RData", sep="")
#    fname <- paste(proj.tmp, "opt_out5_nodist_", p, ".RData", sep="")
    load(fname)
    tmp.l[[p]] <- opt.out
}
out.tmp.l <- unlist(tmp.l, recursive=FALSE)
use <- sapply(out.tmp.l, length) == 11
sum(!use)/length(use) # a few failures?
out.l <- out.tmp.l[use]

inc <- t(sapply(out.l, function(x) pmax(100, 100000*x$incentive[,1]/sum(x$pop))))
colnames(inc) <- c("optimal", "actual")
#zero <- apply(inc == 1, 1, any)
zero <- apply(inc == 100, 1, any)
lim <- c(min(inc) * 0.95, max(inc) * 1.05)
force <- sapply(out.l, function(x) x$force)

library("lattice")
fname <- paste(proj.tmp, "plot_", as.integer(Sys.time()), ".pdf", sep="")
pdf(file=fname, onefile=FALSE)

xyplot(inc[,"actual"] ~ inc[,"optimal"], pch=".", abline = c(0, 1), groups=force,
       scales=list(x=list(log=TRUE), y=list(log=TRUE)),
       xlim=lim, ylim=lim,
       xlab="Optimal merger incentive (¥ per capita)",
       ylab="Actual merger incentive (¥ per capita)")

print(fname)
dev.off()

reg.out <- lm(I(inc[!zero,"actual"]/inc[!zero,"optimal"]) ~ 1)
reg.out <- lm(I(log(inc[!zero,"optimal"]) - log(inc[!zero,"actual"])) ~ 1)

reg.out <- lm(I(inc[!(zero|force),"actual"]/inc[!(zero|force),"optimal"]) ~ 1)
reg.out <- lm(I(log(inc[!(zero|force),"optimal"]) - log(inc[!(zero|force),"actual"])) ~ 1)


force <- t(sapply(out.l, function(x) c(x$prob["centralized",], x$force)))
#sum(force[,2]==0)
sum(force[,2])
sum(force[,1])
sum(force[,2] & !force[,1])

#prob.tmp <- t(sapply(out.l, function(x) x$prob[c("sb","afrac"),]))
prob <- do.call("rbind", lapply(out.l, function(x) t(x$prob)))
rownames(prob) <- NULL
prob.nona <- prob[!apply(is.na(prob), 1, any),]
dim(prob)
dim(prob.nona)
colSums(prob.nona)

#val <- t(sapply(out.l, function(x) x$val[c("sb","afrac"),]*sum(x$pop)))
val <- do.call("rbind", lapply(out.l, function(x) t(x$val)*sum(x$pop)))
rownames(val) <- NULL
s.nan <- is.nan(val[,"social"])
val[s.nan,"social"] <- val[s.nan,"centralized"]
val.nona <- val[!apply(is.na(val), 1, any),]
dim(val)
dim(val.nona)
colSums(val.nona)

sb.inc <- sapply(out.l, function(x) x$incentive["sb",2])
actual.inc <- sapply(out.l, function(x) x$incentive["actual",3])


use.small <- sapply(out.l, function(x) all(x$pop > 2500 & x$pop < 5000))
out.small <- out.l[use.small]
out.small[10:20]
T.initial <- sapply(out.small, function(x) sum(x$pop * x$par["actualh13",2:3])/sum(x$pop))
T.merged <- sapply(out.small, function(x) x$par["actualh13",1])

