#sqCreateScript -q fas_devel -n 1 7_parts.task | qsub

options(echo=TRUE)
p <- as.numeric(commandArgs(trailingOnly=TRUE))
p

library("igraph0") #legacy ZERO-BASED INDEXING
library("bigmemory")
options(bigmemory.typecast.warning=FALSE)
load(paste(proj.home, "pgraph.RData", sep=""))
p.graph <- p.graph.l[[p]]
nmuni <- vcount(p.graph.l[[p]])
coal.l <- list()
coal.l[[1]] <- as.big.matrix(matrix((1:nmuni) - 1, ncol=1), type="short", shared=FALSE)
coal.l[[2]] <- as.big.matrix(t(sapply(as.list(0:(ecount(p.graph)-1)), function(x) get.edge(p.graph, x))), type="short")
for (size in 3:16) {
  fname <- paste(proj.tmp, p, "/", size, "_long.csv", sep="")
  f.bytes <- file.info(fname)[,"size"]
  if(is.na(f.bytes)) stop("missing file")
  coal.l[[size]] <- if(f.bytes == 0) NULL else read.big.matrix(fname, type="short", shared=FALSE)
}
sum(sapply(coal.l, length)) * 2
ncoal <- sapply(coal.l, nrow)

load(paste(proj.home, "gappei.RData", sep=""))
mergers.p <- sapply(mergers.l, function(x) if(as.numeric(x[1]) > p*1000 & as.numeric(x[1]) < (p+1)*1000) TRUE else FALSE) #sole prefecture-switcher is not first
mergers.igraphn <- lapply(mergers.l[mergers.p], function(x) V(p.graph)[label %in% x])
merger.munis <- unlist(mergers.l[mergers.p])
all.munis <- V(p.graph)$label

sizes <- which(!sapply(coal.l, is.null))

coal.len <- rep(sizes, ncoal[sizes])
dyn.load(paste(proj.home, "parts.so", sep=""))
coal.addr.l <- lapply(coal.l, function(x) x@address)

load(paste(proj.home, "shp.RData", sep=""))
