options(echo=TRUE)
proj.home <- "/home/fas/weese/egw5/japan_qe_final/"

library("maptools")
load(paste(proj.home, "shp.RData", sep=""))

library("gpclib")
gpclibPermit()

load(paste(proj.home, "pgraph.RData", sep=""))

merger.str <- apply(shp@data, 1, paste, collapse="、")
for(mname in names(mergers.l))
    merger.str[mergers.l[[mname]]] <- mname

shp.merged.tmp <- unionSpatialPolygons(shp, merger.str)

unique.dat <- t(simplify2array(strsplit(names(shp.merged.tmp), split="、")))
colnames(unique.dat) <- c("pref", "county", "muni")
rownames(unique.dat) <- names(shp.merged.tmp)

shp.merged <- SpatialPolygonsDataFrame(shp.merged.tmp, data=data.frame(unique.dat))

writeSpatialShape(shp, paste(proj.home, "shp_base", sep=""))
writeSpatialShape(shp.merged, paste(proj.home, "shp_merged", sep=""))

pref.str <- shp@data[,"pref"]
pref.tmp <- unionSpatialPolygons(shp, pref.str)
unique.dat <- data.frame(pref=names(pref.tmp))
rownames(unique.dat) <- names(pref.tmp)

pref.shp <- SpatialPolygonsDataFrame(pref.tmp, data=unique.dat)
writeSpatialShape(pref.shp, paste(proj.home, "pref", sep=""))
