
proj.home <- "/home2/egw5/japan_restud/"
dname <- paste(proj.home, "sinfonica", sep="")
var.names <- character(0)
var.names["A1101"] <- "pop"
var.names["A1801"] <- "pop.city" #not clear what this is the right variable for...
var.names["A1303"] <- "pop.over65"
var.names["A1417"] <- "pop.over70"
var.names["C2206"] <- "pop.primary"
var.names["F2301"] <- "employees.farming"
var.names["F2302"] <- "employees.forestry"
var.names["F2303"] <- "employees.fishing"
var.names["F2304"] <- "employees.mining"
var.names["C3125"] <- "pop.fishermen" #missing - prefecture only?
var.names["B1101"] <- "area"
var.names["H9201"] <- "area.parks"
var.names["A7101"] <- "families"
var.names["C310201"] <- "families.farm.commercial"
var.names["C310202"] <- "families.farm.personal"
var.names["H7112"] <- "road.length"
var.names["H7142"] <- "road.width" #missing - prefecture only?
var.names["E1502"] <- "students.nursery"
var.names["E250102"] <- "students.elementary"
var.names["E350101"] <- "students.middle"
var.names["E2301"] <- "classes.elementary" #missing - prefecture only?
var.names["E3301"] <- "classes.middle" #missing - prefecture only?
var.names["E210102"] <- "schools.elementary"
var.names["E310102"] <- "schools.middle"
var.names["C1201"] <- "income"
var.names["C120110"] <- "taxable.income"
var.names["C120120"] <- "tax.payers"
var.names["D2205"] <- "sfr"
var.names["D2206"] <- "sfn"
#var.names[sinfonica$variable == "D320410"] <- "savings"  #savings this year - not useful...
var.names["D3205"] <- "debt"

parse.sinfonica <- function(fname) {
  tmp <- readLines(fname)
  tmp.sub <- substr(tmp, 1, 5)
  if(!all(tmp.sub == "ZA05H")) stop("format error (1)")
  tmp.sub <- substr(tmp, 6, 10)
  if(!all(tmp.sub == "     ")) stop("format error (2)")
  tmp.sub <- substr(tmp, 11, 20)
  variable <- sub(' +$', '', tmp.sub)  # cut trailing spaces
  if(max(nchar(variable)) > 9) stop("no white space at end of variable name")
  year <- substr(tmp, 21, 24)
  tmp.sub <- substr(tmp, 25, 25)
  if(!all(tmp.sub == " ")) stop("format error (3)")
  jis.pref <- substr(tmp, 26, 27)
  tmp.sub <- substr(tmp, 28, 28)
  if(!all(tmp.sub == " ")) stop("format error (4)")
  jis.shichouson <- substr(tmp, 29, 31)
  tmp.sub <- substr(tmp, 32, 46)
  value.char <- sub('^ +', '', tmp.sub)  # cut leading spaces
  if(max(nchar(value.char)) > 14) stop("no white space at beginning of value")
  value.char[value.char == "-" | value.char == "+"] <- NA
  value <- as.numeric(value.char)
  tmp.sub <- substr(tmp, 47, 48)
  units.char <- sub('^ +', '', tmp.sub)  # cut leading spaces
  if(max(nchar(units.char)) > 1) stop("no white space at beginning of units")
  units <- as.numeric(units.char)
  tmp.sub <- substr(tmp, 49, 49)
  if(!all(tmp.sub == " ")) stop("format error (5)")
  unknown <- substr(tmp, 50, 52)
  tmp.sub <- substr(tmp, 53, 56)
  if(!all(tmp.sub == "    ")) stop("format error (6)")
  idx <- as.numeric(substr(tmp, 57, 60))
  tmp.sub <- substr(tmp, 61, 64)
  if(!all(tmp.sub == "    ")) stop("format error (7)")
  ret <- data.frame(variable=variable, year=year, jis.pref=jis.pref, jis.shichouson=jis.shichouson, value=value, units=units, unknown=unknown, idx=idx,
                    row.names=NULL, stringsAsFactors=FALSE)
  return(ret)
}

fnames <- list.files(dname, pattern="ZA05H...TXT", full.names=TRUE)
names(fnames) <- list.files(dname, pattern="ZA05H...TXT")
tmp.l <- lapply(as.list(fnames), parse.sinfonica)
tmp2.l <- lapply(tmp.l, function(x) x[x[,"variable"] %in% names(var.names),])
rm(tmp.l)

sinfonica <- do.call("rbind", tmp2.l)
rm(tmp2.l)

fname <- paste(dname, "/ZA05H.RData", sep="")
save(sinfonica, file=fname)

#pop <- sinfonica[sinfonica$variable == "A2101",]
#save(pop, file="/home2/egw5/sinfonica/pop.RData")
#load("/home2/egw5/sinfonica/pop.RData")

sinfonica$jis <- paste(sinfonica$jis.pref, sinfonica$jis.shichouson, sep="")

sinfonica$var.name <- var.names[sinfonica[,"variable"]]

dim.names <- list(year=sort(unique(sinfonica$year)), jis=sort(unique(sinfonica$jis)), var=unique(sinfonica$var.name))
d <- array(NA, sapply(dim.names, length), dimnames=dim.names)

year <- match(sinfonica$year, dim.names[["year"]])
jis <- match(sinfonica$jis, dim.names[["jis"]])
var <- match(sinfonica$var.name, dim.names[["var"]])

d[cbind(year, jis, var)] <- sinfonica$value

#income <- d["1996", , c("taxable.income", "tax.payers", "area")]
#save(income, file="/home2/egw5/sinfonica/income.RData")

fname <- paste(proj.home, "shp.RData", sep="")
load(fname)

dimnames(d)[[2]][dimnames(d)[[2]] == "01301"] <- "9901301"
dimnames(d)[[2]][dimnames(d)[[2]] == "01234"] <- "01301"     # 広島町
dimnames(d)[[2]][dimnames(d)[[2]] == "01302"] <- "9901302"
dimnames(d)[[2]][dimnames(d)[[2]] == "01235"] <- "01302"     # 石狩町
dimnames(d)[[2]][dimnames(d)[[2]] == "11466"] <- "9911466"
dimnames(d)[[2]][dimnames(d)[[2]] == "11243"] <- "11466"     # 吉川町
dimnames(d)[[2]][dimnames(d)[[2]] == "12327"] <- "9912327"
dimnames(d)[[2]][dimnames(d)[[2]] == "12231"] <- "12327"     # 印西町
dimnames(d)[[2]][dimnames(d)[[2]] == "26342"] <- "9926342"
dimnames(d)[[2]][dimnames(d)[[2]] == "26211"] <- "26342"     # 田辺町
dimnames(d)[[2]][dimnames(d)[[2]] == "40347"] <- "9940347"
dimnames(d)[[2]][dimnames(d)[[2]] == "40223"] <- "40347"     # 古賀町

use.rows <- as.character(as.numeric(dimnames(d)[[2]])) %in% rownames(shp@data)
stopifnot(sum(use.rows) == nrow(shp@data))

cols.a <- c("pop","pop.over65","pop.over70","pop.city","families")
cols.b <- c("families.farm.commercial","families.farm.personal")
cols.c <- c("employees.forestry", "employees.fishing", "employees.mining")
cols.d <- c("area", "students.nursery", "students.elementary", "students.middle", "schools.elementary", "schools.middle", "road.length", "area.parks", "sfr", "sfn")

d.tmp <- cbind(d["2000", use.rows, cols.a],
               d["1999", use.rows, cols.b],
               d["2000", use.rows, cols.c],
               d["2001", use.rows, cols.d])

missing.a <- is.na(d.tmp[,"pop"])
missing.a["13381"] <- TRUE #volcano eruption
stopifnot(!is.na(d.tmp[!missing.a, "pop.over65"]))
stopifnot(!is.na(d.tmp[!missing.a, "pop.over70"]))
# stopifnot(!is.na(d.tmp[!missing.a, "pop.city"]))  # presumably the NAs here mean zero?
stopifnot(!is.na(d.tmp[!missing.a, "families"]))
d.tmp[names(which(missing.a)), cols.a] <- d["1995", names(which(missing.a)), cols.a]

missing.b <- is.na(d.tmp[,"families.farm.commercial"])
# do the NAs here just mean zero??

missing.c <- is.na(d.tmp[,"employees.forestry"])
missing.c["13381"] <- TRUE
stopifnot(!is.na(d.tmp[!missing.c, "employees.fishing"]))
stopifnot(!is.na(d.tmp[!missing.c, "employees.mining"]))
d.tmp[names(which(missing.c)), cols.c] <- d["1995", names(which(missing.c)), cols.c]

missing.d <- is.na(d.tmp[,"area"])
missing.d["13381"] <- TRUE
stopifnot(!is.na(d.tmp[!missing.d, "students.nursery"]))
stopifnot(!is.na(d.tmp[!missing.d, "students.elementary"]))
stopifnot(!is.na(d.tmp[!missing.d, "students.middle"]))
stopifnot(!is.na(d.tmp[!missing.d, "schools.elementary"]))
stopifnot(!is.na(d.tmp[!missing.d, "schools.middle"]))
stopifnot(!is.na(d.tmp[!missing.d, "road.length"]))
d.tmp[names(which(missing.d)), cols.d] <- d["1995", names(which(missing.d)), cols.d]

cols.d2 <- c("sfn", "sfr", "area.parks")
missing.d2 <- is.na(d.tmp[,"sfn"])
missing.d2["13381"] <- TRUE
stopifnot(!is.na(d.tmp[!missing.d2, "sfr"]))
## stopifnot(!is.na(d.tmp[!missing.d2, "area.parks"]))  # presume again that the NAs are zeros?
d.tmp[names(which(missing.d2)), cols.d2] <- d["1998", names(which(missing.d2)), cols.d2]

d.tmp[is.na(d.tmp[,"pop.city"]), "pop.city"] <- 0
d.tmp[is.na(d.tmp[,"families.farm.commercial"]), "families.farm.commercial"] <- 0
d.tmp[is.na(d.tmp[,"families.farm.personal"]), "families.farm.personal"] <- 0
d.tmp[is.na(d.tmp[,"students.nursery"]), "students.nursery"] <- 0
d.tmp[is.na(d.tmp[,"area.parks"]), "area.parks"] <- 0

## for the tokubetsuku, the earliest year available is H16, and that's missing in the data for some reason, so input manually
d.tmp["13101", c("sfr", "sfn")] <- c(20367098, 23907970)
d.tmp["13102", c("sfr", "sfn")] <- c(21471954, 33332865)
d.tmp["13103", c("sfr", "sfn")] <- c(54365509, 47331694)
d.tmp["13104", c("sfr", "sfn")] <- c(41779609, 63364876)
d.tmp["13105", c("sfr", "sfn")] <- c(27452063, 40812169)
d.tmp["13106", c("sfr", "sfn")] <- c(19105087, 44071364)
d.tmp["13107", c("sfr", "sfn")] <- c(18090216, 54500337)
d.tmp["13108", c("sfr", "sfn")] <- c(32363545, 78360023)
d.tmp["13109", c("sfr", "sfn")] <- c(36692446, 69623317)
d.tmp["13110", c("sfr", "sfn")] <- c(39071584, 51483476)
d.tmp["13111", c("sfr", "sfn")] <- c(66743523, 124065140)
d.tmp["13112", c("sfr", "sfn")] <- c(110229630, 130355815)
d.tmp["13113", c("sfr", "sfn")] <- c(46543156, 41969606)
d.tmp["13114", c("sfr", "sfn")] <- c(29926787, 58186221)
d.tmp["13115", c("sfr", "sfn")] <- c(60067808, 88838090)
d.tmp["13116", c("sfr", "sfn")] <- c(27461818, 51766086)
d.tmp["13117", c("sfr", "sfn")] <- c(24694833, 71550414)
d.tmp["13118", c("sfr", "sfn")] <- c(13665020, 48645989)
d.tmp["13119", c("sfr", "sfn")] <- c(41502557, 98199667)
d.tmp["13120", c("sfr", "sfn")] <- c(59974693, 124690126)
d.tmp["13121", c("sfr", "sfn")] <- c(42206870, 133960488)
d.tmp["13122", c("sfr", "sfn")] <- c(29652787, 89240392)
d.tmp["13123", c("sfr", "sfn")] <- c(46536292, 121451867)

stopifnot(!apply(d.tmp, 1:2, is.na))

d.h13 <- d.tmp

fname <- paste(dname, "h13.RData", sep="/")
save(d.h13, file=fname)
               
#sfn <- d["2003",,"sfn"]
               
#lot.area <- sinfonica[sinfonica$variable == "H2140",]
#lot.area[lot.area$jis.pref == "01" & lot.area$jis.shichouson == 209,]


#load("/home2/egw5/scratch/soumushou/H13.RData")


#load
