proj.home <- "/home2/egw5/japan_restud/"
s.dir <- "/home2/egw5/scratch/soumushou/"
## years <- dir(s.dir, pattern="[SH][0-9]+$")
#years <- c("H13", "H14", "H15", "H16", "H17", "H18", "H19", "H2", "H3",  "H4",  "H5",  "H6",  "H7",  "H8")
years <- c("H9")

do.tmp <- function(first, last, in.mat) {
  mat <- in.mat[first:last,]
  nona <- mat[,!apply(mat, 2, function(x) all(is.na(x)))]
  colnames(nona) <- nona[1,]
  ret <- as.matrix(nona[-1,])
}

do.file <- function(fname) {
    tmp <- read.csv(fname, header=FALSE, fileEncoding="SHIFT_JISX0213", encoding="UTF-8", stringsAsFactors=FALSE)
    breaks <- which(tmp[,1] == "決算年度")
    ## break.mat <- cbind(first=breaks, last=c(breaks[-1] - 1, nrow(tmp)))
    ## ret1.l <- apply(break.mat, 1, do.tmp)
    ret <- mapply(do.tmp, as.list(breaks), as.list(c(breaks[-1] - 1, nrow(tmp))), MoreArgs=list(in.mat=tmp), SIMPLIFY=FALSE)
    return(ret)
}

for (year in years) {
  y.dir <- paste(s.dir, year, "/", sep="")

  tmp <- dir(y.dir, pattern="基金残高", full.names=TRUE)
  dname <- dir(tmp, full.names=TRUE)
  stopifnot(length(dname) == 1)
  ##fnames <- system(paste("ls ", dname, "*.txt", sep=""), intern=TRUE)
  fnames <- list.files(dname, full.names=TRUE)
  ret.ll <- list()
  for(fname in fnames)
    ret.ll[[fname]] <- do.file(fname)

  ##fname <- paste(s.dir, "H9/H9　基金残高（２９表）/A0010_1997_61_29/A0010199761291200.txt", sep="")
  ##tmp <- read.csv(fname, header=FALSE, fileEncoding="SHIFT_JISX0213", encoding="UTF-8", stringsAsFactors=FALSE)
  ##breaks <- which(tmp[,1] == "決算年度")
  ##ret2.l <- mapply(do.tmp, as.list(breaks), as.list(c(breaks[-1] - 1, nrow(tmp))), MoreArgs=list(in.mat=tmp), SIMPLIFY=FALSE)
  ##ret.l <- c(ret1.l, ret2.l)
  ret.l <- do.call("c", ret.ll)
  cnames <- sapply(ret.l, colnames)
  if(year == "H13") { #not clear what's going on here...
    cnames[19,5] <- "009:その他特定目的基金・13年度末現在高"
    cnames[21,5] <- "011:その他定額運用基金・13年度末現在高"
  }
  stopifnot(cnames==cnames[,1])  #a couple of mis
  jis <- ret.l[[1]][,3]
  varnames <- sapply(ret.l, function(x) x[1,10])
  dnames <- list(jis, cnames[11:nrow(cnames),1], varnames)  #was previously :21
  ##ret.arr <- array(NA, dim=c(breaks[2] - 2, 11, length(ret.l)))
  ret.arr <- array(NA, dim=sapply(dnames, length), dimnames=dnames)
  for(i in 1:length(ret.l))
    ret.arr[,,i] <- as.numeric(ret.l[[i]][,11:nrow(cnames)])
  kikin <- ret.arr

  tmp <- dir(y.dir, pattern="寄付金", full.names=TRUE)
  dname <- dir(tmp, full.names=TRUE)
  stopifnot(length(dname) == 1)
  fnames <- list.files(dname, full.names=TRUE)
  ret.ll <- list()
  for(fname in fnames)
    ret.ll[[fname]] <- do.file(fname)
  ret.l <- do.call("c", ret.ll)
  sainyuu <- cbind(ret.l[[1]][,11:ncol(ret.l[[1]])], ret.l[[2]][,11:ncol(ret.l[[2]])])  #was previously :61 and :55
  rownames(sainyuu) <- ret.l[[1]][,3]
  storage.mode(sainyuu) <- "numeric"

  tmp <- dir(y.dir, pattern="歳入歳出", full.names=TRUE)
  dname <- dir(tmp, full.names=TRUE)
  stopifnot(length(dname) == 1)
  fnames <- list.files(dname, full.names=TRUE)
  ret.ll <- list()
  for(fname in fnames)
    ret.ll[[fname]] <- do.file(fname)
  ret.l <- do.call("c", ret.ll)  # the second entry is for the previous year, it seems
  nyuushutsu <- ret.l[[1]][,11:ncol(ret.l[[1]])] #was previously :20
  rownames(nyuushutsu) <- ret.l[[1]][,3]
  storage.mode(nyuushutsu) <- "numeric"

  do.row <- function(fname) {
    tmp <- read.csv(fname, header=FALSE, fileEncoding="SHIFT_JISX0213", encoding="UTF-8", stringsAsFactors=FALSE)
    breaks <- which(tmp[,1] == "決算年度")
    return(mapply(do.tmp, as.list(breaks), as.list(c(breaks[-1] - 1, nrow(tmp))), MoreArgs=list(in.mat=tmp), SIMPLIFY=FALSE))
  }

  subdirs <- c("/7表/", "/8表/", "/9表/", "/10表/", "/11表/", "/12表/", "/13表/")
  tmp <- dir(y.dir, pattern="７～１３表", full.names=TRUE)
  tmp2 <- paste(tmp, subdirs, sep="")  #should put things in the correct order
  dnames <- sapply(as.list(tmp2), function(d) system(paste("ls -d ", d, "*/", sep=""), intern=TRUE))  #keeps things in the "right" order
  fnames <- lapply(as.list(dnames), function(fn) system(paste("ls ", fn, "*.txt", sep=""), intern=TRUE)) #"
  row.out <- lapply(fnames, function(x) unlist(Vectorize(do.row, SIMPLIFY=FALSE)(x), recursive=FALSE))

  get.cnames <- function(row.e) {
    ##row.e <- unlist(tmp, recursive=FALSE)
    cnames <- sapply(row.e, colnames)
    stopifnot(cnames == cnames[,1])
    return(cnames[,1])
  }
  row.cnames <- lapply(row.out, get.cnames)
  row.cnames.first10 <- sapply(row.cnames, function(x) x[1:10])
  stopifnot(row.cnames.first10[,1] == row.cnames.first10)
  row.cnames.use <- unlist(lapply(row.cnames, function(x) x[-(1:10)]))

  col.cnames.base <- lapply(row.out, function(row.e) sapply(row.e, function(x) unique(x[,10])))
  
  col.cnames <-  #FIXME:  these are not unique
    c("一　人件費", "うち職員給",
      "二　物件費",
      "三　維持補修費",
      "四　扶助費",
      "五　補助費等", "１　国に対するもの", "２　都道府県に対するもの", "３　同級他団体に対するもの", "４　一部事務組合に対するもの", "５　その他に対するもの",
      "六　普通建設事業費", "１　補助事業費", "２　単独事業費", "３　国直轄事業負担金", "４　県営事業負担金", "５　同級他団体施行事業負担金", "６　受託事業費", "（１） 補助事業費", "（２） 単独事業費",
      "七　災害復旧事業費", "１　補助事業費", "２　単独事業費", "３　県営事業負担金", "４　同級他団体施行事業負担金", "５　受託事業費", "（１）　補助事業費", "（２）　単独事業費",
      "八　失業対策事業費", "１　補助事業費", "２　単独事業費",
      "九　公債費",
      "十　積立金",
      "十一　投資及び出資金",
      "十二　貸付金",
      "十三　繰出金",
      "十四　前年度繰上充用金",
      "歳出合計", "国庫支出金", "都道府県支出金", "使用料・手数料",  "分担金・負担金・寄附金", "財産収入", "繰入金", "諸収入", "繰越金", "地方債",
      "一般財源等", "うち投資的経費充当の一般財源等",
      "歳入振替項目", "歳計剰余金又は翌年度歳入繰上充用金", "歳入合計")

  
  nrows.tmp <- sapply(row.out, function(x) dim(x[[1]]))[1,]
  nrows <- unique(c(nrows.tmp))
  stopifnot(length(nrows)==1)
  dnames <- list(row.out[[1]][[1]][,3], row.cnames.use, col.cnames)
  cross <- array(NA, dim=c(nrows, length(row.cnames.use), length(col.cnames)), dimnames=dnames)

  ##row.l <- apply(row.out, 2, unlist, recursive=FALSE)
  cols.l <- list(c(1:20, 33:36, 38:49),
                 c(1:20, 33:36, 38:49),
                 c(1:20, 29:31, 33:36, 38:49),
                 c(1:20, 29:30, 33:36, 38:49),
                 c(1:20, 33:36, 38:49),
                 c(1:3, 6:28, 32:49),
                 c(1:38, 50:52))

  ##rbind(col.cnames[cols.l[[6]]], col.cnames.base[[6]])

  col.end <- 0
  for(j in 1:length(cols.l)) {
    col.start <- col.end + 1
    col.end <- col.start - 1 + ncol(row.out[[j]][[1]]) - 10
    col.num <- col.end - col.start + 1
    cross.tmp <- cross[, col.start:col.end, cols.l[[j]]]
    for(i in 1:(dim(cross.tmp)[3]))
      cross.tmp[, 1:col.num, i] <- row.out[[j]][[i]][,-(1:10)]
    cross[, col.start:col.end, cols.l[[j]]] <- cross.tmp
  }

  storage.mode(cross) <- "numeric"

  fname <- list.files(y.dir, pattern=".+\\.txt", full.names=TRUE)
  if (length(fname) == 1) {
    tmp <- read.csv(fname, fileEncoding="SHIFT_JISX0213", encoding="UTF-8", stringsAsFactors=FALSE)
    general <- tmp[,1:44] # 45:100 seem to be totally unused
  } else general <- row.out[[1]][[1]][,1:6]

  fname <- paste(s.dir, year, ".RData", sep="")
  save(general, kikin, sainyuu, nyuushutsu, cross, file=fname)
}
