## echo "R CMD REMOVE igraph; R CMD INSTALL /home2/egw5/japan_restud/igraph_weese" | qsub -q fas_devel
## takes less than 10 min on 1 cpu
## Rscript --verbose /home2/egw5/japan_restud/5_subgraphs.R 1
## ..
## Rscript --verbose /home2/egw5/japan_restud/5_subgraphs.R 47
## takes about 1 hr on 32 cpus (Hokkaido size 16 may not have finished)
## cd /home2/egw5/scratch/japan_restud/1; perl -F, -lane 'print join ",", sort {$a <=> $b} @F' < 3.csv > 3_tmp.csv
## ..
## cd /home2/egw5/scratch/japan_restud/1; perl -F, -lane 'print join ",", sort {$a <=> $b} @F' < 12.csv > 12_tmp.csv
## takes about 30 min on 32 cpus

options(echo=TRUE)
proj.home <- "/home2/egw5/japan_restud/"
proj.tmp <- "/home2/egw5/scratch/japan_restud/"
p <- as.numeric(commandArgs(trailingOnly=TRUE))
p

#remove.packages("igraph")
#install.packages(paste(proj.home, "igraph_weese", sep=""), repos=NULL)
##install.packages("/home2/egw5/japan_restud/igraph_old", repos=NULL)



library("maptools")
load(paste(proj.home, "shp.RData", sep=""))
load(paste(proj.home, "pgraph.RData", sep=""))
source(paste(proj.home, "meiji_east.R", sep="")) #1878 county borders
source(paste(proj.home, "meiji_west.R", sep="")) #1896 county borders
shp@data$meiji <- shp@data$county
stopifnot(all(names(meiji) %in% row.names(shp@data)))
shp@data[names(meiji), "meiji"] <- meiji

library("igraph")  #ONE-BASED INDEXING
p.graph <- p.graph.l[[p]]
mergers.p <- sapply(mergers.l, function(x) if(as.numeric(x[1]) > p*1000 & as.numeric(x[1]) < (p+1)*1000) TRUE else FALSE)
counties <- as.numeric(as.factor(shp@data[V(p.graph)$name, "meiji"])) - 1

num.subgraphs <- vector("numeric", 16)
num.subgraphs[1] <- vcount(p.graph)
num.subgraphs[2] <- ecount(p.graph)
for (size in 3:16) {
  fname <- paste(proj.tmp, p, "/", size, ".csv", sep="")
  ## FIXME:  need to deal with Tokyo correctly given the new function
  #sample <- V(p.graph)
  #if(p == 13) sample <- V(p.graph)[which(shp@data[V(p.graph)$label, "meiji"] != "特別区部") - 1] #eliminate special ward area

  max.counties <- 3 #Nagano causes problems because of the large counties, Tokyo also (but later on)
  if(p == 20) max.counties <- 2 else if (p == 13) max.counties <- 1
  num.subgraphs[size] <- graph.motifs.get(p.graph, size=size, counties=counties, file=fname, max.counties=max.counties)
}
num.subgraphs
