# seq 1 47 | perl -ne 'chomp($p=$_); print "Rscript --verbose /home2/egw5/japan_qc/subgraphs_lengthen.R ", $p, "\n"' > subgraphs_lengthen.task1
# sqCreateScript -q fas_high -w 168:00:00 -n 4 subgraphs_lengthen.task1 | qsub
# unclear how long this takes

# bash -O extglob -c " cd /home2/egw5/scratch/japan_restud/1; sort -S 10% -n -t ',' -k 1,1 -k 2,2 -k 3,3 -o 3_long.csv 3_+(tmp|merger*).csv "
# ..
# bash -O extglob -c " cd /home2/egw5/scratch/japan_restud/1; sort -S 10% -n -t ',' -k 1,1 -k 2,2 -k 3,3 -k 4,4 -k 5,5 -k 6,6 -k 7,7 -k 8,8 -k 9,9 -k 10,10 -k 11,11 -k 12,12 -o 12_long.csv 12_+(tmp|merger*).csv "
# ..
# takes more than 1 hr on 32 cpus

options(echo=TRUE)
proj.home <- "/home2/egw5/japan_restud/"
proj.tmp <- "/home2/egw5/scratch/japan_restud/"
p <- as.numeric(commandArgs(trailingOnly=TRUE))
p

library("igraph0") #legacy ZERO-BASED INDEXING
library("bigmemory")
options(bigmemory.typecast.warning=FALSE)
load(paste(proj.home, "shp.RData", sep=""))
load(paste(proj.home, "gappei.RData", sep=""))
load(paste(proj.home, "pgraph.RData", sep=""))
p.graph <- p.graph.l[[p]]
nmuni <- vcount(p.graph.l[[p]])
coal.l <- list()
coal.l[[1]] <- as.big.matrix(matrix((1:nmuni) - 1, ncol=1), type="short", shared=FALSE)
coal.l[[2]] <- as.big.matrix(t(sapply(as.list((1:ecount(p.graph))-1), function(x) get.edge(p.graph, x))), type="short", shared=FALSE)
for (size in 3:16) {
  fname <- paste(proj.tmp, p, "/", size, "_tmp.csv", sep="")
  f.bytes <- file.info(fname)[,"size"]
  if(is.na(f.bytes)) stop("missing file")
  coal.l[[size]] <- if(f.bytes == 0) NULL else read.big.matrix(fname, type="short", shared=FALSE)
}
sum(sapply(coal.l, length)) * 2
ncoal <- sapply(coal.l, nrow)

mergers.p <- sapply(mergers.l, function(x) if(as.numeric(x[1]) > p*1000 & as.numeric(x[1]) < (p+1)*1000) TRUE else FALSE) #sole prefecture-switcher is not first
mergers.igraphn <- lapply(mergers.l[mergers.p], function(x) V(p.graph)[x])
merger.munis <- unlist(mergers.l[mergers.p])
all.munis <- V(p.graph)$name

nonmerger.munis <- setdiff(all.munis, merger.munis)
nonmerger.igraphn <- lapply(nonmerger.munis, function(x) V(p.graph)[x])
names(nonmerger.igraphn) <- paste(shp@data[nonmerger.munis, "pref"], shp@data[nonmerger.munis, "county"], shp@data[nonmerger.munis, "muni"], sep="、")
actual.igraphn <- c(mergers.igraphn, nonmerger.igraphn)
actual.len <- sapply(actual.igraphn, length)

actual.l <- list()
sizes <- which(!sapply(coal.l, is.null))
for (size in sizes) {
  start.i <- sum(ncoal[0:(size-1)])
  for (coal.name in names(actual.igraphn[which(actual.len==size)])) {
    coal.munis <- unlist(actual.igraphn[coal.name])
    actual.l[[coal.name]] <- start.i + mwhich(coal.l[[size]], 1:size, as.list(coal.munis), 'eq', 'AND')
  }
}
ncoal.new <- ncoal
invalid <- which(sapply(actual.l, length) == 0)
for(coal.name in names(invalid)) {
  print(coal.name)
  merger <- unlist(actual.igraphn[coal.name])
  size <- length(merger)
  tmp <- gappei[gappei$merger.name == coal.name, "jis"]
  mcode <- tmp[length(tmp)]
  fname <- paste(proj.tmp, p, "/", size, "_merger", mcode, ".csv", sep="")
  merger.mat <- matrix(merger, nrow=1)
  write.table(merger.mat, file=fname, col.names=FALSE, row.names=FALSE, sep=",")
}
