(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    693596,      16471]
NotebookOptionsPosition[    673010,      15804]
NotebookOutlinePosition[    673411,      15822]
CellTagsIndexPosition[    673368,      15819]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"Remove", "[", "\"\<`*\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.590445687505816*^9, 3.590445693013999*^9}, {
   3.59044574103897*^9, 3.590445744711775*^9}, 3.5904458047623577`*^9, 
   3.5904458533089647`*^9, {3.590446010767091*^9, 3.590446011300754*^9}, {
   3.590446685245199*^9, 3.5904466878264503`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "`*"}]], "Input",
 CellChangeTimes->{{3.592777333088777*^9, 3.592777334013722*^9}}],

Cell[BoxData[
 DynamicModuleBox[{Typeset`open$$ = True}, 
  PaneSelectorBox[{False->
   RowBox[{
    OpenerBox[Dynamic[Typeset`open$$],
     ImageSize->Small], 
    StyleBox["Global`", "InfoHeading"]}], True->GridBox[{
     {
      RowBox[{
       OpenerBox[Dynamic[Typeset`open$$],
        ImageSize->Small], 
       StyleBox["Global`", "InfoHeading"]}]},
     {GridBox[{
        {
         ButtonBox["candidates",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3593973804-1400745", {"candidates", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["linkHost",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3593973804-1400745", {"linkHost", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["linkNameComponents",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3593973804-1400745", {"linkNameComponents", "Global`"}},
          ButtonNote->"Global`"]},
        {
         ButtonBox["IPAddrToInteger",
          BaseStyle->"InformationLink",
          
          ButtonData:>{
           "Info3593973804-1400745", {"IPAddrToInteger", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["linkName",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3593973804-1400745", {"linkName", "Global`"}},
          ButtonNote->"Global`"], 
         ButtonBox["pos",
          BaseStyle->"InformationLink",
          ButtonData:>{"Info3593973804-1400745", {"pos", "Global`"}},
          ButtonNote->"Global`"]}
       },
       DefaultBaseStyle->"InfoGrid",
       GridBoxItemSize->{"Columns" -> {{
            Scaled[0.31666666666666665`]}}}]}
    },
    GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}}]}, 
   Dynamic[Typeset`open$$],
   ImageSize->Automatic]]], "Print", "InfoCell",
 CellChangeTimes->{3.5939918079865017`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Tau]", "[", 
   RowBox[{"p_", ",", "t_"}], "]"}], ":=", 
  RowBox[{"1", "-", 
   RowBox[{
    FractionBox[
     SubscriptBox["\[Beta]", "0"], 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}]], "*", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{"y", "+", "t", "-", 
        RowBox[{
         SubscriptBox["\[Beta]", "3"], 
         RowBox[{"c", "[", "p", "]"}]}]}]}], "y"], 
     ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q", "[", 
   RowBox[{"p_", ",", "t_"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{
    FractionBox[
     SubscriptBox["\[Beta]", "1"], 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}]], "*", 
    FractionBox[
     RowBox[{" ", 
      RowBox[{"y", " ", "+", " ", "t", " ", "-", " ", 
       RowBox[{
        SubscriptBox["\[Beta]", "3"], 
        RowBox[{"c", "[", "p", "]"}]}]}]}], 
     RowBox[{" ", 
      RowBox[{"c", "[", "p", "]"}]}]]}], "+", 
   SubscriptBox["\[Beta]", "3"]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"p_", ",", " ", "yd_"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Beta]", "0"], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"\[Tau]", "[", 
         RowBox[{"p", ",", " ", 
          RowBox[{"yd", "-", "y", " ", "+", " ", 
           RowBox[{
            SubscriptBox["\[Beta]", "3"], " ", 
            RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}], ")"}], "y"}], 
     "]"}]}], "+", 
   RowBox[{
    SubscriptBox["\[Beta]", "1"], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"q", "[", 
       RowBox[{"p", ",", " ", 
        RowBox[{"yd", "-", "y", "+", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], " ", 
          RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}], "-", 
      SubscriptBox["\[Beta]", "3"]}], "]"}]}], " ", "+", " ", 
   RowBox[{
    SubscriptBox["\[Beta]", "2"], 
    RowBox[{"\[Delta]", "[", "p", "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.590446708130501*^9, 3.590446804494493*^9}, {
  3.5904468415171757`*^9, 3.590446875795141*^9}, {3.590446928037532*^9, 
  3.5904469434422903`*^9}, {3.590462680576366*^9, 3.59046271737493*^9}, {
  3.590465970895989*^9, 3.590465974636375*^9}, {3.590978784592759*^9, 
  3.590978808701035*^9}, {3.591055000333907*^9, 3.5910551343842907`*^9}, {
  3.591055165522131*^9, 3.591055283785097*^9}, {3.591066152057662*^9, 
  3.591066166013555*^9}, {3.591066917116493*^9, 3.591066921000555*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"u", "[", 
   RowBox[{"p", ",", 
    SubscriptBox["y", "d"]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"p", ",", 
     SubscriptBox["y", "d"]}], "]"}], ",", 
   SubscriptBox["y", "d"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.591055343832975*^9, 3.5910553445439177`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["y", "d"], " ", 
      SubscriptBox["\[Beta]", "0"]}], 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "0"]}], "+", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["y", "d"], " ", 
      SubscriptBox["\[Beta]", "1"]}], 
     RowBox[{
      RowBox[{"c", "[", "p", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "1"]}], "+", 
  RowBox[{
   SubscriptBox["\[Beta]", "2"], " ", 
   RowBox[{"\[Delta]", "[", "p", "]"}]}]}]], "Output",
 CellChangeTimes->{3.591055288503639*^9, 3.591055345597002*^9, 
  3.5910661023894043`*^9, 3.591066172407048*^9, 3.5910669380079403`*^9, 
  3.591067640832247*^9, 3.591307602447288*^9, 3.5913232776884003`*^9, 
  3.59134804082582*^9, 3.5913498356247663`*^9, 3.591392578153131*^9, 
  3.59140593659*^9, 3.591481140537722*^9, 3.591481662716259*^9, 
  3.591481692771942*^9, 3.591655938008191*^9, 3.5926864524440603`*^9, 
  3.592716766536274*^9, 3.592718007950281*^9, 3.592719173091572*^9, 
  3.5927773432956*^9, 3.593050877757325*^9, 3.5930650526972303`*^9, 
  3.593069110348998*^9, 3.593500651248712*^9, 3.593991810820809*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SubscriptBox["\[Beta]", "0"], 
   SubscriptBox["y", "d"]], "+", 
  FractionBox[
   SubscriptBox["\[Beta]", "1"], 
   SubscriptBox["y", "d"]]}]], "Output",
 CellChangeTimes->{3.591055288503639*^9, 3.591055345597002*^9, 
  3.5910661023894043`*^9, 3.591066172407048*^9, 3.5910669380079403`*^9, 
  3.591067640832247*^9, 3.591307602447288*^9, 3.5913232776884003`*^9, 
  3.59134804082582*^9, 3.5913498356247663`*^9, 3.591392578153131*^9, 
  3.59140593659*^9, 3.591481140537722*^9, 3.591481662716259*^9, 
  3.591481692771942*^9, 3.591655938008191*^9, 3.5926864524440603`*^9, 
  3.592716766536274*^9, 3.592718007950281*^9, 3.592719173091572*^9, 
  3.5927773432956*^9, 3.593050877757325*^9, 3.5930650526972303`*^9, 
  3.593069110348998*^9, 3.593500651248712*^9, 3.5939918108246098`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"uGovt", "[", 
   RowBox[{"p_", ",", "yd_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"p", ",", "yd"}], "]"}], "-", 
   RowBox[{"b", " ", "yd"}], "-", 
   RowBox[{"b", " ", 
    RowBox[{"c", "[", "p", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5910553661700163`*^9, 3.591055369202918*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"uGovt", "[", 
       RowBox[{"p", ",", "yd"}], "]"}], ",", "yd"}], "]"}], "\[Equal]", "0"}],
    ",", "yd"}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"yd", "\[Rule]", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "b"]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{3.591055377140314*^9, 3.59106618092772*^9, 
  3.59106694505134*^9, 3.5910676465972233`*^9, 3.5913076035838737`*^9, 
  3.591323278823195*^9, 3.5913480428853283`*^9, 3.5913498364928827`*^9, 
  3.5913925793705273`*^9, 3.59140593765514*^9, 3.5914811419165983`*^9, 
  3.591481663551949*^9, 3.591481693827038*^9, 3.591655939177367*^9, 
  3.592686459983094*^9, 3.59271677351857*^9, 3.592718015488741*^9, 
  3.592719181343302*^9, 3.592777350249083*^9, 3.5930508858245583`*^9, 
  3.593065062218289*^9, 3.5930691120364*^9, 3.59350065308074*^9, 
  3.593991815109829*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", 
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{
     SubscriptBox["\[Beta]", "0"], "+", 
     SubscriptBox["\[Beta]", "1"]}], 
    RowBox[{"y", " ", "b"}]]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"1", "-", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "+", 
    SubscriptBox["\[Beta]", "1"]}], 
   RowBox[{"b", " ", "y"}]]}]], "Output",
 CellChangeTimes->{
  3.59105549130339*^9, 3.5910661877598886`*^9, 3.591066948816875*^9, 
   3.591067650903782*^9, 3.59130760476519*^9, 3.59132328000597*^9, 
   3.591348043084895*^9, 3.59134983707439*^9, 3.591392580559607*^9, 
   3.591405938644128*^9, 3.591481142754696*^9, {3.5914816643406363`*^9, 
   3.591481694028067*^9}, 3.591655940361174*^9, 3.592686460785593*^9, 
   3.592716774427904*^9, 3.5927180162908792`*^9, 3.592719185027048*^9, 
   3.592777351052445*^9, 3.5930508866259527`*^9, 3.593065065837493*^9, 
   3.593069112869377*^9, 3.593500654071137*^9, 3.5939918234828787`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tfb", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Beta]", "3"], " ", 
    RowBox[{"c", "[", "x", "]"}]}], "-", 
   RowBox[{"a", " ", "y"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"tfb", "[", "p", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"yfb", "=", 
  RowBox[{"Simplify", "[", 
   RowBox[{"y", " ", "+", " ", 
    RowBox[{"tfb", "[", "x", "]"}], "-", 
    RowBox[{
     SubscriptBox["\[Beta]", "3"], 
     RowBox[{"c", "[", "x", "]"}]}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.591055407252467*^9, 3.591055425626875*^9}, {
  3.591055456317586*^9, 3.591055477134226*^9}, {3.591055579177671*^9, 
  3.5910555816485033`*^9}, {3.591055625914177*^9, 3.591055675363545*^9}, {
  3.5910664053248167`*^9, 3.591066435593553*^9}, {3.591350628100402*^9, 
  3.591350639434732*^9}, {3.591394660542708*^9, 3.591394681222237*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "b"}], " ", "y"}], "+", 
   SubscriptBox["\[Beta]", "0"], "+", 
   SubscriptBox["\[Beta]", "1"], "+", 
   RowBox[{"b", " ", 
    RowBox[{"c", "[", "p", "]"}], " ", 
    SubscriptBox["\[Beta]", "3"]}]}], "b"]], "Output",
 CellChangeTimes->{
  3.591055429107561*^9, {3.591055479148119*^9, 3.591055495460299*^9}, 
   3.59105558280438*^9, {3.5910556278776217`*^9, 3.591055640534202*^9}, 
   3.5910556772972727`*^9, 3.591066192274907*^9, {3.5910664277070827`*^9, 
   3.591066436387742*^9}, 3.591066682980492*^9, 3.591066952948372*^9, 
   3.591067656065687*^9, 3.591307604970511*^9, 3.591323280212482*^9, 
   3.5913480440815783`*^9, 3.5913498378808517`*^9, 3.5913505726844788`*^9, 
   3.591350631750801*^9, 3.591392580766872*^9, 3.59139468224687*^9, 
   3.591405939231216*^9, 3.591481143747499*^9, 3.591481664544252*^9, 
   3.591481695260036*^9, 3.591655940566894*^9, 3.5926864613939743`*^9, 
   3.592716775418705*^9, 3.592718017129574*^9, 3.592719186028199*^9, 
   3.592777351702907*^9, 3.593050887656372*^9, 3.5930650670297537`*^9, 
   3.5930691140513163`*^9, 3.5935006548676987`*^9, 3.5939918290454884`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SubscriptBox["\[Beta]", "0"], "+", 
   SubscriptBox["\[Beta]", "1"]}], "b"]], "Output",
 CellChangeTimes->{
  3.591055429107561*^9, {3.591055479148119*^9, 3.591055495460299*^9}, 
   3.59105558280438*^9, {3.5910556278776217`*^9, 3.591055640534202*^9}, 
   3.5910556772972727`*^9, 3.591066192274907*^9, {3.5910664277070827`*^9, 
   3.591066436387742*^9}, 3.591066682980492*^9, 3.591066952948372*^9, 
   3.591067656065687*^9, 3.591307604970511*^9, 3.591323280212482*^9, 
   3.5913480440815783`*^9, 3.5913498378808517`*^9, 3.5913505726844788`*^9, 
   3.591350631750801*^9, 3.591392580766872*^9, 3.59139468224687*^9, 
   3.591405939231216*^9, 3.591481143747499*^9, 3.591481664544252*^9, 
   3.591481695260036*^9, 3.591655940566894*^9, 3.5926864613939743`*^9, 
   3.592716775418705*^9, 3.592718017129574*^9, 3.592719186028199*^9, 
   3.592777351702907*^9, 3.593050887656372*^9, 3.5930650670297537`*^9, 
   3.5930691140513163`*^9, 3.5935006548676987`*^9, 3.5939918290480337`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  RowBox[{"u", "[", 
   RowBox[{"p", ",", 
    RowBox[{"yfb", "[", "p", "]"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"uGovt", "[", 
   RowBox[{"p", ",", 
    RowBox[{"yfb", "[", "p", "]"}]}], "]"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], " ", 
      RowBox[{
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "b"], "[", "p", "]"}]}], 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "0"]}], "+", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "1"], " ", 
      RowBox[{
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "b"], "[", "p", "]"}]}], 
     RowBox[{
      RowBox[{"c", "[", "p", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "1"]}], "+", 
  RowBox[{
   SubscriptBox["\[Beta]", "2"], " ", 
   RowBox[{"\[Delta]", "[", "p", "]"}]}]}]], "Output",
 CellChangeTimes->{
  3.591067034915678*^9, {3.591067632388879*^9, 3.591067661998076*^9}, 
   3.591307605969267*^9, 3.5913232812150507`*^9, 3.591348044519863*^9, 
   3.591349838472603*^9, 3.591392581766273*^9, 3.591405940348021*^9, 
   3.5914811442537537`*^9, 3.591481665183955*^9, 3.591481696315875*^9, 
   3.591655941569893*^9, 3.5926864654484262`*^9, 3.5927167794305563`*^9, 
   3.592718042176008*^9, 3.592719187035696*^9, 3.592777352708684*^9, 
   3.593050888709187*^9, 3.5930650708547163`*^9, 3.59306911489695*^9, 
   3.593500655873064*^9, 3.59399183099461*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "b"}], " ", 
   RowBox[{"c", "[", "p", "]"}]}], "+", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], " ", 
      RowBox[{
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "b"], "[", "p", "]"}]}], 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "0"]}], "+", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "1"], " ", 
      RowBox[{
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "b"], "[", "p", "]"}]}], 
     RowBox[{
      RowBox[{"c", "[", "p", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
   SubscriptBox["\[Beta]", "1"]}], "+", 
  RowBox[{
   SubscriptBox["\[Beta]", "2"], " ", 
   RowBox[{"\[Delta]", "[", "p", "]"}]}], "-", 
  RowBox[{"b", " ", 
   RowBox[{
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "b"], "[", "p", "]"}]}]}]], "Output",
 CellChangeTimes->{
  3.591067034915678*^9, {3.591067632388879*^9, 3.591067661998076*^9}, 
   3.591307605969267*^9, 3.5913232812150507`*^9, 3.591348044519863*^9, 
   3.591349838472603*^9, 3.591392581766273*^9, 3.591405940348021*^9, 
   3.5914811442537537`*^9, 3.591481665183955*^9, 3.591481696315875*^9, 
   3.591655941569893*^9, 3.5926864654484262`*^9, 3.5927167794305563`*^9, 
   3.592718042176008*^9, 3.592719187035696*^9, 3.592777352708684*^9, 
   3.593050888709187*^9, 3.5930650708547163`*^9, 3.59306911489695*^9, 
   3.593500655873064*^9, 3.593991830997842*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"singleP", "[", 
   RowBox[{"p_", ",", "disOne_", ",", "disTwo_"}], "]"}], ":=", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"LogisticDistribution", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", "disTwo"}], "]"}], ",", "s"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", "disOne"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uMerged", "[", 
   RowBox[{"p_", ",", "disOne_", ",", "disTwo_"}], "]"}], ":=", 
  RowBox[{"TruncatedDistribution", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{"p", ",", "disOne"}], "]"}], ",", "\[Infinity]"}], "}"}], ",", 
    
    RowBox[{"LogisticDistribution", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", "disTwo"}], "]"}], ",", "s"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"singleP", "[", 
   RowBox[{"p", ",", 
    SubscriptBox["y", "1"], ",", 
    SubscriptBox["y", "2"]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"uMerged", "[", 
   RowBox[{"p", ",", 
    SubscriptBox["y", "1"], ",", 
    SubscriptBox["y", "2"]}], "]"}], "]"}]}], "Input"],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"1", "+", 
   SuperscriptBox["\[ExponentialE]", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{
             SubscriptBox["y", "1"], " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{
            SubscriptBox["y", "2"], " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{
             SubscriptBox["y", "1"], " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", "p", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{
            SubscriptBox["y", "2"], " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], "s"]]}]]], "Output",
 CellChangeTimes->{3.5910557458981237`*^9, 3.591066196814678*^9, 
  3.591067044197876*^9, 3.591067671901956*^9, 3.591307606730598*^9, 
  3.591323281957605*^9, 3.591348045544519*^9, 3.5913498396586847`*^9, 
  3.591392582527996*^9, 3.591405942474209*^9, 3.591481146202035*^9, 
  3.591481666258165*^9, 3.591481697367084*^9, 3.591655942349845*^9, 
  3.5926866279265127`*^9, 3.592716783490789*^9, 3.592718046288731*^9, 
  3.5927191907010202`*^9, 3.592777356308049*^9, 3.593050892921507*^9, 
  3.593065074620648*^9, 3.593069115802289*^9, 3.5939918322005587`*^9}],

Cell[BoxData[
 RowBox[{"TruncatedDistribution", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{
          SubscriptBox["y", "1"], " ", 
          SubscriptBox["\[Beta]", "0"]}], 
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{
          SubscriptBox["y", "1"], " ", 
          SubscriptBox["\[Beta]", "1"]}], 
         RowBox[{
          RowBox[{"c", "[", "p", "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"\[Delta]", "[", "p", "]"}]}]}], ",", "\[Infinity]"}], "}"}], 
   ",", 
   RowBox[{"LogisticDistribution", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{
          SubscriptBox["y", "2"], " ", 
          SubscriptBox["\[Beta]", "0"]}], 
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{
          SubscriptBox["y", "2"], " ", 
          SubscriptBox["\[Beta]", "1"]}], 
         RowBox[{
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}], " ", 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"\[Delta]", "[", 
        RowBox[{"2", " ", "p"}], "]"}]}]}], ",", "s"}], "]"}]}], 
  "]"}]], "Output",
 CellChangeTimes->{3.5910557458981237`*^9, 3.591066196814678*^9, 
  3.591067044197876*^9, 3.591067671901956*^9, 3.591307606730598*^9, 
  3.591323281957605*^9, 3.591348045544519*^9, 3.5913498396586847`*^9, 
  3.591392582527996*^9, 3.591405942474209*^9, 3.591481146202035*^9, 
  3.591481666258165*^9, 3.591481697367084*^9, 3.591655942349845*^9, 
  3.5926866279265127`*^9, 3.592716783490789*^9, 3.592718046288731*^9, 
  3.5927191907010202`*^9, 3.592777356308049*^9, 3.593050892921507*^9, 
  3.593065074620648*^9, 3.593069115802289*^9, 3.593991832210093*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{"p", ",", "ya"}], "]"}], "-", 
    RowBox[{"b", " ", "ya"}]}], ",", "ya"}], "]"}]], "Input",
 CellChangeTimes->{{3.5916749358009157`*^9, 3.591674987178062*^9}, 
   3.5916756948110933`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "b"}], "+", 
  FractionBox[
   SubscriptBox["\[Beta]", "0"], "ya"], "+", 
  FractionBox[
   SubscriptBox["\[Beta]", "1"], "ya"]}]], "Output",
 CellChangeTimes->{{3.591674952372197*^9, 3.591674968944757*^9}, 
   3.591675696608466*^9, 3.592686631616102*^9, 3.592716789003528*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"1", "+", 
   RowBox[{"1", "/", 
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"LogisticDistribution", "[", 
       RowBox[{"0", ",", "s"}], "]"}], ",", "x"}], "]"}]}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.592780486668051*^9, 3.592780502324006*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"2", "+", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", 
       FractionBox["x", "s"]}]], "+", 
     SuperscriptBox["\[ExponentialE]", 
      FractionBox["x", "s"]]}], ")"}], " ", "s"}]}]], "Output",
 CellChangeTimes->{{3.5927804760640087`*^9, 3.592780503210641*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"1", "-", 
   RowBox[{"CDF", "[", 
    RowBox[{
     RowBox[{"LogisticDistribution", "[", 
      RowBox[{"0", ",", "s"}], "]"}], ",", "x"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.59277838502031*^9, 3.59277843560042*^9}}],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"1", "+", 
   SuperscriptBox["\[ExponentialE]", 
    FractionBox["x", "s"]]}]]], "Output",
 CellChangeTimes->{{3.592778385606098*^9, 3.592778436210236*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"LogisticDistribution", "[", 
        RowBox[{"0", ",", "s"}], "]"}], ",", "x"}], "]"}]}], ")"}], "/", 
   RowBox[{"PDF", "[", 
    RowBox[{
     RowBox[{"LogisticDistribution", "[", 
      RowBox[{"0", ",", "s"}], "]"}], ",", "x"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592777373006219*^9, 3.592777424479767*^9}, {
   3.592778454561677*^9, 3.592778474555792*^9}, 3.5927785593314047`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "+", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
      FractionBox["x", "s"]}]]}], ")"}], " ", "s"}]], "Output",
 CellChangeTimes->{{3.592777391474122*^9, 3.59277742747684*^9}, 
   3.592778405267149*^9, 3.592778475321493*^9, 3.592778560578644*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"LogisticDistribution", "[", 
        RowBox[{"\[Mu]", ",", "s"}], "]"}], ",", "x"}], "]"}]}], ")"}], "*", 
   RowBox[{
    RowBox[{"CDF", "[", 
     RowBox[{
      RowBox[{"LogisticDistribution", "[", 
       RowBox[{"\[Mu]", ",", "s"}], "]"}], ",", "x"}], "]"}], "/", 
    RowBox[{"PDF", "[", 
     RowBox[{
      RowBox[{"LogisticDistribution", "[", 
       RowBox[{"\[Mu]", ",", "s"}], "]"}], ",", "x"}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.592780779395111*^9, 3.592780783164809*^9}}],

Cell[BoxData["s"], "Output",
 CellChangeTimes->{3.592777498893046*^9, 3.592780784101088*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"ExponentialDistribution", "[", "1", "]"}], ",", "x"}], "]"}], 
  "/", 
  RowBox[{"PDF", "[", 
   RowBox[{
    RowBox[{"ExponentialDistribution", "[", "1", "]"}], ",", "x"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.591675815365336*^9, 3.591675838344191*^9}}],

Cell[BoxData[
 FractionBox[
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{"1", "-", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"-", "x"}]]}], 
         RowBox[{"x", "\[GreaterEqual]", "0"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], 
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "x"}]], 
         RowBox[{"x", "\[GreaterEqual]", "0"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False]]], "Output",
 CellChangeTimes->{{3.591675827589993*^9, 3.591675839327999*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"singleP", "[", 
   RowBox[{"p_", ",", "disOne_", ",", "disTwo_"}], "]"}], ":=", 
  RowBox[{"CDF", "[", 
   RowBox[{
    RowBox[{"NormalDistribution", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", "disTwo"}], "]"}], ",", "s"}], "]"}], ",", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", "disOne"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.592719700172886*^9, 3.592719700823366*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  FractionBox[
   RowBox[{"1", "-", 
    RowBox[{"singleP", "[", 
     RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]}], 
   RowBox[{"singleP", "[", 
    RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]], "]"}]], "Input",
 CellChangeTimes->{{3.59271920934804*^9, 3.5927192519903584`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  FractionBox["2", 
   RowBox[{"Erfc", "[", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", "p", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
     RowBox[{
      SqrtBox["2"], " ", "s"}]], "]"}]]}]], "Output",
 CellChangeTimes->{{3.592719234303226*^9, 3.592719253218129*^9}, 
   3.592719714211915*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ExponentialE]", 
   FractionBox[
    RowBox[{
     SubscriptBox["\[Beta]", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
       RowBox[{"\[Delta]", "[", 
        RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], "  ", 
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox["yb", 
     RowBox[{"ya", " "}]], " ", ")"}], 
   FractionBox[
    RowBox[{
     SubscriptBox["\[Beta]", "0"], "+", 
     SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     RowBox[{"c", "[", "p", "]"}], 
     RowBox[{"c", "[", 
      RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
   FractionBox[
    SubscriptBox["\[Beta]", "1"], "s"]]}]], "Input",
 CellChangeTimes->{{3.592719270913478*^9, 3.5927193699569807`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  FractionBox["2", 
   RowBox[{"Erfc", "[", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", "p", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
     RowBox[{
      SqrtBox["2"], " ", "s"}]], "]"}]]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   FractionBox["x", 
    RowBox[{"1", "-", "x"}]], "+", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.592780182253734*^9, 3.5927801977882023`*^9}, {
  3.592781024929377*^9, 3.59278105152181*^9}}],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"1", "-", "x"}]]], "Output",
 CellChangeTimes->{
  3.592780198434382*^9, {3.5927810406891947`*^9, 3.5927810522803593`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"1", "-", "ya"}], 
     RowBox[{"1", "-", "yb"}]], "\[Equal]", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], "1.6"]}], ",", "ya"}], "]"}]], "Input",
 CellChangeTimes->{{3.592719580839769*^9, 3.592719623796669*^9}, {
  3.5927197806214437`*^9, 3.59271983592912*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.592719624606633*^9, 3.592719786120099*^9, 
  3.5927198256651897`*^9, 3.5927202786143303`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  FractionBox[
   RowBox[{"1", "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", "x"}]]}], 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", "x"}]]], "]"}]], "Input",
 CellChangeTimes->{{3.591675852930821*^9, 3.5916758606079693`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1"}], "+", 
  SuperscriptBox["\[ExponentialE]", "x"]}]], "Output",
 CellChangeTimes->{3.591675894301034*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{"p", ",", "ya"}], "]"}], "-", 
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", "yb"}], "]"}]}]]}], ")"}], " ", "*", " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"p", ",", "ya"}], "]"}], "-", 
       RowBox[{"b", " ", "ya"}]}], ",", "ya"}], "]"}]}], "-", 
   RowBox[{"b", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb"}], ")"}], " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{"p", ",", "ya"}], "]"}], ",", "ya"}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5916748704157963`*^9, 3.5916749347129183`*^9}, {
  3.59167498884277*^9, 3.5916750132994833`*^9}, {3.591675915607131*^9, 
  3.5916759842928*^9}, {3.591676869637271*^9, 3.5916768729532137`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "b"}], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "b"}], " ", "ya"}], "+", 
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         SubscriptBox["\[Beta]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"ya", " ", 
           SubscriptBox["\[Beta]", "0"]}], 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}]], ")"}], 
        SubscriptBox["\[Beta]", "0"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"yb", " ", 
           SubscriptBox["\[Beta]", "0"]}], 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}]], ")"}], 
        RowBox[{"-", 
         SubscriptBox["\[Beta]", "0"]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"ya", " ", 
           SubscriptBox["\[Beta]", "1"]}], 
          RowBox[{
           RowBox[{"c", "[", "p", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
        SubscriptBox["\[Beta]", "1"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"yb", " ", 
           SubscriptBox["\[Beta]", "1"]}], 
          RowBox[{
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
        RowBox[{"-", 
         SubscriptBox["\[Beta]", "1"]}]]}]}], ")"}]}]}], "ya"]], "Output",
 CellChangeTimes->{{3.59167487464951*^9, 3.59167488691431*^9}, 
   3.5916749201153297`*^9, {3.5916749917383833`*^9, 3.591675014171631*^9}, 
   3.5916759334109573`*^9, {3.591675964354513*^9, 3.591675985060527*^9}, 
   3.591676878240753*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{"p", ",", "ya"}], "]"}], "-", 
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", "yb"}], "]"}]}]]}], ")"}], " ", "*", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"b", " ", "ya"}]}], ")"}]}], "-", 
   RowBox[{"b", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb"}], ")"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5916789759044952`*^9, 3.591679008418641*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"b", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "ya"}], "+", "yb"}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"b", " ", "ya"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         SubscriptBox["\[Beta]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
       RowBox[{"(", 
        FractionBox["ya", "yb"], " ", ")"}], "  ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}], " "}], 
          RowBox[{
           RowBox[{"c", "[", "p", "]"}], " "}]], ")"}], 
        SubscriptBox["\[Beta]", "1"]]}]}], ")"}]}]}], "\[Equal]", "0"}]], \
"Input",
 CellChangeTimes->{{3.591679028207368*^9, 3.591679098933165*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{"p", ",", "ya"}], "]"}], "-", 
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", "yb"}], "]"}]}]]}], ")"}], " ", "*", " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"u", "[", 
        RowBox[{"p", ",", "yb"}], "]"}], "-", 
       RowBox[{"b", " ", "yb"}]}], ",", "yb"}], "]"}]}], "+", 
   RowBox[{"b", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb"}], ")"}], " ", 
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{"p", ",", "yb"}], "]"}], ",", "yb"}], "]"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5916764517513123`*^9, 3.591676487996644*^9}, {
  3.5916768912191257`*^9, 3.5916768939884853`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"b", " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb"}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "b"}], " ", "yb"}], "+", 
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         SubscriptBox["\[Beta]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"ya", " ", 
           SubscriptBox["\[Beta]", "0"]}], 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}]], ")"}], 
        SubscriptBox["\[Beta]", "0"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"yb", " ", 
           SubscriptBox["\[Beta]", "0"]}], 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}]], ")"}], 
        RowBox[{"-", 
         SubscriptBox["\[Beta]", "0"]}]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"ya", " ", 
           SubscriptBox["\[Beta]", "1"]}], 
          RowBox[{
           RowBox[{"c", "[", "p", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
        SubscriptBox["\[Beta]", "1"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"yb", " ", 
           SubscriptBox["\[Beta]", "1"]}], 
          RowBox[{
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}], " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
        RowBox[{"-", 
         SubscriptBox["\[Beta]", "1"]}]]}]}], ")"}]}]}], "yb"]], "Output",
 CellChangeTimes->{3.5916764893206053`*^9, 3.591676898366933*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "b"}], " ", 
     RowBox[{"(", 
      RowBox[{"ya", "-", "yb"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "b"}], " ", "ya"}], "+", 
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"ya", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], ")"}], 
         SubscriptBox["\[Beta]", "0"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], ")"}], 
         RowBox[{"-", 
          SubscriptBox["\[Beta]", "0"]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"ya", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", "p", "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
         SubscriptBox["\[Beta]", "1"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
         RowBox[{"-", 
          SubscriptBox["\[Beta]", "1"]}]]}]}], ")"}]}]}], "\[Equal]", "0"}], 
  " ", "&&", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"b", " ", 
     RowBox[{"(", 
      RowBox[{"ya", "-", "yb"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "b"}], " ", "yb"}], "+", 
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"ya", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], ")"}], 
         SubscriptBox["\[Beta]", "0"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], ")"}], 
         RowBox[{"-", 
          SubscriptBox["\[Beta]", "0"]}]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"ya", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", "p", "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
         SubscriptBox["\[Beta]", "1"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"yb", " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], ")"}], 
         RowBox[{"-", 
          SubscriptBox["\[Beta]", "1"]}]]}]}], ")"}]}]}], "\[Equal]", 
   "0"}]}]], "Input",
 CellChangeTimes->{{3.591676567315359*^9, 3.5916765799643593`*^9}, {
  3.591676935228901*^9, 3.591676942174303*^9}, {3.591676977503137*^9, 
  3.591676979729945*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     SubscriptBox["\[Beta]", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
       RowBox[{"\[Delta]", "[", 
        RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
   RowBox[{"(", 
    FractionBox[
     RowBox[{"ya", " "}], "yb"], ")"}], "  ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}], 
      RowBox[{
       RowBox[{"c", "[", "p", "]"}], " "}]], ")"}], 
    SubscriptBox["\[Beta]", "1"]]}], " ", "\[Equal]", "1"}]], "Input",
 CellChangeTimes->{{3.591677049575575*^9, 3.591677101959668*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     SubscriptBox["\[Beta]", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
       RowBox[{"\[Delta]", "[", 
        RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], "   ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}], 
      RowBox[{
       RowBox[{"c", "[", "p", "]"}], " "}]], ")"}], 
    SubscriptBox["\[Beta]", "1"]]}], " ", "\[Equal]", 
  RowBox[{"(", 
   FractionBox["yb", "ya"], ")"}]}]], "Input",
 CellChangeTimes->{{3.5916771098554296`*^9, 3.591677119320759*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"b", " ", "ya", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "ya"}], "+", "yb"}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "b"}], " ", "ya"}], "+", 
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
         FractionBox["ya", "yb"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{"c", "[", "p", "]"}], 
            RowBox[{
             RowBox[{"c", "[", 
              RowBox[{"2", " ", "p"}], "]"}], " "}]], ")"}], 
          RowBox[{"-", 
           SubscriptBox["\[Beta]", "1"]}]]}]}], ")"}]}]}], "\[Equal]", "0"}], 
   ",", "ya"}], "]"}]], "Input",
 CellChangeTimes->{{3.5916750405572863`*^9, 3.5916751042552137`*^9}, 
   3.5916759476603613`*^9, {3.591675994765204*^9, 3.59167606883967*^9}, {
   3.591676225326214*^9, 3.591676301396062*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ya", "\[Rule]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "b"}], " ", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             SubscriptBox["\[Beta]", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
               RowBox[{"\[Delta]", "[", 
                RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]]}], "-", 
          RowBox[{"b", " ", "yb", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"c", "[", "p", "]"}], 
              RowBox[{"c", "[", 
               RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
            SubscriptBox["\[Beta]", "1"]]}]}], ")"}]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "b"}], " ", "yb", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{"c", "[", "p", "]"}], 
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
          SubscriptBox["\[Beta]", "1"]]}], "-", 
        RowBox[{"b", " ", 
         SuperscriptBox["yb", "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{"c", "[", "p", "]"}], 
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
          SubscriptBox["\[Beta]", "1"]]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
         SubscriptBox["\[Beta]", "0"]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
         SubscriptBox["\[Beta]", "1"]}], "-", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}], "+", 
             RowBox[{"b", " ", 
              SuperscriptBox["yb", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}], "+", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
              SubscriptBox["\[Beta]", "0"]}], "+", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
              SubscriptBox["\[Beta]", "1"]}]}], ")"}], "2"], "-", 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "b"}], " ", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]]}], "-", 
             RowBox[{"b", " ", "yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "yb"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]], " ", 
              SubscriptBox["\[Beta]", "0"]}], "-", 
             RowBox[{"yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]], " ", 
              SubscriptBox["\[Beta]", "1"]}]}], ")"}]}]}]]}], ")"}]}]}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ya", "\[Rule]", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "b"}], " ", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{
             SubscriptBox["\[Beta]", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
               RowBox[{"\[Delta]", "[", 
                RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]]}], "-", 
          RowBox[{"b", " ", "yb", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"c", "[", "p", "]"}], 
              RowBox[{"c", "[", 
               RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
            SubscriptBox["\[Beta]", "1"]]}]}], ")"}]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "b"}], " ", "yb", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{"c", "[", "p", "]"}], 
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
          SubscriptBox["\[Beta]", "1"]]}], "-", 
        RowBox[{"b", " ", 
         SuperscriptBox["yb", "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{"c", "[", "p", "]"}], 
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
          SubscriptBox["\[Beta]", "1"]]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
         SubscriptBox["\[Beta]", "0"]}], "-", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
         SubscriptBox["\[Beta]", "1"]}], "+", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"b", " ", "yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}], "+", 
             RowBox[{"b", " ", 
              SuperscriptBox["yb", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}], "+", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
              SubscriptBox["\[Beta]", "0"]}], "+", 
             RowBox[{
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]], " ", 
              SubscriptBox["\[Beta]", "1"]}]}], ")"}], "2"], "-", 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "b"}], " ", 
              SuperscriptBox["\[ExponentialE]", 
               RowBox[{
                SubscriptBox["\[Beta]", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                  RowBox[{"\[Delta]", "[", 
                   RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]]}], "-", 
             RowBox[{"b", " ", "yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "yb"}], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]], " ", 
              SubscriptBox["\[Beta]", "0"]}], "-", 
             RowBox[{"yb", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"c", "[", "p", "]"}], 
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
               SubscriptBox["\[Beta]", "1"]], " ", 
              SubscriptBox["\[Beta]", "1"]}]}], ")"}]}]}]]}], ")"}]}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.591676302338326*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"etl", "[", 
   RowBox[{"t_", ",", "\[Mu]_", ",", "s_"}], "]"}], "=", 
  RowBox[{"Expectation", "[", 
   RowBox[{"x", ",", 
    RowBox[{"x", "\[Distributed]", 
     RowBox[{"TruncatedDistribution", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"t", ",", "\[Infinity]"}], "}"}], ",", 
       RowBox[{"NormalDistribution", "[", 
        RowBox[{"\[Mu]", ",", "s"}], "]"}]}], "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.59399189069064*^9, 3.5939918912096777`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"t", "-", "\[Mu]"}], ")"}], "2"], 
      RowBox[{"2", " ", 
       SuperscriptBox["s", "2"]}]]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox["2"], " ", "s"}], "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"t", "-", "\[Mu]"}], ")"}], "2"], 
        RowBox[{"2", " ", 
         SuperscriptBox["s", "2"]}]]], " ", 
      SqrtBox["\[Pi]"], " ", "\[Mu]", " ", 
      RowBox[{"Erfc", "[", 
       FractionBox[
        RowBox[{"t", "-", "\[Mu]"}], 
        RowBox[{
         SqrtBox["2"], " ", "s"}]], "]"}]}]}], ")"}]}], 
  RowBox[{
   SqrtBox["\[Pi]"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"Erf", "[", 
      FractionBox[
       RowBox[{
        RowBox[{"-", "t"}], "+", "\[Mu]"}], 
       RowBox[{
        SqrtBox["2"], " ", "s"}]], "]"}]}], ")"}]}]]], "Output",
 CellChangeTimes->{3.59399190091232*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"etl", "[", 
   RowBox[{"t_", ",", "\[Mu]_", ",", "s_"}], "]"}], "=", 
  RowBox[{"Expectation", "[", 
   RowBox[{"x", ",", 
    RowBox[{"x", "\[Distributed]", 
     RowBox[{"TruncatedDistribution", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"t", ",", "\[Infinity]"}], "}"}], ",", 
       RowBox[{"LogisticDistribution", "[", 
        RowBox[{"\[Mu]", ",", "s"}], "]"}]}], "]"}]}]}], "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox["t", "s"]], " ", "t"}], "-", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox["t", "s"]], " ", "s", " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox["t", "s"]], "+", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox["\[Mu]", "s"]]}], "]"}]}], "-", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox["\[Mu]", "s"]], " ", "s", " ", 
     RowBox[{"Log", "[", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox["t", "s"]], "+", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox["\[Mu]", "s"]]}], "]"}]}]}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox["t", "s"]], "+", 
      SuperscriptBox["\[ExponentialE]", 
       FractionBox["\[Mu]", "s"]]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      FractionBox["1", 
       RowBox[{"1", "+", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"t", "-", "\[Mu]"}], "s"]}]]}]]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{3.591055868731317*^9, 3.5910662535793877`*^9, 
  3.591067080381839*^9, 3.591067713138381*^9, 3.591307644653346*^9, 
  3.5913233189995747`*^9, 3.591348081406814*^9, 3.591349875749576*^9, 
  3.591392620290962*^9, 3.591405978521085*^9, 3.591481183802265*^9, 
  3.591481675930957*^9, 3.591481733127633*^9, 3.591655983578784*^9, 
  3.5926866963172083`*^9, 3.5927168369298286`*^9, 3.592718096464609*^9, 
  3.5930651189638166`*^9, 3.593500691427916*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"etl", "[", "t_", "]"}], "=", 
  RowBox[{"Expectation", "[", 
   RowBox[{"x", ",", 
    RowBox[{"x", "\[Distributed]", 
     RowBox[{"TruncatedDistribution", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"t", ",", "\[Infinity]"}], "}"}], ",", 
       RowBox[{"ExponentialDistribution", "[", "1", "]"}]}], "]"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.59167419414441*^9, 3.5916742256949663`*^9}, {
  3.591674513746364*^9, 3.591674541943315*^9}, {3.591674635897738*^9, 
  3.591674636049224*^9}, {3.5916757385216084`*^9, 3.591675744597445*^9}}],

Cell[BoxData[
 FractionBox[
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {"1", 
         RowBox[{"t", "\[LessEqual]", "0"}]},
        {
         RowBox[{
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"-", "t"}]], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", "t"}], ")"}]}], 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], 
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {"1", 
         RowBox[{"t", "<", "0"}]},
        {
         SuperscriptBox["\[ExponentialE]", 
          RowBox[{"-", "t"}]], 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False]]], "Output",
 CellChangeTimes->{3.591674230198876*^9, 3.5916745216655283`*^9, 
  3.5916745538193827`*^9, 3.5916746386753674`*^9, 3.5916757466820297`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  FractionBox[
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{"-", "5"}]], 
   RowBox[{"1", "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", "5"}]]}]], "]"}]], "Input",
 CellChangeTimes->{{3.59167549241103*^9, 3.591675540672619*^9}}],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{
   RowBox[{"-", "1"}], "+", 
   SuperscriptBox["\[ExponentialE]", "5"]}]]], "Output",
 CellChangeTimes->{{3.5916755160332527`*^9, 3.591675541392892*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"etl", "[", "t_", "]"}], "=", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "EulerGamma"}], "-", 
    RowBox[{"Gamma", "[", 
     RowBox[{"0", ",", 
      FractionBox["1", "t"]}], "]"}]}], 
   RowBox[{"1", "-", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{
      RowBox[{"-", "1"}], "/", "t"}]]}]]}]], "Input",
 CellChangeTimes->{{3.591674353452815*^9, 3.591674396131743*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "EulerGamma"}], "-", 
   RowBox[{"Gamma", "[", 
    RowBox[{"0", ",", 
     FractionBox["1", "t"]}], "]"}]}], 
  RowBox[{"1", "-", 
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "t"}]]}]]], "Output",
 CellChangeTimes->{3.591674403089859*^9, 3.59167465156427*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"etl", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.591674405270915*^9, 3.591674442372089*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", "EulerGamma"}], "-", 
   RowBox[{"Gamma", "[", 
    RowBox[{"0", ",", "1"}], "]"}]}], 
  RowBox[{"1", "-", 
   FractionBox["1", "\[ExponentialE]"]}]]], "Output",
 CellChangeTimes->{{3.59167440901593*^9, 3.591674442996512*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"uExpected", "[", 
   RowBox[{"p_", ",", "disOne_", ",", "disTwo_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"singleP", "[", 
     RowBox[{"p", ",", "disOne", ",", "disTwo"}], "]"}], "*", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", "disOne"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"singleP", "[", 
       RowBox[{"p", ",", "disOne", ",", "disTwo"}], "]"}]}], ")"}], "*", 
    RowBox[{"etl", "[", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{"p", ",", "disOne"}], "]"}], ",", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", "disTwo"}], "]"}], ",", "s"}], 
     "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"uExpected", "[", 
   RowBox[{"p", ",", 
    SubscriptBox["y", "1"], ",", 
    SubscriptBox["y", "2"]}], "]"}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Erfc", "[", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{
             SubscriptBox["y", "1"], " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{
            SubscriptBox["y", "2"], " ", 
            SubscriptBox["\[Beta]", "0"]}], 
           RowBox[{
            SubscriptBox["\[Beta]", "0"], "+", 
            SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{
             SubscriptBox["y", "1"], " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", "p", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox[
           RowBox[{
            SubscriptBox["y", "2"], " ", 
            SubscriptBox["\[Beta]", "1"]}], 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}], " ", 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
     RowBox[{
      SqrtBox["2"], " ", "s"}]], "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{
         SubscriptBox["y", "1"], " ", 
         SubscriptBox["\[Beta]", "0"]}], 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "0"]}], "+", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{
         SubscriptBox["y", "1"], " ", 
         SubscriptBox["\[Beta]", "1"]}], 
        RowBox[{
         RowBox[{"c", "[", "p", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "1"]}], "+", 
     RowBox[{
      SubscriptBox["\[Beta]", "2"], " ", 
      RowBox[{"\[Delta]", "[", "p", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}], "-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
            SubscriptBox["\[Beta]", "0"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", "p", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], "-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], 
            " ", 
            SubscriptBox["\[Beta]", "1"]}], "+", 
           RowBox[{
            SubscriptBox["\[Beta]", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
              RowBox[{"\[Delta]", "[", 
               RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], ")"}], "2"], 
        RowBox[{"2", " ", 
         SuperscriptBox["s", "2"]}]]}]], " ", 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"Erfc", "[", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Log", "[", 
                FractionBox[
                 RowBox[{
                  SubscriptBox["y", "1"], " ", 
                  SubscriptBox["\[Beta]", "0"]}], 
                 RowBox[{
                  SubscriptBox["\[Beta]", "0"], "+", 
                  SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
            SubscriptBox["\[Beta]", "0"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"Log", "[", 
                FractionBox[
                 RowBox[{
                  SubscriptBox["y", "1"], " ", 
                  SubscriptBox["\[Beta]", "1"]}], 
                 RowBox[{
                  RowBox[{"c", "[", "p", "]"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SubscriptBox["\[Beta]", "0"], "+", 
                    SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], 
            " ", 
            SubscriptBox["\[Beta]", "1"]}], "+", 
           RowBox[{
            SubscriptBox["\[Beta]", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
              RowBox[{"\[Delta]", "[", 
               RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
          RowBox[{
           SqrtBox["2"], " ", "s"}]], "]"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SqrtBox["2"], " ", "s"}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Log", "[", 
                 FractionBox[
                  RowBox[{
                   SubscriptBox["y", "1"], " ", 
                   SubscriptBox["\[Beta]", "0"]}], 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}]], "]"}], "-", 
                RowBox[{"Log", "[", 
                 FractionBox[
                  RowBox[{
                   SubscriptBox["y", "2"], " ", 
                   SubscriptBox["\[Beta]", "0"]}], 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
              SubscriptBox["\[Beta]", "0"]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"Log", "[", 
                 FractionBox[
                  RowBox[{
                   SubscriptBox["y", "1"], " ", 
                   SubscriptBox["\[Beta]", "1"]}], 
                  RowBox[{
                   RowBox[{"c", "[", "p", "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SubscriptBox["\[Beta]", "0"], "+", 
                    SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], "-", 
                RowBox[{"Log", "[", 
                 FractionBox[
                  RowBox[{
                   SubscriptBox["y", "2"], " ", 
                   SubscriptBox["\[Beta]", "1"]}], 
                  RowBox[{
                   RowBox[{"c", "[", 
                    RowBox[{"2", " ", "p"}], "]"}], " ", 
                   RowBox[{"(", 
                    RowBox[{
                    SubscriptBox["\[Beta]", "0"], "+", 
                    SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], 
              " ", 
              SubscriptBox["\[Beta]", "1"]}], "+", 
             RowBox[{
              SubscriptBox["\[Beta]", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
                RowBox[{"\[Delta]", "[", 
                 RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], ")"}], "2"], 
          RowBox[{"2", " ", 
           SuperscriptBox["s", "2"]}]]], " ", 
        SqrtBox["\[Pi]"], " ", 
        RowBox[{"Erfc", "[", 
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}], "-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
            SubscriptBox["\[Beta]", "0"]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", "p", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], "-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "2"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", 
                  RowBox[{"2", " ", "p"}], "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], 
            " ", 
            SubscriptBox["\[Beta]", "1"]}], "+", 
           RowBox[{
            SubscriptBox["\[Beta]", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
              RowBox[{"\[Delta]", "[", 
               RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
          RowBox[{
           SqrtBox["2"], " ", "s"}]], "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"Log", "[", 
            FractionBox[
             RowBox[{
              SubscriptBox["y", "2"], " ", 
              SubscriptBox["\[Beta]", "0"]}], 
             RowBox[{
              SubscriptBox["\[Beta]", "0"], "+", 
              SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
           SubscriptBox["\[Beta]", "0"]}], "+", 
          RowBox[{
           RowBox[{"Log", "[", 
            FractionBox[
             RowBox[{
              SubscriptBox["y", "2"], " ", 
              SubscriptBox["\[Beta]", "1"]}], 
             RowBox[{
              RowBox[{"c", "[", 
               RowBox[{"2", " ", "p"}], "]"}], " ", 
              RowBox[{"(", 
               RowBox[{
                SubscriptBox["\[Beta]", "0"], "+", 
                SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
           SubscriptBox["\[Beta]", "1"]}], "+", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}]}], ")"}]}]}], ")"}]}], ")"}], 
   "/", 
   RowBox[{"(", 
    RowBox[{
     SqrtBox["\[Pi]"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"Erf", "[", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "0"]}], 
                RowBox[{
                 SubscriptBox["\[Beta]", "0"], "+", 
                 SubscriptBox["\[Beta]", "1"]}]], "]"}]}], "+", 
             RowBox[{"Log", "[", 
              FractionBox[
               RowBox[{
                SubscriptBox["y", "2"], " ", 
                SubscriptBox["\[Beta]", "0"]}], 
               RowBox[{
                SubscriptBox["\[Beta]", "0"], "+", 
                SubscriptBox["\[Beta]", "1"]}]], "]"}]}], ")"}], " ", 
           SubscriptBox["\[Beta]", "0"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"Log", "[", 
               FractionBox[
                RowBox[{
                 SubscriptBox["y", "1"], " ", 
                 SubscriptBox["\[Beta]", "1"]}], 
                RowBox[{
                 RowBox[{"c", "[", "p", "]"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Beta]", "0"], "+", 
                   SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], "+", 
             RowBox[{"Log", "[", 
              FractionBox[
               RowBox[{
                SubscriptBox["y", "2"], " ", 
                SubscriptBox["\[Beta]", "1"]}], 
               RowBox[{
                RowBox[{"c", "[", 
                 RowBox[{"2", " ", "p"}], "]"}], " ", 
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["\[Beta]", "0"], "+", 
                  SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], ")"}], 
           " ", 
           SubscriptBox["\[Beta]", "1"]}], "+", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
         RowBox[{
          SqrtBox["2"], " ", "s"}]], "]"}]}], ")"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.591055883149387*^9, 3.591066292332526*^9, 
  3.591067111887554*^9, 3.59106772952507*^9, 3.591307646469008*^9, 
  3.591323320687818*^9, 3.591348083194623*^9, 3.591349877426969*^9, 
  3.591392622102553*^9, 3.591405981042296*^9, 3.5914811861743*^9, 
  3.5914817342360907`*^9, 3.591655985424529*^9, 3.592686706336339*^9, 
  3.592716849105492*^9, 3.59271809795997*^9, 3.5930651341348867`*^9, 
  3.593500693918511*^9, 3.5939919126822367`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "approximation", " ", "when", " ", "not", " ", "merging", " ", "is", " ", 
   "very", " ", "bad"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.591402650478292*^9, 3.5914026618474617`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEApprox", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "  ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{"yb", " ", 
       SubscriptBox["\[Beta]", "0"]}], 
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}]], "]"}]}], " ", "+", 
   RowBox[{
    SubscriptBox["\[Beta]", "1"], "  ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{"yb", " ", 
       SubscriptBox["\[Beta]", "1"]}], 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], " ", "+", 
   RowBox[{
    SubscriptBox["\[Beta]", "2"], " ", 
    RowBox[{"\[Delta]", "[", 
     RowBox[{"2", " ", "p"}], "]"}]}], "+", 
   RowBox[{"s", 
    SuperscriptBox[
     RowBox[{"(", " ", 
      FractionBox[
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
          SubscriptBox["\[Beta]", "0"]}], "+", 
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"ya", " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", "p", "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
          SubscriptBox["\[Beta]", "1"]}], "+", 
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}]}]], 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"yb", " ", 
             SubscriptBox["\[Beta]", "0"]}], 
            RowBox[{
             SubscriptBox["\[Beta]", "0"], "+", 
             SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
          SubscriptBox["\[Beta]", "0"]}], "+", 
         RowBox[{
          RowBox[{"Log", "[", 
           FractionBox[
            RowBox[{"yb", " ", 
             SubscriptBox["\[Beta]", "1"]}], 
            RowBox[{
             RowBox[{"c", "[", 
              RowBox[{"2", " ", "p"}], "]"}], " ", 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["\[Beta]", "0"], "+", 
               SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
          SubscriptBox["\[Beta]", "1"]}], "+", 
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}]}]]], ")"}], 
     FractionBox["1", "s"]]}]}]}]], "Input",
 CellChangeTimes->{{3.591402696570465*^9, 3.591402811040709*^9}, {
  3.591402906467548*^9, 3.591402940204708*^9}, {3.5914035419302073`*^9, 
  3.5914035439722443`*^9}, {3.591403602413034*^9, 3.591403668376293*^9}, {
  3.591403769979866*^9, 3.591403770612414*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEApprox", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "  ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{"yb", " ", 
       SubscriptBox["\[Beta]", "0"]}], 
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}]], "]"}]}], " ", "+", 
   RowBox[{
    SubscriptBox["\[Beta]", "1"], "  ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{"yb", " ", 
       SubscriptBox["\[Beta]", "1"]}], 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}]}], " ", "+", 
   RowBox[{
    SubscriptBox["\[Beta]", "2"], " ", 
    RowBox[{"\[Delta]", "[", 
     RowBox[{"2", " ", "p"}], "]"}]}], "+", 
   RowBox[{"s", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["ya", "yb"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", 
        RowBox[{"2", "p"}], "]"}], 
       RowBox[{"c", "[", "p", "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]], " ", 
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{" ", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], ")"}]}], 
       "s"]}]]}]}]}]], "Input",
 CellChangeTimes->{{3.591403785715497*^9, 3.591403907030229*^9}, {
  3.591404455362399*^9, 3.5914045991035433`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEGApprox", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", " ", 
  RowBox[{
   RowBox[{"uEApprox", "[", 
    RowBox[{"p", ",", "ya", ",", "yb"}], "]"}], "+", 
   RowBox[{"b", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"ya", " ", 
       RowBox[{"singleP", "[", 
        RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]}], "+", " ", 
      RowBox[{"yb", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"singleP", "[", 
          RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5916709699018927`*^9, 3.591671054185273*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uExpectedGovt", "[", 
   RowBox[{"p_", ",", "disOne_", ",", "disTwo_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"singleP", "[", 
     RowBox[{"p", ",", "disOne", ",", "disTwo"}], "]"}], "*", 
    RowBox[{"uGovt", "[", 
     RowBox[{"p", ",", "disOne"}], "]"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"singleP", "[", 
       RowBox[{"p", ",", "disOne", ",", "disTwo"}], "]"}]}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"etl", "[", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{"p", ",", "disOne"}], "]"}], ",", 
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", "disTwo"}], "]"}], ",", "s"}], "]"}], "-", 
      
      RowBox[{"b", " ", "disTwo"}], "-", 
      RowBox[{"b", " ", 
       RowBox[{"c", "[", 
        RowBox[{"2", "p"}], "]"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5910559316581087`*^9, 3.591055935733124*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{
    RowBox[{"uExpectedGovt", "[", 
     RowBox[{"p", ",", "ya", ",", "yb"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Beta]", "0"], ">", "0"}], ",", 
      RowBox[{
       SubscriptBox["\[Beta]", "1"], ">", "0"}]}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.5913126082949457`*^9, 3.591312608757248*^9}, {
  3.593992082972939*^9, 3.5939920924327707`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     RowBox[{"-", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Log", "[", "ya", "]"}], "-", 
             RowBox[{"Log", "[", "yb", "]"}]}], ")"}], " ", 
           SubscriptBox["\[Beta]", "0"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Log", "[", 
              FractionBox["ya", 
               RowBox[{"c", "[", "p", "]"}]], "]"}], "-", 
             RowBox[{"Log", "[", 
              FractionBox["yb", 
               RowBox[{"c", "[", 
                RowBox[{"2", " ", "p"}], "]"}]], "]"}]}], ")"}], " ", 
           SubscriptBox["\[Beta]", "1"]}], "+", 
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"\[Delta]", "[", "p", "]"}], "-", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], ")"}], "2"], 
       RowBox[{"2", " ", 
        SuperscriptBox["s", "2"]}]]}]], " ", "s"}], 
   SqrtBox[
    RowBox[{"2", " ", "\[Pi]"}]]], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"Erfc", "[", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", "ya", "]"}]}], "+", 
         RowBox[{"Log", "[", "yb", "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "0"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"Log", "[", 
           FractionBox["ya", 
            RowBox[{"c", "[", "p", "]"}]], "]"}]}], "+", 
         RowBox[{"Log", "[", 
          FractionBox["yb", 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], "]"}]}], ")"}], " ", 
       SubscriptBox["\[Beta]", "1"]}], "+", 
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
     RowBox[{
      SqrtBox["2"], " ", "s"}]], "]"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "b"}], " ", "ya"}], "-", 
     RowBox[{"b", " ", 
      RowBox[{"c", "[", "p", "]"}]}], "+", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"ya", " ", 
         SubscriptBox["\[Beta]", "0"]}], 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "0"]}], "+", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"ya", " ", 
         SubscriptBox["\[Beta]", "1"]}], 
        RowBox[{
         RowBox[{"c", "[", "p", "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "1"]}], "+", 
     RowBox[{
      SubscriptBox["\[Beta]", "2"], " ", 
      RowBox[{"\[Delta]", "[", "p", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"Erf", "[", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Log", "[", "ya", "]"}]}], "+", 
           RowBox[{"Log", "[", "yb", "]"}]}], ")"}], " ", 
         SubscriptBox["\[Beta]", "0"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Log", "[", 
             FractionBox["ya", 
              RowBox[{"c", "[", "p", "]"}]], "]"}]}], "+", 
           RowBox[{"Log", "[", 
            FractionBox["yb", 
             RowBox[{"c", "[", 
              RowBox[{"2", " ", "p"}], "]"}]], "]"}]}], ")"}], " ", 
         SubscriptBox["\[Beta]", "1"]}], "+", 
        RowBox[{
         SubscriptBox["\[Beta]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}]}], 
       RowBox[{
        SqrtBox["2"], " ", "s"}]], "]"}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "b"}], " ", "yb"}], "-", 
     RowBox[{"b", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"yb", " ", 
         SubscriptBox["\[Beta]", "0"]}], 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "0"]}], "+", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        RowBox[{"yb", " ", 
         SubscriptBox["\[Beta]", "1"]}], 
        RowBox[{
         RowBox[{"c", "[", 
          RowBox[{"2", " ", "p"}], "]"}], " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], ")"}]}]], "]"}], " ", 
      SubscriptBox["\[Beta]", "1"]}], "+", 
     RowBox[{
      SubscriptBox["\[Beta]", "2"], " ", 
      RowBox[{"\[Delta]", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.591312649535161*^9, 3.59132336519886*^9, 
  3.591348123201092*^9, 3.591349917391004*^9, 3.591392661868556*^9, 
  3.591481604466549*^9, 3.591481775769977*^9, 3.591656027894853*^9, 
  3.592686763749598*^9, 3.592718152106303*^9, 3.59399205619804*^9, 
  3.593992116990974*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"s", " ", 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{
            SubscriptBox["\[Beta]", "2"], " ", 
            RowBox[{"\[Delta]", "[", "p", "]"}]}], "s"]], " ", 
         SuperscriptBox["ya", 
          FractionBox[
           SubscriptBox["\[Beta]", "0"], "s"]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["ya", 
            RowBox[{"c", "[", "p", "]"}]], ")"}], 
          FractionBox[
           SubscriptBox["\[Beta]", "1"], "s"]]}], "+", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", 
          FractionBox[
           RowBox[{
            SubscriptBox["\[Beta]", "2"], " ", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], "s"]], " ", 
         SuperscriptBox["yb", 
          FractionBox[
           SubscriptBox["\[Beta]", "0"], "s"]], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox["yb", 
            RowBox[{"c", "[", 
             RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
          FractionBox[
           SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], " ", 
      SubsuperscriptBox["\[Beta]", "0", 
       FractionBox[
        SubscriptBox["\[Beta]", "0"], "s"]], " ", 
      SubsuperscriptBox["\[Beta]", "1", 
       FractionBox[
        SubscriptBox["\[Beta]", "1"], "s"]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], ")"}], 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]}]]}], "]"}]}], "-", 
   RowBox[{"b", " ", 
    RowBox[{"(", 
     RowBox[{"yb", "+", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "+", 
   RowBox[{"b", " ", 
    SuperscriptBox["ya", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"yb", "-", "ya"}], ")"}], "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"c", "[", "p", "]"}], "-", 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " "}], 
     RowBox[{
      SuperscriptBox["ya", 
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "s"]], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], "  ", 
       SuperscriptBox["yb", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"c", "[", "p", "]"}], 
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}]}]]}]}]}]], "Input",
 CellChangeTimes->{{3.591312878511817*^9, 3.5913129015428867`*^9}, {
  3.5913129362766953`*^9, 3.59131295087934*^9}, {3.5913476124284973`*^9, 
  3.5913476806527576`*^9}, {3.591348394504417*^9, 3.5913484541857758`*^9}, {
  3.5913485450656652`*^9, 3.591348572965913*^9}, {3.5913964068280153`*^9, 
  3.591396431939702*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"s", " ", 
    RowBox[{"Log", "[", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "s"]], " ", 
        SuperscriptBox["ya", 
         FractionBox[
          SubscriptBox["\[Beta]", "0"], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["ya", 
           RowBox[{"c", "[", "p", "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}], "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], "s"]], " ", 
        SuperscriptBox["yb", 
         FractionBox[
          SubscriptBox["\[Beta]", "0"], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["yb", 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], " ", "]"}]}], "-", 
   RowBox[{"b", " ", 
    RowBox[{"(", 
     RowBox[{"yb", "+", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "+", 
   RowBox[{"b", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"yb", "-", "ya"}], ")"}], "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"c", "[", "p", "]"}], "-", 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " "}], 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], "  ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["yb", "ya"], ")"}], 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"c", "[", "p", "]"}], 
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}]}]]}]}]}]], "Input",
 CellChangeTimes->{
  3.591493170977556*^9, {3.591493928106689*^9, 3.591493943061685*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"p_", ",", "ya_", ",", "yb_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}], 
    RowBox[{"Log", "[", "yb", "]"}]}], "+", 
   RowBox[{"s", " ", 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["ya", "yb"], ")"}], 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{"c", "[", "p", "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}], "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], "s"]], "  ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}]}], "]"}]}], "-", 
   RowBox[{"b", " ", 
    RowBox[{"(", 
     RowBox[{"yb", "+", " ", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "+", 
   RowBox[{"b", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{"yb", "-", "ya"}], ")"}], "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"c", "[", "p", "]"}], "-", 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " "}], 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], "  ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["yb", "ya"], ")"}], 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"c", "[", "p", "]"}], 
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}]}]]}]}]}]], "Input",
 CellChangeTimes->{{3.591494304979075*^9, 3.591494324262145*^9}, {
  3.591494355033313*^9, 3.591494446164255*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"uEG", "[", 
     RowBox[{"p", ",", "ya", ",", "yb"}], "]"}], ",", "ya"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.59166391462726*^9, 3.591663926396111*^9}, {
  3.591664001673962*^9, 3.591664017834915*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["b", 
    RowBox[{"1", "+", 
     RowBox[{
      SuperscriptBox["\[ExponentialE]", 
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
           RowBox[{"\[Delta]", "[", 
            RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["yb", "ya"], ")"}], 
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{"c", "[", "p", "]"}], 
         RowBox[{"c", "[", 
          RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
       FractionBox[
        SubscriptBox["\[Beta]", "1"], "s"]]}]}]]}], "+", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "+", 
    SubscriptBox["\[Beta]", "1"]}], 
   RowBox[{"ya", "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", "ya", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["ya", "yb"], ")"}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "s"]}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{"c", "[", "p", "]"}]], ")"}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[Beta]", "1"], "s"]}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
      FractionBox[
       SubscriptBox["\[Beta]", "1"], "s"]]}]}]], "-", 
  FractionBox[
   RowBox[{"b", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb", "+", 
      RowBox[{"c", "[", "p", "]"}], "-", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", "p", "]"}], 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}]}], 
   RowBox[{"s", " ", "ya", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["yb", "ya"], ")"}], 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"c", "[", "p", "]"}], 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], "2"]}]]}]], "Output",\

 CellChangeTimes->{3.591663927363459*^9, 3.5916640060205393`*^9, 
  3.591664131606099*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "ya"], "-", "b"}], 
   RowBox[{"1", "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], "  ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["yb", "ya"], ")"}], 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"c", "[", "p", "]"}], 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
      FractionBox[
       SubscriptBox["\[Beta]", "1"], "s"]]}]}]], "-", 
  FractionBox[
   RowBox[{"b", " ", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "ya"], 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb", "+", 
      RowBox[{"c", "[", "p", "]"}], "-", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", "p", "]"}], 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]], " "}], 
   RowBox[{"s", "  ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["yb", "ya"], ")"}], 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"c", "[", "p", "]"}], 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], "2"]}]]}]], "Input",\

 CellChangeTimes->{{3.591667057591343*^9, 3.591667129256563*^9}, {
  3.591667168456335*^9, 3.59166718314734*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"s", "  ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "2"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
            RowBox[{"\[Delta]", "[", 
             RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["yb", "ya"], ")"}], 
        FractionBox[
         RowBox[{
          SubscriptBox["\[Beta]", "0"], "+", 
          SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"c", "[", "p", "]"}], 
          RowBox[{"c", "[", 
           RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
        FractionBox[
         SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], "ya"], "-", "b"}], ")"}]}], "-", 
   RowBox[{"b", " ", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "ya"], 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb", "+", 
      RowBox[{"c", "[", "p", "]"}], "-", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", "p", "]"}], 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]]}]}], " ", "\[Equal]", 
  "0"}]], "Input",
 CellChangeTimes->{{3.591670537972642*^9, 3.591670560983412*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullSimplify", "[", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"uEG", "[", 
     RowBox[{"p", ",", "ya", ",", "yb"}], "]"}], ",", "yb"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5916705856608763`*^9, 3.5916705860762663`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "b"}], "+", 
  FractionBox["b", 
   RowBox[{"1", "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["yb", "ya"], ")"}], 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"c", "[", "p", "]"}], 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
      FractionBox[
       SubscriptBox["\[Beta]", "1"], "s"]]}]}]], "+", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "+", 
    SubscriptBox["\[Beta]", "1"]}], "yb"], "-", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "+", 
    SubscriptBox["\[Beta]", "1"]}], 
   RowBox[{"yb", "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["ya", "yb"], ")"}], 
      RowBox[{"-", 
       FractionBox[
        RowBox[{
         SubscriptBox["\[Beta]", "0"], "+", 
         SubscriptBox["\[Beta]", "1"]}], "s"]}]], " ", "yb", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{"c", "[", "p", "]"}]], ")"}], 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox["\[Beta]", "1"], "s"]}]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
      FractionBox[
       SubscriptBox["\[Beta]", "1"], "s"]]}]}]], "+", 
  FractionBox[
   RowBox[{"b", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb", "+", 
      RowBox[{"c", "[", "p", "]"}], "-", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", "p", "]"}], 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}]}], 
   RowBox[{"s", " ", "yb", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["yb", "ya"], ")"}], 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"c", "[", "p", "]"}], 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], "2"]}]]}]], "Output",\

 CellChangeTimes->{3.591670729280611*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SubscriptBox["\[Beta]", "0"], "+", 
    SubscriptBox["\[Beta]", "1"]}], "yb"], "-", "b", "+", 
  FractionBox[
   RowBox[{"b", "-", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], 
     RowBox[{" ", "yb"}]]}], 
   RowBox[{"1", "+", 
    RowBox[{
     SuperscriptBox["\[ExponentialE]", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
          RowBox[{"\[Delta]", "[", 
           RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["yb", "ya"], ")"}], 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Beta]", "0"], "+", 
        SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{"c", "[", "p", "]"}], 
        RowBox[{"c", "[", 
         RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
      FractionBox[
       SubscriptBox["\[Beta]", "1"], "s"]]}]}]], "+", 
  FractionBox[
   RowBox[{"b", " ", 
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
         RowBox[{"\[Delta]", "[", 
          RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["yb", "ya"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{"ya", "-", "yb", "+", 
      RowBox[{"c", "[", "p", "]"}], "-", 
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"c", "[", "p", "]"}], 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], ")"}]}], 
   RowBox[{"s", " ", "yb", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{
        SuperscriptBox["\[ExponentialE]", 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              RowBox[{"\[Delta]", "[", "p", "]"}]}], "+", 
             RowBox[{"\[Delta]", "[", 
              RowBox[{"2", " ", "p"}], "]"}]}], ")"}]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["yb", "ya"], ")"}], 
         FractionBox[
          RowBox[{
           SubscriptBox["\[Beta]", "0"], "+", 
           SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{"c", "[", "p", "]"}], 
           RowBox[{"c", "[", 
            RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
         FractionBox[
          SubscriptBox["\[Beta]", "1"], "s"]]}]}], ")"}], "2"]}]]}]], "Input",\

 CellChangeTimes->{{3.591670768316661*^9, 3.5916708202614717`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uEG", "[", 
  RowBox[{"10000.", ",", "yfb", ",", "yfb"}], "]"}]], "Input",
 CellChangeTimes->{{3.59149321192566*^9, 3.591493247239038*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.9834369581312399`"}]], "Output",
 CellChangeTimes->{{3.5914932237970457`*^9, 3.591493247982759*^9}, 
   3.591493949842815*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["yfb"], "Input",
 CellChangeTimes->{{3.591494093441923*^9, 3.591494093690771*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.591494094177809*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"avgDist", "[", 
   RowBox[{"L_", ",", "W_"}], "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{
     SuperscriptBox["W", "3"], 
     RowBox[{"ArcSinh", "[", 
      RowBox[{"L", "/", "W"}], "]"}]}], "+", " ", 
    RowBox[{
     SuperscriptBox["L", "3"], 
     RowBox[{"ArcSinh", "[", 
      RowBox[{"W", "/", "L"}], "]"}]}], "+", 
    RowBox[{"2", "L", " ", "W", " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["L", "2"], "+", 
       SuperscriptBox["W", "2"]}]]}]}], 
   RowBox[{"12", "L", " ", "W"}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Delta]", "[", "p_", "]"}], ":=", 
  RowBox[{"avgDist", "[", 
   RowBox[{
    RowBox[{
     RadicalBox["2", "4"], 
     SqrtBox[
      FractionBox["p", "d"]]}], ",", 
    RowBox[{
     RadicalBox[
      RowBox[{"1", "/", "2"}], "4"], 
     SqrtBox[
      FractionBox["p", "d"]]}]}], "]"}]}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "p_", "]"}], ":=", 
  RowBox[{
   FractionBox["F", "p"], "+", "v"}]}]], "Input",
 CellChangeTimes->{{3.591347871960644*^9, 3.591347877283619*^9}, {
  3.5913489835862513`*^9, 3.591349008865074*^9}, {3.591349592768444*^9, 
  3.59134959333521*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"F", " ", "=", 
   RowBox[{"13000", "/", 
    RowBox[{"(", 
     RowBox[{"40", "-", 
      RowBox[{"13", "/", "10"}]}], ")"}]}]}], 
  RowBox[{"(*", " ", 
   RowBox[{"12946000", "/", "1000"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"v", " ", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"13", "/", "10"}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"40", "-", 
     RowBox[{"13", "/", "10"}]}], ")"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"1364", "/", "1000"}], " ", "*)"}], " "}]}]}], "Input",
 CellChangeTimes->{{3.59139439202238*^9, 3.591394392093158*^9}, {
  3.591493648173504*^9, 3.5914936589767933`*^9}, {3.591493746237986*^9, 
  3.591493755348494*^9}}],

Cell[BoxData[
 FractionBox["130000", "387"]], "Output",
 CellChangeTimes->{3.5913942164360228`*^9, 3.591394397933592*^9, 
  3.5914063882911167`*^9, 3.591481606308289*^9, 3.591481918749117*^9, 
  3.591493660144017*^9, 3.591493762892028*^9, 3.591500526363697*^9, 
  3.592686896845418*^9, 3.5927169017990913`*^9, 3.5927182143587313`*^9, 
  3.5930509202716837`*^9, 3.593065163735708*^9, 3.5930691652311153`*^9, 
  3.59350069758491*^9, 3.5939921327986917`*^9}],

Cell[BoxData[
 FractionBox["13", "387"]], "Output",
 CellChangeTimes->{3.5913942164360228`*^9, 3.591394397933592*^9, 
  3.5914063882911167`*^9, 3.591481606308289*^9, 3.591481918749117*^9, 
  3.591493660144017*^9, 3.591493762892028*^9, 3.591500526363697*^9, 
  3.592686896845418*^9, 3.5927169017990913`*^9, 3.5927182143587313`*^9, 
  3.5930509202716837`*^9, 3.593065163735708*^9, 3.5930691652311153`*^9, 
  3.59350069758491*^9, 3.593992132802104*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"c", "[", "p", "]"}], "*", 
    RowBox[{"(", 
     RowBox[{"40", "-", 
      RowBox[{"13", "/", "10"}]}], ")"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", " ", "300", ",", "5000000"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "16"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}]}], ",", 
   
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Population\>\"", ",", "\"\<Cost per capita (\[Yen]100,000)\>\""}], 
     "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.593050931953293*^9, 3.593050954863193*^9}, {
  3.5930510042768373`*^9, 3.5930511874287233`*^9}, {3.5930512539892473`*^9, 
  3.5930513219610786`*^9}, {3.593051706634429*^9, 3.59305170707377*^9}, {
  3.5930663045869913`*^9, 3.593066334891967*^9}, {3.593069177795979*^9, 
  3.5930691826830673`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwd1nk0ld3bB3DzmJkyO/M5zjkOJSKxL8pQKVJkiqhEMxmfNJhChkgDMmRI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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->NCache[{
     Log[300], 0}, {5.703782474656201, 0}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Frame->{True, True, False, False},
  FrameLabel->{{
     FormBox["\"Cost per capita (\[Yen]100,000)\"", TraditionalForm], None}, {
    
     FormBox["\"Population\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[300], 
      Log[5000000]}, {0, 16}}, {{5.703782474656201, 15.424948470398375`}, {0, 
     16}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{
  3.5930517079677887`*^9, 3.5930663381982594`*^9, {3.593069169152437*^9, 
   3.5930691843306713`*^9}, 3.593500698994405*^9, 3.593992136267029*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.593051703831169*^9, 3.593051703966469*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{"\"\</Users/egw5/cost_theory.pdf\>\"", ",", "%"}], "]"}]], "Input",
 CellChangeTimes->{{3.5930514272711487`*^9, 3.593051440107224*^9}, {
  3.593051539989045*^9, 3.593051542645548*^9}, {3.593051628769701*^9, 
  3.593051629207881*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Export", "::", "nodir"}], "MessageName"], ":", 
  " ", "\<\"Directory \[NoBreak]\\!\\(\\\"/Users/egw5/\\\"\\)\[NoBreak] does \
not exist. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\
\\\", ButtonFrame->None, ButtonData:>\\\"paclet:ref/Export\\\", ButtonNote -> \
\\\"Export::nodir\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.593051637435405*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Export", "::", "noopen"}], "MessageName"], ":", 
  " ", "\<\"Cannot open \
\[NoBreak]\\!\\(\\\"/Users/egw5/cost_theory.pdf\\\"\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/noopen\\\", \
ButtonNote -> \\\"Export::noopen\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.593051637439385*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.593051446316946*^9, 3.593051547036137*^9, 
  3.593051637441428*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.591484026901764*^9, 3.5914840270033197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"y", "=", 
  RowBox[{"40", "/", 
   RowBox[{"(", 
    RowBox[{"40", "-", 
     RowBox[{"13", "/", "10"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"b", "=", 
  FractionBox["1", 
   RowBox[{"y", "-", "v"}]]}]}], "Input",
 CellChangeTimes->{{3.5914832064375668`*^9, 3.591483206932954*^9}, 
   3.591483317343708*^9, {3.591484032043541*^9, 3.5914840394243402`*^9}, {
   3.591484344276271*^9, 3.591484353974193*^9}, {3.5914936671998034`*^9, 
   3.591493675728528*^9}, {3.591493758044183*^9, 3.59149376041343*^9}}],

Cell[BoxData[
 FractionBox["400", "387"]], "Output",
 CellChangeTimes->{
  3.591394410313837*^9, 3.591406394648892*^9, 3.59148160670234*^9, 
   3.591481919749028*^9, 3.591483216407632*^9, 3.5914833479406033`*^9, 
   3.5914840416357107`*^9, 3.59148435606112*^9, {3.5914936683712463`*^9, 
   3.591493678050207*^9}, 3.591493766682819*^9, 3.591500531630365*^9, 
   3.592686900178775*^9, 3.592716905207222*^9, 3.5927182178974943`*^9, 
   3.59306517235126*^9, 3.59350075848771*^9, 3.593992145408434*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.591394410313837*^9, 3.591406394648892*^9, 3.59148160670234*^9, 
   3.591481919749028*^9, 3.591483216407632*^9, 3.5914833479406033`*^9, 
   3.5914840416357107`*^9, 3.59148435606112*^9, {3.5914936683712463`*^9, 
   3.591493678050207*^9}, 3.591493766682819*^9, 3.591500531630365*^9, 
   3.592686900178775*^9, 3.592716905207222*^9, 3.5927182178974943`*^9, 
   3.59306517235126*^9, 3.59350075848771*^9, 3.59399214541182*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"scale", "=", "200"}]], "Input",
 CellChangeTimes->{{3.591500995512295*^9, 3.591501009824595*^9}}],

Cell[BoxData["200"], "Output",
 CellChangeTimes->{{3.591500996461994*^9, 3.591501011058202*^9}, 
   3.592686904680975*^9, 3.59271690963861*^9, 3.592718221589246*^9, 
   3.593065176285128*^9, 3.5935007626096497`*^9, 3.5939921490050793`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Beta]", "0"], "=", 
  RowBox[{"195", "/", "scale"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Beta]", "1"], "=", 
  RowBox[{"5", "/", "scale"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Beta]", "2"], "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "/", "5"}], ")"}], "/", 
   "scale"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Beta]", "3"], "=", " ", "1"}], " ", 
  RowBox[{"(*", " ", "1.05", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Beta]", "4"], "=", " ", "1", " ", 
  RowBox[{"(*", " ", "0.49", " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.591395874296583*^9, 3.591395911261838*^9}, {
  3.5914831871052313`*^9, 3.591483195254861*^9}, {3.5914833249302397`*^9, 
  3.591483340247377*^9}, {3.591483447328285*^9, 3.591483455604981*^9}, {
  3.591491186515109*^9, 3.591491198615143*^9}, {3.5914926347190037`*^9, 
  3.591492641815834*^9}, {3.591500502630291*^9, 3.591500512706913*^9}, {
  3.591500586752186*^9, 3.5915005977908916`*^9}, {3.591500941294119*^9, 
  3.591500973545019*^9}, {3.591501019160721*^9, 3.591501029512883*^9}}],

Cell[BoxData[
 FractionBox["39", "40"]], "Output",
 CellChangeTimes->{3.591394228892682*^9, 3.591395914556458*^9, 
  3.5914063959820337`*^9, 3.591481607697012*^9, 3.591481920337776*^9, 
  3.591483220144904*^9, 3.591483351350463*^9, 3.591483468617897*^9, 
  3.591484047119751*^9, 3.591491202304772*^9, 3.591492643997697*^9, 
  3.5914937858933363`*^9, 3.5915005356098223`*^9, 3.591500600493987*^9, 
  3.5915007008812647`*^9, 3.5915009754156923`*^9, 3.591501031470188*^9, 
  3.592686908431015*^9, 3.592716913816084*^9, 3.592718225338863*^9, 
  3.593065179758705*^9, 3.593500763683587*^9, 3.593992152844296*^9}],

Cell[BoxData[
 FractionBox["1", "40"]], "Output",
 CellChangeTimes->{3.591394228892682*^9, 3.591395914556458*^9, 
  3.5914063959820337`*^9, 3.591481607697012*^9, 3.591481920337776*^9, 
  3.591483220144904*^9, 3.591483351350463*^9, 3.591483468617897*^9, 
  3.591484047119751*^9, 3.591491202304772*^9, 3.591492643997697*^9, 
  3.5914937858933363`*^9, 3.5915005356098223`*^9, 3.591500600493987*^9, 
  3.5915007008812647`*^9, 3.5915009754156923`*^9, 3.591501031470188*^9, 
  3.592686908431015*^9, 3.592716913816084*^9, 3.592718225338863*^9, 
  3.593065179758705*^9, 3.593500763683587*^9, 3.593992152848279*^9}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["1", "1000"]}]], "Output",
 CellChangeTimes->{3.591394228892682*^9, 3.591395914556458*^9, 
  3.5914063959820337`*^9, 3.591481607697012*^9, 3.591481920337776*^9, 
  3.591483220144904*^9, 3.591483351350463*^9, 3.591483468617897*^9, 
  3.591484047119751*^9, 3.591491202304772*^9, 3.591492643997697*^9, 
  3.5914937858933363`*^9, 3.5915005356098223`*^9, 3.591500600493987*^9, 
  3.5915007008812647`*^9, 3.5915009754156923`*^9, 3.591501031470188*^9, 
  3.592686908431015*^9, 3.592716913816084*^9, 3.592718225338863*^9, 
  3.593065179758705*^9, 3.593500763683587*^9, 3.59399215285063*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.591394228892682*^9, 3.591395914556458*^9, 
  3.5914063959820337`*^9, 3.591481607697012*^9, 3.591481920337776*^9, 
  3.591483220144904*^9, 3.591483351350463*^9, 3.591483468617897*^9, 
  3.591484047119751*^9, 3.591491202304772*^9, 3.591492643997697*^9, 
  3.5914937858933363`*^9, 3.5915005356098223`*^9, 3.591500600493987*^9, 
  3.5915007008812647`*^9, 3.5915009754156923`*^9, 3.591501031470188*^9, 
  3.592686908431015*^9, 3.592716913816084*^9, 3.592718225338863*^9, 
  3.593065179758705*^9, 3.593500763683587*^9, 3.5939921528528547`*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.591394228892682*^9, 3.591395914556458*^9, 
  3.5914063959820337`*^9, 3.591481607697012*^9, 3.591481920337776*^9, 
  3.591483220144904*^9, 3.591483351350463*^9, 3.591483468617897*^9, 
  3.591484047119751*^9, 3.591491202304772*^9, 3.591492643997697*^9, 
  3.5914937858933363`*^9, 3.5915005356098223`*^9, 3.591500600493987*^9, 
  3.5915007008812647`*^9, 3.5915009754156923`*^9, 3.591501031470188*^9, 
  3.592686908431015*^9, 3.592716913816084*^9, 3.592718225338863*^9, 
  3.593065179758705*^9, 3.593500763683587*^9, 3.593992152854907*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"d", "=", "340", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"instead", " ", "of", " ", "340"}], " ", "*)"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"81", "?"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.591395941480132*^9, 3.5913959417148523`*^9}, {
  3.5915000809175034`*^9, 3.5915000901391*^9}, {3.591504502486519*^9, 
  3.5915045052892427`*^9}, {3.5915049448281116`*^9, 3.5915049449628487`*^9}, {
  3.59150540936427*^9, 3.591505409461822*^9}, {3.591505759899383*^9, 
  3.591505771766271*^9}}],

Cell[BoxData["340"], "Output",
 CellChangeTimes->{3.591394336663628*^9, 3.591395942405346*^9, 
  3.591406399761116*^9, 3.59148160796493*^9, 3.591481921230214*^9, 
  3.591483226268971*^9, 3.5914840573465157`*^9, 3.591491207388549*^9, 
  3.591492655074584*^9, 3.591493793971025*^9, 3.591500090784793*^9, 
  3.591504505955326*^9, 3.591504945845294*^9, 3.591505410241354*^9, 
  3.59268692695681*^9, 3.5927169176099367`*^9, 3.5927182290834618`*^9, 
  3.5930651948837967`*^9, 3.593500768133832*^9, 3.593992156284131*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fudge", "=", "10"}]], "Input",
 CellChangeTimes->{{3.591505321218687*^9, 3.591505331176499*^9}}],

Cell[BoxData["10"], "Output",
 CellChangeTimes->{3.592716921170412*^9, 3.593992159929035*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"s", "=", 
  RowBox[{
   FractionBox[
    SqrtBox["3"], "\[Pi]"], "/", 
   SqrtBox["scale"]}]}]], "Input",
 CellChangeTimes->{{3.591394441726914*^9, 3.5913944436892157`*^9}, {
   3.591492656407346*^9, 3.591492656929668*^9}, 3.591492750619527*^9, 
   3.59149598355624*^9, {3.591496243074952*^9, 3.59149624315485*^9}, {
   3.591499643686874*^9, 3.591499644012808*^9}, {3.5915000264158792`*^9, 
   3.591500028357586*^9}, {3.5915004374441442`*^9, 3.591500448583313*^9}, {
   3.591500628496252*^9, 3.591500641998851*^9}, {3.5915010397933607`*^9, 
   3.591501041482279*^9}, {3.5915050826596518`*^9, 3.591505086255281*^9}, 
   3.591505633120743*^9, 3.592718249975142*^9, 3.592877873925568*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", "=", 
  RowBox[{"1", "/", 
   SqrtBox["scale"]}]}]], "Input",
 CellChangeTimes->{3.5939921966189613`*^9}],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"10", " ", 
   SqrtBox["2"]}]]], "Output",
 CellChangeTimes->{3.59139445049756*^9, 3.5913959463709097`*^9, 
  3.591406439811399*^9, 3.591481613924201*^9, 3.591481923114851*^9, 
  3.591484061370083*^9, 3.5914912116492662`*^9, 3.591492659243533*^9, 
  3.591492751394471*^9, 3.591493809362919*^9, 3.591495984274049*^9, 
  3.591496243835326*^9, 3.591499644777422*^9, 3.591500029276044*^9, 
  3.59150045205033*^9, 3.5915006451877403`*^9, 3.591500705065074*^9, 
  3.591500815120376*^9, 3.591501042140852*^9, 3.591505087301094*^9, 
  3.591505634849464*^9, 3.592686941806403*^9, 3.592716924622006*^9, 
  3.592718251188602*^9, 3.593065199012362*^9, 3.59350077190906*^9, 
  3.593992166703188*^9, 3.593992197301358*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SqrtBox["scale"], "*", 
  RowBox[{"StandardDeviation", "[", 
   RowBox[{"NormalDistribution", "[", 
    RowBox[{"0", ",", "s"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.593992181690399*^9, 3.59399218316508*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.593992183778696*^9, 3.593992201103003*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SqrtBox["scale"], "*", 
  RowBox[{"StandardDeviation", "[", 
   RowBox[{"LogisticDistribution", "[", 
    RowBox[{"0", ",", "s"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.59150090825148*^9, 3.591500917923621*^9}, {
   3.591501052026333*^9, 3.591501052677808*^9}, {3.5915051164657784`*^9, 
   3.5915051200305367`*^9}, 3.591505648036579*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.591500918542116*^9, {3.591501045933689*^9, 3.591501053819314*^9}, {
   3.591505093109211*^9, 3.591505120520398*^9}, 3.591505648700075*^9, 
   3.5926869560672626`*^9, 3.592716925620079*^9, 3.592718257665814*^9, 
   3.593065203144484*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", "//", "N"}]], "Input",
 CellChangeTimes->{{3.591501065739554*^9, 3.591501066373941*^9}}],

Cell[BoxData["0.07071067811865475`"], "Output",
 CellChangeTimes->{3.591501067225071*^9, 3.591505153148777*^9, 
  3.592686961409112*^9, 3.592716926604869*^9, 3.5927182624958057`*^9, 
  3.593065206341156*^9, 3.5935007756755047`*^9, 3.593992209747466*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Simplify", "[", 
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"83", ",", "ya", ",", "yfb"}], "]"}], ",", "ya"}], "]"}], "]"}],
   "/.", 
  RowBox[{"ya", "\[Rule]", "0"}]}]], "Input",
 CellChangeTimes->{
  3.5913947716611357`*^9, {3.591398000152731*^9, 3.5913980414863873`*^9}, {
   3.5913980961227703`*^9, 3.591398104386015*^9}, {3.591398134700809*^9, 
   3.591398183876762*^9}, {3.591491245827587*^9, 3.591491255611589*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.591398021789227*^9, 3.591398044431164*^9}, {
   3.591398107028273*^9, 3.591398185184581*^9}, 3.591481960280312*^9, 
   3.5914832371495237`*^9, 3.591483360609231*^9, 3.59148347888177*^9, {
   3.591491233341859*^9, 3.591491251629279*^9}, 3.5914926676458*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Maximize", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"uEG", "[", 
       RowBox[{"10000", ",", "ya", ",", "yb"}], "]"}], ",", 
      RowBox[{"ya", ">=", "0"}], ",", 
      RowBox[{"yb", ">=", "0"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"ya", ",", "yb"}], "}"}], ",", "Reals"}], "]"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"doesn", "'"}], "t", " ", "work"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.591394823796152*^9, 3.5913948448409643`*^9}, {
  3.591394894926917*^9, 3.5913948999627857`*^9}, {3.591394960433466*^9, 
  3.591395018406925*^9}, {3.591396565362543*^9, 3.591396566953054*^9}}],

Cell[BoxData[
 RowBox[{"Maximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"200", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["39", "20"], "+", "yb"}], ")"}]}], "7771"]}], "+", 
      FractionBox[
       RowBox[{"200", " ", "ya", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["13", "20"]}], "-", "ya", "+", "yb"}], ")"}]}], 
       RowBox[{"7771", " ", 
        RowBox[{"(", 
         RowBox[{"ya", "+", 
          FractionBox[
           RowBox[{
            SuperscriptBox["2", 
             RowBox[{"1", "/", "20"}]], " ", 
            SuperscriptBox["\[ExponentialE]", 
             RowBox[{
              FractionBox["1", "5"], " ", 
              RowBox[{"(", 
               RowBox[{
                FractionBox[
                 RowBox[{"27", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox[
                    RowBox[{"1000000", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"3", "/", "4"}]]}], 
                    RowBox[{"243", " ", 
                    SqrtBox["3"]}]], "+", 
                    RowBox[{
                    FractionBox["1000000", "729"], " ", 
                    SuperscriptBox["2", 
                    RowBox[{"3", "/", "4"}]], " ", 
                    RowBox[{"ArcSinh", "[", 
                    FractionBox["1", 
                    SqrtBox["2"]], "]"}]}], "+", 
                    RowBox[{
                    FractionBox["500000", "729"], " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "4"}]], " ", 
                    RowBox[{"ArcSinh", "[", 
                    SqrtBox["2"], "]"}]}]}], ")"}]}], "40000"], "-", 
                FractionBox[
                 RowBox[{"27", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox[
                    RowBox[{"4000000", " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "4"}]]}], 
                    RowBox[{"243", " ", 
                    SqrtBox["3"]}]], "+", 
                    RowBox[{
                    FractionBox["4000000", "729"], " ", 
                    SuperscriptBox["2", 
                    RowBox[{"1", "/", "4"}]], " ", 
                    RowBox[{"ArcSinh", "[", 
                    FractionBox["1", 
                    SqrtBox["2"]], "]"}]}], "+", 
                    RowBox[{
                    FractionBox["1000000", "729"], " ", 
                    SuperscriptBox["2", 
                    RowBox[{"3", "/", "4"}]], " ", 
                    RowBox[{"ArcSinh", "[", 
                    SqrtBox["2"], "]"}]}]}], ")"}]}], "80000"]}], ")"}]}]], 
            " ", "yb"}], 
           SuperscriptBox["3", 
            RowBox[{"1", "/", "40"}]]]}], ")"}]}]], "+", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox["1", "40"], " ", 
        SuperscriptBox["39", 
         RowBox[{"39", "/", "40"}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["5", "13"], ")"}], 
            RowBox[{"1", "/", "40"}]], " ", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"27", " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"1000000", " ", 
                   SuperscriptBox["2", 
                    RowBox[{"3", "/", "4"}]]}], 
                  RowBox[{"243", " ", 
                   SqrtBox["3"]}]], "+", 
                 RowBox[{
                  FractionBox["1000000", "729"], " ", 
                  SuperscriptBox["2", 
                   RowBox[{"3", "/", "4"}]], " ", 
                  RowBox[{"ArcSinh", "[", 
                   FractionBox["1", 
                    SqrtBox["2"]], "]"}]}], "+", 
                 RowBox[{
                  FractionBox["500000", "729"], " ", 
                  SuperscriptBox["2", 
                   RowBox[{"1", "/", "4"}]], " ", 
                  RowBox[{"ArcSinh", "[", 
                   SqrtBox["2"], "]"}]}]}], ")"}]}], "200000"]}]], " ", 
           "ya"}], "+", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox["5", "39"], ")"}], 
            RowBox[{"1", "/", "40"}]], " ", 
           SuperscriptBox["2", 
            RowBox[{"1", "/", "20"}]], " ", 
           SuperscriptBox["\[ExponentialE]", 
            RowBox[{"-", 
             FractionBox[
              RowBox[{"27", " ", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  RowBox[{"4000000", " ", 
                   SuperscriptBox["2", 
                    RowBox[{"1", "/", "4"}]]}], 
                  RowBox[{"243", " ", 
                   SqrtBox["3"]}]], "+", 
                 RowBox[{
                  FractionBox["4000000", "729"], " ", 
                  SuperscriptBox["2", 
                   RowBox[{"1", "/", "4"}]], " ", 
                  RowBox[{"ArcSinh", "[", 
                   FractionBox["1", 
                    SqrtBox["2"]], "]"}]}], "+", 
                 RowBox[{
                  FractionBox["1000000", "729"], " ", 
                  SuperscriptBox["2", 
                   RowBox[{"3", "/", "4"}]], " ", 
                  RowBox[{"ArcSinh", "[", 
                   SqrtBox["2"], "]"}]}]}], ")"}]}], "400000"]}]], " ", 
           "yb"}]}], ")"}]}], "]"}]}], ",", 
     RowBox[{"ya", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"yb", "\[GreaterEqual]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ya", ",", "yb"}], "}"}], ",", "Reals"}], "]"}]], "Output",
 CellChangeTimes->{3.591396569734296*^9, 3.591481961699891*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uEG", "[", 
  RowBox[{"15000", ",", "ya", ",", "yb"}], "]"}]], "Input",
 CellChangeTimes->{{3.591493846477211*^9, 3.5914938534231*^9}, {
  3.5914941272540283`*^9, 3.591494152958139*^9}, {3.5914945301274652`*^9, 
  3.591494551896757*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["52", "1161"]}], "-", "yb", "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox["13", "1161"]}], "-", "ya", "+", "yb"}], 
   RowBox[{"1", "+", 
    FractionBox[
     RowBox[{"25", " ", 
      SqrtBox["5"], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"9", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"1000000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"3", "/", "4"}]]}], "81"], "+", 
               FractionBox[
                RowBox[{"1000000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"3", "/", "4"}]], " ", 
                 RowBox[{"ArcSinh", "[", 
                  FractionBox["1", 
                   SqrtBox["2"]], "]"}]}], 
                RowBox[{"81", " ", 
                 SqrtBox["3"]}]], "+", 
               FractionBox[
                RowBox[{"500000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"1", "/", "4"}]], " ", 
                 RowBox[{"ArcSinh", "[", 
                  SqrtBox["2"], "]"}]}], 
                RowBox[{"81", " ", 
                 SqrtBox["3"]}]]}], ")"}]}], "40000"]}], "+", 
          FractionBox[
           RowBox[{"9", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"500000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"1", "/", "4"}]]}], "81"], "+", 
              FractionBox[
               RowBox[{"500000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"1", "/", "4"}]], " ", 
                RowBox[{"ArcSinh", "[", 
                 FractionBox["1", 
                  SqrtBox["2"]], "]"}]}], 
               RowBox[{"81", " ", 
                SqrtBox["3"]}]], "+", 
              FractionBox[
               RowBox[{"125000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"3", "/", "4"}]], " ", 
                RowBox[{"ArcSinh", "[", 
                 SqrtBox["2"], "]"}]}], 
               RowBox[{"81", " ", 
                SqrtBox["3"]}]]}], ")"}]}], "20000"]}], ")"}]}]], " ", 
      SuperscriptBox["yb", "100"]}], 
     RowBox[{"32", " ", 
      SuperscriptBox["ya", "100"]}]]}]], "+", 
  RowBox[{
   FractionBox["1", "100"], " ", 
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "13"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "400000"]}]]}], "5408"], "+", 
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "65"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"125000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "200000"]}]], " ", 
       SuperscriptBox["ya", "100"]}], 
      RowBox[{"4225", " ", 
       SuperscriptBox["yb", "100"]}]]}], "]"}]}], "+", 
  RowBox[{"Log", "[", "yb", "]"}]}]], "Output",
 CellChangeTimes->{3.591494585680368*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox["13", "1161"]}], "-", "ya", "+", "yb"}], 
   RowBox[{"1", "+", 
    FractionBox[
     RowBox[{"25", " ", 
      SqrtBox["5"], " ", 
      SuperscriptBox["\[ExponentialE]", 
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"9", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"1000000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"3", "/", "4"}]]}], "81"], "+", 
               FractionBox[
                RowBox[{"1000000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"3", "/", "4"}]], " ", 
                 RowBox[{"ArcSinh", "[", 
                  FractionBox["1", 
                   SqrtBox["2"]], "]"}]}], 
                RowBox[{"81", " ", 
                 SqrtBox["3"]}]], "+", 
               FractionBox[
                RowBox[{"500000", " ", 
                 SuperscriptBox["2", 
                  RowBox[{"1", "/", "4"}]], " ", 
                 RowBox[{"ArcSinh", "[", 
                  SqrtBox["2"], "]"}]}], 
                RowBox[{"81", " ", 
                 SqrtBox["3"]}]]}], ")"}]}], "40000"]}], "+", 
          FractionBox[
           RowBox[{"9", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"500000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"1", "/", "4"}]]}], "81"], "+", 
              FractionBox[
               RowBox[{"500000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"1", "/", "4"}]], " ", 
                RowBox[{"ArcSinh", "[", 
                 FractionBox["1", 
                  SqrtBox["2"]], "]"}]}], 
               RowBox[{"81", " ", 
                SqrtBox["3"]}]], "+", 
              FractionBox[
               RowBox[{"125000", " ", 
                SuperscriptBox["2", 
                 RowBox[{"3", "/", "4"}]], " ", 
                RowBox[{"ArcSinh", "[", 
                 SqrtBox["2"], "]"}]}], 
               RowBox[{"81", " ", 
                SqrtBox["3"]}]]}], ")"}]}], "20000"]}], ")"}]}]], " ", 
      SuperscriptBox["yb", "100"]}], 
     RowBox[{"32", " ", 
      SuperscriptBox["ya", "100"]}]]}]], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ya", "\[Rule]", "1."}], ",", 
    RowBox[{"yb", "\[Rule]", "0.4769466011959595`"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.591494567703211*^9, 3.5914946126863213`*^9}, {
  3.5914948095385447`*^9, 3.59149481317983*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.5342506425594238`"}]], "Output",
 CellChangeTimes->{
  3.5914938544118233`*^9, {3.5914941199792747`*^9, 3.591494153800026*^9}, {
   3.591494458112659*^9, 3.591494486107386*^9}, {3.5914945386472*^9, 
   3.5914945786289043`*^9}, 3.5914946134456577`*^9, 3.5914947679065027`*^9, 
   3.591494814129266*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "13"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "400000"]}]]}], "5408"], "+", 
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "65"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"125000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "200000"]}]], " ", 
       SuperscriptBox["ya", "100"]}], 
      RowBox[{"4225", " ", 
       SuperscriptBox["yb", "100"]}]]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ya", "\[Rule]", "1."}], ",", 
     RowBox[{"yb", "\[Rule]", "0.4769466011959595`"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.591494636394554*^9, 3.5914946406437063`*^9}, {
   3.591494757366808*^9, 3.591494778761643*^9}, 3.591494825394363*^9}],

Cell[BoxData["80.70848989794415`"], "Output",
 CellChangeTimes->{
  3.5914946417451267`*^9, {3.5914947582652283`*^9, 3.5914947798687067`*^9}, 
   3.591494826627475*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "13"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"1000000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "400000"]}]]}], "5408"], "+", 
     FractionBox[
      RowBox[{"4043763", " ", 
       SqrtBox[
        FractionBox["129", "65"]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]]}], "81"], "+", 
             FractionBox[
              RowBox[{"500000", " ", 
               SuperscriptBox["2", 
                RowBox[{"1", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]], "+", 
             FractionBox[
              RowBox[{"125000", " ", 
               SuperscriptBox["2", 
                RowBox[{"3", "/", "4"}]], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}], 
              RowBox[{"81", " ", 
               SqrtBox["3"]}]]}], ")"}]}], "200000"]}]], " ", 
       SuperscriptBox["ya", "100"]}], 
      RowBox[{"4225", " ", 
       SuperscriptBox["yb", "100"]}]]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ya", "\[Rule]", "1."}], ",", 
     RowBox[{"yb", "\[Rule]", "1."}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.591495171617464*^9, 3.5914951732808847`*^9}}],

Cell[BoxData["7.549190435110356`"], "Output",
 CellChangeTimes->{3.5914951741681433`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    RowBox[{"4043763", " ", 
     SqrtBox[
      FractionBox["129", "65"]], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"9", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"500000", " ", 
             SuperscriptBox["2", 
              RowBox[{"1", "/", "4"}]]}], "81"], "+", 
           FractionBox[
            RowBox[{"500000", " ", 
             SuperscriptBox["2", 
              RowBox[{"1", "/", "4"}]], " ", 
             RowBox[{"ArcSinh", "[", 
              FractionBox["1", 
               SqrtBox["2"]], "]"}]}], 
            RowBox[{"81", " ", 
             SqrtBox["3"]}]], "+", 
           FractionBox[
            RowBox[{"125000", " ", 
             SuperscriptBox["2", 
              RowBox[{"3", "/", "4"}]], " ", 
             RowBox[{"ArcSinh", "[", 
              SqrtBox["2"], "]"}]}], 
            RowBox[{"81", " ", 
             SqrtBox["3"]}]]}], ")"}]}], "200000"]}]], " ", 
     SuperscriptBox["ya", "100"]}], 
    RowBox[{"4225", " ", 
     SuperscriptBox["yb", "100"]}]], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ya", "\[Rule]", "1."}], ",", 
     RowBox[{"yb", "\[Rule]", "1.`"}]}], "}"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591494923453311*^9, 3.59149493380718*^9}, 
   3.591494978477921*^9, {3.5914950219430027`*^9, 3.5914950221039658`*^9}}],

Cell[BoxData["791.0931665501995`"], "Output",
 CellChangeTimes->{{3.5914949291129913`*^9, 3.591494934503175*^9}, 
   3.5914949795681953`*^9, 3.591495022747169*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Log", "[", "791.", "]"}]], "Input",
 CellChangeTimes->{{3.591495029023389*^9, 3.59149503642454*^9}}],

Cell[BoxData["6.673297967767654`"], "Output",
 CellChangeTimes->{{3.591495032112874*^9, 3.591495037043309*^9}}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.591494761925395*^9, 3.591494762845497*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"15000", ",", "yfb"}], "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.59149469824024*^9, 3.591494708086946*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.050172691696720395`"}]], "Output",
 CellChangeTimes->{{3.591494704540621*^9, 3.591494708629795*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"u", "[", 
   RowBox[{"30000", ",", "yfb"}], "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591494712090783*^9, 3.591494716809452*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.0468027249833247`"}]], "Output",
 CellChangeTimes->{3.591494717314555*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NMaximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"30000", ",", 
       RowBox[{"yfb", "*", "stick"}], ",", 
       RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
     RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"carrot", ",", "stick"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591492592662006*^9, 3.591492592926951*^9}, {
  3.59149268216031*^9, 3.59149268879338*^9}, {3.591492998525846*^9, 
  3.591493045145689*^9}, {3.5914938244342213`*^9, 3.5914938354123583`*^9}, {
  3.591494508087213*^9, 3.591494514895952*^9}, {3.591495820042053*^9, 
  3.591495861492017*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "1.055664778685515`"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"carrot", "\[Rule]", "1.0024656116597743`"}], ",", 
     RowBox[{"stick", "\[Rule]", "0.9971039008914597`"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.591492594008535*^9, {3.591492671836423*^9, 3.5914926897130337`*^9}, 
   3.5914927600543327`*^9, {3.591493000119672*^9, 3.59149304599442*^9}, {
   3.5914938177182627`*^9, 3.5914938362759933`*^9}, 3.5914941111335497`*^9, {
   3.5914944954991713`*^9, 3.591494516069181*^9}, {3.5914958294408197`*^9, 
   3.5914958623645697`*^9}, 3.593992225950962*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FindMaximum", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"20000", ",", 
       RowBox[{"yfb", "*", "stick"}], ",", 
       RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
     RowBox[{"stick", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"carrot", "\[GreaterEqual]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"carrot", ",", "stick"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591493295257213*^9, 3.591493328953968*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"FindMaximum", "::", "eit"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The algorithm does not converge to the tolerance of \
\[NoBreak]\\!\\(4.806217383937354`*^-6\\)\[NoBreak] in \[NoBreak]\\!\\(500\\)\
\[NoBreak] iterations. The best estimated solution, with feasibility \
residual, KKT residual, or complementary residual of \
\[NoBreak]\\!\\({1.375977147624217`*^-8, 0.18171715418992274`, \
1.1851085633982028`*^-8}\\)\[NoBreak], is returned. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/FindMaximum\\\", ButtonNote -> \
\\\"FindMaximum::eit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591493303048348*^9, 3.591493333088367*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.4788250517434207`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"carrot", "\[Rule]", "0.9942399783337273`"}], ",", 
     RowBox[{"stick", "\[Rule]", "0.9908355892190787`"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.591493303050503*^9, 3.591493333093143*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"getCarrot", "[", "lp_", "]"}], ":=", 
  RowBox[{"carrot", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{
          RowBox[{"Exp", "[", "lp", "]"}], ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getStick", "[", "lp_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", 
       RowBox[{"yfb", "*", "stick"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", "yfb"}], " ", ")"}]}], 
    ")"}], "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{
          RowBox[{"Exp", "[", "lp", "]"}], ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.5913953665367203`*^9, 3.591395444743286*^9}, {
  3.591395484395846*^9, 3.591395514763567*^9}, {3.5913955591823072`*^9, 
  3.59139556855757*^9}, {3.5913977159277887`*^9, 3.591397732283499*^9}, {
  3.591406563455407*^9, 3.5914066130174932`*^9}, {3.591406689483697*^9, 
  3.591406692498693*^9}, {3.5914067297568283`*^9, 3.591406754614114*^9}, {
  3.591406899504566*^9, 3.591406914825438*^9}, {3.5914958733299923`*^9, 
  3.59149589180912*^9}, {3.591497382261945*^9, 3.5914973955668583`*^9}, {
  3.591498906607987*^9, 3.5914989067711687`*^9}, {3.59149923461547*^9, 
  3.5914992373489113`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"getCarrot", "[", "lp_", "]"}], ":=", 
  RowBox[{"carrot", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{
          RowBox[{"Exp", "[", "lp", "]"}], ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gStick", "[", "p_", "]"}], ":=", 
  RowBox[{"stick", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{"p", ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getStick", "[", "lp_", "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", 
          RowBox[{"yfb", "*", 
           RowBox[{"gStick", "[", 
            RowBox[{"Exp", "[", "lp", "]"}], "]"}]}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", "yfb"}], " ", ")"}]}],
        ",", 
       RowBox[{
        RowBox[{"gStick", "[", 
         RowBox[{"Exp", "[", "lp", "]"}], "]"}], ">", "0"}]}], "}"}], "}"}], 
    ",", "\[ImaginaryI]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.591499863182373*^9, 3.591499863948442*^9}, {
  3.591502118256126*^9, 3.591502122538872*^9}, {3.591502152794559*^9, 
  3.5915021558187513`*^9}, {3.591502302301382*^9, 3.591502437544718*^9}, {
  3.591502618103422*^9, 3.591502625541566*^9}, {3.591502791594653*^9, 
  3.591502804171961*^9}, {3.591505261717452*^9, 3.59150526255768*^9}, {
  3.591505662306487*^9, 3.591505662466283*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"getCarrot", "[", "p_", "]"}], ":=", 
  RowBox[{"carrot", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{"p", ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getStick", "[", "p_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", "[", "p", "]"}], "+", 
       RowBox[{"yfb", "*", "stick"}]}], ")"}], "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", "[", "p", "]"}], "+", "yfb"}], " ", ")"}]}], ")"}], "/.", 
   
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{"p", ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "50"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.591497640609787*^9, 3.591497669259742*^9}, {
  3.5914978772092648`*^9, 3.591497882762236*^9}, {3.591498016337569*^9, 
  3.5914980182526493`*^9}, {3.5914982960603228`*^9, 3.591498305537624*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"gCarrot", "[", "p_", "]"}], ":=", 
    RowBox[{"carrot", "/.", 
     RowBox[{
      RowBox[{"NMaximize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uEG", "[", 
           RowBox[{"p", ",", 
            RowBox[{"yfb", "*", "stick"}], ",", 
            RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
          RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
          ",", 
          RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
        RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"gStick", "[", "p_", "]"}], ":=", 
    RowBox[{"stick", "/.", 
     RowBox[{
      RowBox[{"NMaximize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"uEG", "[", 
           RowBox[{"p", ",", 
            RowBox[{"yfb", "*", "stick"}], ",", 
            RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
          RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
          ",", 
          RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
        RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}], "[", 
      RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"getCarrot", "[", "lp_", "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"c", "[", 
        RowBox[{"2", " ", 
         RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"gCarrot", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}], "-", "1"}], ")"}], "*", 
        "yfb"}]}], ")"}], "/", 
     RowBox[{"c", "[", 
      RowBox[{"2", " ", 
       RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}]}], " ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"getStick", "[", "lp_", "]"}], ":=", 
    RowBox[{"Piecewise", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"c", "[", 
             RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", 
            RowBox[{"yfb", "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"gStick", "[", 
                RowBox[{"Exp", "[", "lp", "]"}], "]"}], "-", "1"}], ")"}]}]}],
            ")"}], "/", 
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}]}], " ", ",", 
         RowBox[{
          RowBox[{"gStick", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}], ">", "0"}]}], "}"}], "}"}],
       ",", "\[ImaginaryI]"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5926890918005323`*^9, 3.592689260840199*^9}, {
  3.592689358013742*^9, 3.592689359089398*^9}, {3.5926895687277193`*^9, 
  3.592689573231982*^9}, {3.592689764199855*^9, 3.592689768389327*^9}, {
  3.5926906794614363`*^9, 3.592690692526185*^9}, {3.5926907257723494`*^9, 
  3.59269076040158*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"getStick", "[", "lp_", "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}], "+", 
          RowBox[{"yfb", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"gStick", "[", 
              RowBox[{"Exp", "[", "lp", "]"}], "]"}], "-", "1"}], ")"}]}]}], 
         ")"}], "/", 
        RowBox[{"c", "[", 
         RowBox[{"Exp", "[", "lp", "]"}], "]"}]}], " ", ",", 
       RowBox[{
        RowBox[{"gStick", "[", 
         RowBox[{"Exp", "[", "lp", "]"}], "]"}], ">", "0"}]}], "}"}], "}"}], 
    ",", "\[ImaginaryI]"}], "]"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"gCarrot", "[", "p_", "]"}], ":=", 
  RowBox[{"carrot", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{"p", ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"gStick", "[", "p_", "]"}], ":=", 
  RowBox[{"stick", "/.", 
   RowBox[{
    RowBox[{"NMaximize", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"uEG", "[", 
         RowBox[{"p", ",", 
          RowBox[{"yfb", "*", "stick"}], ",", 
          RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
        RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], 
        ",", 
        RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
      RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"getCarrot", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", " ", "p"}], "]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"gCarrot", "[", "p", "]"}], "-", "1"}], ")"}], "*", 
       "yfb"}]}], ")"}], "/", 
    RowBox[{"c", "[", 
     RowBox[{"2", " ", "p"}], "]"}]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"getStick", "[", "p_", "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"c", "[", "p", "]"}], "+", 
          RowBox[{"yfb", "*", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"gStick", "[", "p", "]"}], "-", "1"}], ")"}]}]}], ")"}], 
        "/", 
        RowBox[{"c", "[", "p", "]"}]}], " ", ",", 
       RowBox[{
        RowBox[{"gStick", "[", "p", "]"}], ">", "0"}]}], "}"}], "}"}], ",", 
    "\[ImaginaryI]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.593065664965815*^9, 3.593065680511347*^9}, {
  3.593067419447661*^9, 3.5930674557871027`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gCarrot", "[", "1000", "]"}]], "Input",
 CellChangeTimes->{{3.593065301868655*^9, 3.593065305112443*^9}}],

Cell[BoxData["1.00049676875129775444631354172686472441503671299630543581`20."]\
, "Output",
 CellChangeTimes->{3.593065305734476*^9, 3.593500786848001*^9, 
  3.5939922432732363`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"iamt", "[", "p_", "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"gStick", "[", "p", "]"}]}], ")"}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"gCarrot", "[", "p", "]"}], "-", "1"}], ")"}]}], 
   RowBox[{" ", 
    RowBox[{
     RowBox[{"c", "[", "p", "]"}], " ", "-", " ", 
     RowBox[{"c", "[", 
      RowBox[{"2", "p"}], "]"}]}]}]]}]], "Input",
 CellChangeTimes->{{3.593500795629076*^9, 3.593500833464243*^9}, {
  3.59350086433698*^9, 3.593500902770681*^9}, {3.593501395555315*^9, 
  3.5935014114111633`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gStick", "[", "200", "]"}]], "Input",
 CellChangeTimes->{{3.593501007304262*^9, 3.593501029228079*^9}}],

Cell[BoxData["0.\
191717482996297782049395473958665050063279157773389556346480796066003784604271\
84556933652981659449908686596134413134230065259483546359`100."], "Output",
 CellChangeTimes->{{3.593501010131755*^9, 3.593501031518887*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"iamt", "[", "1000000", "]"}]], "Input",
 CellChangeTimes->{{3.593500909524473*^9, 3.593500964794483*^9}, 
   3.5935009973244257`*^9, {3.5935010616390467`*^9, 3.593501075252368*^9}, {
   3.59350142832742*^9, 3.5935014406761427`*^9}}],

Cell[BoxData["0.96247387116326054126497433341295372343`16.20855241972544"], \
"Output",
 CellChangeTimes->{{3.5935009120390263`*^9, 3.593500966101227*^9}, 
   3.593500999331938*^9, {3.593501063122395*^9, 3.593501076109276*^9}, {
   3.593501419528985*^9, 3.593501442103632*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"iamt", "[", "p", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "1000", ",", "1000000"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.593500969855795*^9, 3.59350098640209*^9}, {
  3.593501040573413*^9, 3.593501040647127*^9}, {3.5935010798691483`*^9, 
  3.593501101722846*^9}, {3.593501244311298*^9, 3.593501248785419*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \
\[NoBreak]\\!\\(2.\
952212946138556383658240077033329985980106393763711006150011154642135973350628\
24741574412896878168001111095102077513071475027097018315`100.00496994544076 - \
\\(\\(\\(\[LeftSkeleton] 154 \[RightSkeleton]\\)\\) - 65000\\/\\(387\\\\ p\\)\
\\)\\/\\(1 + \\(\\(\\(\\(\[LeftSkeleton] 152 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[Pi]\\\\ \\(\\((\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\))\\)\\)\\)\\/\\(50\\\\ \\@6\\)\\)\\)\\)\\\\ \
\\((\\(13\\/387 + \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\)\\/\\(Plus[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\\)\\)\\)\\) + \
65000\\/\\(387\\\\ p\\) - \\(\\@\\(3\\/2\\)\\\\ \\(\\(Log[\\(\\(\\(\\(\\(\\(\
\[LeftSkeleton] 149 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\/\\(60\\\\ \\@6\\\\ p\\)\\)\\)\\)\\\\ \
\\((1\\/\\(13\\/387 + \\(\\(Times[\\(\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)\
\\)]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\\)\\)\\) + \\(\\(\\(\\(\
\[LeftSkeleton] 153 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\/\\(30\\\\ \\@6\\\\ p\\)\\)\\)\\)\\\\ \
\\((1\\/\\(13\\/387 + \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \
\\@6\\)\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \[Pi]\\)\\)\[NoBreak] is not a \
number at \[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] = \
\[NoBreak]\\!\\({2.\
918621214872406512857206485302063836109305360171979740000140353608544242084478\
37661471053723751553014030991742904386456487946993659142`100., \
0.8317573390544834577298161093494854867458343505859375`100.}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \\\
\"NMaximize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.5935012503681498`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250513563*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \
\[NoBreak]\\!\\(2.952212946138556383658247053706813524875484432643564253398`\
20.00496994544077 - \
\\(2.08686387581792305512739735262606188825884601101279258728`19.\
745419014815667 - 65000\\/\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\/\\(1 \
+ \\(\\(9.648023977411430828284751586458488555071737048151863`17.\
988835765505748*^13\\\\ \[ExponentialE]\\^\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\\\ \\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\^\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\)\\) + 65000\\/\\(387 \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\) \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\) - \\(\\@\\(3\\/2\\)\\\\ \
\\(\\(Log[\\(\\(\\(\\(8.5560339463243667755042812053329878374395796342287`18.\
19672425875081*^11\\\\ \[ExponentialE]\\^\\(-\\(\\(\\(17\\\\ \[Pi]\\\\ \
\\(\\((\\(\[LeftSkeleton] 1 \[RightSkeleton]\\))\\)\\)\\)\\/\\(60\\\\ \
\\@6\\\\ p\\)\\)\\)\\)\\\\ \\((1\\/\\(13\\/387 + \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\\)\\)\\) + \\(\\(\
\\(\\(\[LeftSkeleton] 78 \[RightSkeleton]\\)\\)\\\\ \[ExponentialE]\\^\\(-\\(\
\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\/\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\)\\)\\\\ \\((1\\/\\(\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\) \\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\) \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\
\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \[Pi]\\)\\)\[NoBreak] is not a number \
at \[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] = \
\[NoBreak]\\!\\({2.91862121487240651285721346197554737500468036159873008728`\
20., 0.8317573390544834577298161093494854867458343505859375`20.}\\)\[NoBreak].\
 \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \\\
\"NMaximize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250516561*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.5935012507084837`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250711439*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \
\[NoBreak]\\!\\(\\*StyleBox[\\(ReplaceAll :: reps\\), \\\"MessageName\\\"]\\)\
\[NoBreak] will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250713183*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \
\[NoBreak]\\!\\(2.\
952212946138556383658240077033329985980106393763711006150011154642135973350628\
24741574412896878168001111095102077513071475027097018315`100.00496994544076 - \
\\(\\(\\(\[LeftSkeleton] 154 \[RightSkeleton]\\)\\) - 65000\\/\\(387\\\\ p\\)\
\\)\\/\\(1 + \\(\\(\\(\\(\[LeftSkeleton] 152 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[Pi]\\\\ \\(\\((\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\))\\)\\)\\)\\/\\(50\\\\ \\@6\\)\\)\\)\\)\\\\ \
\\((\\(13\\/387 + \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\)\\/\\(Plus[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\\)\\)\\)\\) + \
65000\\/\\(387\\\\ p\\) - \\(\\@\\(3\\/2\\)\\\\ \\(\\(Log[\\(\\(\\(\\(\\(\\(\
\[LeftSkeleton] 149 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\/\\(60\\\\ \\@6\\\\ p\\)\\)\\)\\)\\\\ \
\\((1\\/\\(13\\/387 + \\(\\(Times[\\(\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)\
\\)]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \\@6\\)\\)\\)\\) + \\(\\(\\(\\(\
\[LeftSkeleton] 153 \[RightSkeleton]\\)\\)\\\\ \
\[ExponentialE]\\^\\(-\\(\\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\/\\(30\\\\ \\@6\\\\ p\\)\\)\\)\\)\\\\ \
\\((1\\/\\(13\\/387 + \\(\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\))\\)\\^\\(\[Pi]\\/\\(2\\\\ \
\\@6\\)\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \[Pi]\\)\\)\[NoBreak] is not a \
number at \[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] = \
\[NoBreak]\\!\\({2.\
918621214872406512857206485302063836109305360171979740000140353608544242084478\
37661471053723751553014030991742904386456487946993659142`100., \
0.8317573390544834577298161093494854867458343505859375`100.}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \\\
\"NMaximize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250898911*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(NMaximize \
:: nnum\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.5935012509023323`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "precw"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\(-0.\
201526687687269926375879127274437677258152972722225956876422302250016227898127\
70513020758457845886856040116354591462035986218857103102`100.07919146093393\\)\
\\) - carrot + \\(\\(\\(-\\(\\(\[LeftSkeleton] 154 \
\[RightSkeleton]\\)\\)\\)\\) + carrot - stick\\)\\/\\(1 + \\(\\(\\(\\(\
\[LeftSkeleton] 154 \[RightSkeleton]\\)\\)\\\\ \\((carrot\\/stick)\\)\\^\\(10\
\\\\ \\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\) + \\(\\@\\(3\\/2\\)\\\\ \
\\(\\(Log[\\(\\(\\(\\(\\(\\(\[LeftSkeleton] 152 \[RightSkeleton]\\)\\)\\\\ \
carrot\\^\\(\\(\\(13\\/2\\\\ \\(\\(Power[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\)\\)\\\\ \[Pi]\\)\\) + \\(\\(1\\/2\\\\ \
\\(\\(Power[\\(\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)\\)]\\)\\)\\\\ \
\[Pi]\\)\\)\\)\\)\\) + \\(\\(\\(\\(\[LeftSkeleton] 153 \[RightSkeleton]\\)\\)\
\\\\ stick\\^\\(\\(\\(13\\/2\\\\ \\(\\(Power[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\)\\)\\\\ \[Pi]\\)\\) + \\(\\(1\\/2\\\\ \\(\\(\
\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\\\ \
\[Pi]\\)\\)\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \[Pi]\\)\\)\[NoBreak]) is \
less than WorkingPrecision (\[NoBreak]\\!\\(100\\)\[NoBreak]). \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/precw\\\", \
ButtonNote -> \\\"NMaximize::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.593500987343947*^9, {3.593501041230792*^9, 3.5935011027819567`*^9}, 
   3.593501250904248*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVznk4lAkcwHGlHEsJbdEMxjjGeB0P0pBn+/14Yk2RckUosUwbXVLC64yK
VAZZQo6h5EyOokKYrCNRagql3kEk2862edLKbvvH9/n8+9UOOOIatFxKSsr7
e/978sNKQWoxDZ8YaHldMxaDhrejdJOAhrv6KM8BIzF0CVMD35bRMCa6tvQz
IQaVQiVdqwoaarX8SNgZiqF6l3rZ5C0auunUDj/RF8NEk9F17KJhBKue8URL
DLsS3Crnp2hYfyRsZquyGIzWFdcHGNHxQdyWH8YlFEhnLvbeM6Fj0WRiRPuf
FIwoeVHrzOhYHHD1Y9FHCs7KKyn3WdLx/fzEt71zFFCL5GELoGPdrF7S42kK
csRe7BWudLwtr9mVME7Biro1hWURdMyeOVvD6qfg1fb41OkOOj4eLR3dX0JB
di//7gYhHcMSvNvViynYyRV8cOqm4+JSaPNgIQUdDg931PXRka3gP2VTQEG5
raJq1DAdk7kD+rI5FIRxcvIUpui4oEtqHrtAgZzOzSoTeQ38/K1Zwo+gwOLr
+EC4iwZGMRQUpbkUOLku48JLDZTZaeP7nnoL+5qCU24f1sSFvYvhj395C2qZ
TpxNXzVRSo1JelFvoC/6ZGUAXwvZ6uYVPO4b0Jatq5hSYeAo580ymvs41Cry
Nml5MXDW1Jh+UPM1bFaDMhMBAz2PKE/UdI2Bmr9om+0MA60Gqr040aMgIncq
fDLWRoCIwUGLEcgsnK2JPqWNxomPuNsevYCSJYcU2VZttC0KiPtGiqAmsMvh
oDwT5+7nTH9Seg55BUytUDcm9pjHjmZXDMOoqq3JsRwmCqbY7yv2PQW19ASG
s5iJb+UUfNd+G4Jyx0SuEVsHw9OEkg+3B8FStsyDCtfBM857DCRtA1B6pZzk
tOlg1SSvsMisH4IPho5cWqGLbX+tykyb7AE9dKW1ueiiT8Or9u7T3cBx/ZIh
uayLVE3joidPCIbWcXqdI7rYwokUCcI6YYO+QV6Inh5q8/m5d048AD8X/s/r
Q/TwAHz4PBDRBgWxdFFukx5OjnhI5KTvQWviuYS7Uvr4MKig4ca7O2De2RDw
xl4fg+33u9+3bQKBvDRrLF0fl9nnX+stqwdemjJz9Lk+CpvXx4aG1YHihJRV
JI2Fmt331pUs1UCNrYrZH0EsfLrDXtJoXgmCUbF/cCULU2WZJ4vlyiE7WnS8
cZ6FNyMVb5j9Uwpju8/fl/3JAF3CJ4eCw0tAWp7BXEgwQPta95DfsQhY7c9/
fdBvgJzZ5IvbuPlwtd55Ok2FjXyezNPNQzmgUj3FNd3LxhfFPtZ1py8DL9r/
4dFyNgZeepZUWJMBSmeuRDbOsbGBcrD090uHhux5pSErQ0zfwzma4J4GVWKV
Vx9jDdEiZtJbofUcJK9cI6zuNESJjW8A/3oy+BibptutJtBgyWjOryURkvir
M0bcCFx1TK5D6BUPgZXqrsoeBBoKuRYvd8SDnVBXxdGTwNcNB3wkW+Ph3y+b
Mxq9CAztEAeZmsVDlD8vI92PwJKhlNx5+Xg4atqe4cAjsKrCuGVjZBz4PjqW
eSuKQKULMx32TrFg8450m4kmvv/25j21joUNy86pMmIIPDIQufUgKxZEG69m
XogjkD/dktS2PBZc83szDyQR+PeCss9ccww4huhkaV4ksFn/UBTXMAZYySbu
HpcInDePf52iFgMyhdZr09IJtL79rGlQJgY6n7hkLWQQWC+7pZUUk7BlM5k1
/BuBx/U4Ns4FJGi4n3VXyCXQeKU6b+w8CYuHMtbaXSFwu1CkRUaR0FJcnlWb
T+CksONaz24Scu/Wu08VEOhMjeQmOpBw6lnrWo1CAgv6U0T2liR4fuwZdisi
sDJr3FtVlwRL+WdZqcUEnsi+qzGrQsJ/vT2HDQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[1000], 0.}, {6.907755278982137, 0.}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {8.517193191416238, 
       FormBox["5000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      10.819778284410283`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      11.512925464970229`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      13.122363377404328`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      13.815510557964274`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      15.424948470398375`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[1000], 
      Log[1000000]}, {0., 0.5993224831702497}}, {{6.907755278982137, 
    13.815510557964274`}, {0., 0.5993224831702497}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {8.517193191416238, 
      FormBox["5000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     10.819778284410283`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     11.512925464970229`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     13.122363377404328`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     13.815510557964274`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     15.424948470398375`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{
  3.593500987647088*^9, {3.593501041573024*^9, 3.5935010825978813`*^9}, 
   3.5935012384847918`*^9, 3.5935012758866997`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "[", "1000", "]"}]], "Input",
 CellChangeTimes->{{3.593500839944572*^9, 3.593500851600143*^9}}],

Cell[BoxData[
 FractionBox["143", "387"]], "Output",
 CellChangeTimes->{3.5935008521557093`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NMaximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"1000", ",", 
       RowBox[{"yfb", "*", "stick"}], ",", 
       RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
     RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.59306533958862*^9, 3.593065341115089*^9}}],

Cell[BoxData[
 RowBox[{"NMaximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"1000", ",", "stick", ",", "carrot"}], "]"}], ",", 
     RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Output",
 CellChangeTimes->{3.593065341894211*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getStick", "/@", 
  RowBox[{"{", 
   RowBox[{
   "400", ",", "410", ",", "420", ",", "430", ",", "440", ",", "450", ",", 
    "460", ",", "470", ",", "480", ",", "490", ",", "500"}], "}"}]}]], "Input",\

 CellChangeTimes->{{3.5914980943453836`*^9, 3.591498273874192*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "400"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "400"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "410"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "410"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "420"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "420"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "430"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "430"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "440"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "440"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "450"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "450"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "460"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "460"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "470"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "470"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "480"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "480"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "490"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "490"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False], ",", 
   TagBox[GridBox[{
      {"\[Piecewise]", GridBox[{
         {
          FractionBox[
           RowBox[{
            RowBox[{"-", 
             FractionBox["374", "387"]}], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "500"]}]], "+", 
            RowBox[{"(", 
             RowBox[{"stick", "/.", "\[VeryThinSpace]", 
              RowBox[{"{", 
               RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], 
           RowBox[{
            FractionBox["13", "387"], "+", 
            FractionBox["130000", 
             RowBox[{"387", " ", 
              SuperscriptBox["\[ExponentialE]", "500"]}]]}]], 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
         {"\[ImaginaryI]", 
          TagBox["True",
           "PiecewiseDefault",
           AutoDelete->True]}
        },
        AllowedDimensions->{2, Automatic},
        Editable->True,
        GridBoxAlignment->{
         "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
          "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}},
           "RowsIndexed" -> {}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.84]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}},
        Selectable->True]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.35]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    "Piecewise",
    DeleteWithContents->True,
    Editable->False,
    SelectWithContents->True,
    Selectable->False]}], "}"}]], "Output",
 CellChangeTimes->{{3.5914980977110977`*^9, 3.591498203497528*^9}, {
   3.591498235430366*^9, 3.5914982763088417`*^9}, 3.591498317801042*^9, 
   3.592687044883234*^9, {3.592718346954031*^9, 3.592718369479992*^9}, 
   3.593065252567519*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getStick", "[", 
  RowBox[{"Log", "[", "1400", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5914982860507183`*^9, 3.591498288671927*^9}, {
   3.591498653780658*^9, 3.591498664834984*^9}, {3.59149879695152*^9, 
   3.591498820024013*^9}, 3.591500676718988*^9, 3.591500741666993*^9, {
   3.5915008032105513`*^9, 3.591500805026986*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {
        RowBox[{
         FractionBox["903", "247"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox["656", "903"]}], "+", 
           RowBox[{"(", 
            RowBox[{"stick", "/.", "\[VeryThinSpace]", 
             RowBox[{"{", 
              RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"stick", "/.", "\[VeryThinSpace]", 
           RowBox[{"{", 
            RowBox[{"carrot", ",", "stick"}], "}"}]}], ")"}], ">", "0"}]},
       {"\[ImaginaryI]", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.591498289435787*^9, 3.5914983110108023`*^9}, {
   3.5914986550674343`*^9, 3.5914986658050127`*^9}, {3.591498798595684*^9, 
   3.591498821322657*^9}, 3.59150055362088*^9, {3.591500661551552*^9, 
   3.591500677977235*^9}, 3.591500743363016*^9, {3.591500806720807*^9, 
   3.591500825749028*^9}, 3.591502734559705*^9, 3.5915028161483994`*^9, 
   3.592687090959607*^9, 3.592716984194627*^9, 3.593065266230324*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"gStick", "[", "1400", "]"}]], "Input",
 CellChangeTimes->{{3.591502778017968*^9, 3.591502779983683*^9}}],

Cell[BoxData["0.\
887923057137799457244332443399856315340962402761818110114459729216028408994979\
14772261831192620105281563325169266756785311199612139145`100."], "Output",
 CellChangeTimes->{{3.5915027811961813`*^9, 3.591502809866185*^9}, 
   3.592687108977524*^9, 3.5927169794791613`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getCarrot", "[", 
  RowBox[{"Log", "[", "39000", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.591395519898222*^9, 3.591395592618753*^9}, {
  3.591395703881588*^9, 3.591395710090147*^9}, {3.5913957418582573`*^9, 
  3.591395742356349*^9}, {3.591396058867147*^9, 3.591396103155135*^9}, {
  3.5913964823497458`*^9, 3.591396496589364*^9}, {3.591397750575317*^9, 
  3.591397753098239*^9}, {3.591492987626154*^9, 3.591492994038726*^9}, {
  3.591496429705811*^9, 3.5914964525621758`*^9}, {3.591497302857349*^9, 
  3.591497312054688*^9}, {3.591497401297893*^9, 3.591497409203223*^9}}],

Cell[BoxData["1.001937198292218203362788699870722117984173482856343822799`20.\
"], "Output",
 CellChangeTimes->{{3.5913955234379787`*^9, 3.591395593214847*^9}, {
   3.5913957067394114`*^9, 3.5913957109379597`*^9}, 3.591395743389059*^9, {
   3.5913960543346233`*^9, 3.5913961041569157`*^9}, {3.591396475903797*^9, 
   3.591396497445181*^9}, {3.591397738664184*^9, 3.591397754061673*^9}, 
   3.591481963011739*^9, 3.591491271797008*^9, 3.591492701223507*^9, {
   3.5914929904987288`*^9, 3.591492994487812*^9}, 3.5914958965246687`*^9, {
   3.591496431302526*^9, 3.591496453511524*^9}, {3.5914973044388742`*^9, 
   3.591497312508843*^9}, {3.591497402491132*^9, 3.591497411792573*^9}, 
   3.592687119266584*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NMaximize", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uEG", "[", 
      RowBox[{"39000", ",", 
       RowBox[{"yfb", "*", "stick"}], ",", 
       RowBox[{"yfb", "*", "carrot"}]}], "]"}], ",", 
     RowBox[{"1", "\[GreaterEqual]", "stick", "\[GreaterEqual]", "0"}], ",", 
     RowBox[{"carrot", "\[GreaterEqual]", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"carrot", ",", "stick"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591496518787771*^9, 3.591496542613147*^9}, {
  3.5914973378900013`*^9, 3.591497374033484*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
   "-", "0.942193709753761379401793662686681573621959243157963332875`20."}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
     "carrot", "\[Rule]", 
      "1.001985890673045418349205061352430351193061695096118038107`20."}], 
     ",", 
     RowBox[{
     "stick", "\[Rule]", 
      "0.997844898172542560918746060115786921089045107573803304804`20."}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5914965256525583`*^9, 3.591496543624153*^9}, {
  3.5914973523929768`*^9, 3.591497375470171*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"p", ",", "ya", ",", "yb"}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"p", "\[Rule]", "39000"}], ",", 
    RowBox[{"ya", "\[Rule]", "0.9981518081569045`"}], ",", 
    RowBox[{"yb", "->", "1.0024301936368611`"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.591496494607094*^9, 3.591496503075569*^9}, {
  3.591496549124481*^9, 3.591496594862108*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.9375330224007838`"}]], "Output",
 CellChangeTimes->{{3.591496579263379*^9, 3.591496597063662*^9}, 
   3.592687134904028*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"\[Delta]", "[", "p", "]"}]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["ya", "yb"], ")"}], 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "0"], "+", 
       SubscriptBox["\[Beta]", "1"]}], "s"]], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["1", 
       RowBox[{"c", "[", "p", "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]]}], "+", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", 
     FractionBox[
      RowBox[{
       SubscriptBox["\[Beta]", "2"], " ", 
       RowBox[{"\[Delta]", "[", 
        RowBox[{"2", " ", "p"}], "]"}]}], "s"]], "  ", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["1", 
       RowBox[{"c", "[", 
        RowBox[{"2", " ", "p"}], "]"}]], ")"}], 
     FractionBox[
      SubscriptBox["\[Beta]", "1"], "s"]]}]}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"p", "\[Rule]", "39000"}], ",", 
    RowBox[{"ya", "\[Rule]", "0.9981518081569045`"}], ",", 
    RowBox[{"yb", "->", "1.0024301936368611`"}]}], "}"}]}]], "Input",
 CellChangeTimes->{3.591496637118376*^9}],

Cell[BoxData["10.946554897350271`"], "Output",
 CellChangeTimes->{3.5914966379166718`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["yb", "ya"], ")"}], 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "0"], "+", 
      SubscriptBox["\[Beta]", "1"]}], "s"]], "  ", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"p", "\[Rule]", "37000"}], ",", 
     RowBox[{"ya", "\[Rule]", "0.9981518081569045`"}], ",", 
     RowBox[{"yb", "->", "1.0024301936368611`"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.591496671727597*^9, 3.591496682728675*^9}, {
  3.591496714561357*^9, 3.591496786162879*^9}, {3.591496878277659*^9, 
  3.5914968796829653`*^9}}],

Cell[BoxData["1.1128548869739499`"], "Output",
 CellChangeTimes->{{3.591496652974605*^9, 3.591496683857642*^9}, {
   3.5914967155566483`*^9, 3.591496787426811*^9}, 3.591496880385243*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getCarrot", "[", "9976.318319274413`", "]"}]], "Input",
 CellChangeTimes->{{3.59139731963805*^9, 3.591397344621619*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "unfl"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Underflow occurred in computation. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/unfl\\\", ButtonNote -> \
\\\"General::unfl\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.59148196421698*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "unfl"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Underflow occurred in computation. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/unfl\\\", ButtonNote -> \
\\\"General::unfl\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5914819642243*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "unfl"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Underflow occurred in computation. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/unfl\\\", ButtonNote -> \
\\\"General::unfl\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591481964226144*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(General \
:: unfl\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591481964278245*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "nnum"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The function value \[NoBreak]\\!\\(Indeterminate\\)\
\[NoBreak] is not a number at \[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] = \
\[NoBreak]\\!\\({1.9186212148724064`, 1.663514678108967`}\\)\[NoBreak]. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \\\
\"NMaximize::nnum\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591481964471744*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5914819644848223`*^9}],

Cell[BoxData[
 RowBox[{"carrot", "/.", "\[VeryThinSpace]", 
  RowBox[{"{", 
   RowBox[{"carrot", ",", "stick"}], "}"}]}]], "Output",
 CellChangeTimes->{{3.5913973332203007`*^9, 3.5913973457702427`*^9}, 
   3.59148196448796*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.591407181983006*^9, 3.591407412022156*^9}, {
   3.591407469767543*^9, 3.591407485528679*^9}, {3.5914075236559687`*^9, 
   3.5914075272177353`*^9}, {3.591407583650271*^9, 3.5914077964038687`*^9}, 
   3.591591987178722*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"tokurei", "[", "p", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "1", ",", "10000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591407413740526*^9, 3.59140743653309*^9}, {
  3.591407488318288*^9, 3.59140755535581*^9}, {3.591407604217366*^9, 
  3.591407617433774*^9}, {3.59140781161556*^9, 3.591407861560956*^9}}],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13k4VO8XAHCZ7DHDGPs2Ssm+pTsM9zDIvkQi2YlC9uWrElIhlCghKooW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      "]], 
     LineBox[{{9.21548007084447, 72.24762393442356}, {9.219348817570197, 
      72.43506838446054}, {9.22462755034584, 72.69229716313572}, {
      9.235185015897127, 73.21188874305066}, {9.2562999469997, 
      74.2719674406793}, {9.298529809204846, 76.47867442431934}, {
      9.382989533615136, 81.2635830289931}, {9.388268266390778, 
      81.58014908456207}, {9.393546999166421, 81.89887014230497}, {
      9.404104464717708, 82.54284338583787}, {9.425219395820282, 
      83.8573852239276}, {9.467449258025427, 86.59674048395861}, {
      9.551908982435718, 92.54975351347353}, {9.55683257075416, 
      92.91758749174484}, {9.561756159072601, 93.2878213085499}, {
      9.571603335709483, 94.0355591106881}, {9.591297688983246, 
      95.56061810794618}, {9.611122538266153, 97.13661146396825}}], 
     LineBox[CompressedData["
1:eJwVjmkw3GcAhzUJmZiONMWiSRD/9yU0mzYYSlN+VNxGCIpgsda1jt0dG1dG
Ou5G44yjxhGKtiFthIpg1rURKqJGIsgh2qi4WnSIbEuqH555Pj0zz7HgWHfe
Hjk5Octd/reo6e65BWsGa7apd91qvNF2UeuxBZ+BqWkdadj2QYeG50fSaAYD
fE/NOhVfSNouZzkIGFR9YZE2+KEv7q1umHqIGTjWhN3M8PXFZMj9sohLDJ7o
etVP3fGFzDnR92oRA7LsF2bw5XlYHB1/ttDJwMIqdKSO7Y+k2rNt9RIGyT2p
IoGzP9r0HuQG9TI4nmUbIeb746ThkOXUAIP+c+Zs9nV/aNl11wyOMYjvqb0Q
ZBAAOWEj77t5BrzHcwrOJhyc3jxuwV1koJ1ikTXvzUFCcgNLa4VByfDXXGky
B6sZNfdK1hl05rf72fRxMFteqp+5vfubsyfCRD8QfdK0lRBlgq2H+1VWuwOx
4/DOgDaL4GXX0o+R44EwH02peqpOoMIUVCnOB+LWVKKrhybBi6VYSadSEL79
M7b5c30CaWqPbIkThHR1P7GOJUGdckT/gwPBsI0y3p6JJBA3hE4cTuFC0UHB
ITqa4FntPhubYi5G6eRVWSzBT/pd3qVNXHjPJJ9QFRO4JelNSp5wEenef97x
EsGbuNS3R06HIPcT947WIoJc3XCNMHke3FWJgnUJwTVjtY0QLR7U1jfcRssI
hM3V3kVmPFxr/GZhoXK3P/SZS1oMD7c0Z9W1vidYGow365zmYWKfIP6rLgK5
6B+KX3WFonzWqp/VTWC3vBWjPR0KjkT5YF0vQWmfVXHe61C8ir/dIBkgcD1U
X6FqFAbZ4s6jv38liGyVVYw0hUFz7IpxwByBUrunrk9jOHiVjWuGShQev8nm
EyYjUdY0wml5j6L6uat44t9I/NL514iRMkWYqNQl8RgfJ6eNrhurUwynf2BQ
wOdjk9UVbKJDoWjntqixNwqZ+ffHzUwoEqc1WlmIRkPays8IoJCypWzrzVhM
Fh4kvYEU/JH8Vcv3BVCsPVVoxaV49Joty9EXIKZHHGMdTsHyLGFueAtgsr2t
ayOi+Mcg+IbmHQHC39UulsZR+Nv3PW8eE6D8sPXeM/EUfyRohIgXBdgxy5w5
c5Ei3URbKe+IEAMXlMrsMik+fXH0inqaEFsZHysMZlNkV9vLm1cKYVDsHmef
Q+FpGHwq77YQuS0lZx3yKX5X0wufWBaip69dMlRIUcnu9xraL8L62PQJx2IK
l8vGvWs6Initah5wKqewtF5++tJHhOy3iB+uoBA4pSfdFIvQocSdc6qm0GaV
R7UUiPBwWd5VvYbimHO+7pt6Ef4D2Vy9Jw==
      "]], LineBox[CompressedData["
1:eJwBQQK+/SFib1JlAgAAACMAAAACAAAApCBgplumJUAqmB3ZW8FyQFA8yS/N
piVA8IjaXWbCckCCS+udTaklQNHjnw5KyHJA52kvek6uJUDSFemgJ9RyQFBh
mWgFsSVAqm6vIKTackC6WANXvLMlQA5oOHQp4XJAjkfXMyq5JUCYvq/GTu5y
QDYlf+0FxCVA0+qabQUJc0CG4M5gvdklQJtgdZ0tQHNAJFduRywFJkAlEPvg
w7VzQI5O2DXjByZATt/IaHO9c0D4RUIkmgomQC15L2YtxXNAzDQWAQgQJkC5
Gsr6wNRzQHQSvrrjGiZAAwSNHmj0c0DDzQ0umzAmQE8NCCzDNXRAYkStFApc
JkCg9LRvF8F0QFSTa3aSXiZA4+pPOJbJdEBG4inYGmEmQOGr0skf0nRAK4Cm
mytmJkBZ52R+U+N0QPS7nyJNcCZAM+ZjsT4GdUCGM5IwkIQmQJ69RJYwTnVA
qyJ3TBatJkClDUTY6OZ1QJ5xNa6eryZAlTD7odzwdUCQwPMPJ7ImQFtRIg7d
+nVAdF5w0ze3JkBOff0NBA92QD6aaVpZwSZA7wsMcuw3dkDQEVxonNUmQKry
5kA1jHZAwmAayiTYJkDIQKTj+pZ2QLSv2Cut2iZAXNM4M86hdkCZTVXvvd8m
QDsybx6et3ZAYolOdt/pJkBNJ50Q5eN2QPQAQYQi/iZAL283Ch8/d0AeOEdm
4QAnQD77JV/DS3dASG9NSKADJ0BOxegaeVh3QHKQ9X78AydA/jrqRCVad0Bh
MfOT
      "]], LineBox[CompressedData["
1:eJwVkGtIU2EAhtfKaSp2W6m14czk+9RlV6kp6ptQRDJzYWaeWVpLBM1KwXO2
s9Ip3XT5Y5mSRWVKxiybl6Qky2bhyii7KKvs7kJKrSYjKbLWj5eH58/z4w3e
tW/LHqFAIIhw7z8T7m0ejJ9J4Cz5I+grYWETZ44P+RCUNUY7px9l4UzM7j/j
R/BCY5NUn2CxobOgKlBM0PT13YWBWhb7f3BF9gUEtdqseWV1LGppcVpNIMEM
zUSH4jKL8eoKyfwgAuttV4/1OouawoaG2eEE0khP9fqnLKxm85EncoK2ptCu
WDuL0Q+WnMplBKeKtR3x71gguUvuG0Vg2th4KXOMxYh8sN0TBP1deyb8vTlE
f/a8P7WVIO7RvaU56zlopH6NXWkEfVVHcwVKDpUp4uN6hiCs3SitT+Hw0SpT
/sokyFNNC/DScKg4rxhw5RJsv5k9pSrjMJSW6xg1EIzbV5qcPRyK+x57vL5K
MKdwTfhzpRYr08OYXAvBDWNpcFyqFsMjZZbfre7/Epd9aduhxSaRgpHcIBgu
YUj3Pi3E6+otGVaCl+1XXqlNWlzuYJn3gwTNYkNz20st+utkLY6/BAbT3RXx
B3QoXc6LioQUmbM+Ncl4HaLuDDAiDwrlQYvd77AOtUPlIuJN8W2huWLOaR00
/i4mR0xhk68Ibb2rw6TxgegrpWAiz77Jn8/DvGiJmo+gqIxRbQuR8cgwH2rx
iaRwlL4yOcJ5WHtXqeWrKDRJa6tPgodReK5lbyxFp+6+tSaPRzBXoP6uoqj/
k9+Q3MsjQSF9UZhCkeQXtPPaMx67fvUm/kyl2JIxlid5y+OiXhozxVCcbo94
GOxy92NtrYYdFIrlk7GdAj0+ThWEe2RRpHqfVWb56iHsll48tpsi3XnIxz9A
j8UGW6BvNsWt3qDy1yF6zF3taH7v9p7QJC8r0eMfhjAqGQ==
      "]], 
     LineBox[CompressedData["
1:eJwVj20s1HEAx6/Ejp1da2JnuTnuzu/3IqtMsjFfDy3yTJpCZ5crLKuVo/K/
8ydya8Ki0wtuuc7DOqVWbtgQ3Y4ztEpsFiK04pZs5EVP14vPPq8+Lz4i+eUU
xW4OhyO1899LF8OcxJcIDKPzJQv+DMrNo6y2gICTcVeddISBvvLajuAKQcJC
f1PSMQY+d4QzfjcJNro2XZuTGETEWhOMDMHQp7T016cZyHmFFv9SAu7QAfmP
THtfY+0OrCCY5dlmc/IY+NYXNkTWEETFbCgflzMQN40ly/QEP18UefWaGERl
Ka1LBgJW28fL7meQI/QOv9BOMM9TZvHNDAwPlYcKOgnKtrXxVW/tfas3v8RE
MCli6ufWGUieFo1rxwjenLUEH5SoIH3lc2Jyk0Dhkvi9vUkFdd7+MM0Wwcd0
g0XQqsL0Pm5QxA5BrWaVND5R4bbCJjX9JsjekE+8HFBh1aXHScelKB5MTVMt
qtCWFm8pEFKI1w7rk6kakrXi464nKR7c6l9RDavBNOSHjsRR+O7tOFc2rsZU
aFZgWSKFMfF61b1pNSrqIiRbpyjSzT0B89/UWA50dZyTUbgFL3K93EphYPXm
TiVFZupcdUxeKcTuE5FxLRRXa1tkSj6LPR5uXTOPKIKUfN1fNxbLHhme59so
3j3Lt9V5smgVfN24YaTQ3d/1eVTCQurlqGvvpgj7s0RqQ1g4CeOcA3oo3N83
21IiWHwR1hcO9FE4/zDwhNEsOrxFsR8GKRzgVzqWykIjyjVlD9v/HDQrxjMs
cn26ROtmil+pnPEGGYto3+3q4hEKwVFRSKWCxfOZqXmzlaLX1Bi+ls/iH/sX
Cj8=
      "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQ3citb8ZxXtNBZJ37w6qMBodXqqfPSSLxT6kJWS29
iOCvUo9canAFwc/WfF7tfhPB19EuDYq7h+Cv1Zv4v/sFgq9ntHbNzk8IvomD
bGKBtBacb+nXK6ruguA7FGa1p8xB8N2nuP9c+AXB31HKV/h0oTZCveXrva3O
OnD+Qa5DMsc+IfiR+9YFJE/ThfNDeFdInDTTg/M9smZ/OvcEwQ9euWShYbs+
nP/FpMf/ykME3/vBzjprOQM4HwD93pIC
      "]]}, {}}, {{}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 0.},
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{0., 
       FormBox["1", TraditionalForm]}, {4.605170185988092, 
       FormBox["100", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.1354942159291497`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.5263605246161616`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.8066624897703196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.02535169073515, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.204692619390966, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.356708826689592, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.48863636973214, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.090076835776092, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.7406644019172415`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.131530710604252, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.411832675758411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.630521876723241, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.809862805379057, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.961879012677683, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.093806555720231, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.695247021764184`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.345834587905333`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.736700896592344`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.017002861746503`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.235692062711331`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.415032991367148`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.567049198665774`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.698976741708323`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{0., 
       FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {2.4849066497880004`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.1354942159291497`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.5263605246161616`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.8066624897703196`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.02535169073515, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.204692619390966, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.356708826689592, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.48863636973214, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.090076835776092, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.7406644019172415`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.131530710604252, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.411832675758411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.630521876723241, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.809862805379057, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.961879012677683, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.093806555720231, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.695247021764184`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.345834587905333`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.736700896592344`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.017002861746503`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.235692062711331`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.415032991367148`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.567049198665774`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.698976741708323`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{0, 
      Log[10000000]}, {0., 525.3648712017667}}, {{0, 16.11809565095832}, {0., 
     525.3648712017667}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{0., 
      FormBox["1", TraditionalForm]}, {4.605170185988092, 
      FormBox["100", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {2.4849066497880004`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.1354942159291497`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.5263605246161616`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.8066624897703196`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.02535169073515, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.204692619390966, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.356708826689592, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.48863636973214, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.090076835776092, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.7406644019172415`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.131530710604252, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.411832675758411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.630521876723241, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.809862805379057, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.961879012677683, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.093806555720231, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.695247021764184`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.345834587905333`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.736700896592344`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.017002861746503`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.235692062711331`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.415032991367148`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.567049198665774`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.698976741708323`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{{3.59140741773464*^9, 3.591407437271233*^9}, {
   3.591407491271914*^9, 3.5914075564667263`*^9}, {3.5914076030276823`*^9, 
   3.5914076177671127`*^9}, {3.5914078063313828`*^9, 3.591407863443054*^9}, 
   3.5914819663554897`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.591407913378251*^9, 3.591407942922392*^9}, {
   3.591408071104814*^9, 3.591408072097725*^9}, 3.5914088800673733`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "1000", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5914081952121773`*^9, 3.591408198410285*^9}, {
  3.591408287908102*^9, 3.591408288759738*^9}}],

Cell[BoxData["14.3`"], "Output",
 CellChangeTimes->{3.591408199673278*^9, 3.591408289476617*^9, 
  3.591481967421389*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "2000", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591408203313415*^9, 3.5914082057944527`*^9}, {
  3.591408282443972*^9, 3.591408282807352*^9}}],

Cell[BoxData["7.8`"], "Output",
 CellChangeTimes->{3.591408206457879*^9, 3.591408283688149*^9, 
  3.591481968404361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1.3", "2"], 
   RowBox[{"(", ".7", ")"}], 
   RowBox[{"c", "[", "1000", "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5914082129288483`*^9, 3.591408217907044*^9}, {
  3.5914082482472363`*^9, 3.591408249098701*^9}, {3.5914083936626987`*^9, 
  3.5914084339919147`*^9}}],

Cell[BoxData["6.5065`"], "Output",
 CellChangeTimes->{
  3.591408218809945*^9, 3.591408249742256*^9, {3.591408395547086*^9, 
   3.5914084347520857`*^9}, 3.591481968794654*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", "1.02"}], ")"}], "^", "12"}]}], ")"}], 
  RowBox[{"(", 
   RowBox[{"1", "/", ".02"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.591408560754732*^9, 3.59140861012545*^9}}],

Cell[BoxData["10.5753412209172`"], "Output",
 CellChangeTimes->{{3.591408584538159*^9, 3.5914086109802637`*^9}, 
   3.5914819697787247`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "/", "1.02"}], ")"}], "^", "15"}]}], ")"}], "*", ".7", 
   "*", 
   RowBox[{"c", "[", "1000", "]"}]}], "+", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "1.02"}], ")"}], "^", "15"}], "  ", "0.7", 
   RowBox[{"c", "[", "2000", "]"}]}], "+", 
  RowBox[{
   RowBox[{"tokurei", "[", "1000", "]"}], "*", ".02"}]}]], "Input",
 CellChangeTimes->{{3.5914086291653233`*^9, 3.591408661455065*^9}, {
  3.591408755657425*^9, 3.591408788610474*^9}, {3.591408824691792*^9, 
  3.591408850445826*^9}, {3.591408882244928*^9, 3.591408882564486*^9}}],

Cell[BoxData["7.18392057855224`"], "Output",
 CellChangeTimes->{{3.591408624572585*^9, 3.591408636688773*^9}, 
   3.591408757937048*^9, 3.591408789494163*^9, {3.591408826256873*^9, 
   3.5914088517611313`*^9}, 3.591408883944437*^9, 3.591481970209161*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"santei", "[", "p_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "/", "1.02"}], ")"}], "^", "15"}]}], ")"}], "*", ".7", 
    "*", 
    RowBox[{"c", "[", "p", "]"}]}], "+", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "/", "1.02"}], ")"}], "^", "15"}], "  ", "0.7", 
    RowBox[{"c", "[", "p", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.591409046783495*^9, 3.591409072410778*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"c", "[", "2000", "]"}]], "Input",
 CellChangeTimes->{{3.5914088532455063`*^9, 3.591408856364418*^9}}],

Cell[BoxData[
 FractionBox["39", "5"]], "Output",
 CellChangeTimes->{3.5914088569759617`*^9, 3.5914819713932333`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"0.7", 
  RowBox[{"c", "[", "2000", "]"}]}]], "Input",
 CellChangeTimes->{{3.591408860863274*^9, 3.5914088620763903`*^9}}],

Cell[BoxData["5.46`"], "Output",
 CellChangeTimes->{3.591408862968395*^9, 3.5914819723862543`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "1000", "]"}], "/", 
  RowBox[{"c", "[", "2000", "]"}]}]], "Input",
 CellChangeTimes->{{3.5914082596804323`*^9, 3.591408263531827*^9}}],

Cell[BoxData[
 FractionBox["11", "6"]], "Output",
 CellChangeTimes->{3.591408264143116*^9, 3.591481972777129*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getCarrot", "[", 
  RowBox[{"Log", "[", "20000", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.591492506583185*^9, 3.5914925640968113`*^9}, {
  3.591492958562252*^9, 3.5914929744603453`*^9}}],

Cell[BoxData["0.4769465770508101`"], "Output",
 CellChangeTimes->{{3.5914925144496107`*^9, 3.5914925652188683`*^9}, {
  3.591492955177421*^9, 3.5914929754549*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"0.008", "*", "40000"}]], "Input",
 CellChangeTimes->{{3.591501155007842*^9, 3.591501155778817*^9}, {
  3.5915011869365053`*^9, 3.591501197012999*^9}}],

Cell[BoxData["320.`"], "Output",
 CellChangeTimes->{{3.591501192529779*^9, 3.591501197713066*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"getCarrot", "[", "p", "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "300", ",", "5000000"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "20"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.01"}], ",", ".21"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}]}], ",", 
   
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Population\>\"", ",", "\"\<Fraction of c\>\""}], "}"}]}]}], 
  "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxNl3c41X/4/40mMhJnGefIXg3Z3u/XbVZaxscMZUYDWZnZZUcaEpURFUKU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->NCache[{
     Log[300], -0.01}, {5.703782474656201, -0.01}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Frame->{True, True, False, False},
  FrameLabel->{{
     FormBox["\"Fraction of c\"", TraditionalForm], None}, {
     FormBox["\"Population\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[300], 
      Log[5000000]}, {-0.01, 0.21}}, {{5.703782474656201, 
    15.424948470398375`}, {-0.01, 0.21}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.5939923979294357`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"getCarrot", "[", "p", "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "300", ",", "5000000"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "20"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.01"}], ",", ".21"}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}]}], ",", 
   
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Population\>\"", ",", "\"\<Fraction of c\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5930656917713633`*^9, 3.593065700235557*^9}, {
   3.5930657520615807`*^9, 3.5930657535388308`*^9}, {3.593065919232813*^9, 
   3.593065948892407*^9}, {3.593066099870635*^9, 3.593066103124448*^9}, {
   3.5930661849831944`*^9, 3.5930661901831923`*^9}, {3.5930664325748377`*^9, 
   3.5930664414472933`*^9}, {3.593066597426407*^9, 3.5930666011646967`*^9}, 
   3.59306668698028*^9, {3.5930682962800417`*^9, 3.593068301142308*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVV3k4Ve0XVaRCpZR7r/FemYcbn+FD7t0bSYkMZUgo8xCKTCFRxgwpknxU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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->NCache[{
     Log[300], -0.01}, {5.703782474656201, -0.01}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Frame->{True, True, False, False},
  FrameLabel->{{
     FormBox["\"Fraction of c\"", TraditionalForm], None}, {
     FormBox["\"Population\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[300], 
      Log[5000000]}, {-0.01, 0.21}}, {{5.703782474656201, 
    15.424948470398375`}, {-0.01, 0.21}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.59306572333777*^9, 3.593065804415647*^9, 
  3.5930660048376503`*^9, 3.5930661631351023`*^9, 3.5930662510210133`*^9, 
  3.593066497508101*^9, 3.593066656906698*^9, 3.5930667436561737`*^9, 
  3.593068359687749*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"getCarrot", "[", "lp", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "300", "]"}], ",", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.593065491271048*^9, 3.593065491558793*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt2Hk4Vd/XAHAplFmGOxnuEbqmGykROotSFIkKlSGSqNBgqEiISplVJMoY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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{6., 1.},
  Method->{},
  PlotRange->NCache[{{
      Log[300], 
      Log[5000000]}, {1.000000000091824, 1.1249666831351601`}}, {{
    5.703782474656201, 15.424948470398375`}, {1.000000000091824, 
    1.1249666831351601`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.592687210476289*^9, 3.592689321181951*^9, 
  3.592689428681114*^9, 3.5926908378401337`*^9, 3.593065239266391*^9, 
  3.593065433363253*^9, 3.593065544205913*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Exp", "[", "10", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.592689469215632*^9, 3.592689490721863*^9}}],

Cell[BoxData["22026.465794806718`"], "Output",
 CellChangeTimes->{{3.5926894751954193`*^9, 3.592689491327483*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"getCarrot", "[", "lp", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "50", "]"}], ",", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "20"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591395629483778*^9, 3.591395686772867*^9}, {
  3.591396723813941*^9, 3.5913967626679373`*^9}, {3.591396851681734*^9, 
  3.59139685287927*^9}, {3.591397766939871*^9, 3.5913977779845552`*^9}, {
  3.5914849560555563`*^9, 3.5914849570876093`*^9}, {3.5914928559757147`*^9, 
  3.591492857653212*^9}, {3.59149965389396*^9, 3.591499657475322*^9}, {
  3.591499774442622*^9, 3.591499784424909*^9}, {3.591500167060083*^9, 
  3.5915001731143208`*^9}, {3.5915002627116137`*^9, 3.591500267581345*^9}, {
  3.5915052519766693`*^9, 3.591505252194092*^9}, {3.5915056674036016`*^9, 
  3.5915056676949663`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "precw"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\(-3.391974898051742`\\)\\) - carrot + \
\\(\\(\\(-3.358383166785593`\\)\\) + carrot - stick\\)\\/\\(1 + \
\\(\\(1.5496721249243952`\\\\ \\((carrot\\/stick)\\)\\^\\(10\\\\ \
\\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\) + \\(\\(Log[carrot]\\)\\) + \
\\(\\@\\(3\\/2\\)\\\\ \\(\\(Log[\\(\\(\\(\\(0.45183876065342143` \
\[VeryThinSpace]\\)\\) + \\(\\(0.2915705544329034`\\\\ \\((stick\\/carrot)\\)\
\\^\\(10\\\\ \\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \
\[Pi]\\)\\)\[NoBreak]) is less than WorkingPrecision (\[NoBreak]\\!\\(20\\)\
\[NoBreak]). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/precw\\\", ButtonNote -> \
\\\"NMaximize::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.59149742032092*^9, 3.591499658490065*^9, 
  3.5914997854751*^9, 3.591500040600279*^9, 3.5915000996445227`*^9, 
  3.591500181401618*^9, 3.59150027056087*^9, 3.591500834765244*^9, 
  3.591505166278799*^9, 3.5915056684693623`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF2Xc8le0fB3A7IlF0Bs65jWMeR0NGim+IJKMkEiKjjCiU1UBCipKUhpHd
stIyGrSQVCqleopUshMNlN/3ep7n9Xv84/V+3bfbda7xva77cxQ3Bq/2EeDj
4xvk5+Mjv1XmLWx/aj0TgvnIz7DJGqNtkVkMKTjo/I9pf1kmrkqRgsYYwb/9
IvnCzNvTpf/vo/rSmXOTpMFeWuRvJ3zzULX/LQ0S/z4vsqy8KjhkFlRu+ef+
VOVwptnHWZDl/o/zjy+JmeM8G4T+vf+S7BGPwmezQeNfN6R/At1VMpCp8o9F
FVXVQu/KgI7VP7Yp9ZlRaSgLfP/en7psQdCFq7JwjPfP8x+94WstWjgH3FP/
ad9c7rJpjhVz/n9/WvR+E0FtGqzN/+e6noNsa4cVDQID//n7N5pn3Ct9abD7
X9+j4k17ttBg778um7NJlbWdBon/uiDNmX49ggb7/3WmxIrpa3bSYNOapBnE
KYlGk4N7aLBtLFmSOE5Ae3D/XhpQ/dkzicN3sd6rJOL91neliAN/znx6M5kG
c5dPSRN7hPLfcUmlwfO9NrOJHQdHLo+l0WBNeYUM8Qq/7uLDGTQw6OXOITbu
fn5C6wQNjFwaaMTqHdd2eebSoE9dT45YwfFc8GQ+DZYbyykQz3p8yvN4MQ16
D7PYxCLWKQ7zz9NgsGmpIvHE3d3LWkpp4Lc9UZl4GLbqb66kgVnPIIe4u8ZT
Q/AKDTz27VT/u/8rzGcY1tGguGIm7+/x5OpNtd2igdYexjzia8VqX4Pu0OBh
j70u8Zms6c8LmmnQIONgRHyMPnnPpJUGynFKJsTJ6QPXOp7i8+o0zIjD9j8+
LdVBg8JnvdbEfkL1qeff0sCz/Zw9sfueSzEWnXj/+EVH4tXjBSGd3TRoXfTT
hdhy+zHvnT3YX6YpHsSLhxPX0vppEDYr2Pfv+RIQubxyiAYuW/IDiTmf/BfZ
fKPBPj9uKDHT05Xb8x3nwyXhv8e7f6XSqIMw/f++adBTc3P2f+4+QtMUWfCf
RQcsMleu/s/Mk+6tQ57/Wdtyh0j6tv8cMn/xs+jtdHAWzvohgL6iIJDnHUmH
rnt8bEEyPqIPgm120eGskdZyYhhNWaIXS+7XDSWOf+cgzt5HB85GpVzixibG
q2n76bDzmXgr8eozhWGvDtPBx5O2QIj0/8EA0/qjdPhc7LWZ+HX4PKnzmXRg
D0/kEHvb1p3fmUuHadl2c4TRJYZ7I30K6OD21MSReEDFytK2hA5Spg+OEe+Y
eNbFLqdDewNDSQRd/elkuWgVHXrOzAgknnrisfvrVTpoc/muEyeV9DMabtKh
r9PSdRr6lKPQKt9WOkTPs2oWRb+HJpZdGx1+jjLniqFVuIf79dvp8MCsMZO4
VEA+SewdHS7pLt4xHT0y0Ok40kWHdXd0+oj1XxUrv/5Eh1Zqp7c4+lbZgpsX
BulQteeKtwRa6NSvgxkjdGCNdPYRWyXcdNn9nQ7SR0fDZ6Cfulp/t/tDB8Z0
uxxJMr5iXtrfZjCgL0pWRxqdZ+McfUKaAYcitj0n9kizaTSRZUBssXzsLPRb
uoHPQXkGuEh+6ZmNPu2qfWk+xYDJAMdCGbRLrhL/K2UG2OWlb5Il9VdtRhZH
C5+3z/jPHFJ/AwT6mnkM2K469pRGxq/sh0HIfAbk72KU0tGtel3PbhgyIEza
LoKJfrDsqoTzcgYc6Oj1YJF6vf+Cyx9rBliPHdrCRpu3nCkpsGPA7bufYyn0
7TUHzb+uZUCLT2S9EhkvL8+dyT4MEHspUKKGjihe2zTXjwH8D11+qJP62WdN
bw9kwM0F7Xaa6MoQvSrlMAZYiskpaKPPx4r318YxoMLjifYCtP9dvkVeCQy4
LtTdrEvqk9j3RLFkBuzfkxOmR+rp4ffKa9OwPdrKnw1J/+RcXj+UwwDVuwvW
LiX98+Hc2Yx8BvBMp+zM0HS13B9GxQyQNTdYuwydUZqcnlTKgI7uL0lWZH+o
29CsWMeA75OZKavRK/kdGQ9uMYBx0+HrGvT0ZSs2Bd1hwK4Dll5O6MSHuoI1
zQyIe88JdUXHvBYzWtPBgJOGb5dvIvWVPZU0/hbbb3qO44+e3Dj6IreTAeev
1szaQva/3r9CBnoYwM4OZ4WS9fvr0rmEHwx4kqcsFIP+OuJ9nDnBAMfUC857
0Vv7ZeNL/zDgbuSDGwno4Hfhbi+EmeC5ue5WCtkP7hpJqcowYehSQN5pdN+N
/snrNCYUpMQn55L+vJb1xUaOCa3ftBMKSD08P1W/XYkJO+PmXr+A9k1r2H53
LhNs6Qtlb6A/JodtXKfLBLWvP3LryXqO59gN6DNhVrOj6X20V3iiuqwJE9wT
Ou89JvPXzfq1tw0TCsfT/+om/a/RBkL+TDjxcyhWmn/Y5JVSvHbmFiaI9usm
0NDO8guZ3G1M0DmuX6CAdpp5/JtDBBPCM114mug1Yy5F+QlMKCqaF2eObhsU
T9dPZkJvud56a/Tqnto9zSlMOJrXa7caveo1a923o0xYpLozxQNte7tL3Cyf
CRndPRt2o1uq03++KGKClEWwQgJ6ZZX5R/9z2D8bc36moK2Li24cqcD28reL
ZqOXp/hv67rJBJkA4+M30WbrRl7EvmFCfDczW1QA98OG8Byv90wIq6nhzEZ3
cX9vWtbNBPta12cK6Bg+0V+i/Uy4EzlWvABdW6wgd3iCCakNYzxPtN735Ruy
mXLQZZI03IAW9nikFsOSA3eLO8JP0M8aHYY9leTgydKqZX+hQ7LcYzmacpBq
vNriF7rMPCz/gqEc3Ao4bzdPENdHes7namc5ENixs/As+sekSvlpVznoYXEi
r6Pv+Z6L2O0hB4s/vopsRHsvuixmulkO5BRvC/Siz3Q2aTWGy4Gu0YCuthDu
N3O/B7cfk4M/x9LUa9ESLSt/fnsmB79OR3pNCuP54hD/0vSXcvDuY2S4lMiw
SfaqK/vnv5EDj6HTlSponRdsuW0f5CAyWTLbBr363ciSwa9yUFW21eIMOvNr
5t4eSXn4HWd9224a7p9zPkq+XS4PkWZqBg9Ecf1s2MW5VysP4oGnLzEksL6l
iay4dEse3MumeRqgg+8cCsq9Iw9mBrkaTuhcjbyrUQ/lQX+u+PQMtODoPSud
N/KgrVr7S3oG1rckqaDMCXmY2GrJlpLE9lTmX/FfpACCOZPFDCmc/8JNljOv
KUAvK4p/qQzW+wFJ8d4a9LotWz3RzBcOj+7cVICHy9gvYtEtRW/XRN1XgMZK
am89Wnf5V8+PLxRgChQczWSHTfgP0HfWjCnApaUlG0znYH2S2lS+aQELTmQk
B8+nD5t8/3k+1FSfBbJfYkrt0fadw3oKRixQG3vYFoQWrIyqe2rKgqlpaa3n
0P4OqU1LVrPgcoDVHkUG7k/HLnfP3saCtXxv3MWYuN/ICTFulbJAItV5zS25
YZMi1whX50oWCPYEt7xER2b15wxfZsH1H5s4X9EU+7mqYh0LtEZ+bFWUHzbZ
olSkG9fMgpahmuAYtKjGcnvzHhYIZMu81FfA/d2vNv1NHwt4QiNKtujSc3Pb
w4ZYMC18mpU32pHLcC/8zoKQhS6qh9F5Or0BIsJsuGDYzf6EXqJ3MPGBIhsK
G973JLOGTaTC+Zo9OGywvsvflo3uvhom+UudDaq2NRmV6GRDtwyNuWyYV5Ja
8Ar9cjEvP9mYDY/finZz2LgezB7fWLmeDVHZi55cQVvEmwt8dGfDiu1e+g/Q
jLvXlu3ayAbpNsuwV+hbFmceXvRjg+hIZcgEesaKkA7JCDa8yV69ZwmF5xN7
me+Pj7JBPb+06Tq6md9N9momG8yfFb5oRA9WFupmnWaDRMjiilfohbL6oX4F
bKi47f/0J7r+1bph/io2OE1WNugqkvqZN7PnKhvoIv7mZmjRxX28RzVs+Gp3
O30V2jZ755aTDWwIDmnP2oJ+vTGnd34bG7pLlDzz0X9m94gx2tlg1h65thyt
dHeuxlQHG54XRzPr0JvV6jc1d7FB8nWC5Av0aF93t9cIG0A5sURYCfenRRnB
TaIUhOzaUbYeTU833FM3nYLhjM0ZPuhzfW9TyyUoEG7+viIY/ei0aukxKQpe
T1hy4tAyU1f7N9IpqJaxOVGILnJynXRkUiAu9uzPRbR+OZ+ElTwFC+5n615B
u3haaelQFEjXSM+6h85t6PCbUKPg3aoDxz6g58vviRzUoGDDb7+4XnRDmPL+
Ti0KylwTTL6iP3ECS+7rUNBoWsr7g47YLXWteh4FOSbFHkLKuP+2V92/uICC
nfR87+lo7aTfn9L1Kahlv+mSRd94f+Z7giEFEflRbnJoe0MLkSgjCvxLY85R
6LDeVI6HCQVLewNqNdHVKylvriUFJc79dxajk1a9WfBnOQUWn6LSAe20NlPw
8QoKQv13GJmjRzdI5YfaUiAxaEy3Rtd7PwxZZk9B0ZLVNrboNL8kU9pqCmJy
3F1XoXmhfF3VjhSMf5IQc0JPhtdWHHSi4Hfvk6J16OadEbHu6ygo3GvEdkWf
jNVdNXc9BZdGeCHu6M0Jw5SAGwUrxmfmeqD1DlwYbnOnoO3k9LMb0UKHN98q
9KDgVZpEijf66VGVw+EbKRDUX7fSF33mxPsNVt4UJHVLft6E3pp9WkfOF8dT
cJ2bH9o433mqfxMFNyuty/zREiUyrTf8KDg5f/HbAHTHhcfZhwMo6DU0/ByI
Lqk4GLRxCwWXv/u3bEGHX1lurBtMgVPlr0NBaIsaIUmRbRTYjczQCUbL3Lr1
tj2EgiuOLeeIu+7svHg2DNtr5y+4FV3RaLAregcFrGwhQ+KYR6MrbSJwPv76
ZE1s21Yuz46iAHLfGxHLvwzsH46mQMswTYy47416bf0uCj4FVVaR51d3dh84
ugf75+GtJcRJn3LX+8ZSsEPnSwFp39o+Vy2DvRRQkZNfSPs5w/QJsX0UlK7Y
M4N4dPRZ0+sECvg7d88kn7f+1+GTF5Mo2OOxdJj0z+E/K/33JFPQwMgpI/3n
Lii2aNVB7M8Shu1mNFf0rphyKs4nv+vNpP8nJGJfjR6iQGd5hboPukl6ydl7
afj/mjR9vNCZc35FZKZTcC3ZOtYTrUttoy8+jvOnKHqdG1qAo90z4wTOR42L
suvRTzS+XH13kgKeALfSGR20wNNpbzYFSvcsUxzQiw0U1BxzcX3VDjbbo8WX
vPqumofjI/S+z4aMn8WqY02F+Ly7a1st0TusZ/ieLsbxHw1KJ/N7mX3jwqCz
WB/2+RkuJeO1bulz6YsU6C9kaC1Cl7v/LvhQip8/NThcD73H63rY5XIKDOIl
i+aT8dkyT2ZdFQXt7o/Ok/XlGKPokFtDQZdbtysDvbLuvtSJOgo+eBm4y6BN
x7c8SruJ/b37ofFMsl7Cqq32NlBwVzsxi6x30c0O4NuM9cVlZscA1oM/Bb9+
u7dQEO8t2/EZPdqZU+PUiv0vT6vpRHeu79ezaqPAfTCfeo6uttunzX2N6996
RUw1uvygVp/KW/y8Go9SLqGLG5+UKLyjIPiMyO4L6KNmLJWZHyhwToqalo3e
on+VOdJLQbTP/Tt7lMh++WXatXEKzknXyxmj57geuls+ieMhtzd4IXrGiYV7
z/6hYMD3ylkuenxW3J+TAopwKPfLEya6TURubNd0RXB2//RjDOt1wuDKLjOm
IoQsDWwqRvfVlde2GiqCwgmBGRNkP3leZXXTSBGORDxuHkJnDlx7UbpEEf4o
HI/oRlso3B5OWaoIWS8cTreg83Y+UVlppQintqrMykGvMxo5+MBZET4fmXpn
jL5/bYHb7XBFCFwkZB2K+1/+pSu/Ky8rwjOaUts13J8PXys2t9BQgpgX89sM
8DwRcV9VJKNICZ7ce6C4Ac8vGR8Pt6TLKQPvnk39r1l4Pq3ZFmiRqgyxS3Sc
xmYOm0iefr+varoKiLSuMaXheWvXgUWFT3ergFniF+GW6cMmG7XyxJtiVEDY
tO9DA3p5s1jI7TgVKIgtelCNlhF/ZVyeoAIHglsLS9DnksNfpqSqQEu6YFk8
+uX+KnGrbBV4Fx85vgQ9P4kXcrNOBTgijzZeFhs26YlXMrkwqQIxXiXtV/D8
WDr1OezkHxVgxU76laHDoi6eS+LjQMVbDYESNP9Wgzk+Qhw4l6BodgLNXG87
oCDBAdAIFd2Jtp4XdeqQHAeyFlM5puR5b5/8CFnEAbU18z624Xk1TC+23DCC
A/E2p9RF0OFu7kUiURxYtbdzBx86Kt7odFs0BxysAhvH8bwb83QsccseDhR0
mUcPoQ8G+W84k8CBq79qpF+hC4ocJMUyOHD73aFpF9HP5qgGvqzgQO6X3cLO
6IU/mtTC+zjACk27cR3P3x5rj4gHDHDAPlawsAqdfHndkPsQB6TNkg+Vod+H
9lyx+MaBn1t3bStEHxwWtpgzwYGyRK3NaejuL+B9eboqeJVps/3RR99cyf2m
oQobb6dmsdAjt/MYWzergiNLUT8dz/8uLbF1pv6q8MKqz/0Quv6lh6dsoCpc
252z/wA6bYh1tjpYFXyj9/bsRc9VOGUgHK4K9o90m8PQQRHpTif3qYL+i2gl
J3QfLz7jTp4qTI06i7LQ3ad8pBlvVWFmju/iKnwf4cblxXf9pQpz+z9qVKDD
Nr/7cf69Kohav2eUooUXrvvLuFsVXpuY8ZegVR+tPO/dpwqcsZiBU2g/Pt1l
5b/w+tqERfHoQW+BSMs5ajDLojtzLXk/0s55v91ODUS82GIC6M0r7y31XaUG
dhcNVk3h+9VL/4G8tQ5q8FXy0KlJAZJHGvnoO6mBtXWb/g90hOLLLz/d1WDr
mekp/ehxGelv0UFqUGt0rKQd/WciTjguRQ30wxozytAiTb6aqc1qsEx//L0P
+tLRQmu3FjXYITuzwwvtsaE7kNuqBsohF56R98PqUc+ypqdq8O6PfasbOojt
pjutQw2ufW156YhuD3MwjulRA51aPyMLdAkbVocIq8NGGk1PHb1iOyNqrYk6
xG/1vT6M76/sCNP9K5eqQ+GQ6MggejQqINPUTB0WTovhDqCzY+qu8CzVIZG/
tvALeuSA5zcRO3XoOdZ/vgt9Mu9s4FV3dbCxzRJ6ju5tNdxA360O6X36b6rR
+zVdzDtq1UFd0f5NMrn/1cnZZTfU4ahTc/J+9IWk1117b6nDgVHjRUnox59c
Y7XvqAPdLen0PjQ9f8ONmGZ18GkODIpBF8n5GKh1qEOYwznLHegGia3csB/q
UPxC6sFG9O/BfTKS8zVg4KVDqzF6OELl0qsFGqAZeebOEnSXQMOqwoUaEKz+
unox+t4cvkOLDTUgMabz7CL0YeMosQDQgLubY47ooZVSg/7ct9WAZIEjB3nk
/V/bqSc2QANMhOQV2ej0APXasQIN2JqWViCALtWuWN5TpAFDU8nV/OgHQ4bP
O0o0IE8n4wkfejLUevDmBQ0QWfadf4rkKzuDqOQqDRBqbAucQBukVMWz7mjA
md9f/EbJ9wmlYGP5QQMclntNfCJ55YjzX5mKmiC0wNPxETra45emv7ImKIrP
KGkh+eKjE+FGHE0Y07GZeEjyp/MdUn+p43XP5Pxmkh96u5opz9WEj6rfxx+Q
vLZ9Q8lFY034mjd0pwE9rc43pH69JnjD8O3r6N7EMJH+DE14XlhmWUzyId4U
dB/XhJ++m8qL0D3P9ke/OaEJNsOxDOJPijnDD7M04dgpGCB5UldNY8fFQk3g
3Y86lYfuGGKVBV/WhPiFHtLZ6CanRqdvzzSBT93SI4PkfWqss+OztcDKwn7r
PpKvnRW59EVWC/w3BYzHk7xKc6j2JU0LFJ2Y+4g1tW89viKnBenRsadIHlYy
f+PPEGUtELyg2BJL8sAlRZZ987Vglk2A+W6SBzrwPr1epQU/Po/sCif53h5j
5bpDWjC2fVA8gDzvovFAcpoWSBXMqyL53P0O46vO6VpgNPDHlZhPz8R69JgW
KIhDmR96W79JqFa2FhQdW+O0Gb1m3dKGExe0YKsg97IPyecXmHvtaNQCP4eS
Ag900SerfB1BLvzKbF5O8kL/lbrrVYS54Kpxb2ItmlfJms2YxgXDvZ5lxFd3
fYsTEOeC2dHOOcQPZLI2Pp/FhVsvi7+Q/LHPdFgxWokLLUZbTpF8cm7Osdx7
S7kgkZEz1xZ93elDllsMF2a8XTbbguSxfh9l58VxQfmRcgfJO2ujP6cIxXOB
Fex4hvhGTt+u84l4fd2UDnH9529uv1K5MCK+w84c3RwuxMrI4kKhQuhxUzKf
jnOyH1ZzoXck3coEzf9yU7bRGBeuuunwSP7adef+R+EfXBA2ucVHfKdCTfvx
Ty6kmhe1GZC8/sDnGu9JLsjO2hVJLGmy6VWKoDacKg69r4+WL/KVeS+tDTJF
z/1IvqsX5pMcz9OGY0XPH5A8OEDKa0fLJm14ZJvey0OHLbx4/oafNpz/K7Ke
eLfLj/dlAdpQf3v7SeIjBQesjwRrQ3OrujXxNYMqyilcGy5/eHiR5M1CnsLN
7xO0QW7bo0guOruimD1aqA2rltzXJPn049X9D5jd2nDtPruXg56jYnuj96M2
VD5TfkjsNlZ2qfqzNnh7Qylx7/HQbJc+bRBrrA8hFnw7HnpyRBseavZOqpDP
s0mMzeTnwe7NFbLEWdGq2xksHhQm1jiT/Ny/wEOR7syDcuoYm+TtSa0KEiwX
HjzocRIiLhrv+K7sygPb/fQvJJ/vsnd8qOPBg9Gczkpil99W4ZabeeBs/tWS
eMXaBS07InjAu6q+Q4HMd1GRyOeZPOgP+vpBDr18QYPX65M8OBSe0kzs6x5j
23maBzluJpeI86rGlQdyefA7vjuOmOk59EjoLA9kvOYpE0+vfqmie50HTSmN
m8j3B+ofM2YuquGB+akme2ILKYdxkzoe2Nl2GBLH+ba0Wt/mwQxTfgni8Vn1
UV6NPDhVvreCQfJ54z0+fs08OLPd8BSxnt9i++AW7I+xt/HEITevcKKf8GCf
i5cz8eHeUKnYNh7EBdqaEpfKzptIeM6Def0mXOKHMPjxYDsPDPhXziHuDTj/
+MgrHtTZWfIR/w/5S0NS
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{4., 1.},
  Method->{},
  PlotRange->NCache[{{
      Log[50], 
      Log[5000000]}, {1., 1.0086520161563055`}}, {{3.912023005428146, 
    15.424948470398375`}, {1., 1.0086520161563055`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.59139567707999*^9, 3.591395696969276*^9}, {
   3.59139671812024*^9, 3.591396774698358*^9}, 3.591396882697029*^9, 
   3.591397099498045*^9, 3.591397807039177*^9, 3.5914064188639383`*^9, 
   3.5914064741808453`*^9, 3.5914820018742657`*^9, 3.591483280910741*^9, 
   3.591483400698716*^9, 3.59148356397647*^9, 3.591484126423511*^9, 
   3.59149108432341*^9, 3.591491304143928*^9, 3.591492734617681*^9, 
   3.5914928209375134`*^9, 3.591492941108633*^9, 3.591495951281534*^9, 
   3.591496022320353*^9, 3.591496393238061*^9, 3.591497477570285*^9, 
   3.591499690870138*^9, 3.591499813752454*^9, 3.5915000616124487`*^9, 
   3.5915001207475033`*^9, 3.59150021350272*^9, 3.591500305668589*^9, 
   3.591500886887149*^9, 3.591505243915475*^9, 3.591505718795629*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"testa", "[", "p_", "]"}], ":=", 
  RowBox[{"Piecewise", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"p", ",", 
       RowBox[{"p", "\[GreaterEqual]", "0"}]}], "}"}], "}"}], ",", 
    "\[ImaginaryI]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.591502000547359*^9, 3.591502079356189*^9}, {
  3.5915024529516163`*^9, 3.591502457465135*^9}, {3.591502534078932*^9, 
  3.591502535520335*^9}, {3.591502579849131*^9, 3.591502580952132*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"testa", "[", "p", "]"}]], "Input",
 CellChangeTimes->{{3.591502589512793*^9, 3.591502595818425*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"\[Piecewise]", GridBox[{
       {"p", 
        RowBox[{"p", "\[GreaterEqual]", "0"}]},
       {"\[ImaginaryI]", 
        TagBox["True",
         "PiecewiseDefault",
         AutoDelete->True]}
      },
      AllowedDimensions->{2, Automatic},
      Editable->True,
      GridBoxAlignment->{
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}},
      GridBoxItemSize->{
       "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
        "RowsIndexed" -> {}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.84]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}},
      Selectable->True]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.35]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  "Piecewise",
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 CellChangeTimes->{{3.591502591660375*^9, 3.59150259663019*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"testa", "[", "p", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", 
     RowBox[{"-", "10"}], ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591502025031426*^9, 3.5915020437318497`*^9}, {
  3.591502087780079*^9, 3.591502097404805*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxFxWlMknEcAGB8o9LAMIez1yQEHVs2tMVGeRWOka1lEUQWbrUQGjMaSWVs
eMwkyObWAeiGsjktWjPXNbE212qRlDhyHRjhugwN2JyiFGM1qg/8/h+ePQyZ
WqTACARCxT//51VIA+GM5R3JmzDzi13bj+xMXmStc1G5rfAn/P48idIJizkf
Rg2VZtjhq7lg1Fnh9KfhfKe0D244cTLoNNthAmE4UfdkBHZN+C5zxC9hpfaj
q3bzKzi1wE/UrxiH9+imW949dMMTmz5rzlFfw0q+ZsgfegOr+s5baHd8cCn7
2QNh9wyMNWZNy/EFeDVZ2Cab/wm3f/HyNQN/4Hs9BmFLJIWXXN0vz/h+aCV8
tN5KM7alwh0HGks4vSSYSLXMtsbXwlPuiwt6yjpYopNxrc8zYRUpzPRIqTB9
cKxrVSgL1j3iiyk92fBpu8rBLcZhMrZNVhTIgQWnDloKTbnw+sc0taBgI3xd
c+nalik6LDLsZ9sceXBhrV5yo5kBe2fT+k0SJuyRBSoz6fnwV+KtmIWJXrYr
7+IsNB4O5zLYaPmZyK/iMnS8PTFUXYNm3cRzOq6gS6r8k2QTem+w13i1C93A
zot229Cjw6xJ+yBaNMYxOF1ohTJavtuN1q4ZWXJ70LZ9pcffvkf/8PLKv82g
41psSTGHTt/gvB0Mobceq8peXEQLUtI8Z6PowwPj+lgMXS/oLGv6jW6eq44k
Eui/0BOwXA==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  Method->{},
  PlotRange->{{-10, 10}, {0., 9.999999591836735}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.591502027649913*^9, 3.5915020443354187`*^9}, {
   3.591502082269802*^9, 3.591502098310218*^9}, 3.591502461701159*^9, 
   3.591502538476706*^9, 3.5915025829958563`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"getStick", "[", "p", "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "125", ",", "5000000"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}], ",", 
   RowBox[{"Frame", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}]}], ",", 
   
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Population\>\"", ",", "\"\<Fraction of c\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5939937467853937`*^9, 3.5939937472584467`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVVHk81O0XVRKVpZjv2PcwZhhRiVCXKLIvr+x7Ki/JmhSlZCmJpKREZC2R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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->NCache[{
     Log[125], -0.5039062322598339}, {
    4.8283137373023015`, -0.5039062322598339}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Frame->{True, True, False, False},
  FrameLabel->{{
     FormBox["\"Fraction of c\"", TraditionalForm], None}, {
     FormBox["\"Population\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[125], 
      Log[5000000]}, {-0.5039062322598339, 0.}}, {{4.8283137373023015`, 
    15.424948470398375`}, {-0.5039062322598339, 0.}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.59399417284449*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"getStick", "[", "p", "]"}], "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "125", ",", "5000000"}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}], ",", " ", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", ".49"}]}], "}"}]}], ",", 
   RowBox[{"Frame", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"True", ",", "True", ",", "False", ",", "False"}], "}"}]}], ",", 
   
   RowBox[{"FrameLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<Population\>\"", ",", "\"\<Fraction of c\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5930674681442623`*^9, 3.59306748060856*^9}, {
  3.593067587065179*^9, 3.593067588611394*^9}, {3.593067728286581*^9, 
  3.593067740915059*^9}, {3.593067898962799*^9, 3.593067926212092*^9}, {
  3.593068112152396*^9, 3.593068112446059*^9}, {3.593068315012863*^9, 
  3.5930683193888187`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlHk0FA4XhmVJG8o+Y6xhzBhjqUTCJYpElpKEbCn9lJC1yB4SSYQUWQot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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->NCache[{
     Log[125], 0}, {4.8283137373023015`, 0}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  Frame->{True, True, False, False},
  FrameLabel->{{
     FormBox["\"Fraction of c\"", TraditionalForm], None}, {
     FormBox["\"Population\"", TraditionalForm], None}},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[125], 
      Log[5000000]}, {0, -0.49}}, {{4.8283137373023015`, 
     15.424948470398375`}, {0, -0.49}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], {None, None}},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.593067574115183*^9, 3.593067712919497*^9, 
  3.5930678637356243`*^9, 3.593068075312312*^9, 3.593068266657153*^9, 
  3.5930684812205467`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"getStick", "[", "lp", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "100", "]"}], ",", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592689597812648*^9, 3.5926895981091337`*^9}, {
  3.593067084717033*^9, 3.593067085521502*^9}, {3.593067267242743*^9, 
  3.5930672676119204`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Hk4Vd0XB3ANUkjo4nIvIXdyB4VKqL2UJq9kSiOiQmlWhEbSawqpvESD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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{6., 0.52},
  Method->{},
  PlotRange->NCache[{{
      Log[100], 
      Log[5000000]}, {0.526638342245936, 0.9996381148817335}}, {{
    4.605170185988092, 15.424948470398375`}, {0.526638342245936, 
    0.9996381148817335}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.592689696794099*^9, 3.592689911402238*^9, 
  3.593067188723249*^9, 3.5930673903403263`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Alpha]", "[", "lp_", "]"}], ":=", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", " ", 
        RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], " ", 
      RowBox[{"getCarrot", "[", "lp", "]"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", " ", 
        RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], " ", 
      RowBox[{"getStick", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", 
         RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], "]"}]}]}], 
    RowBox[{
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"Exp", "[", "lp", "]"}], "]"}], 
      RowBox[{"getStick", "[", "lp", "]"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{"c", "[", 
       RowBox[{"2", " ", 
        RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], " ", 
      RowBox[{"getStick", "[", 
       RowBox[{"Log", "[", 
        RowBox[{"2", " ", 
         RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], "]"}]}]}]]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.592690897513444*^9, 3.592690986464067*^9}, {
  3.592691026466982*^9, 3.592691103381424*^9}, {3.5926953301270447`*^9, 
  3.592695345737252*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Alpha]", "[", "lp_", "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"2", " ", 
       RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], " ", 
     RowBox[{"getCarrot", "[", "lp", "]"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"c", "[", 
      RowBox[{"2", " ", 
       RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], " ", 
     RowBox[{"getStick", "[", 
      RowBox[{"Log", "[", 
       RowBox[{"2", " ", 
        RowBox[{"Exp", "[", "lp", "]"}]}], "]"}], "]"}]}]}], 
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "lp", "]"}], "]"}], " ", "-", " ", 
    RowBox[{"c", "[", 
     RowBox[{"2", " ", 
      RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}]]}]], "Input",
 CellChangeTimes->{{3.592695348824634*^9, 3.592695360138637*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Alpha]", "[", "14", "]"}]], "Input",
 CellChangeTimes->{{3.5926911209698257`*^9, 3.592691187069564*^9}, {
  3.5926953754799223`*^9, 3.5926954061536293`*^9}}],

Cell[BoxData["0.73833703134188832524486688365614246882`16.01330160058292"], \
"Output",
 CellChangeTimes->{{3.592691127339044*^9, 3.592691191146037*^9}, 
   3.592694823203843*^9, {3.592695371270666*^9, 3.592695407923015*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"getCarrot", "[", 
     RowBox[{"Log", "[", "5000", "]"}], "]"}], "-", "1"}], ")"}], "*", 
  RowBox[{"c", "[", 
   RowBox[{"2", "*", "5000"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5927170114612837`*^9, 3.592717025875586*^9}, {
  3.592717449374282*^9, 3.5927174632868977`*^9}, {3.592717722347864*^9, 
  3.5927177245853357`*^9}, {3.592718388430895*^9, 3.592718389895076*^9}, {
  3.5927188032972927`*^9, 3.592718812802322*^9}}],

Cell[BoxData["0.0115946109823843439976051538722710105563946152294668386`18.\
059249674865576"], "Output",
 CellChangeTimes->{
  3.592717026916875*^9, {3.5927174501566973`*^9, 3.592717464274432*^9}, 
   3.592717731773947*^9, 3.592718390762371*^9, 3.592718813919663*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "-", 
    RowBox[{"getStick", "[", 
     RowBox[{"Log", "[", "5000", "]"}], "]"}]}], " ", ")"}], "*", " ", 
  RowBox[{"c", "[", "5000", "]"}]}]], "Input",
 CellChangeTimes->{{3.592717030387168*^9, 3.5927170492325287`*^9}, {
  3.592717404200913*^9, 3.5927174079019327`*^9}, {3.59271773595306*^9, 
  3.592717741635721*^9}, {3.592718402095256*^9, 3.592718403503665*^9}, {
  3.5927188196172857`*^9, 3.592718825826716*^9}}],

Cell[BoxData["0.\
019567426152736878087059449915682700198215325422294833697622669957694321041828\
4226347582315829090381164130449151329952728255632121711`98.3001159716723"], \
"Output",
 CellChangeTimes->{{3.5927170402732973`*^9, 3.592717050692033*^9}, 
   3.592717411312809*^9, 3.592717743175321*^9, 3.5927184049455853`*^9, 
   3.5927188274069357`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{"getStick", "[", 
      RowBox[{"Log", "[", "5000", "]"}], "]"}]}], " ", ")"}], "*", " ", 
   RowBox[{"c", "[", "5000", "]"}]}], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"getCarrot", "[", 
      RowBox[{"Log", "[", "5000", "]"}], "]"}], "-", "1"}], ")"}], "*", 
   RowBox[{"c", "[", 
    RowBox[{"2", "*", "5000"}], "]"}]}]]], "Input",
 CellChangeTimes->{{3.592718844964069*^9, 3.592718851082802*^9}}],

Cell[BoxData["1.68763110573227571883010683966409205051`18.059249674865576"], \
"Output",
 CellChangeTimes->{3.592718854478305*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  FractionBox[
   RowBox[{"1", "-", 
    RowBox[{"singleP", "[", 
     RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]}], 
   RowBox[{"singleP", "[", 
    RowBox[{"p", ",", "ya", ",", "yb"}], "]"}]], "]"}]], "Input",
 CellChangeTimes->{{3.592719089753252*^9, 3.5927191176826363`*^9}}],

Cell[BoxData[
 SuperscriptBox["\[ExponentialE]", 
  FractionBox[
   RowBox[{"\[Pi]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", 
       SuperscriptBox["2", 
        RowBox[{"1", "/", "4"}]], " ", 
       SqrtBox["255"], " ", 
       SqrtBox["p"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["2", 
        RowBox[{"3", "/", "4"}]], " ", 
       SqrtBox["255"], " ", 
       SqrtBox["p"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["2", 
        RowBox[{"1", "/", "4"}]], " ", 
       SqrtBox["85"], " ", 
       SqrtBox["p"], " ", 
       RowBox[{"ArcSinh", "[", 
        FractionBox["1", 
         SqrtBox["2"]], "]"}]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["2", 
        RowBox[{"3", "/", "4"}]], " ", 
       SqrtBox["85"], " ", 
       SqrtBox["p"], " ", 
       RowBox[{"ArcSinh", "[", 
        FractionBox["1", 
         SqrtBox["2"]], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"1", "/", "4"}]], " ", 
       SqrtBox["85"], " ", 
       SqrtBox["p"], " ", 
       RowBox[{"ArcSinh", "[", 
        SqrtBox["2"], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["2", 
        RowBox[{"3", "/", "4"}]], " ", 
       SqrtBox["85"], " ", 
       SqrtBox["p"], " ", 
       RowBox[{"ArcSinh", "[", 
        SqrtBox["2"], "]"}]}], "-", 
      RowBox[{"3978000", " ", 
       RowBox[{"Log", "[", "ya", "]"}]}], "-", 
      RowBox[{"102000", " ", 
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{"p", " ", "ya"}], 
         RowBox[{"10000", "+", "p"}]], "]"}]}], "+", 
      RowBox[{"3978000", " ", 
       RowBox[{"Log", "[", "yb", "]"}]}], "+", 
      RowBox[{"102000", " ", 
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{"p", " ", "yb"}], 
         RowBox[{"5000", "+", "p"}]], "]"}]}]}], ")"}]}], 
   RowBox[{"408000", " ", 
    SqrtBox["6"]}]]]], "Output",
 CellChangeTimes->{3.592719106974365*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"singleP", "[", 
  RowBox[{"5000", ",", 
   RowBox[{"gStick", "[", "5000", "]"}], ",", 
   RowBox[{"gCarrot", "[", "5000", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592718778880167*^9, 3.592718791802113*^9}}],

Cell[BoxData["0.37207487349462519555269357975397186189`18.887000927826556"], \
"Output",
 CellChangeTimes->{3.592718793271144*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox[
  RowBox[{"1", "-", 
   RowBox[{"singleP", "[", 
    RowBox[{"5000", ",", 
     RowBox[{"gStick", "[", "5000", "]"}], ",", 
     RowBox[{"gCarrot", "[", "5000", "]"}]}], "]"}]}], 
  RowBox[{"singleP", "[", 
   RowBox[{"5000", ",", 
    RowBox[{"gStick", "[", "5000", "]"}], ",", 
    RowBox[{"gCarrot", "[", "5000", "]"}]}], "]"}]]], "Input",
 CellChangeTimes->{{3.592718866002035*^9, 3.5927188696644983`*^9}, {
  3.592718901299959*^9, 3.5927189035797653`*^9}}],

Cell[BoxData["1.68763109588061310344531541518112473193`18.68490878958263"], \
"Output",
 CellChangeTimes->{3.592718872411626*^9, 3.592718905503426*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"Exp", "[", "8", "]"}], "]"}], "-", 
   RowBox[{"c", "[", 
    RowBox[{"2", " ", 
     RowBox[{"Exp", "[", "8", "]"}]}], "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.592717104305748*^9, 3.592717113913149*^9}, {
  3.592717431572816*^9, 3.59271743302934*^9}}],

Cell[BoxData["0.056343852231688044`"], "Output",
 CellChangeTimes->{{3.592717108721065*^9, 3.5927171145813293`*^9}, {
  3.5927174228507957`*^9, 3.592717437334035*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ifrac", "[", "lp_", "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"getCarrot", "[", "lp", "]"}], "-", "1"}], ")"}], "*", 
     RowBox[{"c", "[", 
      RowBox[{"2", " ", 
       RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"getStick", "[", "lp", "]"}]}], " ", ")"}], "*", " ", 
     RowBox[{"c", "[", 
      RowBox[{"Exp", "[", "lp", "]"}], "]"}]}]}], 
   RowBox[{
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "lp", "]"}], "]"}], "-", 
    RowBox[{"c", "[", 
     RowBox[{"2", " ", 
      RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}]]}]], "Input",
 CellChangeTimes->{{3.592717481256157*^9, 3.59271754238652*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "/", 
  RowBox[{"ifrac", "[", "14", "]"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"is", " ", "this", " ", 
    RowBox[{"s", "?"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.5927175480339212`*^9, 3.592717612138441*^9}, {
  3.592717794518551*^9, 3.592717800400955*^9}, {3.592717834441292*^9, 
  3.592717839449747*^9}}],

Cell[BoxData["1.03898976664906990818542240503090376624`16.12843567947671"], \
"Output",
 CellChangeTimes->{{3.592717552776081*^9, 3.592717614214758*^9}, {
  3.5927177968776617`*^9, 3.592717801797134*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"1", "/", 
  RowBox[{"ifrac", "[", "14", "]"}]}]], "Input"],

Cell[BoxData["1.07797276671103284390605002276524160534`16.11244202582764"], \
"Output",
 CellChangeTimes->{3.5927184149750233`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getStick", "[", "8", "]"}]], "Input",
 CellChangeTimes->{{3.592717380072877*^9, 3.592717382827445*^9}}],

Cell[BoxData["0.\
685683073777624852088153699161485504833635396083979744670670208982114107983942\
36039277225294289856868748423629635865931752236977071269`99.0217483622824"], \
"Output",
 CellChangeTimes->{3.592717384133329*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"getCarrot", "[", "lp", "]"}], "/", 
    RowBox[{"getStick", "[", "lp", "]"}]}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"lp", ",", " ", "10", ",", "12"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592696946098043*^9, 3.5926969683372507`*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.592698633575811*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getCarrot", "[", "16", "]"}], "/", 
  RowBox[{"getStick", "[", "16", "]"}]}]], "Input",
 CellChangeTimes->{{3.592698648466618*^9, 3.5926986757963448`*^9}, {
  3.5926987102209587`*^9, 3.592698717245311*^9}}],

Cell[BoxData["1.00054123584575968483615772661719722415`18.526627032504393"], \
"Output",
 CellChangeTimes->{{3.5926986524143343`*^9, 3.5926986773776903`*^9}, 
   3.5926987191306543`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"Exp", "[", "16", "]"}], "]"}], "/", 
   RowBox[{"c", "[", 
    RowBox[{"2", " ", 
     RowBox[{"Exp", "[", "16", "]"}]}], "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.592698678874947*^9, 3.592698697128592*^9}, {
  3.5926987369989347`*^9, 3.592698739718247*^9}}],

Cell[BoxData["1.000562359447503`"], "Output",
 CellChangeTimes->{{3.59269869202125*^9, 3.5926987048782597`*^9}, 
   3.592698740447102*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"\[Alpha]", "[", "lp", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"lp", ",", " ", 
     RowBox[{"Log", "[", "50", "]"}], ",", " ", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592691469317687*^9, 3.59269149343007*^9}, {
  3.592694856827313*^9, 3.59269485962459*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.592694815806904*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"\[Alpha]", "[", "lp", "]"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"lp", ",", "10", ",", " ", "12"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.592694870750554*^9, 3.5926948757055683`*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.592695325414093*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"getStick", "[", "lp", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "50", "]"}], ",", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".55", ",", "1"}], "}"}]}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Input"],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13k4lN8XAHDKUminLFmGGWNWokTKPaSy9i2klCVrlqSokDXZomRJlkpS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{4., 0.56},
  Method->{},
  PlotRange->NCache[{{
      Log[50], 
      Log[5000000]}, {0.55, 1}}, {{3.912023005428146, 15.424948470398375`}, {
     0.55, 1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{3.592687415264543*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["yfb"], "Input",
 CellChangeTimes->{{3.5926874346510077`*^9, 3.592687435248642*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.592687436005795*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getStick", "[", "5.5", "]"}]], "Input",
 CellChangeTimes->{{3.5926874814907417`*^9, 3.59268750719692*^9}}],

Cell[BoxData["0.6872326935348835`"], "Output",
 CellChangeTimes->{{3.592687494328425*^9, 3.592687509228819*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Exp", "[", "5.5", "]"}]], "Input",
 CellChangeTimes->{{3.59268751032857*^9, 3.592687512875265*^9}}],

Cell[BoxData["244.69193226422038`"], "Output",
 CellChangeTimes->{3.592687513681499*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yfb", "+", 
  RowBox[{"c", "[", 
   RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.592687564078994*^9, 3.592687569490863*^9}, {
  3.592687618822394*^9, 3.59268762299483*^9}}],

Cell[BoxData["2.406409010336767`"], "Output",
 CellChangeTimes->{3.5926875700605087`*^9, 3.59268762417198*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getStick", "[", "5.5", "]"}], "*", 
  RowBox[{"(", 
   RowBox[{"yfb", "+", 
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.592687739504281*^9, 3.5926877501448936`*^9}}],

Cell[BoxData["1.6537629459203496`"], "Output",
 CellChangeTimes->{3.592687752151066*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yfb", "+", 
  RowBox[{"c", "[", 
   RowBox[{"2", " ", 
    RowBox[{"Exp", "[", "5.5", "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.59268763724772*^9, 3.592687655266674*^9}}],

Cell[BoxData["1.7200003708014584`"], "Output",
 CellChangeTimes->{3.592687655941195*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"getStick", "[", "6", "]"}], "*", 
  RowBox[{"(", 
   RowBox[{"yfb", "+", 
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "6", "]"}], "]"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.592687828210376*^9, 3.59268783215588*^9}}],

Cell[BoxData["1.\
465541614631432509471457443890366512980267299560673245503851180675720573923375\
31769976866181312951625278696359308225616752612759587275`100.38835814305827"],\
 "Output",
 CellChangeTimes->{3.5926878371495743`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"yfb", "+", 
   RowBox[{"c", "[", 
    RowBox[{"2", " ", 
     RowBox[{"Exp", "[", "6", "]"}]}], "]"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5926878523936253`*^9, 3.592687860022016*^9}}],

Cell[BoxData["1.4499196162359516`"], "Output",
 CellChangeTimes->{{3.592687854008658*^9, 3.592687860685079*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"getStick", "[", "5.5", "]"}], "*", 
   RowBox[{"(", 
    RowBox[{"yfb", "+", 
     RowBox[{"c", "[", 
      RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}], ")"}]}], "-", 
  RowBox[{"c", "[", 
   RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.592688295594738*^9, 3.59268829851702*^9}}],

Cell[BoxData["0.24735393558358276`"], "Output",
 CellChangeTimes->{3.59268830057141*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"singleP", "[", 
  RowBox[{
   RowBox[{"Exp", "[", "5.5", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"getStick", "[", "5.5", "]"}], "*", 
     RowBox[{"(", 
      RowBox[{"yfb", "+", 
       RowBox[{"c", "[", 
        RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}], ")"}]}], "-", 
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "5.5", "]"}], "]"}]}], ",", "yfb"}], "]"}]], "Input",\

 CellChangeTimes->{{3.592688207727949*^9, 3.592688209736947*^9}, {
  3.5926882731943207`*^9, 3.592688316192668*^9}}],

Cell[BoxData["1.7909680398240784`*^-16"], "Output",
 CellChangeTimes->{3.592688318449087*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"singleP", "[", 
  RowBox[{
   RowBox[{"Exp", "[", "6", "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"getStick", "[", "6", "]"}], "*", 
     RowBox[{"(", 
      RowBox[{"yfb", "+", 
       RowBox[{"c", "[", 
        RowBox[{"Exp", "[", "6", "]"}], "]"}]}], ")"}]}], "-", 
    RowBox[{"c", "[", 
     RowBox[{"Exp", "[", "6", "]"}], "]"}]}], ",", "yfb"}], "]"}]], "Input",
 CellChangeTimes->{{3.592688364748452*^9, 3.592688372325677*^9}}],

Cell[BoxData["1.\
305468401371973236443290107563942755249303289389387400425824523790040474851726\
09660429176603878808824029979999084379134838629845`98.3950066459219*^-6"], \
"Output",
 CellChangeTimes->{3.592688374347117*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"getStick", "[", "lp", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "50", "]"}], ",", 
     RowBox[{"Log", "[", "5000000", "]"}]}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".55", ",", "1"}], "}"}]}], ",", 
   RowBox[{"WorkingPrecision", "\[Rule]", "100"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591397854743577*^9, 3.5913978568327503`*^9}, {
  3.591484961432096*^9, 3.5914849624623528`*^9}, {3.591496034031495*^9, 
  3.5914960357917967`*^9}, {3.591499248338346*^9, 3.591499254633465*^9}, {
  3.591499851849176*^9, 3.591499852178926*^9}, {3.5915012726966057`*^9, 
  3.591501275504197*^9}, {3.591503158201823*^9, 3.591503180978711*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "precw"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\(-3.391974898051742`\\)\\) - carrot + \
\\(\\(\\(-3.358383166785593`\\)\\) + carrot - stick\\)\\/\\(1 + \
\\(\\(1.5522693537619925`\\\\ \\((carrot\\/stick)\\)\\^\\(10\\\\ \
\\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\) + \\(\\(Log[carrot]\\)\\) + \
\\(\\@\\(3\\/2\\)\\\\ \\(\\(Log[\\(\\(\\(\\(0.45442949561604606` \
\[VeryThinSpace]\\)\\) + \\(\\(0.2927517022188942`\\\\ \\((stick\\/carrot)\\)\
\\^\\(10\\\\ \\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \
\[Pi]\\)\\)\[NoBreak]) is less than WorkingPrecision (\[NoBreak]\\!\\(100\\)\
\[NoBreak]). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/precw\\\", ButtonNote -> \
\\\"NMaximize::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591499586883917*^9, 3.591499832762639*^9, 
  3.591499876787813*^9, 3.591501082210525*^9, 3.591501277621311*^9, 
  3.591502643013006*^9, 3.5915028257615757`*^9, 3.591503183831944*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "cvmit"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Failed to converge to the requested accuracy or precision \
within \[NoBreak]\\!\\(100\\)\[NoBreak] iterations. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \
\\\"NMaximize::cvmit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591499586883917*^9, 3.591499832762639*^9, 
  3.591499876787813*^9, 3.591501082210525*^9, 3.591501277621311*^9, 
  3.591502643013006*^9, 3.5915028257615757`*^9, 3.591503184551238*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "precw"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"The precision of the argument function \
(\[NoBreak]\\!\\(\\(\\(-3.391974898051742`\\)\\) - carrot + \
\\(\\(\\(-3.358383166785593`\\)\\) + carrot - stick\\)\\/\\(1 + \
\\(\\(1.5522693537619925`\\\\ \\((carrot\\/stick)\\)\\^\\(10\\\\ \
\\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\) + \\(\\(Log[carrot]\\)\\) + \
\\(\\@\\(3\\/2\\)\\\\ \\(\\(Log[\\(\\(\\(\\(0.45442949561604606` \
\[VeryThinSpace]\\)\\) + \\(\\(0.2927517022188942`\\\\ \\((stick\\/carrot)\\)\
\\^\\(10\\\\ \\@\\(2\\/3\\)\\\\ \[Pi]\\)\\)\\)\\)\\)]\\)\\)\\)\\/\\(10\\\\ \
\[Pi]\\)\\)\[NoBreak]) is less than WorkingPrecision (\[NoBreak]\\!\\(100\\)\
\[NoBreak]). \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/precw\\\", ButtonNote -> \
\\\"NMaximize::precw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591499586883917*^9, 3.591499832762639*^9, 
  3.591499876787813*^9, 3.591501082210525*^9, 3.591501277621311*^9, 
  3.591502643013006*^9, 3.5915028257615757`*^9, 3.5915031845549583`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"NMaximize", "::", "cvmit"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Failed to converge to the requested accuracy or precision \
within \[NoBreak]\\!\\(100\\)\[NoBreak] iterations. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/NMaximize\\\", ButtonNote -> \
\\\"NMaximize::cvmit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591499586883917*^9, 3.591499832762639*^9, 
  3.591499876787813*^9, 3.591501082210525*^9, 3.591501277621311*^9, 
  3.591502643013006*^9, 3.5915028257615757`*^9, 3.5915031853482313`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Plot", "::", "exclul"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({\\(\\(\\(\\((stick/.\[VeryThinSpace] \
\\(\\({carrot, stick}\\)\\))\\)\\) - 0\\)\\), \\(\\(\\(\\(-\\(\\((stick/.\
\[VeryThinSpace] \\(\\({carrot, stick}\\)\\))\\)\\)\\)\\) - 0\\)\\)}\\)\
\[NoBreak] must be a list of equalities or real-valued functions. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Plot\\\", ButtonNote -> \
\\\"Plot::exclul\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.591499586883917*^9, 3.591499832762639*^9, 
  3.591499876787813*^9, 3.591501082210525*^9, 3.591501277621311*^9, 
  3.591502643013006*^9, 3.5915028257615757`*^9, 3.591503185351137*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13k4lN8XAHDKUminLFmGGWNWokTKPaSy9i2klCVrlqSokDXZomRJlkpS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{4., 0.56},
  Method->{},
  PlotRange->NCache[{{
      Log[50], 
      Log[5000000]}, {0.55, 1}}, {{3.912023005428146, 15.424948470398375`}, {
     0.55, 1}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{3.591397873075288*^9, 3.591406518821679*^9, 
  3.5914067788846197`*^9, 3.591406926504661*^9, 3.591482011183756*^9, 
  3.591483598713295*^9, 3.591484160025392*^9, 3.591491121719108*^9, 
  3.591496055931872*^9, 3.591497581491661*^9, 3.591499192187619*^9, 
  3.591499349105842*^9, 3.591499608721627*^9, 3.59149984046172*^9, 
  3.5914999008562202`*^9, 3.59150110364624*^9, 3.59150136019816*^9, 
  3.5915026888367023`*^9, 3.591502989963751*^9, 3.591503348128681*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Exp", "[", "10", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591499927492598*^9, 3.591499935577539*^9}}],

Cell[BoxData["22026.465794806718`"], "Output",
 CellChangeTimes->{{3.591499929265586*^9, 3.591499936680451*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"getStick", "[", "10", "]"}]], "Input",
 CellChangeTimes->{{3.5914992059408693`*^9, 3.59149921221742*^9}}],

Cell[BoxData["0.\
99611734836447585801579063485634034538358056496390961611969605778785663971629`\
50.02079290398921"], "Output",
 CellChangeTimes->{3.591499213311206*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"u", "[", 
    RowBox[{"p", ",", 
     RowBox[{"40", "-", 
      RowBox[{
       SubscriptBox["\[Beta]", "3"], 
       RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "10", ",", "10000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591483768003127*^9, 3.59148378127426*^9}, {
  3.591483873926754*^9, 3.591483874175124*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13k8VO8XB3AkzcwdS4XINou5M2QtiRSfRKFEUkoLkSQikZClxa9UUhQK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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[10], 3.0103511393754134`}, {2.302585092994046, 3.0103511393754134`}],
  
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{2.302585092994046, 
       FormBox["10", TraditionalForm]}, {4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{2.302585092994046, 
       FormBox["\"\"", TraditionalForm]}, {4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {2.995732273553991, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.4011973816621555`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.6888794541139363`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {3.912023005428146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.0943445622221, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.248495242049359, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.382026634673881, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {4.499809670330265, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[10], 
      Log[10000000]}, {3.0103511393754134`, 3.5129436744624845`}}, {{
    2.302585092994046, 16.11809565095832}, {3.0103511393754134`, 
    3.5129436744624845`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{2.302585092994046, 
      FormBox["10", TraditionalForm]}, {4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {2.995732273553991, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.4011973816621555`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.6888794541139363`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {3.912023005428146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.0943445622221, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.248495242049359, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.382026634673881, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {4.499809670330265, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.591483782394273*^9, 3.5914838753188047`*^9, 
  3.591484210724201*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"yfb", "//", "N"}]], "Input",
 CellChangeTimes->{{3.591483908497744*^9, 3.5914839088128242`*^9}, {
  3.5914839812807817`*^9, 3.5914839819650307`*^9}}],

Cell[BoxData["40.`"], "Output",
 CellChangeTimes->{3.591483909427148*^9, 3.591483982862341*^9, 
  3.591484219919324*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["b"], "Input",
 CellChangeTimes->{3.591483961931126*^9}],

Cell[BoxData[
 FractionBox["1", "40"]], "Output",
 CellChangeTimes->{3.591483968543589*^9, 3.591484229668971*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"p", ",", "yfb"}], "]"}], ",", 
     RowBox[{"u", "[", 
      RowBox[{"p", ",", 
       RowBox[{"y", "-", 
        RowBox[{
         SubscriptBox["\[Beta]", "3"], 
         RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "1000", ",", "1000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591482185975268*^9, 3.591482217465405*^9}, {
  3.591482259978361*^9, 3.59148226119119*^9}, {3.591482460887714*^9, 
  3.591482505633902*^9}, {3.591482608307609*^9, 3.591482626324999*^9}, {
  3.591482662093659*^9, 3.591482666925808*^9}, {3.591483626664112*^9, 
  3.591483630280757*^9}, {3.591484409557621*^9, 3.591484411206091*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwd13s8VNsXAPDxjhmqQUiEOXvEiJKS9Fj0QMpbj5vkEb0QV6FQuE0PCQmF
ilCkUFxCyVui6KqIyaskFMVVSm5+6/z+ms/3s+ecs9fea6+9t7rbYTsPYQaD
ISXEYNC/AZ/FMiJvKMP9KctrRbVMUNlpLlKcoQzKDu4Kzejaukj3vpvKsHen
eOwAmp06m1qZowzSk59DFOqYkGurdPNDgTLE7OFtPIbuL9bJglplSNzwPnp1
PRNsw+3vfB9QBu83H4WrnzBBZ96NQjedBdDyq8eioZEJXZZhkYPVC0Agto0P
/zBh2VRP8xFrFdAamIrWaWfCFjshi3UdKiB14LSN4C0T9hR7nnvgowr9A09C
u98xQfHSFsMVU6ow+9uXr3aDTGgKDrjjdnEhHB6cuswaZYK6xP2cAbYaNN2r
ZAT+y4R81r4VC3eowY5ZqWdsfzBhleK6m7oZasBwLz6+8z98n0v7ZpMhNfi7
0MrnhRAL2kNsmP8uVgfq3P3pb2IsuJT6KS84SB30Qq/wl0ixIP33pnMSj9Vh
12mr/m5pFuS51246KKkBu61EpmLmsiDlmsZCL3sNEISn+/XKsUAga6Lrd0UD
Vnjey8xXYIFibLja1vcaIFm62NJrPguyzSMsdLQ4sLukNyF/AQuWS9x0fHeE
A0njXY6tqiyIkDfJYQZwwHnyD3Yn+gWn67dBIAfetL562of2AvnsM8c4sNSm
UmsMnX6MP6VzggPqVidzZy9kwZzPHqmBZziQQwZqLdGfX3CHWMkcSLQoWl6J
zkzODjGs4MCMesGyZDUWvL+9sHtLJQeOaVebpqE1ShPXuVVxYLj/3NZb6LT2
U8IXajhg1WSyrQB9Vc717LsnHBCMOhk0ouOjleIvvOCA9o8LnJ9ofkTknfd9
HLjAcHhhr84Cz4NenTGiFLg8EAuaRpcL+V5+JEaB0MSh90IaLJBL8ncYEqcg
w/GDhQS6+snxZlNJCjJjZGex0arkXPU3aQoCOF4Wmui2nps5uxQomPMsrNcG
vcmx57imNgXlK7rc09DXPr8zdOBR8C4lW/8meuKvgYkwHQpUui5P30anF4z4
dOri9+f3hxeif8+edruwjALHeFO7enRxo6Llv6spGByMlfqEJmCnXGFNwcc2
s64lHBb4vFnyod2GgtAEp0YDdLHv7PyvthQsY24oXInedOOZqYYDBStHo4IA
vV/Y7CB/BwVWO2T/sUbn1BqXWrpSoLt+Z5k3WteCbH/zJwXZT4X9bqED+kTU
x/wpaNO267iNfnzs3bDkUQrKRP9ak4u2zkk9YRxIQTjj/M9CtC9z/q3rwRRc
1zGBKnTBc5lve09RwF+aP0uANrT7ETeWQIHePcFZJsWCVm/TDtHLFIzHlO+R
Qfuci1qoeIWC304l+nPRtyrV7q5NpkDmzNSzeeh5ehZ1569T4JZQ3qqOnmAm
T5IsCqiT6RxD9L06Y6c/SijQOiDR7Yze0sdP9y6lYK1h/0pX9OB0y2BYGQWP
Vw3GuKMXGuw9mvUI+3Nnn/5+dHR6VPREJQXn79tY+KG9T3ZVRj+loHCjXkUE
WtvoJKnppMDp1+rmdHT3W8cnIwIKLpJj7ZnouDCdA4pdFOxTXff2Fvrnk467
3j0UrKs4+CYH3bDNwECxn4KlF21SCtCeR4ZMvUcoMO54ZVmFnq9Y2X95lIKR
u2PSNejmh4mnq79Q4OVwo6kWvVxkQ6PCOAW+ux8aNaBF467bVn/HeGYN9zaj
0/PtXRQYBPM9f5cAvc1eW9hUiEDAitXtb9FSk4xML2EChXoeVt1ov7V5H6tE
CYRmRun1oeH5rMNekgSclE3KB+j4hstDq9gEeqcfio/R8UXHL/wsS+BFrdnq
cfQm/UNV8+QJNHGCvP9F5x5TFPNSIODV3lD9DR0yyz9q3gIC5a5GRlN0fNxF
KYcIAduvLxyFCQsqGjssIrgEjNUYK0TQew+f/3FFk8DOE4fYoui8klHHei0C
1vwfFWJoU8uiOeq6BODH5Mgs9McvnhWGegTKXsndk0RHxSv6WC0hcMrJz0cK
3dYV3BSsT2CV9qceJvqQr+npthUE8t+OJMig58hPGIwYEhjXl1s1G11cevO9
iBGBm7dDO2kzRCRNlhoT8L6nPGcuOj6h5df5dQTuUrFWsmijVeE56bgqfcME
r2h3d+vvLDUhYHPAe7scetGixOKB9QTkEz1t5dGPypz8TMwJvFlTpqiAdt0j
o7bDgsDpDxvDaYuLVjb7bCYgdUJ5gLbNVo7O1S04X0tuZSqiv4296izYSkBS
w+k37eTE0+eeWhFILNjtoITu7xka+G5DgOW88Rvtc6dSEqTtMD4rHZiP1tXa
uoGyJyB+3uUM7ZfPf4+vciDQH/KukXbQn/du2DoSYMQUSCmjVRTcbPZvI5DN
+2cT7eqHsjMnthOYebT2JG2WWKDT3Z0E/vKY9YH2/duLmDV/ENC18WAvQG+z
6izt2EWA38ZeTfvX+Pn9X50I9LnOdaOddnmNgoQzjt8u11O0N67+Uqeyh4CR
jkgG7eHetCMGLgTmrZkspx3Dt+NYuhJ4+H3Na9oG2qKtrm4E8qraB2l3NBeF
BbkT2CJe94P2Cf99ejF7CTToiIupoDmKSt03PQgsupYiTbvhUWPUI08C5hV8
Nm1v1xDjl/sIvJ2qlaXNFtcdHtpPwPPBzrm0S3J6rjAOYv45bWDS3m190Uzh
EIErNnwh2vNDWmw3euF8PG4dp7/fni3t5O+N7QUve2jHv7b0vOFDwCz/bANt
W+FI35bDBGYbjt+lLaPXcPw/XwILn825QLtplzif9ycBj6/9+2mfPbshZqc/
gXhyGP4/XkURSWeOEFAeyZelLfyuMqPoKI5/Q9Y7ej4qZGZy3wfg+jPcnks7
xHhNydwgAiGPHvvTNtofXL3uGAFBW/dy2t/jS595HycgLVHyL50PhVWTbSnB
ON/PNufSXqx85NNkKIEbiqmytIfNCr6RkwSGrrpW0vmWdeTrjH0YAfW/e/bT
Vm/2krsXQaA0YU4una/dUzmq3X8RuOZUa047RXNoEYtPICh/eS+d7/LhHmv2
nyGg/8VOmHZrboZZ4llsb5uJmkfPf2efbe05AmFrvWRpSxo4e6pFEbgTwZel
19d/A9ti3sQS0DzwpJeNLpNNSBKPw/UwEGpBOxBeZhhcImBZOZlLr+exJOuS
2ASsb0cND85Bf9hi3meeTIAsn8iXJvR55vSngBQCR0Zbv7PQe27Vfsu8SuBj
S5AR7Y4ZkBJKxf5+Ui6g683zAqNlpRkE5C4985VAR/YErvmYie2pYwniaDNW
sZn8Lcz/833FdD2r8tB38ssmENvF+UzXvyJFHl8rF9f/knUUA33txIL2pGIC
a0VWNE1i/czTrd9d/YCAa3Z4wXf04+7D/cMlBOoU6xPoetu7tmbM+CH+X9zY
hq7HGjMHWN0VBKh7vfGj9H568oGJxlMCn7UCd/eji/VcGzY3Yr3/Eib6Hv2k
R8rav4lAjGRkFr0fDK5zdqp9js+/Sumj9wtthligZysB7psG0kH3J8zubo6A
QLVF2ugzuj9LpvVfvsXx5zc7NqFbem+W/uoiMNdWuPQp+iv8rN/SS8BPNcS/
Hq0vlNY32k/AXammpILuT/jIvGWjBIJbx07dp98XcTb8IYML8Wa7uHHoymXS
8i+EuGAaPW9ZLLq6/2J2vzAXmlo8Vkej6zaltEiLcWG+U9WGSPQzqTwVF0ku
TBge0aH3b0Hcy1JRNhdqZcV20Pv7j3TV8a0cLrisvqW+FT1ln8F3o7iQ0+1e
tRk9LbpIKZBwIbOyfLc5esZzKaRpcmHjKrOo9Whx3obocR4XdAsfVBqh5QsP
aF824EKi5fozhI6v5m+33o1cyPsvOWoKzz9bputsWWZccD2a+9ck2nN5O6w0
58Ln3qaACXRS1k/V2M1cWJC22HYUzYhaK1hnzQU+I6qtD93s0GCfugPfLzHC
aUAfHBBscD7EhfqZr40X0RmSIppvY7mQXqq3TQmdt/6LxsRFLpy0ik2UR5eF
ClRZl7gw/jry5Vz0i7HCeasTuLDSxGq9FHq6Y6/41SQueCmwp6bwvOmQU/9h
VzoXXqvfrhWgxSwjMwWFXCg+0t2cjN4XNVdD0MaFML3rj2TQ9RYHkkfauVBz
4YSxFJqSqGIzOrigYqH2QAz9LtxXhAjweZHsTPr87RTY0u/Tg+Of/3THMNrG
7UKW8CAX0mScSR161UrJxdo/uVBW8cs6CM3qZ6w8pqwJph/5n17h+T7PhL10
1EMTyt7YZ23E+0SG4L2L5x1N+CM4+laSCgsSg9v9i75rQlbIwj+ilFnwdvv5
cok1i+CeAlNhnxILRCTVNH6GLwJehK2MHN6PNCvbDlQ9WwSPt8OmrXh/ul64
dTCKrQWaMxErA/B+xc4dsNBz1oKJbrNOJRmMP9il3jdbC46ynY3D8H42+3Ty
saIRLXg4pMp7K86CvxO/z/5npTaoHPRfkijMgrvv2V1fTmiD/PEY1qbfTOCL
zanLrdGGPQeW2pX+ZMKuxXqxpjI8UGjqrN03wYRTF2XiOu150JNqdHb2Fya4
31Gym+vIA63H85u+433TtI5im2/jAWczV7wbPfNjVVzRDh6UDxfuvYs+7rIv
LnY3D9x7D9WYo331KuM27cP2ay5iYSNMcHrud6ngOA98zGrPD35igvHHEPuh
YB40aGe1NKPnC52VVQvlQd6UF7MI3W5w/dKFkzyQNL5yMBxtd7Xx0v5TPEiS
XvxECW1+iBOvGs0D1TbLSfNhJtYBXQfHGB4sDrco0UWLpxrJRcXi9zTF/OTQ
Na3W8T/jePCTlfu0Z4gJa1eFxL+6jPFnhCoEoFUczjgwk3iwIl4rcRd62jtO
zjSZB05lYSwTdNmN7Pj8qzzQX6bZy0QnPSx0GLjGg/hGvzVjeD8Pev1YTiWV
B3vUnOPa0Nu+PH1ln4bj+Wqo+yF6ueTr+MgbPIg9w+bcQP8Pz+iF+g==
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV13k4Vd0XB3BTonvNkeGnDPfsgysKvZTUosgUMjSIUiqRqcgQhUpJKlNl
TKUiSQNJMpVIaJTo5SrjK0KapMRvnb88n8dz97DO2t9ztur2AMedAnx8fGx+
Pj7mb+Xjqdrdd1Vgk9N2YuvMAnmPNmvTTypgvLwkYcqbBW2RDqxvC1VB373a
syWGBSk5w0URYapw7EKje0gaCy5PW5yYXaUKzWAUOF7AgiLPJxY+omow0Lf0
b0gFCzKz1Rb4OqmBetBkTmATCzpkTHX2pqmBS3GnQX4bzpcYo7K2Vw3ejpu/
MuplQb7lYSttTXV43BChnvWZBUtmX3XpCVaH32faevf8YMGVjPxIw2p1EFja
k9A+xYJdPr7/nhHiwGuejnaTABsocFSqtueABO+0i5UIG/zbF/W3OXBgm8l1
eTd0aaDErS/rOOC2wvWlP9riUrOZmjMHfoekzktF7xZY4xO7kQMnjk7IdKEL
nhg/sNnGgZ9NvJoAUTboWFEb2vdx4LpVq1j8HDYYOv5KHj/LgXsqD2Iy2Wx4
42f2Xug8BzQiU/lvoP1PJCyQT+NAoGp+SDn6Wo1K4YoMDlzQPgHv0XK6VnUn
L3DAVDjfSU6MDd9ZGRNUHgeiJmcOnEbfrjN2cy3jwIz/wFCIOBu0lkZRtf9y
YIn2Fl1NSTZ0dbo8HengQE3R9SWG6ORobW95Hgco8b2LzNGTT98X+n3ggJD3
McFt6Ib1BgbyfRzw5TiopKF3BX8y8xvhwJveCCMhKTZcvuXkMY+PgnbRRMG3
aEWikbmHoqA40nnGUYYN1Y3vrQ4TCo6K1R13R+8IOPkrjabg0ndq9m50Udmo
S70mBePG9UORaDObe5KqOhRcP95lfg29J9Ds2Lt/KJCR32A3ga4od9trakmB
taRLdfJcNmzbKq6y0YqC0hID7Sy0sFDNC39rClhSfolX0Q5r1bWzbClQO/l9
RRm678OngZ8OFLxwLTXgodmzQt0KN1GQkFUVS8mywd0+ac28PRTYRTi33EIr
Rr5cZ+5LwcFk374ydFu+mFuQHwWPQ58PP0KvE4gPfBlAwdWCMF4L2vze4fTj
wTi/Js92Ar1QKXh44iAFipJKW5fLseHvwPoz7YkUHHnc6VONLpc5my6cTEFZ
mIbtU3QotOQapFBw8dkizkv0eLp9WeJZCiap2LIudL+tZbdlBgUDFdn7/qKf
312q/yCXgt/aZ3SXzmND9qH/taWXUsAvKNZ3HV2kU+/++D4FmtFiR2+jq7oC
+obKKJhqPa50H/1xRe248UMKXq/4uegJWm3Gm91VTcFfQYmfPPS1qPumas9w
fIs3wxLyOF60Y2FBBwWhi+0z/NBVi6b0WjopeDbqoBuEfvnx6oM/PArcc7Uq
wtBfYLLe9iMFhSZ7K4+g9fgvdo/2UaDXl74lHV0aMyKnP0rB+ZwG5VpmvMNx
MQ/5CJTcrLwsqcCGGn0x2Vf8BPa1e36ai37cl5TfJ0BgRsxEUwFdZ5H5UmwW
AXGppFRVdPOcImUPUQKpwb8V9NAdyS0PhKQJrAu+1r0O3blq41oFGQJXboZV
uKC7vnd+XDiXwPTynMRN6J71A7M3yBE4fHScsw09pDjpcl2RwIbo3r8B6F+X
539dq05AZGf1vgT0b6fc2O0cAlITDb1n0FNCGgqhFAHHIQu7FPTMrsVwkSag
35wnkYEW5q4+/ZVLQHSBweo8tGyxt9Z5AwJNUhohNWi92pLtH80JaAbVzxlF
207VrWOvIVCX9XLgC3rXkjYwssT97PN7+A2dnjc5P9GaQK57oN0kmi9hRcdK
ewIRMS1KQopseOHc4JSzkcBCBfZ6efTgqfdmTZsIbK7ZW6GIFng6tHjClUCe
daKSMnrJUjFJe3cCZ7r4nqiis5Qdm6e34X5jRyq10D4DHau37CGgcqtjgzH6
6IIR/XhfAqs3tVqboC9snFYr9SOwNK7gn5Xo140q/OKB+PwGxn6ZoY1u7ays
DCbw3EdVwxrtOBhS+Gk/gW9svR4btK9qXKZsKIFzYzpn16JzUgrC/cIJ/Cn9
0e+AFg4bW6J8iEBA5Re9DWiVO3yUVRSBbbysko3oZUNSc/dHEzh23lzXFe3n
ZvC1+TABv6FUCXf0WwgvijxOYBXxjNyOHg2Pz86PI8C/QrveEy1SnJnw9gSB
l4P8ojvRy6kqH+0EAlFt/4Z7oXNFBenORALs/nARX3TRqjG170nYLz/eivih
yw92zGenELAc1hH0R78aL5ZbfhbX29DfH4Ceer9DOCudgNG7eM8g9Oy56wRK
MrB/rokYBKOl7UymmzJxvkdJ04w1Hsv+/JNNQGKyKSYE7VxQ37/5MoGU6Tmm
4eitfXe7g3IJhNSL9TD2mZ/DO3kFn9ckffAAOjo5tPXhNQJdafmXItAnmz1f
t+QRuMknzY1EnxN2eD6cj+ttSCtiXHhAo07pBoGvW4WuHETfL5n7SL+QwDPV
z7KH0I9H+SptbhIQoCdiGD/XGCnzLCLQ2E8GGbdvf18ScYvAkpZIyyh0b1bd
7ZTbBMw8f19mPPruTuGNOwQ6RS5NMJ5lE3+lo5jAZ9eAM9FoydiQi99KsD/+
S3/D+H/V27NYpXi+bb5JxKDpSbs09fsEdL9GrmGsp2+calxGIMfKKJyxiR+d
6PSAQGUFucrYMk8mYU85gRf3rJoYO3XPHD/ykMCcC5eHGW9R+nwkswLrydMT
Poz2dmmPKq4kcKjjjyLj4DNPIpqqcP9/pzUZRz27HdpbTWDXdRN9xvGC2UF/
agjomT34h/FZkxMBMo8JTGkFGTC+GLp/D7eWwJE6X23GN+5s81r1hMD+fXnz
GZcOr/XcXEdgbxKHxfgRtWxrUD3mQ0z/OLO+5q1k88mnBKovDL9h3JYuvSG3
gYDQGqMixj0t044Pn2F9W5uPMB4RG7ZracQ8yS1wYvxrTZv1cBOBMVaLMmPB
w7UWgs8JDO9c08PUV7zilpnSC6y/iOglxgo/M1fovySgZKPgypizKG6ZzSsC
yTHhYox1fYL/8XxNwI2P+5B5fsuueOhFvCFwQFHXk7F5l61OSguBQdXjsxg7
yC/VuvEWf+9lcJnpD68EKbWOdwTkPqc0Mv1Vb+WdMdKGecS+tJExZ/Yjab73
BOSnoZvpx56YQEGqg8A/hit6mP6FlQ0Rhp0E2j5nuzLOmVrw3YqH59vh7HOm
391CX/b5fyAQ+c0+lzkP5Qa0e8xHAufTZYUZK3w91JrSjfUoD/UMQ7/z1akv
68V81pMTD2XWu/1UnsAgAZDmqTHnr2hB/wLZTwQUy/JcmfMqxlueRg/hfBby
p/ahGzd8jrP9jHnyaKw7kNn/Whufc1+wfyPTbJg8uDIntyd/nIBC+d2NTF4I
NPx2ffiVgJZUpMcedI1Zgc3H75h3KSoe3kw9jUQXak1inu96tYDJn7QfHleX
/8Z8/nFYYAd64m6Zsv0fAh6pIx+Y/CpZuFs8+C+ef5+xeA+0jvrTsUp+GpZp
PLm0Ga0uHnt33RwaNu240sLk5+GmTq0dLBpWerlut0d/jDPIDWHTIFL6fpjJ
2wuCfSmZ4jRk7TIaY/JZftJsf780Df3aKfdXo9l9fEbhSjQspq/YGzLjafaz
cv9Hw/3cOzuWoCf9n31oVqbh7HBRkD56YDLpuIoKDRmfD0bpMvuVUG97yqHB
699EO5o5X8bmIXI6NERk5TTJooeiNa1Bl4YGmZXRMuht9WLzfRbRcEG4R0cK
bbfuXV2lHg3lKoYH2Ew+ennJ7jSk4fSilc8E0LzkEyXFQMNcqsmKeX86t/vF
8UxpkE/VyRlGNyo7us1eRcO3P3mjg+iyfEWhzeY0qGh3R/Sik6tuOAlY05iL
CfbtaIuh518dnGh4kHS/k3k/F5lKLx7dSUNFUcPZU2i5uNdSQl40LGkL8IlH
H3qR+FVhN9ZTQXzZcfTazRIl5j400FL6jdHoz8Fsw2x/rFeVQVEQmpsvbGIb
SsPvi7WxG9H54n8sC+JoMHuxJmw+WtKlXLPmBA3jlVY3FdFhmeFz3sXTwB/g
ypNDW2r8auI/RcO+NwU6Euj/TH/YbUqigS9b8dwMfk+R/WPOIhlY76NNYR/Q
uR29Hrtu0CAu+TUpE61WoJudUoj7NRZtOoe+HBbxvuYmDfrR3tNJjGVlHJVu
03B1rYhzHGN7s1WvSmhQOtlSHoy+WHuRWlZFQ3C8aagtOuuG+5DYaxp8r1rf
nsDvx3MRbUH3ftLwPXCOhQl6ts10xYsJGtK4OVGG6DBFSnjwFw1iR1xLFqNd
H+xLU/xDQ3yahQRBL5gQq4yaoUFbfSZeHJ2/b7WwtYgGuLmZZzDfww+876R1
KWhA6u5MxQh054aTlbNNNEB1fVbxVfz+FhRVUZuM0YCaW2+7m/D+QNe8837U
rAHPl6a5huJ95ULx2sEEaU2INFTnTeF9SfrmgJXuFk0IHlSPnWBhXkV41Afm
a8IPyazbeXi/kziWEX5vRBN8Tt7Zu3IWnr9zPyVeG2lBase85sX8+P7sleaN
HdIC9rbvlhJ/WRA7S7LuZq0WBF32zbr+iwWbF+ommolzwc5fZCDyGwuOJokn
/+vEhSm7hKNmoyzwvKHgKOXChSHhilVaaLM6jrTlei4UPmv8LYWe+bUs+d5G
LszfddChe4QFBzy8khPdubDm2HR6FDpQtybZwosLcu3Xc8vxPuz2fG/K3QNc
OFRuekRrmAXG/0U6fYrggsZu92VSaEX+OBmVg1w4oib3aWII7+8GF1JORXHh
uun6hXVox6zGlN1HufD9bKvDVrTlHvXU+ae5cFpwnD/5EwvoWB1nlzNckFfj
LQ5DC+csnZuQiOv5uWrTFnTtG/vUyWQukDnhp7XQK5ZFpr49z4Xd91clPx5k
gbLzcWdWOhdaPRoO5qOn/JLnmmVwIdqk1OM0uvxSfuqtLC6oVT1hu6LTHxY7
D2Rz4dzPj60r0WGtVXOVc7iw6qT7OQq9fuzZW6eLXOCsNrJjoZeItqbGX8L/
D/r//fIfC/4P97+ZWg==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[1000], 3.4161608694798073`}, {6.907755278982137, 
    3.4161608694798073`}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {8.517193191416238, 
       FormBox["5000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      10.819778284410283`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      11.512925464970229`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      13.122363377404328`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      13.815510557964274`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      15.424948470398375`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm]}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[1000], 
      Log[1000000]}, {3.4161608694798073`, 3.518121866654253}}, {{
    6.907755278982137, 13.815510557964274`}, {3.4161608694798073`, 
    3.518121866654253}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {8.517193191416238, 
      FormBox["5000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     10.819778284410283`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     11.512925464970229`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     13.122363377404328`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     13.815510557964274`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     15.424948470398375`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{{3.591482201266163*^9, 3.5914822188854856`*^9}, 
   3.591482261979087*^9, {3.5914824623483753`*^9, 3.5914825069486217`*^9}, {
   3.5914826096922207`*^9, 3.591482627366543*^9}, 3.591482667982045*^9, {
   3.59148361561796*^9, 3.591483631755034*^9}, {3.591484234516129*^9, 
   3.591484240154162*^9}, 3.591484366081531*^9, 3.591484412341704*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{
      RowBox[{"2", "p"}], ",", 
      RowBox[{"y", "-", 
       RowBox[{
        SubscriptBox["\[Beta]", "3"], 
        RowBox[{"c", "[", 
         RowBox[{"2", "p"}], "]"}]}]}]}], "]"}], "-", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", 
      RowBox[{"y", "-", 
       RowBox[{
        SubscriptBox["\[Beta]", "3"], 
        RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "100", ",", "10000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591484534848968*^9, 3.591484550353758*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nk4lPsbBvA5kWOpEKFmzAw6cmYsI6VSeb4cpRynbOFIZSmddIqKRIsh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[100], -0.21414680661367985`}, {
    4.605170185988092, -0.21414680661367985`}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[100], 
      Log[10000000]}, {-0.21414680661367985`, 0.27915084593335104`}}, {{
    4.605170185988092, 16.11809565095832}, {-0.21414680661367985`, 
    0.27915084593335104`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{3.591484552816538*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", "yfb"}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{"p", ",", "yfb"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", "p"}], ",", 
        RowBox[{"1", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", 
           RowBox[{"2", "p"}], "]"}]}]}]}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{"p", ",", 
        RowBox[{"1", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "250", ",", "250000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5914825200097857`*^9, 3.591482657964075*^9}, {
  3.5914828014646387`*^9, 3.591482820495327*^9}, {3.591482922716628*^9, 
  3.591482927138237*^9}, {3.59148443635006*^9, 3.5914844400466146`*^9}, {
  3.5914847413503036`*^9, 3.591484770176*^9}, {3.59150871389774*^9, 
  3.5915087193698587`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVj30w1Hkcx5fpQWripLWEdln213VdWjvWVfp+jtLmkueHyTkrdtOstB5a
KvFbF3ZL7HUqblbIiMZWW3Sear8ex0OcJRqli5I8pdtCyV1zt/fHez7zmvfD
zIdx5IS/wJBCoXjr9f9dDt8//nkjFYzcjjB0QwpU2i33cKBRgZfvw5Hrmcft
KfO1ogJnxopmp+crpn7RFbZU0IqX/AIGFWhH6+GJQBYVUs9l51QPKFAMETd5
x5UKdYJSY1GfAg19yJ8VhFHhYNGlK/c7FUid/Wq+v4QKe58PsWsaFCjyYXN3
CNcCegr9Gk4WKlCtiGHyutUCfiz81S1TokDaVnf5bW8aqP6mFTn7KtA4q7LL
cZwGRh1edVcZCqRckZtcHmcJ/KakfM3LPOQzVzvbv9IK6DL3UKUoD7Wll13e
/ZsVyCQHtjZN56LR8ya3bjE3wZLxWR0zKhctluLzPQ2bQFbwPDio+SK6u0M3
9N7TGrQu0epIq4tou+hVcJDWGsi3tOJFYQ6qUNOuCQU2oHv7hT74ywXUHtfn
n6azAUpAU/j6+vPoT9fuXo9sW0hJcOFta5CjWlVW2v5Nm6EgQzLSUiVD3MJW
pV/5ZhCnJ/AeF2Wjp7zrTeds6FAXIXkhEmahYwZl01FRdDAy7h0Ids5EH3H7
ouUdOjBHyk2Cn/yMBAFd1ic+06FpmT0XGJ+BWPYXT3fsYQBzI2lTYSlFb5YS
Gj/KGUBXb722yzUdLRlbOm/RMkDrq9MciE5Fs++L25fN7WCsymC1tuAUGnnB
21UWYQdGCarv7+VJkK3RvclD5XbQGbv7mUSTiH7iuiX36+zAN/hB8j/1YpS+
6yZjfqc9jI1NiR2ui9D8mSFDGmkPYq5mbYy/EEW32HdseGQPFGGkoK+Gj4h9
7Bazr5hAieAnV3NDUK+SMawOYgI5GNkT/a8XOrHM7nco0fuqo8yKVV+j6PwV
Btcm9GzyYHhgqysO4SxtmHNyAOCb5I80+OAiU1U4SnYAUtPLvDEUituaocXp
gQOUrG0JIB/y8VTKpzWfVzmC0+bw2KgIAY6IjZO1HXQEiG849EPVMfxYsHpG
WKBnSoxXXUAcJjhSYeUrRzAt6rtfkRyPtXsaLedYLBB/qIoqL0/EJ30s1EaJ
LBjeZlYcbyLBx5XOZ1n1LNBa/5X1DT8Fe2qcBBNfWDCVQTm1WHsaW7/xcTrN
I2D48qT/y7CzeJ/XdrZZLgH01x0ZHu/SMTN65wdeHgGm3Y3mhsvp2DBt3710
BQG+j1SZLw1J3HQ3jD13iQDZOIV6Yz2Jd1vK2J1XCaDUyNVujiRmT42x00oJ
WPguR1ARRGLbrEvOMzUEqN6uvnLsPom/FBfN038nAELLzogbSfy8vrI6pFbv
Jx2/mdJM4sI5jXN7PQFiT++xnF4SmwfNOpdoCEgZOPNH2wSJjZl7OcGd+v5I
v2ciVYqn3XwWcrr0/wS+M8izluLOkMM1rd0ExOQhU5WdFGdeEHN29BJQ4rJ3
y8y3UkyZV3LWDRAwtdKFL9kvxaPrKhfcHxOwdDukU+ktxRrH6ppTg/r9Ua68
LUCKUw93cSaf6PfMly1ofCkOSxpcsBkmIFSEJj2EUrwzd7Qm8CkB6uk1ZvGx
UkyrnEm68EyfP7q2sDhBij81L3JaRvT5vsXUvhQp/g+THT1E
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwVkHtMk2cUxiszDpVsCshNvtpCaT+ckVq6oSC+Z6NFvAIqoOKEQEHUcUlB
AYf9OqYIdgKpuIFUAQnCgEjBFmE1fUuRUVAciDLQOoStqDQYBigXh1v3x8mT
X/KcnOc5zJjkfXFWNBptj2X+V++CgZr3IQQslIXj8Jh2VK10uh4fR0B4Jvfc
80k9KpeZ/5EfI4BQG9uOmfSoOF4biY8TkLDsaf7CkB7luoqcnZII0GZcVW9p
16MTuQ1FXacJuMDihRA/6tHG6EDZhlwC7IMbasX+etT8aVrGVC0BYt3ljHXy
NtSR9Ns+ySQBs01zLuZQHXpzSJMwNEXACcfFtsLtOuQgrJbw3xKwesEvcpu/
DsWvpWrH5wmowC7CRlKHrA0brSI+ooNVer3v+L8Y7WLmN3o50KHc/2qiMQqj
vv7dq0b86CA2FO01rdei55u7ewIu0CEkT3b+4rgG1a+/ZLycRwcX06B7w5AG
ZbmGmP+UWfwtjN5hgwa50AaszxXSYXBGz46r1qCDnSMB90ro8MnWD6UfRBr0
OGy+VVBPB4VT3a7Y0V9Qt5i8Keyjw4EbVmF1plZ0pz5Hsn3tOlAV2pkcbFqQ
T0m7IrRqHcgTluyKXlShoaAbunMEA5RNAf3Rnk3o+JLK17GxDODLR24JHjSg
d7jjrXMDA4q/NMnT5HUobn+Xa/I8A27aiW/v/lCNOO6XznRuY0JC6f0pg30V
GpsTa97lMSGwW+VtDrmB5lY4e3v2MuEvJyUrxKYcmf8u61iwdwPViStRGzgK
9OyPIL/KKDdgGAeWZx8pRnTrppd7q9xAGhD4cMznCjrq45/eN+kGkCJ6cMZL
jii/n5nTvu5w8MJo65htAZr+9omVk9QdJnltkviqi0ikd++0u+8ODK8UP1lY
DiKFPL3tahYYRHvWpDdnox4Fc1AZxoLCk+q+/YsSlLzA6/MoZ4HyfLdaXJOB
REVLl1w3WfjXxUTHHakogj9nN8H1gPLKW51zb06ia6vqv0bpHsAY5xh7+2LQ
vTbQc+96gG4vK+bgmjD0KmN2+fwyNtA87AOUWZtQ1DdJufd2W1jKb7KjBLg/
7uPx+GI2SLM/H6nZcgiT/O/ia0bZUG586Hb0eizu3aZxnuBw4IVZqFWbj+NT
wY5K61QOFKrufqbekYITFd5nOa0cYJCjneaIVByo5caZFjmgk5HsR6GnsetY
MPdMEAnRvLlTpfmZWLjTi2ebTwItfYw9oMjCLJHvVFABCVKBZ1BxbRa2kgib
qEISXkx0FUW2ZGFdYyRvQm7Zr8hvMfVn4a3OuTzDTyRMxs+KrFeexbxXL3iS
ChIgELPzMs9ieo7ce1xFQu/vtq9zIiR4sezaNKPZcq/K83txnAQbW2tuR9wh
QfkkWBaVKsElE1rvjlYSdHSbN/4FEmwfZvYu11pYSvOx6ZTgFSwBP9xAQkpo
T+XkFxR+7R8880OXJV/33JoZAYUNEYdV7d0krLJ1cZzfR+HzshT+ph4SQpyT
Hn6cTGHatIJv84gERvu1nZurKTxsUzPzVb+FQZMYpKawln1blfnYkmeEwz3c
TuGsw138lwMkcI84lGYPUzgy7fEMMWjpk1m3vWSCwr75w6oDQxa/oLm08T2F
nWrG02RPLTxc9sC0VIpn297y9c8s/wknK6ZXSvF/YjdGHQ==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[250], -0.008531208992941394}, {
    5.521460917862246, -0.008531208992941394}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.214608098422191, 
       FormBox["500", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {8.517193191416238, 
       FormBox["5000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      10.819778284410283`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      11.512925464970229`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      13.122363377404328`, 
       FormBox[
        TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
          
          TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
           SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
      5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[250], 
      Log[250000]}, {-0.008531208992941394, 0.15143856375402703`}}, {{
    5.521460917862246, 12.429216196844383`}, {-0.008531208992941394, 
    0.15143856375402703`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.214608098422191, 
      FormBox["500", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {8.517193191416238, 
      FormBox["5000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     10.819778284410283`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     11.512925464970229`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "1", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     13.122363377404328`, 
      FormBox[
       TemplateBox[{"\[Times]", "\"\[Times]\"", "5", 
         TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> 
          SuperscriptBox]}, "RowWithSeparators"], TraditionalForm]}, {
     5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{{3.591482551992786*^9, 3.5914826370689793`*^9}, 
   3.591482823557242*^9, 3.5914829283339443`*^9, {3.591484428055716*^9, 
   3.591484441112463*^9}, {3.5914847481506033`*^9, 3.591484771315977*^9}, 
   3.591508720778384*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Exp", "[", "lp", "]"}]}], ",", "yfb"}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "lp", "]"}], ",", "yfb"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Exp", "[", "lp", "]"}]}], ",", 
        RowBox[{"40", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", 
           RowBox[{"2", 
            RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}]}]}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "lp", "]"}], ",", 
        RowBox[{"40", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}]}]}]}], "]"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "10", "]"}], ",", 
     RowBox[{"Log", "[", "10000", "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5914857459446983`*^9, 3.5914857570380774`*^9}, {
  3.591485787234392*^9, 3.591485818493658*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV0X9QzHkYB/BvS12hH1Yqra0tpJFLtddulHk+9kqtu4TisqauOq7kdtZV
vlvdur7bL9vP3e8pOWloo+L8KO2PyThcMW5OlPwIoRxW4sqPjsJxjz+eeeY1
88w8z3serxTFmk0ciqKisT71Dv/6y61bOITRDHbzD7HgZOujtd2K3pMQ7IJO
vH845tssdNz1Ggf0xE5Dz7TtHEKpj8d+bGYhYOJCb2olmv+kcRBd1zlyg9+K
8+8lJ/Xo7PiwgZLXaPH70rnoRfl9o8nqSYSxO1Lk0cQC+091nfzYZEI92+Fk
PsACrFjrU3zBmlBVqU/FehZ+fFvjzuu3IcyzZoV6Hwu7O1Jqp9rYEuZ+UcuS
vSxMVfm/seXbEUbVfe7KbhYyovMHkr+aQqg46fmWKrw/Y71QnDWVMFahgrk6
FnZpAlNmlUwjzNnn+zaVsdBhYvnfGO0JM6dpv76IhSU3XrbVX3IglEAi2JPH
gkjaZ0wbdCTMMruLH7JZmDHspY8ociIMt7rx1VYWAptvrktwmk4o69hXhWks
SDOuXvFuQhtM50ITWZhj0eb7hHIJM/ZZQ+8aFhp6u/YHnEdvkJ24vZwFj4vR
RUOyGYTya4gOC8H8YTF9jRa0693Ifl8WZO1Vo9yfnQlV0Nhr78KCeLB26e/c
mYSx/yPUx4qFk3lzJuR16LyGVYue6kDsN5rbJXQhjHbiQ3yPDmQxoemBZ10I
dW+2mWfQAfCl2mtSV0JZ/t7lUq0Dzzd7cucNuBJGn/86QqGDg1L5VVW6G2Gy
y08ciNTBvOaCl2qrWYQZVt9VuOogtWVD5PnqWfgfT7fsc1qICTTYOQrcCbVI
HtWyVguBp1f9YmNCKyssl7srob1Trpks4RHqv56Ft8MrYVLm1wZyER0nv1d2
rAKi/BWNC5JmEypLrtG/LQdhCteG9xRdeTjYQ1IObvoJv3Y1n1Bt1o/dU8ug
QZZ8JsHBg1Djzl8Ga0rh+alSDdmNdqh9MH9vCeYfd73yuSehXgg5eRoNzOVa
nNPa0Z0aoc+2HVDMmfbDOl8BoRaajg6Ki6G/p2ioJgM9LrxcMVIIBf1nau+Y
0TzL8bEjBeD7jBc0zvEilPu81fWSfBAsDvnoIkUrIv/tecTAhCz48bUKdLG3
qNopD7rz405svokWrN7Y5qCCcYvQYOXhTagx9t1fS3Kgj4KsEE+0KVni458D
JvcVXygE6ClBhWqvHMhcmWS44412Tv0ots2BEWO5wTwf3WXHOXg9Gx4VPjLI
A9GnzhxktmZDr3eN8VY4muNmljYqoTVMv81pOTrds6DpVyXo1h0NjoxEHzNt
t65QQnRpp9EgRcsGJndkKuHPF6NG7Ur08IfipcuUcPpslCkiHj2Ua4Y7NNTd
jqVV69Hjg/Pru2lQjSWK2mToVYYBTicNi323mQQJaFGH34VDNBi09aZ3yZ/2
+yfFKmnYeegIHfQdOsAsMqfTkNFpFm3eiJbcSuIl0hDw5pLpxvfotBfGh+E0
OE6/RdunoQ8/eSANoWFkwUNR+GZ0Vd6W4340dIWPvs5NRycFrZzpScNviW9N
rVvQKqbiJy4N/wPLYwNs
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwVk2s41IkXgIU0jMtv5oeodZeUJFKkrFNaicJWJEUqpFCoFkVypzaUXKql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     "]], LineBox[CompressedData["
1:eJwVk3s8VOkfxychaxMqdc6MmYZVjWhXoya6fb+VSzelWOlCEUJySdTuliRh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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{3., 0},
  Method->{},
  PlotRange->NCache[{{
      Log[10], 
      Log[10000]}, {-1.945761679165879, 1.2715633783585063`}}, {{
    2.302585092994046, 9.210340371976184}, {-1.945761679165879, 
    1.2715633783585063`}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{{3.591485748521468*^9, 3.591485757865307*^9}, 
   3.591485819696739*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Exp", "[", "lp", "]"}]}], ",", 
        RowBox[{"yfb", "*", 
         RowBox[{"getCarrot", "[", "lp", "]"}]}]}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "lp", "]"}], ",", 
        RowBox[{"yfb", "*", 
         RowBox[{"getStick", "[", "lp", "]"}]}]}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Exp", "[", "lp", "]"}]}], ",", "yfb"}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "lp", "]"}], ",", "yfb"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"2", 
         RowBox[{"Exp", "[", "lp", "]"}]}], ",", 
        RowBox[{"40", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", 
           RowBox[{"2", 
            RowBox[{"Exp", "[", "lp", "]"}]}], "]"}]}]}]}], "]"}], "-", 
      RowBox[{"u", "[", 
       RowBox[{
        RowBox[{"Exp", "[", "lp", "]"}], ",", 
        RowBox[{"40", "-", 
         RowBox[{
          SubscriptBox["\[Beta]", "3"], 
          RowBox[{"c", "[", 
           RowBox[{"Exp", "[", "lp", "]"}], "]"}]}]}]}], "]"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"lp", ",", 
     RowBox[{"Log", "[", "10", "]"}], ",", 
     RowBox[{"Log", "[", "10000", "]"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591482906860004*^9, 3.591482950789803*^9}, 
   3.591484760676861*^9, {3.591484942242709*^9, 3.591484945899827*^9}, {
   3.591484994609748*^9, 3.591485102776614*^9}, {3.591485189897984*^9, 
   3.591485203154748*^9}, {3.591485316477803*^9, 3.591485344240885*^9}, {
   3.5914856886090317`*^9, 3.5914856901737947`*^9}, {3.591485852540771*^9, 
   3.591485852966658*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591485065812954*^9, 3.591485093763413*^9}, 
   3.591485205411201*^9, 3.591485345351337*^9, 3.5914856910180597`*^9, 
   3.591485854703476*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591485065812954*^9, 3.591485093763413*^9}, 
   3.591485205411201*^9, 3.591485345351337*^9, 3.5914856910180597`*^9, 
   3.5914858548954897`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ReplaceAll", "::", "reps"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({carrot, stick}\\)\[NoBreak] is neither a \
list of replacement rules nor a valid dispatch table, and so cannot be used \
for replacing. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/ReplaceAll/reps\\\", ButtonNote -> \
\\\"ReplaceAll::reps\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591485065812954*^9, 3.591485093763413*^9}, 
   3.591485205411201*^9, 3.591485345351337*^9, 3.5914856910180597`*^9, 
   3.591485854897657*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \
\[NoBreak]\\!\\(\\*StyleBox[\\(ReplaceAll :: reps\\), \\\"MessageName\\\"]\\)\
\[NoBreak] will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591485065812954*^9, 3.591485093763413*^9}, 
   3.591485205411201*^9, 3.591485345351337*^9, 3.5914856910180597`*^9, 
   3.591485854900126*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Plot", "::", "exclul"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\({\\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\
\\/\\(81\\\\ \\@2\\) + \\(\\@2\\\\ \[ExponentialE]\\^lp\\)\\/81\\)\\)]\\)\\) \
- 0\\)\\), \\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\\)\\)]\\)\\) - 0\\)\\), \
\\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\\)\\)]\\)\\) - 0\\)\\), \
\\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\\)\\)]\\)\\) - 0\\)\\), \
\\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\\)\\)]\\)\\) - 0\\)\\), \
\\(\\(\\(\\(Im[\\(\\(\[ExponentialE]\\^lp\\)\\)]\\)\\) - 0\\)\\), \
\\(\\(\\(\\(387\\/400\\\\ \\(\\(Im[\\(\\(\\(carrot/.\[VeryThinSpace] \
\\(\\({carrot, stick}\\)\\)\\)\\/\\(13\\/10 + \\(\\(Times[\\(\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)\\)]\\)\\)\\)\\)\\)]\\)\\)\\)\\) - \
0\\)\\), \\(\\(\\(\\(15093\\/400\\\\ \\(\\(Im[\\(\\(\\(13\\/10 + \\(\\(Times[\
\\(\\(\[LeftSkeleton] 2 \[RightSkeleton]\\)\\)]\\)\\) + \\(\\(Times[\\(\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)\\)]\\)\\)\\)\\/\\(Plus[\\(\\(\
\[LeftSkeleton] 2 \[RightSkeleton]\\)\\)]\\)/.\[VeryThinSpace] \\(\\({carrot, \
stick}\\)\\)\\)\\)]\\)\\)\\)\\) - 0\\)\\), \\(\\(\\(\\(387\\/400\\\\ \
\\(\\(Im[\\(\\(\\(\\(\\(\\(\\(Power[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\)\\)\\\\ \\(\\(Plus[\\(\\(\[LeftSkeleton] 3 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\)/.\[VeryThinSpace] \\(\\({carrot, \
stick}\\)\\)\\)\\/\\(13\\/10 + \\(\\(Times[\\(\\(\[LeftSkeleton] 2 \
\[RightSkeleton]\\)\\)]\\)\\)\\)\\)\\)]\\)\\)\\)\\) - 0\\)\\)}\\)\[NoBreak] \
must be a list of equalities or real-valued functions. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Plot\\\", ButtonNote -> \
\\\"Plot::exclul\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.591485065812954*^9, 3.591485093763413*^9}, 
   3.591485205411201*^9, 3.591485345351337*^9, 3.5914856910180597`*^9, 
   3.5914858550896683`*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k41PsXxydKimS+KLJkSVwtSKRcnU8JKVuLtTDZE1mTFkKRypJIUcqW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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV0X9QzHkYB/BvS12hH1Yqra0tpJFLtddulHk+9kqtu4TisqauOq7kdtZV
vlvdur7bL9vP3e8pOWloo+L8KO2PyThcMW5OlPwIoRxW4sqPjsJxjz+eeeY1
88w8z3serxTFmk0ciqKisT71Dv/6y61bOITRDHbzD7HgZOujtd2K3pMQ7IJO
vH845tssdNz1Ggf0xE5Dz7TtHEKpj8d+bGYhYOJCb2olmv+kcRBd1zlyg9+K
8+8lJ/Xo7PiwgZLXaPH70rnoRfl9o8nqSYSxO1Lk0cQC+091nfzYZEI92+Fk
PsACrFjrU3zBmlBVqU/FehZ+fFvjzuu3IcyzZoV6Hwu7O1Jqp9rYEuZ+UcuS
vSxMVfm/seXbEUbVfe7KbhYyovMHkr+aQqg46fmWKrw/Y71QnDWVMFahgrk6
FnZpAlNmlUwjzNnn+zaVsdBhYvnfGO0JM6dpv76IhSU3XrbVX3IglEAi2JPH
gkjaZ0wbdCTMMruLH7JZmDHspY8ociIMt7rx1VYWAptvrktwmk4o69hXhWks
SDOuXvFuQhtM50ITWZhj0eb7hHIJM/ZZQ+8aFhp6u/YHnEdvkJ24vZwFj4vR
RUOyGYTya4gOC8H8YTF9jRa0693Ifl8WZO1Vo9yfnQlV0Nhr78KCeLB26e/c
mYSx/yPUx4qFk3lzJuR16LyGVYue6kDsN5rbJXQhjHbiQ3yPDmQxoemBZ10I
dW+2mWfQAfCl2mtSV0JZ/t7lUq0Dzzd7cucNuBJGn/86QqGDg1L5VVW6G2Gy
y08ciNTBvOaCl2qrWYQZVt9VuOogtWVD5PnqWfgfT7fsc1qICTTYOQrcCbVI
HtWyVguBp1f9YmNCKyssl7srob1Trpks4RHqv56Ft8MrYVLm1wZyER0nv1d2
rAKi/BWNC5JmEypLrtG/LQdhCteG9xRdeTjYQ1IObvoJv3Y1n1Bt1o/dU8ug
QZZ8JsHBg1Djzl8Ga0rh+alSDdmNdqh9MH9vCeYfd73yuSehXgg5eRoNzOVa
nNPa0Z0aoc+2HVDMmfbDOl8BoRaajg6Ki6G/p2ioJgM9LrxcMVIIBf1nau+Y
0TzL8bEjBeD7jBc0zvEilPu81fWSfBAsDvnoIkUrIv/tecTAhCz48bUKdLG3
qNopD7rz405svokWrN7Y5qCCcYvQYOXhTagx9t1fS3Kgj4KsEE+0KVni458D
JvcVXygE6ClBhWqvHMhcmWS44412Tv0ots2BEWO5wTwf3WXHOXg9Gx4VPjLI
A9GnzhxktmZDr3eN8VY4muNmljYqoTVMv81pOTrds6DpVyXo1h0NjoxEHzNt
t65QQnRpp9EgRcsGJndkKuHPF6NG7Ur08IfipcuUcPpslCkiHj2Ua4Y7NNTd
jqVV69Hjg/Pru2lQjSWK2mToVYYBTicNi323mQQJaFGH34VDNBi09aZ3yZ/2
+yfFKmnYeegIHfQdOsAsMqfTkNFpFm3eiJbcSuIl0hDw5pLpxvfotBfGh+E0
OE6/RdunoQ8/eSANoWFkwUNR+GZ0Vd6W4340dIWPvs5NRycFrZzpScNviW9N
rVvQKqbiJy4N/wPLYwNs
     "]]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], LineBox[CompressedData["
1:eJwVz3s01Gkcx/FJsW2bRVtW85thOG2Idl1yq/R9al1KWKUoIUSRO41qK0ej
mCQzu7QzLgmVE7kbE2rHTG6zruOSSS7pQhy3IW3jUu2zf/zO77zO+3Oe5zza
fuGHAxRIJNJx/P3/3+Kk4TdnRkYlgZUV/cb9wDwyMJlsS0Y0eiolJOsFCM8r
dKwLJqPqyxkLdg5SWJjYUuQXSkaypmdiBXMp6HraJ9WGk5Fc2bpQqi2FFJRs
d/YcGb0IG33XutgHnt+q1/1zBfe3irH9hX0gz9AvY7LJ6NjHj2X+an1gLHD5
U4mPe/buDv3ZXthvop9kXk1GZZWSwNfDveCdv4pxupaMJOwdBYUdvZCUUhHZ
JMCmSUsjS3rhjffGQwnNZIQOXZrtCOuF1K9SFaV+bE07Qel8D3xEJ28prpAR
c/r2Wl+lHlhfZXHd7AsZjTfe+J4q7wYdfdUrASQCxX357e/3E93grCYKaVxD
INrWeNHD9m7If63jeF2ZQHqOKTrS293gzhhbp6hFIPbNR/wevW6oqQ9lrtlH
IMmCk07zsS6I2UO9qG9DoBGjorpIxy7YUdMW5GxHICM3voke6oKSEoODXAcC
kaJsT1TrdkFe+oSyoSuBVMdZSv6fJJAcHpDq6k8gOcnj7gBXAt6EV3ZeAoFy
ppYLOps7YXW0Iw+14vsuRI5a/9IOss8bPdPaCfzeUZuVze0wzBxaPd6Jz1Nk
LXasaYfq7DBXVi+BZCHRi2Uv2yCkhT0/NESgMivhFf/ENujVfm50SUagCM2h
C9HvWiFf4lVctYmC4nK6yphFLbD/5/D8bT4UxB6c3NcULgaNJ9Nn3PwoyOiO
rrqijxjG7UP0Gf4U5JIVMOHiIoZE36Ci/kAKkkV9dlMxFkNT2qkKZiTeR9xp
+OlDM/y67C4YY1AQrZH9suhiM+wRo768B3hf+uhEM6sJTP02KBGTFDRiw9rO
GGoAk68FsfRpCspxHz6T2ImdtfdT5yzuO2s8uSLsvojxawv4/pjcfUMPGsDI
obNl5jMFSQ6TM+fCGsDQJJn1TJWKjIL5HKvVDbBVQWnzWXMqchFHKnwwrQeN
vEWDmqtUNNLZOJ1TKYIlZC+YjKeinKWDb5ceimDwVZqLZgIVSV69L/fMFkEu
1Ygen0RFEfLEpxY3RLAt/bTAKZWKZNlR1Q4nRbCL3ePy5j62o6FsaL0IvGOL
6d+JqYgm+sOeGSqEex6+dV7fayIfdmvJcoIAZE+TmIiriYS8ow/vMmrBwkD+
Y9d2LURbdSruTB8ftmwY2xhYo4WE0pZA85lKSFBYH+KmR0NxwTcnZNblMCC5
Ps6JoiHhoex1XfJiiB+oyxx8jHts3a6rRwpBb4owkStoI+H8E7fK0XygWVl+
VT+gjeJy/3rbsvk+LHqYve+9hXudkrdKaS50Mo5UBL3QRqS16rkRgmyQj5ny
VmnqoLjzQsNvZjJASoJzllo6iDS1aWplKAP4ZIcd4TTs9Jy5pfYMiHb24Q3q
4L00oValJANmqpJ5j3VxH+6qyAzLgNFro7xQY9zNjzZYzqVDtw6nqt8GW4MT
7r/ChfLdeXRVO7wfWTE4Ps0Ftluxmb097vlprKPDXHBKqq/iHcD2pVsFCLkg
nputYjnjfRYj7dU1LgiE+/m2x7C9H7jvVuHCnZeuMZePY6/luxeQuHB5wdu8
0gP7xlcedZ4DVnp0Ps0Ln6dmSac85wCPlctf9sU9tj8lMpMDqQVFMSansM1M
lzVucSCq/rF5kD/eW/+Q2xzLAaNP7fy+07jvbUvc6ccBFbX+GOVAbPpI3RdX
Dsxse2duE4TtP6fVYsuBNpvZf38/i919/16WBQceeS/xy4PxeaJ7djH6HPgP
SBmbEA==
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->{3., 0},
  Method->{},
  PlotRange->NCache[{{
      Log[10], 
      Log[10000]}, {-0.2222956491008111, 0.3936676259160191}}, {{
    2.302585092994046, 9.210340371976184}, {-0.2222956491008111, 
    0.3936676259160191}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{3.591482952816804*^9, 3.591485066923559*^9, 
  3.5914851191639347`*^9, 3.59148523270011*^9, 3.591485372707781*^9, 
  3.5914857183917637`*^9, 3.5914858824680862`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{
      RowBox[{"2", "p"}], ",", "yfb"}], "]"}], "-", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", "yfb"}], "]"}]}], "/.", " ", 
   RowBox[{"p", "\[Rule]", "10000000"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5914906257624187`*^9, 3.591490659282707*^9}, {
  3.591490727639306*^9, 3.591490727726247*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.05701388598826779`"}]], "Output",
 CellChangeTimes->{{3.5914906342527122`*^9, 3.59149066169419*^9}, 
   3.591490728379827*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "100", ",", "10000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.591490515615135*^9, {3.591490551786004*^9, 3.5914905912271957`*^9}, {
   3.591490807553472*^9, 3.59149082260109*^9}, {3.591490941523843*^9, 
   3.591490943696916*^9}, {3.591503880484861*^9, 3.5915038812054253`*^9}, 
   3.591503922876587*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1nk4VV0XAHCkScRrvIbrXjJzB5FKtFZIRYbIEJIyRiJjyTyXEBGVORok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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[100], 0.}, {4.605170185988092, 0.}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[100], 
      Log[10000000]}, {0., 0.9873731283246716}}, {{4.605170185988092, 
    16.11809565095832}, {0., 0.9873731283246716}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{
  3.591490517577025*^9, 3.591490557777342*^9, 3.591490592007272*^9, {
   3.591490812006177*^9, 3.59149082366825*^9}, 3.5914909446796618`*^9, 
   3.591503388584621*^9, 3.591503882738284*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"u", "[", 
     RowBox[{
      RowBox[{"2", "p"}], ",", 
      RowBox[{"y", "-", 
       RowBox[{
        SubscriptBox["\[Beta]", "3"], 
        RowBox[{"c", "[", 
         RowBox[{"2", "p"}], "]"}]}]}]}], "]"}], "-", 
    RowBox[{"u", "[", 
     RowBox[{"p", ",", 
      RowBox[{"y", "-", 
       RowBox[{
        SubscriptBox["\[Beta]", "3"], 
        RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}], "/.", " ", 
   RowBox[{"p", "\[Rule]", "250"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591490890186184*^9, 3.59149092728658*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "0.029720932921743604`"}], "-", 
  RowBox[{"3.141592653589793`", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.59149089650884*^9, 3.5914909280585947`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LogLinearPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"LogisticDistribution", "[", 
        RowBox[{"0", ",", 
         RowBox[{"s", "*", "5"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", 
          RowBox[{"y", "-", 
           RowBox[{
            SubscriptBox["\[Beta]", "3"], 
            RowBox[{"c", "[", 
             RowBox[{"2", "p"}], "]"}]}]}]}], "]"}], "-", 
        RowBox[{"u", "[", 
         RowBox[{"p", ",", 
          RowBox[{"y", "-", 
           RowBox[{
            SubscriptBox["\[Beta]", "3"], 
            RowBox[{"c", "[", "p", "]"}]}]}]}], "]"}]}]}], "]"}], ",", 
     RowBox[{"CDF", "[", 
      RowBox[{
       RowBox[{"LogisticDistribution", "[", 
        RowBox[{"0", ",", 
         RowBox[{"s", "*", "5"}]}], "]"}], ",", 
       RowBox[{
        RowBox[{"u", "[", 
         RowBox[{
          RowBox[{"2", "p"}], ",", "yfb"}], "]"}], "-", 
        RowBox[{"u", "[", 
         RowBox[{"p", ",", "yfb"}], "]"}]}]}], "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "100", ",", "10000000"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.591490840417059*^9, 3.591490865880578*^9}, {
  3.591490960276781*^9, 3.5914909619096203`*^9}, {3.59150368022383*^9, 
  3.5915037498748493`*^9}, {3.591503926413595*^9, 3.5915039309032373`*^9}, {
  3.591504557981473*^9, 3.591504621961802*^9}, {3.591504757667264*^9, 
  3.5915047714627457`*^9}, {3.591505032140151*^9, 3.591505044924839*^9}, {
  3.591505340181353*^9, 3.5915053910920153`*^9}, {3.591505426735508*^9, 
  3.591505481697892*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF13k81Nv/B3BXJUUlZGk+n1mILJkRpZDOmyuhpMWWtFhbUakslV2y3GuJ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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1XlYzPsXB3ASLaLMTDPTtKq0N99RkSjncJMWkbSr62rjqrQhcmkxSETb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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesLabel->{None, None},
  AxesOrigin->NCache[{
     Log[100], 0.}, {4.605170185988092, 0.}],
  CoordinatesToolOptions:>{"DisplayFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& ), "CopiedValueFunction" -> ({
      Exp[
       Part[#, 1]], 
      Part[#, 2]}& )},
  FrameTicks->{{Automatic, Automatic}, {{{4.605170185988092, 
       FormBox["100", TraditionalForm]}, {6.907755278982137, 
       FormBox["1000", TraditionalForm]}, {9.210340371976184, 
       FormBox[
        TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {11.512925464970229`, 
       FormBox[
        TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {13.815510557964274`, 
       FormBox[
        TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {16.11809565095832, 
       FormBox[
        TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox],
         TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}, {{4.605170185988092, 
       FormBox["\"\"", TraditionalForm]}, {6.907755278982137, 
       FormBox["\"\"", TraditionalForm]}, {9.210340371976184, 
       FormBox["\"\"", TraditionalForm]}, {11.512925464970229`, 
       FormBox["\"\"", TraditionalForm]}, {13.815510557964274`, 
       FormBox["\"\"", TraditionalForm]}, {16.11809565095832, 
       FormBox["\"\"", TraditionalForm]}, {5.298317366548036, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.703782474656201, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {5.991464547107982, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.214608098422191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.396929655216146, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.551080335043404, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.684611727667927, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {6.802394763324311, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {7.600902459542082, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.006367567650246, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.294049640102028, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.517193191416238, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.699514748210191, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.85366542803745, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {8.987196820661973, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.104979856318357, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {9.903487552536127, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.308952660644293`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.596634733096073`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {10.819778284410283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.002099841204238`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.156250521031495`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.289781913656018`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {11.407564949312402`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.206072645530174`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.611537753638338`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {12.89921982609012, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.122363377404328`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.304684934198283`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.458835614025542`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.592367006650065`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {13.710150042306449`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.508657738524219`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {14.914122846632385`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.201804919084164`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.424948470398375`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.60727002719233, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.761420707019587`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {15.89495209964411, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}, {16.012735135300492`, 
       FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
        Thickness[0.001]}}}}},
  GridLines->{None, None},
  Method->{},
  PlotRange->NCache[{{
      Log[100], 
      Log[10000000]}, {0., 1.}}, {{4.605170185988092, 16.11809565095832}, {0.,
     1.}}],
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{{{4.605170185988092, 
      FormBox["100", TraditionalForm]}, {6.907755278982137, 
      FormBox["1000", TraditionalForm]}, {9.210340371976184, 
      FormBox[
       TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {11.512925464970229`, 
      FormBox[
       TemplateBox[{"10", "5"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {13.815510557964274`, 
      FormBox[
       TemplateBox[{"10", "6"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {16.11809565095832, 
      FormBox[
       TemplateBox[{"10", "7"}, "Superscript", SyntaxForm -> SuperscriptBox], 
       TraditionalForm]}, {5.298317366548036, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.703782474656201, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {5.991464547107982, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.214608098422191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.396929655216146, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.551080335043404, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.684611727667927, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {6.802394763324311, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {7.600902459542082, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.006367567650246, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.294049640102028, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.517193191416238, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.699514748210191, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.85366542803745, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {8.987196820661973, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.104979856318357, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {9.903487552536127, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.308952660644293`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.596634733096073`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {10.819778284410283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.002099841204238`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.156250521031495`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.289781913656018`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {11.407564949312402`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.206072645530174`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.611537753638338`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {12.89921982609012, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.122363377404328`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.304684934198283`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.458835614025542`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.592367006650065`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {13.710150042306449`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.508657738524219`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {14.914122846632385`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.201804919084164`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.424948470398375`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.60727002719233, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.761420707019587`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {15.89495209964411, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}, {16.012735135300492`, 
      FormBox["\"\"", TraditionalForm], {0.00375, 0.}, {
       Thickness[0.001]}}}, Automatic}]], "Output",
 CellChangeTimes->{
  3.591490868657106*^9, 3.591490963075986*^9, 3.591503399858715*^9, {
   3.5915036820918016`*^9, 3.591503751142453*^9}, 3.5915039329721212`*^9, 
   3.591504515482101*^9, {3.591504559861373*^9, 3.591504623835188*^9}, {
   3.5915047620414248`*^9, 3.59150477313083*^9}, {3.591505035638556*^9, 
   3.591505046627355*^9}, {3.591505344421101*^9, 3.59150548318563*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Maximize", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"u", "[", 
      RowBox[{"p", ",", "yfb"}], "]"}], "-", 
     RowBox[{"b", " ", 
      RowBox[{"c", "[", "p", "]"}]}]}], ",", "p"}], "]"}], "//", 
  "N"}]], "Input",
 CellChangeTimes->{{3.5915048518224287`*^9, 3.591504865837502*^9}, {
  3.5915049006402283`*^9, 3.591504912299691*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "0.0777361768650735`"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", "\[Rule]", "142158.52364054`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.591504907214457*^9, 3.5915049130813427`*^9}, 
   3.591504956035314*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"128000000", "/", "142159"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5915049673810062`*^9, 3.5915049762881727`*^9}}],

Cell[BoxData["900.4002560513228`"], "Output",
 CellChangeTimes->{{3.59150497219571*^9, 3.591504979460375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Delta]", "[", "100000", "]"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.591504089064702*^9, 3.59150414682787*^9}, 
   3.59150429047299*^9}],

Cell[BoxData["6.719771635099049`"], "Output",
 CellChangeTimes->{{3.591504092517639*^9, 3.591504147542753*^9}, 
   3.591504291063324*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"s", "//", "N"}]], "Input",
 CellChangeTimes->{{3.591503757460381*^9, 3.591503759508224*^9}}],

Cell[BoxData["0.038984840061683804`"], "Output",
 CellChangeTimes->{3.591503760164307*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"u", "[", 
  RowBox[{"p", ",", "ya"}], "]"}]], "Input",
 CellChangeTimes->{{3.591482279819757*^9, 3.591482282813026*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"27", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["2", "81"], " ", "p", " ", 
        SqrtBox[
         RowBox[{
          FractionBox["p", 
           RowBox[{"81", " ", 
            SqrtBox["2"]}]], "+", 
          FractionBox[
           RowBox[{
            SqrtBox["2"], " ", "p"}], "81"]}]]}], "+", 
       RowBox[{
        FractionBox["1", "729"], " ", 
        SuperscriptBox["2", 
         RowBox[{"3", "/", "4"}]], " ", 
        SuperscriptBox["p", 
         RowBox[{"3", "/", "2"}]], " ", 
        RowBox[{"ArcSinh", "[", 
         FractionBox["1", 
          SqrtBox["2"]], "]"}]}], "+", 
       FractionBox[
        RowBox[{
         SuperscriptBox["p", 
          RowBox[{"3", "/", "2"}]], " ", 
         RowBox[{"ArcSinh", "[", 
          SqrtBox["2"], "]"}]}], 
        RowBox[{"729", " ", 
         SuperscriptBox["2", 
          RowBox[{"3", "/", "4"}]]}]]}], ")"}]}], 
    RowBox[{"20", " ", "p"}]]}], "+", 
  RowBox[{
   FractionBox["39", "40"], " ", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"39", " ", "ya"}], "40"], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "40"], " ", 
   RowBox[{"Log", "[", 
    FractionBox["ya", 
     RowBox[{"40", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["13", "10"], "+", 
        FractionBox["13000", "p"]}], ")"}]}]], "]"}]}]}]], "Output",
 CellChangeTimes->{3.591482283613637*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.5913942392641573`*^9, 3.591394246336117*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"uEG", "[", 
   RowBox[{"10", ",", 
    RowBox[{"yfb", "*", "1.663514678108967`"}], ",", 
    RowBox[{"yfb", "*", "1.9186212148724064`"}]}], "]"}], "//", 
  "N"}]], "Input",
 CellChangeTimes->{{3.5913969554683943`*^9, 3.591396965026335*^9}, {
  3.591397005769924*^9, 3.591397062900406*^9}}],

Cell[BoxData[
 RowBox[{"-", "21.691817059907162`"}]], "Output",
 CellChangeTimes->{
  3.591396967023526*^9, {3.591397007852414*^9, 3.5913970637142982`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"c", "[", "p_", "]"}], "=."}]], "Input",
 CellChangeTimes->{{3.591349595471365*^9, 3.591349616823658*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"uExpected", "[", 
   RowBox[{"100", ",", "ya", ",", "yfb"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.591398775749984*^9, 3.5913987968310747`*^9}, {
  3.5913988322681837`*^9, 3.591398833477339*^9}, {3.591398885845065*^9, 
  3.591398890183343*^9}, {3.591398926401699*^9, 3.5913989267363043`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"17", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6099232541", " ", 
       SuperscriptBox["3", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["17", 
        RowBox[{"19", "/", "20"}]], " ", 
       SuperscriptBox["101", 
        RowBox[{"1", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", 
           SqrtBox["6"]}], "+", 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{"ArcSinh", "[", 
           SqrtBox["2"], "]"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]]}], "+", 
      RowBox[{"941845200", " ", 
       SuperscriptBox["17", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", 
           SqrtBox["3"], " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             SqrtBox["2"]}], ")"}]}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"2", "+", 
             SqrtBox["2"]}], ")"}], " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SqrtBox["2"]}], ")"}], " ", 
           RowBox[{"ArcSinh", "[", 
            SqrtBox["2"], "]"}]}]}], 
         RowBox[{"54", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]], " ", "ya"}], "+", 
      RowBox[{"2040000", " ", 
       SuperscriptBox["3", 
        RowBox[{"1", "/", "40"}]], " ", 
       SuperscriptBox["101", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", 
           SqrtBox["3"]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            SqrtBox["2"], "]"}]}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]], " ", 
       SuperscriptBox["ya", "2"]}]}], ")"}], " ", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{
       SuperscriptBox["39", 
        RowBox[{"19", "/", "20"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"784871", " ", 
          SuperscriptBox["17", 
           RowBox[{"39", "/", "40"}]], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{"4", " ", 
               SqrtBox["3"]}], "+", 
              RowBox[{"4", " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], "+", 
              RowBox[{
               SqrtBox["2"], " ", 
               RowBox[{"ArcSinh", "[", 
                SqrtBox["2"], "]"}]}]}], 
             RowBox[{"54", " ", 
              SuperscriptBox["2", 
               RowBox[{"3", "/", "4"}]]}]]}]]}], "+", 
         RowBox[{"3400", " ", 
          SuperscriptBox["3", 
           RowBox[{"1", "/", "40"}]], " ", 
          SuperscriptBox["101", 
           RowBox[{"39", "/", "40"}]], " ", 
          SuperscriptBox["\[ExponentialE]", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{
              RowBox[{"2", " ", 
               SqrtBox["6"]}], "+", 
              RowBox[{"2", " ", 
               SqrtBox["2"], " ", 
               RowBox[{"ArcSinh", "[", 
                FractionBox["1", 
                 SqrtBox["2"]], "]"}]}], "+", 
              RowBox[{"ArcSinh", "[", 
               SqrtBox["2"], "]"}]}], 
             RowBox[{"54", " ", 
              SuperscriptBox["2", 
               RowBox[{"3", "/", "4"}]]}]]}]], " ", "ya"}]}], ")"}]}], 
      RowBox[{"1373600", " ", 
       SuperscriptBox["10", 
        RowBox[{"39", "/", "40"}]]}]], "]"}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"7771", " ", 
       SuperscriptBox["51", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["101", 
        RowBox[{"1", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", 
           SqrtBox["6"]}], "+", 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{"ArcSinh", "[", 
           SqrtBox["2"], "]"}]}], 
         RowBox[{"54", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]]}], "+", 
      RowBox[{"10200", " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", 
           SqrtBox["3"]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            SqrtBox["2"], "]"}]}]}], 
         RowBox[{"54", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]], " ", "ya"}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"784871", " ", 
       SuperscriptBox["17", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", 
           SqrtBox["6"]}], "+", 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{"ArcSinh", "[", 
           SqrtBox["2"], "]"}]}], 
         RowBox[{"54", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]]}], "+", 
      RowBox[{"3400", " ", 
       SuperscriptBox["3", 
        RowBox[{"1", "/", "40"}]], " ", 
       SuperscriptBox["101", 
        RowBox[{"39", "/", "40"}]], " ", 
       SuperscriptBox["\[ExponentialE]", 
        FractionBox[
         RowBox[{
          RowBox[{"4", " ", 
           SqrtBox["3"]}], "+", 
          RowBox[{"4", " ", 
           RowBox[{"ArcSinh", "[", 
            FractionBox["1", 
             SqrtBox["2"]], "]"}]}], "+", 
          RowBox[{
           SqrtBox["2"], " ", 
           RowBox[{"ArcSinh", "[", 
            SqrtBox["2"], "]"}]}]}], 
         RowBox[{"54", " ", 
          SuperscriptBox["2", 
           RowBox[{"3", "/", "4"}]]}]]], " ", "ya"}]}], ")"}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.591398781233472*^9, 3.591398798297997*^9}, 
   3.591398835957027*^9, 3.5913988911200943`*^9, 3.591398927709105*^9}],

Cell[BoxData[
 RowBox[{"Root", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "16"}], "+", 
     RowBox[{"14", " ", "#1"}], "-", 
     RowBox[{"6", " ", 
      SuperscriptBox["#1", "2"]}], "+", 
     SuperscriptBox["#1", "3"], "+", 
     RowBox[{"10", " ", 
      SuperscriptBox["#1", "4"]}], "-", 
     RowBox[{"10", " ", 
      SuperscriptBox["#1", "5"]}], "+", 
     RowBox[{"46", " ", 
      SuperscriptBox["#1", "6"]}], "+", 
     RowBox[{"24", " ", 
      SuperscriptBox["#1", "7"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["#1", "8"]}], "+", 
     RowBox[{"29", " ", 
      SuperscriptBox["#1", "9"]}], "-", 
     RowBox[{"21", " ", 
      SuperscriptBox["#1", "10"]}], "+", 
     RowBox[{"69", " ", 
      SuperscriptBox["#1", "11"]}], "-", 
     RowBox[{"115", " ", 
      SuperscriptBox["#1", "12"]}], "+", 
     RowBox[{"54", " ", 
      SuperscriptBox["#1", "13"]}], "+", 
     RowBox[{"33", " ", 
      SuperscriptBox["#1", "14"]}], "-", 
     RowBox[{"76", " ", 
      SuperscriptBox["#1", "15"]}], "+", 
     RowBox[{"49", " ", 
      SuperscriptBox["#1", "16"]}], "-", 
     RowBox[{"20", " ", 
      SuperscriptBox["#1", "17"]}], "-", 
     RowBox[{"82", " ", 
      SuperscriptBox["#1", "18"]}], "-", 
     RowBox[{"65", " ", 
      SuperscriptBox["#1", "19"]}], "+", 
     RowBox[{"99", " ", 
      SuperscriptBox["#1", "20"]}], "-", 
     RowBox[{"34", " ", 
      SuperscriptBox["#1", "21"]}], "-", 
     RowBox[{"163", " ", 
      SuperscriptBox["#1", "22"]}], "-", 
     RowBox[{"39", " ", 
      SuperscriptBox["#1", "23"]}], "-", 
     RowBox[{"10", " ", 
      SuperscriptBox["#1", "24"]}], "-", 
     RowBox[{"50", " ", 
      SuperscriptBox["#1", "25"]}], "-", 
     RowBox[{"13", " ", 
      SuperscriptBox["#1", "26"]}], "-", 
     RowBox[{"13", " ", 
      SuperscriptBox["#1", "27"]}], "+", 
     RowBox[{"110", " ", 
      SuperscriptBox["#1", "28"]}], "+", 
     RowBox[{"91", " ", 
      SuperscriptBox["#1", "29"]}], "+", 
     RowBox[{"66", " ", 
      SuperscriptBox["#1", "30"]}], "-", 
     RowBox[{"11", " ", 
      SuperscriptBox["#1", "31"]}], "+", 
     RowBox[{"21", " ", 
      SuperscriptBox["#1", "32"]}], "+", 
     RowBox[{"52", " ", 
      SuperscriptBox["#1", "33"]}], "+", 
     RowBox[{"32", " ", 
      SuperscriptBox["#1", "34"]}], "-", 
     RowBox[{"68", " ", 
      SuperscriptBox["#1", "35"]}], "+", 
     RowBox[{"57", " ", 
      SuperscriptBox["#1", "36"]}], "+", 
     RowBox[{"32", " ", 
      SuperscriptBox["#1", "37"]}], "-", 
     RowBox[{"52", " ", 
      SuperscriptBox["#1", "38"]}], "-", 
     RowBox[{"203", " ", 
      SuperscriptBox["#1", "39"]}], "-", 
     RowBox[{"28", " ", 
      SuperscriptBox["#1", "40"]}], "+", 
     RowBox[{"29", " ", 
      SuperscriptBox["#1", "41"]}], "-", 
     RowBox[{"40", " ", 
      SuperscriptBox["#1", "42"]}], "-", 
     RowBox[{"41", " ", 
      SuperscriptBox["#1", "43"]}], "-", 
     RowBox[{"15", " ", 
      SuperscriptBox["#1", "44"]}], "+", 
     SuperscriptBox["#1", "45"], "-", 
     RowBox[{"29", " ", 
      SuperscriptBox["#1", "46"]}], "+", 
     RowBox[{"7", " ", 
      SuperscriptBox["#1", "47"]}], "+", 
     RowBox[{"73", " ", 
      SuperscriptBox["#1", "48"]}], "+", 
     RowBox[{"19", " ", 
      SuperscriptBox["#1", "49"]}]}], "&"}], ",", "4"}], "]"}]], "Output",
 CellChangeTimes->{3.592687107538484*^9}]
}, Open  ]]
},
Evaluator->"Bulldogk",
WindowSize->{1005, 847},
WindowMargins->{{10, Automatic}, {Automatic, 58}},
ShowSelection->True,
FrontEndVersion->"9.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (January 25, \
2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 333, 5, 28, "Input"],
Cell[CellGroupData[{
Cell[915, 29, 111, 2, 28, "Input"],
Cell[1029, 33, 1887, 51, 75, "Print"]
}, Open  ]],
Cell[2931, 87, 2582, 75, 113, "Input"],
Cell[CellGroupData[{
Cell[5538, 166, 387, 11, 46, "Input"],
Cell[5928, 179, 1420, 36, 50, "Output"],
Cell[7351, 217, 819, 16, 50, "Output"]
}, Open  ]],
Cell[8185, 236, 344, 10, 28, "Input"],
Cell[CellGroupData[{
Cell[8554, 250, 239, 8, 28, "Input"],
Cell[8796, 260, 796, 16, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9629, 281, 206, 7, 51, "Input"],
Cell[9838, 290, 766, 15, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10641, 310, 909, 21, 63, "Input"],
Cell[11553, 333, 1172, 22, 47, "Output"],
Cell[12728, 357, 1014, 17, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13779, 379, 297, 8, 46, "Input"],
Cell[14079, 389, 1628, 44, 59, "Output"],
Cell[15710, 435, 1885, 53, 59, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17632, 493, 1271, 38, 80, "Input"],
Cell[18906, 533, 2643, 70, 71, "Output"],
Cell[21552, 605, 2611, 72, 91, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24200, 682, 281, 8, 28, "Input"],
Cell[24484, 692, 316, 8, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24837, 705, 313, 9, 28, "Input"],
Cell[25153, 716, 355, 10, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25545, 731, 281, 7, 28, "Input"],
Cell[25829, 740, 199, 5, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26065, 750, 547, 14, 28, "Input"],
Cell[26615, 766, 318, 8, 45, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26970, 779, 653, 19, 46, "Input"],
Cell[27626, 800, 92, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27755, 806, 334, 10, 28, "Input"],
Cell[28092, 818, 3332, 95, 87, "Output"]
}, Open  ]],
Cell[31439, 916, 474, 13, 28, "Input"],
Cell[CellGroupData[{
Cell[31938, 933, 323, 8, 51, "Input"],
Cell[32264, 943, 2105, 63, 73, "Output"]
}, Open  ]],
Cell[34384, 1009, 850, 28, 57, "Input"],
Cell[35237, 1039, 2012, 61, 75, "Input"],
Cell[CellGroupData[{
Cell[37274, 1104, 247, 6, 45, "Input"],
Cell[37524, 1112, 166, 4, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[37727, 1121, 387, 11, 51, "Input"],
Cell[38117, 1134, 150, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38304, 1141, 294, 8, 50, "Input"],
Cell[38601, 1151, 148, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38786, 1160, 1011, 30, 35, "Input"],
Cell[39800, 1192, 2624, 78, 65, "Output"]
}, Open  ]],
Cell[42439, 1273, 631, 20, 35, "Input"],
Cell[43073, 1295, 1090, 35, 51, "Input"],
Cell[CellGroupData[{
Cell[44188, 1334, 917, 29, 35, "Input"],
Cell[45108, 1365, 2430, 74, 65, "Output"]
}, Open  ]],
Cell[47553, 1442, 5106, 153, 111, "Input"],
Cell[52662, 1597, 707, 22, 51, "Input"],
Cell[53372, 1621, 677, 21, 51, "Input"],
Cell[CellGroupData[{
Cell[54074, 1646, 1415, 41, 51, "Input"],
Cell[55492, 1689, 11357, 303, 307, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66886, 1997, 515, 13, 28, "Input"],
Cell[67404, 2012, 1115, 39, 95, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68556, 2056, 450, 12, 28, "Input"],
Cell[69009, 2070, 1724, 46, 90, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70770, 2121, 597, 14, 28, "Input"],
Cell[71370, 2137, 3453, 98, 89, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74860, 2240, 291, 8, 52, "Input"],
Cell[75154, 2250, 197, 5, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75388, 2260, 417, 13, 57, "Input"],
Cell[75808, 2275, 352, 11, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76197, 2291, 122, 2, 28, "Input"],
Cell[76322, 2295, 281, 8, 56, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76640, 2308, 894, 27, 63, "Input"],
Cell[77537, 2337, 16812, 460, 509, "Output"]
}, Open  ]],
Cell[94364, 2800, 238, 5, 28, "Input"],
Cell[94605, 2807, 3280, 93, 81, "Input"],
Cell[97888, 2902, 1823, 58, 57, "Input"],
Cell[99714, 2962, 647, 19, 28, "Input"],
Cell[100364, 2983, 980, 29, 63, "Input"],
Cell[CellGroupData[{
Cell[101369, 3016, 553, 16, 28, "Input"],
Cell[101925, 3034, 5757, 175, 290, "Output"]
}, Open  ]],
Cell[107697, 3212, 3814, 112, 128, "Input"],
Cell[111514, 3326, 2748, 84, 127, "Input"],
Cell[114265, 3412, 2907, 90, 122, "Input"],
Cell[CellGroupData[{
Cell[117197, 3506, 305, 8, 28, "Input"],
Cell[117505, 3516, 4304, 137, 163, "Output"]
}, Open  ]],
Cell[121824, 3656, 3253, 103, 95, "Input"],
Cell[125080, 3761, 2349, 74, 82, "Input"],
Cell[CellGroupData[{
Cell[127454, 3839, 261, 7, 28, "Input"],
Cell[127718, 3848, 4353, 140, 163, "Output"]
}, Open  ]],
Cell[132086, 3991, 3364, 107, 95, "Input"],
Cell[CellGroupData[{
Cell[135475, 4102, 163, 3, 28, "Input"],
Cell[135641, 4107, 157, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[135835, 4115, 95, 1, 28, "Input"],
Cell[135933, 4118, 70, 1, 28, "Output"]
}, Open  ]],
Cell[136018, 4122, 902, 32, 108, "Input"],
Cell[136923, 4156, 289, 7, 50, "Input"],
Cell[CellGroupData[{
Cell[137237, 4167, 711, 20, 46, "Input"],
Cell[137951, 4189, 455, 7, 48, "Output"],
Cell[138409, 4198, 449, 7, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[138895, 4210, 1015, 26, 46, "Input"],
Cell[139913, 4238, 22343, 415, 255, "Output"]
}, Open  ]],
Cell[162271, 4656, 92, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[162388, 4661, 282, 5, 28, "Input"],
Cell[162673, 4668, 428, 8, 24, "Message"],
Cell[163104, 4678, 450, 9, 24, "Message"],
Cell[163557, 4689, 123, 2, 28, "Output"]
}, Open  ]],
Cell[163695, 4694, 94, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[163814, 4699, 537, 12, 70, "Input"],
Cell[164354, 4713, 497, 8, 48, "Output"],
Cell[164854, 4723, 472, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165363, 4735, 121, 2, 28, "Input"],
Cell[165487, 4739, 239, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[165763, 4747, 1174, 27, 97, "Input"],
Cell[166940, 4776, 607, 9, 48, "Output"],
Cell[167550, 4787, 606, 9, 48, "Output"],
Cell[168159, 4798, 625, 10, 48, "Output"],
Cell[168787, 4810, 587, 8, 28, "Output"],
Cell[169377, 4820, 585, 8, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169999, 4833, 519, 10, 28, "Input"],
Cell[170521, 4845, 514, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171072, 4857, 120, 2, 28, "Input"],
Cell[171195, 4861, 93, 1, 28, "Output"]
}, Open  ]],
Cell[171303, 4865, 709, 13, 54, "Input"],
Cell[CellGroupData[{
Cell[172037, 4882, 133, 4, 40, "Input"],
Cell[172173, 4888, 751, 13, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172961, 4906, 245, 6, 34, "Input"],
Cell[173209, 4914, 94, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173340, 4920, 373, 8, 34, "Input"],
Cell[173716, 4930, 289, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[174042, 4940, 116, 2, 28, "Input"],
Cell[174161, 4944, 253, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[174451, 4952, 490, 12, 28, "Input"],
Cell[174944, 4966, 307, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[175288, 4975, 677, 17, 28, "Input"],
Cell[175968, 4994, 5893, 154, 397, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[181898, 5153, 261, 5, 28, "Input"],
Cell[182162, 5160, 4942, 141, 621, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[187141, 5306, 2664, 74, 571, "Input"],
Cell[189808, 5382, 332, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190177, 5393, 2673, 75, 223, "Input"],
Cell[192853, 5470, 168, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[193058, 5478, 2584, 74, 223, "Input"],
Cell[195645, 5554, 89, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[195771, 5560, 1452, 42, 110, "Input"],
Cell[197226, 5604, 163, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[197426, 5611, 124, 2, 28, "Input"],
Cell[197553, 5615, 111, 1, 28, "Output"]
}, Open  ]],
Cell[197679, 5619, 92, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[197796, 5624, 173, 4, 28, "Input"],
Cell[197972, 5630, 131, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198140, 5637, 174, 4, 28, "Input"],
Cell[198317, 5643, 105, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[198459, 5650, 768, 17, 28, "Input"],
Cell[199230, 5669, 642, 14, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[199909, 5688, 502, 13, 28, "Input"],
Cell[200414, 5703, 776, 14, 65, "Message"],
Cell[201193, 5719, 318, 8, 28, "Output"]
}, Open  ]],
Cell[201526, 5730, 2313, 59, 80, "Input"],
Cell[203842, 5791, 2623, 69, 131, "Input"],
Cell[206468, 5862, 1881, 51, 97, "Input"],
Cell[208352, 5915, 3222, 87, 165, "Input"],
Cell[211577, 6004, 782, 24, 28, "Input"],
Cell[212362, 6030, 2572, 75, 148, "Input"],
Cell[CellGroupData[{
Cell[214959, 6109, 129, 2, 28, "Input"],
Cell[215091, 6113, 182, 3, 28, "Output"]
}, Open  ]],
Cell[215288, 6119, 607, 18, 51, "Input"],
Cell[CellGroupData[{
Cell[215920, 6141, 127, 2, 28, "Input"],
Cell[216050, 6145, 238, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216325, 6153, 256, 4, 28, "Input"],
Cell[216584, 6159, 277, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[216898, 6168, 457, 9, 28, "Input"],
Cell[217358, 6179, 2156, 38, 208, "Message"],
Cell[219517, 6219, 618, 13, 24, "Message"],
Cell[220138, 6234, 2151, 35, 153, "Message"],
Cell[222292, 6271, 620, 13, 24, "Message"],
Cell[222915, 6286, 618, 13, 24, "Message"],
Cell[223536, 6301, 610, 13, 24, "Message"],
Cell[224149, 6316, 2154, 38, 208, "Message"],
Cell[226306, 6356, 611, 13, 24, "Message"],
Cell[226920, 6371, 1655, 28, 157, "Message"],
Cell[228578, 6401, 14272, 283, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[242887, 6689, 123, 2, 28, "Input"],
Cell[243013, 6693, 96, 2, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[243146, 6700, 579, 14, 28, "Input"],
Cell[243728, 6716, 497, 12, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[244262, 6733, 295, 7, 28, "Input"],
Cell[244560, 6742, 26407, 721, 871, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[271004, 7468, 357, 6, 28, "Input"],
Cell[271364, 7476, 2447, 64, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[273848, 7545, 128, 2, 28, "Input"],
Cell[273979, 7549, 290, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[274306, 7558, 600, 9, 28, "Input"],
Cell[274909, 7569, 706, 10, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[275652, 7584, 631, 15, 46, "Input"],
Cell[276286, 7601, 564, 17, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[276887, 7623, 418, 10, 28, "Input"],
Cell[277308, 7635, 155, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[277500, 7643, 1275, 41, 57, "Input"],
Cell[278778, 7686, 90, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[278905, 7692, 622, 17, 57, "Input"],
Cell[279530, 7711, 186, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[279753, 7718, 144, 2, 28, "Input"],
Cell[279900, 7722, 413, 9, 24, "Message"],
Cell[280316, 7733, 412, 9, 24, "Message"],
Cell[280731, 7744, 414, 9, 24, "Message"],
Cell[281148, 7755, 530, 11, 24, "Message"],
Cell[281681, 7768, 576, 11, 24, "Message"],
Cell[282260, 7781, 543, 11, 24, "Message"],
Cell[282806, 7794, 227, 5, 28, "Output"]
}, Open  ]],
Cell[283048, 7802, 270, 4, 28, "Input"],
Cell[CellGroupData[{
Cell[283343, 7810, 397, 8, 28, "Input"],
Cell[283743, 7820, 21868, 397, 244, "Output"]
}, Open  ]],
Cell[305626, 8220, 166, 2, 28, "Input"],
Cell[CellGroupData[{
Cell[305817, 8226, 198, 4, 28, "Input"],
Cell[306018, 8232, 121, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[306176, 8239, 198, 4, 28, "Input"],
Cell[306377, 8245, 120, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[306534, 8252, 326, 8, 48, "Input"],
Cell[306863, 8262, 175, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307075, 8270, 287, 9, 28, "Input"],
Cell[307365, 8281, 140, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307542, 8288, 680, 19, 28, "Input"],
Cell[308225, 8309, 254, 3, 28, "Output"]
}, Open  ]],
Cell[308494, 8315, 526, 17, 28, "Input"],
Cell[CellGroupData[{
Cell[309045, 8336, 125, 2, 28, "Input"],
Cell[309173, 8340, 117, 2, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309327, 8347, 145, 3, 28, "Input"],
Cell[309475, 8352, 98, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309610, 8358, 179, 4, 28, "Input"],
Cell[309792, 8364, 113, 2, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309942, 8371, 215, 4, 28, "Input"],
Cell[310160, 8377, 163, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310360, 8384, 174, 3, 28, "Input"],
Cell[310537, 8389, 98, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310672, 8395, 673, 19, 46, "Input"],
Cell[311348, 8416, 28796, 520, 251, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[340181, 8941, 1120, 25, 46, "Input"],
Cell[341304, 8968, 27221, 494, 251, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[368562, 9467, 374, 9, 28, "Input"],
Cell[368939, 9478, 10397, 179, 244, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[379373, 9662, 147, 3, 28, "Input"],
Cell[379523, 9667, 114, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[379674, 9673, 921, 17, 28, "Input"],
Cell[380598, 9692, 1209, 21, 124, "Message"],
Cell[381810, 9715, 10450, 178, 236, "Output"]
}, Open  ]],
Cell[392275, 9896, 492, 12, 28, "Input"],
Cell[CellGroupData[{
Cell[392792, 9912, 124, 2, 28, "Input"],
Cell[392919, 9916, 1583, 45, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[394539, 9966, 312, 8, 28, "Input"],
Cell[394854, 9976, 1323, 29, 246, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[396214, 10010, 617, 16, 46, "Input"],
Cell[396834, 10028, 23153, 428, 251, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[420024, 10461, 986, 24, 46, "Input"],
Cell[421013, 10487, 22118, 411, 255, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[443168, 10903, 476, 11, 28, "Input"],
Cell[443647, 10916, 6819, 121, 250, "Output"]
}, Open  ]],
Cell[450481, 11040, 1206, 35, 71, "Input"],
Cell[451690, 11077, 812, 24, 51, "Input"],
Cell[CellGroupData[{
Cell[452527, 11105, 183, 3, 28, "Input"],
Cell[452713, 11110, 225, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[452975, 11118, 492, 11, 28, "Input"],
Cell[453470, 11131, 268, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[453775, 11140, 474, 10, 28, "Input"],
Cell[454252, 11152, 353, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[454642, 11163, 507, 15, 51, "Input"],
Cell[455152, 11180, 130, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[455319, 11187, 320, 8, 51, "Input"],
Cell[455642, 11197, 1954, 63, 59, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[457633, 11265, 237, 5, 28, "Input"],
Cell[457873, 11272, 130, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[458040, 11279, 489, 12, 51, "Input"],
Cell[458532, 11293, 151, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[458720, 11300, 335, 9, 28, "Input"],
Cell[459058, 11311, 167, 2, 28, "Output"]
}, Open  ]],
Cell[459240, 11316, 782, 24, 51, "Input"],
Cell[CellGroupData[{
Cell[460047, 11344, 352, 8, 28, "Input"],
Cell[460402, 11354, 204, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[460643, 11362, 82, 2, 28, "Input"],
Cell[460728, 11366, 131, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[460896, 11373, 127, 2, 28, "Input"],
Cell[461026, 11377, 228, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[461291, 11386, 321, 8, 28, "Input"],
Cell[461615, 11396, 77, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[461729, 11402, 241, 5, 28, "Input"],
Cell[461973, 11409, 186, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[462196, 11417, 340, 9, 28, "Input"],
Cell[462539, 11428, 138, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[462714, 11435, 378, 9, 28, "Input"],
Cell[463095, 11446, 77, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[463209, 11452, 257, 6, 28, "Input"],
Cell[463469, 11460, 77, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[463583, 11466, 408, 11, 28, "Input"],
Cell[463994, 11479, 8911, 154, 247, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[472942, 11638, 97, 1, 28, "Input"],
Cell[473042, 11641, 70, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[473149, 11647, 130, 2, 28, "Input"],
Cell[473282, 11651, 112, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[473431, 11657, 123, 2, 28, "Input"],
Cell[473557, 11661, 88, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[473682, 11667, 226, 5, 28, "Input"],
Cell[473911, 11674, 110, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[474058, 11680, 268, 7, 28, "Input"],
Cell[474329, 11689, 88, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[474454, 11695, 202, 5, 28, "Input"],
Cell[474659, 11702, 88, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[474784, 11708, 261, 7, 28, "Input"],
Cell[475048, 11717, 232, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[475317, 11726, 230, 6, 28, "Input"],
Cell[475550, 11734, 112, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[475699, 11740, 354, 10, 28, "Input"],
Cell[476056, 11752, 88, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[476181, 11758, 527, 15, 28, "Input"],
Cell[476711, 11775, 93, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[476841, 11781, 466, 13, 28, "Input"],
Cell[477310, 11796, 226, 4, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[477573, 11805, 770, 16, 28, "Input"],
Cell[478346, 11823, 1165, 20, 124, "Message"],
Cell[479514, 11845, 648, 12, 24, "Message"],
Cell[480165, 11859, 1167, 20, 124, "Message"],
Cell[481335, 11881, 650, 12, 24, "Message"],
Cell[481988, 11895, 793, 14, 24, "Message"],
Cell[482784, 11911, 9350, 160, 247, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[492171, 12076, 147, 3, 28, "Input"],
Cell[492321, 12081, 112, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[492470, 12087, 129, 2, 28, "Input"],
Cell[492602, 12091, 170, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[492809, 12099, 439, 12, 28, "Input"],
Cell[493251, 12113, 25656, 476, 245, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[518944, 12594, 173, 3, 28, "Input"],
Cell[519120, 12599, 120, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[519277, 12606, 69, 1, 28, "Input"],
Cell[519349, 12609, 113, 2, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[519499, 12616, 799, 19, 28, "Input"],
Cell[520301, 12637, 22864, 425, 243, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[543202, 13067, 642, 20, 28, "Input"],
Cell[543847, 13089, 19129, 362, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[563013, 13456, 1140, 32, 28, "Input"],
Cell[564156, 13490, 15249, 295, 243, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[579442, 13790, 1239, 38, 46, "Input"],
Cell[580684, 13830, 8834, 157, 242, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[589555, 13992, 1912, 54, 46, "Input"],
Cell[591470, 14048, 663, 13, 24, "Message"],
Cell[592136, 14063, 665, 13, 24, "Message"],
Cell[592804, 14078, 663, 13, 24, "Message"],
Cell[593470, 14093, 655, 13, 24, "Message"],
Cell[594128, 14108, 1967, 31, 137, "Message"],
Cell[596098, 14141, 9631, 170, 241, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[605766, 14316, 395, 11, 28, "Input"],
Cell[606164, 14329, 157, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[606358, 14337, 418, 9, 28, "Input"],
Cell[606779, 14348, 23103, 427, 249, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[629919, 14780, 595, 19, 28, "Input"],
Cell[630517, 14801, 207, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[630761, 14810, 1674, 44, 46, "Input"],
Cell[632438, 14856, 25775, 472, 246, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[658250, 15333, 374, 11, 28, "Input"],
Cell[658627, 15346, 274, 7, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[658938, 15358, 156, 3, 28, "Input"],
Cell[659097, 15363, 110, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[659244, 15369, 180, 4, 28, "Input"],
Cell[659427, 15375, 137, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[659601, 15382, 116, 2, 28, "Input"],
Cell[659720, 15386, 90, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[659847, 15392, 144, 3, 28, "Input"],
Cell[659994, 15397, 1468, 50, 89, "Output"]
}, Open  ]],
Cell[661477, 15450, 94, 1, 28, "Input"],
Cell[CellGroupData[{
Cell[661596, 15455, 324, 8, 28, "Input"],
Cell[661923, 15465, 156, 3, 28, "Output"]
}, Open  ]],
Cell[662094, 15471, 140, 3, 28, "Input"],
Cell[CellGroupData[{
Cell[662259, 15478, 352, 6, 28, "Input"],
Cell[662614, 15486, 7007, 212, 553, "Output"],
Cell[669624, 15700, 3370, 101, 94, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
