hosei.years <- c("S43", "S47", "H3", "H4", "H9", "H13", "H14", "H15", "H16", "H17", "H18", "H19", "H20")
hosei <- vector(mode="list", length=length(hosei.years))
names(hosei) <- hosei.years

### Firefighting

hosei[["S43"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  1.00
     + max(0,  -150000 + min(P,  250000)) *  0.91
     + max(0,  -250000 + min(P,  400000)) *  0.88
     + max(0,  -400000 +     P          ) *  0.76)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.26
     + max(0,   -40000 + min(M, 60000))   *  0.28
     + max(0,   -60000 + min(M, 80000))   * -0.07
     + max(0,   -80000 + min(M, 84000))   * -0.43
     + max(0,   -84000 + min(M, 88000))   * -0.37
     + max(0,   -88000 + min(M, 92000))   * -0.35
     + max(0,   -92000 +     M        )   * -0.65)
} / P

hosei[["S47"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0, -100000 +     P          )  *  0.86)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.16
     + max(0,   -70000 + min(M, 80000))   * -0.24
     + max(0,   -80000 + min(M, 88000))   * -0.23
     + max(0,   -88000 + min(M, 96000))   * -0.23
     + max(0,   -96000 +     M        )   * -1.25)
} / P

hosei[["H3"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.76
     + max(0,  -250000 + min(P,  400000)) *  0.76
     + max(0,  -400000 + min(P, 1000000)) *  0.77
     + max(0, -1000000 + min(P, 2000000)) *  0.76
     + max(0, -2000000 +     P          ) *  0.76)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.16
     + max(0,   -70000 + min(M, 80000))   * -0.18
     + max(0,   -80000 + min(M, 88000))   * -0.23
     + max(0,   -88000 + min(M, 96000))   * -0.25
     + max(0,   -96000 +     M        )   * -1.31)
} / P

## f.h4$firefighting.pop.oldstyle <- function(P) {
##   if(is.na(P)) total <- NA
##   else if(P > 100000) total <- 
##     sum(                          100000   *  1.00,
##         max(0,  -100000 + min(P,  250000)) *  0.76,
##         max(0,  -250000 + min(P,  400000)) *  0.76,
##         max(0,  -400000 + min(P, 1000000)) *  0.77,
##         max(0, -1000000 + min(P, 2000000)) *  0.76,
##         max(0, -2000000 +     P          ) *  0.77)
##   else total <-
##     sum(   P                               *  1.00,
##         min(M <- 100000 - P,     70000)    *  0.16,
##         max(0,   -70000 + min(M, 80000))   * -0.18,
##         max(0,   -80000 + min(M, 88000))   * -0.23,
##         max(0,   -88000 + min(M, 92000))   * -0.25,
##         max(0,   -92000 + min(M, 96000))   * -0.24,
##         max(0,   -96000 +     M        )   * -1.32)
##   return(total / P)
## }

hosei[["H4"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (2.32 * P +   320)
  else if(P <    8000)  1/P * (1.24 * P +  4640)
  else if(P <   12000)  1/P * (1.25 * P +  4560)
  else if(P <   20000)  1/P * (1.23 * P +  4800)
  else if(P <   30000)  1/P * (1.18 * P +  5800)
  else if(P <  100000)  1/P * (0.84 * P + 16000)
  else if(P <  250000)  1/P * (0.76 * P + 24000)
  else if(P <  400000)  1/P * (0.76 * P + 24000)
  else if(P < 1000000)  1/P * (0.77 * P + 20000)
  else if(P < 2000000)  1/P * (0.76 * P + 30000)
  else                  1/P * (0.77 * P + 10000)
}

hosei[["H9"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <       1)  1/1 * (2.22 * 1 +   340) #added to make the graph look pretty
  else if(P <    4000)  1/P * (2.22 * P +   340)
  else if(P <    8000)  1/P * (1.23 * P +  4300)
  else if(P <   12000)  1/P * (1.28 * P +  3900)
  else if(P <   20000)  1/P * (1.18 * P +  5100)
  else if(P <   30000)  1/P * (1.11 * P +  6500)
  else if(P <  100000)  1/P * (0.86 * P + 14000)
  else if(P <  250000)  1/P * (0.75 * P + 25000)
  else if(P <  400000)  1/P * (0.76 * P + 22500)
  else if(P < 1000000)  1/P * (0.76 * P + 22500)
  else if(P < 2000000)  1/P * (0.76 * P + 22500)
  else                  1/P * (0.76 * P + 22500)
}

## f.h9$firefighting.pop.log <- Vectorize(function(P) {
##   if(is.na(P)) NA
##   else if(P <       1)  log(1/1 * (2.22 * 1 +   340)) #added to make the graph look pretty
##   else if(P <    4000)  log(1/P * (2.22 * P +   340))
##   else if(P <    8000)  log(1/P * (1.23 * P +  4300))
##   else if(P <   12000)  log(1/P * (1.28 * P +  3900))
##   else if(P <   20000)  log(1/P * (1.18 * P +  5100))
##   else if(P <   30000)  log(1/P * (1.11 * P +  6500))
##   else if(P <  100000)  log(1/P * (0.86 * P + 14000))
##   else if(P <  250000)  log(1/P * (0.75 * P + 25000))
##   else if(P <  400000)  log(1/P * (0.76 * P + 22500))
##   else if(P < 1000000)  log(1/P * (0.76 * P + 22500))
##   else if(P < 2000000)  log(1/P * (0.76 * P + 22500))
##   else                  log(1/P * (0.76 * P + 22500))
## })


#reg <- nls(log(f.h9$firefighting.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .85 * P + 7520
#coef(reg)[2] / coef(reg)[1]  # 8809

hosei[["H13"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.20 * P +  4100)
           else if(P <   12000)  1/P * (1.21 * P +  4020)
           else if(P <   20000)  1/P * (1.12 * P +  5100)
           else if(P <   30000)  1/P * (1.09 * P +  5700)
           else if(P <  100000)  1/P * (0.88 * P + 12000)
           else if(P <  250000)  1/P * (0.75 * P + 25000)
           else if(P <  400000)  1/P * (0.76 * P + 22500)
           else if(P < 1000000)  1/P * (0.76 * P + 22500)
           else if(P < 2000000)  1/P * (0.76 * P + 22500)
           else                  1/P * (0.76 * P + 22500)
           , 2.24)
}

hosei[["H14"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.21 * P +  3720)
           else if(P <   12000)  1/P * (1.23 * P +  3560)
           else if(P <   20000)  1/P * (1.11 * P +  5000)
           else if(P <   30000)  1/P * (1.12 * P +  4800)
           else if(P <  100000)  1/P * (0.88 * P + 12000)
           else if(P <  250000)  1/P * (0.75 * P + 25000)
           else if(P <  400000)  1/P * (0.76 * P + 22500)
           else if(P < 1000000)  1/P * (0.76 * P + 22500)
           else if(P < 2000000)  1/P * (0.76 * P + 22500)
           else                  1/P * (0.76 * P + 22500)
           , 2.14)
}

hosei[["H15"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.22 * P +  3360)
           else if(P <   12000)  1/P * (1.24 * P +  3200)
           else if(P <   20000)  1/P * (1.09 * P +  5000)
           else if(P <   30000)  1/P * (1.09 * P +  5000)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.74 * P + 26000)
           else if(P <  400000)  1/P * (0.76 * P + 21000)
           else if(P < 1000000)  1/P * (0.75 * P + 25000)
           else if(P < 2000000)  1/P * (0.76 * P + 15000)
           else                  1/P * (0.76 * P + 15000)
           , 2.09)
}

hosei[["H16"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.22 * P +  3020)
           else if(P <   12000)  1/P * (1.29 * P +  2460)
           else if(P <   20000)  1/P * (1.07 * P +  5100)
           else if(P <   30000)  1/P * (1.12 * P +  4100)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.73 * P + 27000)
           else if(P <  400000)  1/P * (0.76 * P + 19500)
           else if(P < 1000000)  1/P * (0.75 * P + 23500)
           else if(P < 2000000)  1/P * (0.75 * P + 23500)
           else                  1/P * (0.76 * P +  3500)
           , 1.975)
}

hosei[["H17"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.23 * P +  2920)
           else if(P <   12000)  1/P * (1.27 * P +  2600)
           else if(P <   20000)  1/P * (1.07 * P +  5000)
           else if(P <   30000)  1/P * (1.13 * P +  3800)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.73 * P + 27000)
           else if(P <  400000)  1/P * (0.75 * P + 22000)
           else if(P < 1000000)  1/P * (0.75 * P + 22000)
           else if(P < 2000000)  1/P * (0.75 * P + 22000)
           else                  1/P * (0.76 * P +  2000)
           , 1.960)
}

hosei[["H18"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.22 * P +  2940)
           else if(P <   12000)  1/P * (1.26 * P +  2620)
           else if(P <   20000)  1/P * (1.07 * P +  4900)
           else if(P <   30000)  1/P * (1.14 * P +  3500)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.73 * P + 27000)
           else if(P <  400000)  1/P * (0.76 * P + 19500)
           else if(P < 1000000)  1/P * (0.75 * P + 23500)
           else if(P < 2000000)  1/P * (0.75 * P + 23500)
           else                  1/P * (0.76 * P +  3500)
           , 1.955)
}

hosei[["H19"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.23 * P +  2820)
           else if(P <   12000)  1/P * (1.27 * P +  2500)
           else if(P <   20000)  1/P * (1.07 * P +  4900)
           else if(P <   30000)  1/P * (1.14 * P +  3500)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.73 * P + 27000)
           else if(P <  400000)  1/P * (0.75 * P + 22000)
           else if(P < 1000000)  1/P * (0.75 * P + 22000)
           else if(P < 2000000)  1/P * (0.75 * P + 22000)
           else                  1/P * (0.76 * P +  2000)
           , 1.935)
}

hosei[["H20"]]$firefighting.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.22 * P +  2880)
           else if(P <   12000)  1/P * (1.28 * P +  2400)
           else if(P <   20000)  1/P * (1.08 * P +  4800)
           else if(P <   30000)  1/P * (1.13 * P +  3800)
           else if(P <  100000)  1/P * (0.89 * P + 11000)
           else if(P <  250000)  1/P * (0.73 * P + 27000)
           else if(P <  400000)  1/P * (0.76 * P + 19500)
           else if(P < 1000000)  1/P * (0.75 * P + 23500)
           else if(P < 2000000)  1/P * (0.75 * P + 23500)
           else                  1/P * (0.76 * P +  3500)
           , 1.940)
}

hosei[["S43"]]$firefighting.density <- function(P) if(is.na(P)) NA else 1
hosei[["S47"]]$firefighting.density <- function(P) if(is.na(P)) NA else 1

hosei[["H3"]]$firefighting.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.06
        + max(0,    -50 + min(M, 100)) *  0.01
        + max(0,   -100 + min(M, 150)) * -0.02
        + max(0,   -150 +     M      ) * -0.02
        ) / P
}

hosei[["H4"]]$firefighting.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.94 * P + 12.0)
    else if(P > 100) 1/P * (0.99 * P +  4.5)
    else if(P >  50) 1/P * (1.01 * P +  2.5)
    else             1/P * (1.03 * P +  1.5)
  }
}

hosei[["H9"]]$firefighting.density <- hosei[["H4"]]$firefighting.density

hosei[["H13"]]$firefighting.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.94 * P + 12.0)
    else if(P > 100) 1/P * (0.97 * P +  7.5)
    else if(P >  50) 1/P * (0.97 * P +  7.5)
    else             1/P * (1.05 * P +  3.5)
  }
}

hosei[["H14"]]$firefighting.density <- hosei[["H13"]]$firefighting.density
hosei[["H15"]]$firefighting.density <- hosei[["H14"]]$firefighting.density

hosei[["H16"]]$firefighting.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.94 * P + 12.0)
    else if(P > 100) 1/P * (0.97 * P +  7.5)
    else if(P >  50) 1/P * (0.98 * P +  6.5)
    else             1/P * (1.04 * P +  3.5)
  }
}

hosei[["H17"]]$firefighting.density <- hosei[["H16"]]$firefighting.density
hosei[["H18"]]$firefighting.density <- hosei[["H17"]]$firefighting.density
hosei[["H19"]]$firefighting.density <- hosei[["H18"]]$firefighting.density
hosei[["H20"]]$firefighting.density <- hosei[["H19"]]$firefighting.density

### Parks

#FIXME:  need to check back and figure out why the splines don't line up here...

hosei[["S43"]]$parks.investment.type <- function(A) if(is.na(A)) NA else 1

hosei[["S47"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else if (A > 100000) 100000/A * 0.5   + 0.5
  else                 100000/A * 0.125 + 0.875
}

hosei[["H3"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 500000) (100000/A * 0.302 + 0.366 + 0.448) # B
    else if(A > 300000) (100000/A * 0.304 + 0.347 + 0.399) 
    else if(A > 100000) (100000/A * 0.288 + 0.714)
    else if(A >  50000) (100000/A * 0.112 + 0.888)
    else if(A >  10000) (100000/A * 0.088 + 0.938)
    else if(A >   5000) (100000/A * 0.080 + 1.026)
    else                (100000/A * 0.072 + 1.172)
  }
}

hosei[["H4"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 500000) (100000/A * 0.302 + 0.374 + 0.424) # B
    else if(A > 300000) (100000/A * 0.304 + 0.347 + 0.399) 
    else if(A > 100000) (100000/A * 0.288 + 0.712)
    else if(A >  50000) (100000/A * 0.112 + 0.888)
    else if(A >  10000) (100000/A * 0.088 + 0.934)
    else if(A >   5000) (100000/A * 0.078 + 1.024)
    else                (100000/A * 0.072 + 1.170)
  }
}

hosei[["H9"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.202 + 0.365 + 0.547) # B
    else if(A > 100000) (100000/A * 0.287 + 0.284 + 0.426)
    else if(A >  50000) (100000/A * 0.112 + 0.355 + 0.533)
    else if(A >  10000) (100000/A * 0.088 + 0.375 + 0.562)
    else if(A >   5000) (100000/A * 0.078 + 0.409 + 0.613)
    else                (100000/A * 0.072 + 0.469 + 0.704)
  }
}

### "fixed":  this is discontinuous in the original documents (typo?)
# 0.290 - (1.007 - 0.710) * 3  = -0.601
hosei[["H13"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
#    if     (A > 300000) (100000/A * 0.290 + 1.007) # * B
    if     (A > 300000) (100000/A *-0.601 + 1.007) # * B
    else if(A > 100000) (100000/A * 0.290 + 0.710)
    else                (100000/A * 0.066 + 0.934)
  }
}

hosei[["H14"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.290 + 1.070) # * B
    else if(A > 100000) (100000/A * 0.290 + 0.709)
    else                (100000/A * 0.065 + 0.934)
  }
}

hosei[["H15"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.290 + 1.098) # * B
    else if(A > 100000) (100000/A * 0.290 + 0.709)
    else                (100000/A * 0.065 + 0.934)
  }
}

hosei[["H16"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.290 + 1.280) # * B
    else if(A > 100000) (100000/A * 0.290 + 0.707)
    else                (100000/A * 0.061 + 0.936)
  }
}

hosei[["H17"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.297 + 1.364) # * B
    else if(A > 100000) (100000/A * 0.297 + 0.703)
    else                (100000/A * 0.059 + 0.941)
  }
}

hosei[["H18"]]$parks.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 300000) (100000/A * 0.297 + 1.472) # * B
    else if(A > 100000) (100000/A * 0.297 + 0.708)
    else                (100000/A * 0.061 + 0.943)
  }
}

hosei[["H19"]]$parks.investment.type <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$parks.investment.type <- function(A) if(is.na(A)) NA else 0


### Other land

hosei[["S43"]]$otherland.pop <- function(P) min({
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  0.68
     + max(0,  -150000 + min(P,  250000)) *  0.62
     + max(0,  -250000 + min(P,  400000)) *  0.55
     + max(0,  -400000 +     P          ) *  0.53)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.16
     + max(0,   -40000 + min(M, 60000))   *  0.07
     + max(0,   -60000 + min(M, 80000))   *  0.00
     + max(0,   -80000 + min(M, 88000))   * -0.14
     + max(0,   -88000 +     M        )   * -0.17)
} / P, 2.20)

hosei[["S47"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.68
     + max(0,  -250000 + min(P,  400000)) *  0.60
     + max(0,  -400000 +     P          ) *  0.43)  #plus large cities
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.09
     + max(0,   -70000 + min(M, 80000))   * -0.06
     + max(0,   -80000 + min(M, 88000))   * -0.06
     + max(0,   -88000 + min(M, 96000))   * -0.22
     + max(0,   -96000 +     M        )   * -0.82)
} / P

hosei[["H3"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.71
     + max(0,  -250000 + min(P,  400000)) *  0.65
     + max(0,  -400000 +     P          ) *  0.48)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.09
     + max(0,   -70000 + min(M, 80000))   *  0.00
     + max(0,   -80000 + min(M, 88000))   * -0.04
     + max(0,   -88000 + min(M, 96000))   * -0.21
     + max(0,   -96000 +     M        )   * -0.96)
} / P

hosei[["H4"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (1.88 * P +    840)
  else if(P <    8000)  1/P * (1.49 * P +   2400)
  else if(P <   12000)  1/P * (0.92 * P +   6960)
  else if(P <   20000)  1/P * (1.05 * P +   5400)
  else if(P <   30000)  1/P * (1.06 * P +   5200)
  else if(P <  100000)  1/P * (0.90 * P +  10000)
  else if(P <  250000)  1/P * (0.70 * P +  30000)
  else if(P <  400000)  1/P * (0.66 * P +  40000)
  else                  1/P * (0.47 * P + 116000)  #plus large cities
}

hosei[["H9"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (2.01 * P +   1960)
  else if(P <    8000)  1/P * (1.13 * P +   5480)
  else if(P <   12000)  1/P * (0.95 * P +   6920)
  else if(P <   20000)  1/P * (1.16 * P +   4400)
  else if(P <   30000)  1/P * (0.80 * P +  11600)
  else if(P <  100000)  1/P * (0.92 * P +   8000)
  else if(P <  250000)  1/P * (0.67 * P +  33000)
  else if(P <  400000)  1/P * (0.50 * P +  75500)
  else                  1/P * (0.45 * P +  95500)  #plus large cities
}

#reg <- nls(log(hosei[["H9"]]$otherland.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .67 * P + 9652
#coef(reg)[2] / coef(reg)[1]  # 14387


hosei[["H13"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.06 * P +   5420)
           else if(P <   12000)  1/P * (1.00 * P +   5900)
           else if(P <   20000)  1/P * (1.10 * P +   4700)
           else if(P <   30000)  1/P * (0.82 * P +  10300)
           else if(P <  100000)  1/P * (0.93 * P +   7000)
           else if(P <  250000)  1/P * (0.71 * P +  29000)
           else if(P <  400000)  1/P * (0.58 * P +  61500)
           else if(P < 1000000)  1/P * (0.56 * P +  69500)
           else                  1/P * (0.50 * P + 129500)
           , 2.415)
}

hosei[["H14"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.07 * P +   4740)
           else if(P <   12000)  1/P * (1.01 * P +   5220)
           else if(P <   20000)  1/P * (1.12 * P +   3900)
           else if(P <   30000)  1/P * (0.86 * P +   9100)
           else if(P <  100000)  1/P * (0.93 * P +   7000)
           else if(P <  250000)  1/P * (0.70 * P +  30000)
           else if(P <  400000)  1/P * (0.57 * P +  62500)
           else if(P < 1000000)  1/P * (0.55 * P +  70500)
           else                  1/P * (0.50 * P + 120500)
           , 2.255)
}

hosei[["H15"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.05 * P +   4240)
           else if(P <   12000)  1/P * (1.05 * P +   4240)
           else if(P <   20000)  1/P * (1.12 * P +   3400)
           else if(P <   30000)  1/P * (0.91 * P +   7600)
           else if(P <  100000)  1/P * (0.93 * P +   7000)
           else if(P <  250000)  1/P * (0.69 * P +  31000)
           else if(P <  400000)  1/P * (0.56 * P +  63500)
           else if(P < 1000000)  1/P * (0.55 * P +  67500)
           else                  1/P * (0.49 * P + 127500)
           , 2.11)
}

hosei[["H16"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.05 * P +   3640)
           else if(P <   12000)  1/P * (1.06 * P +   3560)
           else if(P <   20000)  1/P * (1.14 * P +   2600)
           else if(P <   30000)  1/P * (0.95 * P +   6400)
           else if(P <  100000)  1/P * (0.93 * P +   7000)
           else if(P <  250000)  1/P * (0.68 * P +  32000)
           else if(P <  400000)  1/P * (0.56 * P +  62000)
           else if(P < 1000000)  1/P * (0.54 * P +  70000)
           else                  1/P * (0.49 * P + 120000)
           , 1.960)
}

hosei[["H17"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.04 * P +   3400)
           else if(P <   12000)  1/P * (1.06 * P +   3240)
           else if(P <   20000)  1/P * (1.13 * P +   2400)
           else if(P <   30000)  1/P * (0.92 * P +   6600)
           else if(P <  100000)  1/P * (0.94 * P +   6000)
           else if(P <  250000)  1/P * (0.70 * P +  30000)
           else if(P <  400000)  1/P * (0.61 * P +  52500)
           else if(P < 1000000)  1/P * (0.59 * P +  60500)
           else                  1/P * (0.53 * P + 120500)
           , 1.890)
}

hosei[["H18"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.04 * P +   2580)
           else if(P <   12000)  1/P * (1.05 * P +   2500)
           else if(P <   20000)  1/P * (1.10 * P +   1900)
           else if(P <   30000)  1/P * (0.96 * P +   4700)
           else if(P <  100000)  1/P * (0.95 * P +   5000)
           else if(P <  250000)  1/P * (0.76 * P +  24000)
           else if(P <  400000)  1/P * (0.70 * P +  39000)
           else if(P < 1000000)  1/P * (0.67 * P +  51000)
           else                  1/P * (0.63 * P +  91000)
           , 1.685)
}

hosei[["H19"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.09 * P +   2200)
           else if(P <   12000)  1/P * (1.11 * P +   2040)
           else if(P <   20000)  1/P * (1.08 * P +   2400)
           else if(P <   30000)  1/P * (0.95 * P +   5000)
           else if(P <  100000)  1/P * (0.95 * P +   5000)
           else if(P <  250000)  1/P * (0.80 * P +  20000)
           else if(P <  400000)  1/P * (0.70 * P +  45000)
           else if(P < 1000000)  1/P * (0.68 * P +  53000)
           else                  1/P * (0.64 * P +  93000)
           , 1.640)
}

hosei[["H20"]]$otherland.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.11 * P +   2380)
           else if(P <   12000)  1/P * (1.11 * P +   2380)
           else if(P <   20000)  1/P * (1.10 * P +   2500)
           else if(P <   30000)  1/P * (0.97 * P +   5100)
           else if(P <  100000)  1/P * (0.94 * P +   6000)
           else if(P <  250000)  1/P * (0.80 * P +  20000)
           else if(P <  400000)  1/P * (0.69 * P +  47500)
           else if(P < 1000000)  1/P * (0.66 * P +  59500)
           else                  1/P * (0.63 * P +  89500)
           , 1.705)
}

hosei[["S43"]]$otherland.investment.type <- function(A) if(is.na(A)) NA else 1

hosei[["S47"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else if (A > 100000) 100000/A * 0.2 + 0.8
  else                 100000/A * 0.3 + 0.7
}

hosei[["H3"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.392 + 9.519)
    else if(A > 1000000) (100000/A * 0.392 + 7.464)
    else if(A >  500000) (100000/A * 0.392 + 6.635)
    else if(A >  300000) (100000/A * 0.392 + 5.381)
    else if(A >  100000) (100000/A * 0.392 + 2.228)
    else if(A >   50000) (100000/A * 0.313 + 2.306)
    else if(A >   10000) (100000/A * 0.312 + 2.308)
    else if(A >    5000) (100000/A * 0.294 + 2.488)
    else                 (100000/A * 0.281 + 2.748)
  }
}

hosei[["H4"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.392 + 8.615)
    else if(A > 1000000) (100000/A * 0.392 + 6.755)
    else if(A >  500000) (100000/A * 0.392 + 6.005)
    else if(A >  300000) (100000/A * 0.392 + 4.870)
    else if(A >  100000) (100000/A * 0.392 + 2.228)
    else if(A >   50000) (100000/A * 0.313 + 2.305)
    else if(A >   10000) (100000/A * 0.312 + 2.308)
    else if(A >    5000) (100000/A * 0.294 + 2.488)
    else                 (100000/A * 0.281 + 2.748)
  }
}

hosei[["H9"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.408 + 9.169)
    else if(A > 1000000) (100000/A * 0.408 + 7.250)
    else if(A >  500000) (100000/A * 0.408 + 5.967)
    else if(A >  300000) (100000/A * 0.408 + 5.283)
    else if(A >  100000) (100000/A * 0.408 + 2.318)
    else if(A >   50000) (100000/A * 0.335 + 2.391)
    else if(A >   10000) (100000/A * 0.333 + 2.395)
    else if(A >    5000) (100000/A * 0.316 + 2.561)
    else                 (100000/A * 0.303 + 2.831)
  }
}

### "broken":  discontinuous in original documents
# (2.069 - 5.423) * 3 + 0.591 = -9.471
# (5.423 - 6.590) * 10 - 9.471 = -21.141
# (6.590 - 8.335) * 50 - 21.141 = -108.391
hosei[["H13"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A*-108.391+ 8.335)
    else if(A > 1000000) (100000/A* -21.141+ 6.590)
    else if(A >  300000) (100000/A *-9.471 + 5.423)
    else if(A >  100000) (100000/A * 0.591 + 2.069)
    else                 (100000/A * 0.209 + 2.451)
  }
}

hosei[["H14"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.591 + 8.393)
    else if(A > 1000000) (100000/A * 0.591 + 6.648)
    else if(A >  300000) (100000/A * 0.591 + 5.481)
    else if(A >  100000) (100000/A * 0.591 + 2.060)
    else                 (100000/A * 0.200 + 2.451)
  }
}

hosei[["H15"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.591 + 8.392)
    else if(A > 1000000) (100000/A * 0.591 + 6.647)
    else if(A >  300000) (100000/A * 0.591 + 5.482)
    else if(A >  100000) (100000/A * 0.591 + 2.060)
    else                 (100000/A * 0.200 + 2.452)
  }
}

hosei[["H16"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.591 + 10.640)
    else if(A > 2000000) (100000/A * 0.591 + 8.341)
    else if(A > 1000000) (100000/A * 0.591 + 6.600)
    else if(A >  300000) (100000/A * 0.591 + 5.805)
    else if(A >  100000) (100000/A * 0.591 + 2.061)
    else                 (100000/A * 0.200 + 2.450)
  }
}

hosei[["H17"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.591 + 13.503)
    else if(A > 2000000) (100000/A * 0.591 + 10.111)
    else if(A > 1000000) (100000/A * 0.591 + 7.560)
    else if(A >  300000) (100000/A * 0.591 + 6.967)
    else if(A >  100000) (100000/A * 0.591 + 2.060)
    else                 (100000/A * 0.200 + 2.451)
  }
}

hosei[["H18"]]$otherland.investment.type <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A > 5000000) (100000/A * 0.532 + 13.604)
    else if(A > 2000000) (100000/A * 0.532 + 9.309)
    else if(A > 1000000) (100000/A * 0.532 + 6.954)
    else if(A >  300000) (100000/A * 0.532 + 6.797)
    else if(A >  100000) (100000/A * 0.532 + 1.853)
    else                 (100000/A * 0.180 + 2.206)
  }
}

hosei[["H19"]]$otherland.investment.type <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$otherland.investment.type <- function(A) if(is.na(A)) NA else 0


### Other education


hosei[["S43"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  0.64
     + max(0,  -150000 + min(P,  250000)) *  0.63
     + max(0,  -250000 + min(P,  400000)) *  0.65
     + max(0,  -400000 +     P          ) *  0.69)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.18
     + max(0,   -40000 + min(M, 60000))   *  0.09
     + max(0,   -60000 + min(M, 70000))   * -0.05
     + max(0,   -70000 + min(M, 80000))   * -0.09
     + max(0,   -80000 + min(M, 84000))   * -0.07
     + max(0,   -84000 + min(M, 88000))   * -0.10
     + max(0,   -88000 + min(M, 92000))   * -0.24
     + max(0,   -92000 +     M        )   * -0.38)
} / P

hosei[["S47"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.63
     + max(0,  -250000 + min(P,  400000)) *  0.65
     + max(0,  -400000 + min(P, 1000000)) *  0.68
     + max(0, -1000000 +     P          ) *  0.67)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.13
     + max(0,   -70000 + min(M, 80000))   * -0.16
     + max(0,   -80000 + min(M, 88000))   * -0.09
     + max(0,   -88000 + min(M, 96000))   * -0.27
     + max(0,   -96000 +     M        )   * -1.11)
} / P

hosei[["H3"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.68
     + max(0,  -250000 + min(P,  400000)) *  0.68
     + max(0,  -400000 + min(P, 1000000)) *  0.70
     + max(0, -1000000 +     P          ) *  0.66)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.16
     + max(0,   -70000 + min(M, 80000))   * -0.20
     + max(0,   -80000 + min(M, 88000))   * -0.16
     + max(0,   -88000 + min(M, 96000))   * -0.34
     + max(0,   -96000 +     M        )   * -1.25)
} / P

hosei[["H4"]]$othereducation.pop <- function(P) {
  if     (P <    4000)  1/P * (2.24 * P +    180)
  else if(P <    8000)  1/P * (1.24 * P +   4180)
  else if(P <   12000)  1/P * (1.32 * P +   3540)
  else if(P <   20000)  1/P * (1.24 * P +   4500)
  else if(P <   30000)  1/P * (1.12 * P +   6900)
  else if(P <  100000)  1/P * (0.85 * P +  15000)
  else if(P <  250000)  1/P * (0.68 * P +  32000)
  else if(P <  400000)  1/P * (0.69 * P +  29500)
  else if(P < 1000000)  1/P * (0.71 * P +  21500)
  else                  1/P * (0.66 * P +  71500)
}

hosei[["H9"]]$othereducation.pop <- function(P) {
  if     (P <    4000)  1/P * (2.25 * P +    140)
  else if(P <    8000)  1/P * (1.21 * P +   4300)
  else if(P <   12000)  1/P * (1.30 * P +   3580)
  else if(P <   20000)  1/P * (1.24 * P +   4300)
  else if(P <   30000)  1/P * (1.07 * P +   7700)
  else if(P <  100000)  1/P * (0.86 * P +  14000)
  else if(P <  250000)  1/P * (0.69 * P +  31000)
  else if(P <  400000)  1/P * (0.71 * P +  26000)
  else if(P < 1000000)  1/P * (0.71 * P +  26000)
  else                  1/P * (0.67 * P +  66000)
}

#reg <- nls(log(hosei[["H9"]]$othereducation.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .81 * P + 7875
#coef(reg)[2] / coef(reg)[1]  # 9683


hosei[["H13"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.39 * P +   3520)
           else if(P <   12000)  1/P * (1.39 * P +   3520)
           else if(P <   20000)  1/P * (1.30 * P +   4600)
           else if(P <   30000)  1/P * (1.06 * P +   9400)
           else if(P <  100000)  1/P * (0.84 * P +  16000)
           else if(P <  250000)  1/P * (0.72 * P +  28000)
           else if(P <  400000)  1/P * (0.74 * P +  23000)
           else if(P < 1000000)  1/P * (0.73 * P +  27000)
           else                  1/P * (0.70 * P +  57000)
           , 2.270)
}

hosei[["H14"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.36 * P +   3300)
           else if(P <   12000)  1/P * (1.37 * P +   3220)
           else if(P <   20000)  1/P * (1.28 * P +   4300)
           else if(P <   30000)  1/P * (1.06 * P +   8700)
           else if(P <  100000)  1/P * (0.85 * P +  15000)
           else if(P <  250000)  1/P * (0.70 * P +  30000)
           else if(P <  400000)  1/P * (0.74 * P +  20000)
           else if(P < 1000000)  1/P * (0.73 * P +  24000)
           else                  1/P * (0.69 * P +  64000)
           , 2.185)
}

hosei[["H15"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.33 * P +   3100)
           else if(P <   12000)  1/P * (1.35 * P +   2940)
           else if(P <   20000)  1/P * (1.27 * P +   3900)
           else if(P <   30000)  1/P * (1.12 * P +   6900)
           else if(P <  100000)  1/P * (0.85 * P +  15000)
           else if(P <  250000)  1/P * (0.69 * P +  31000)
           else if(P <  400000)  1/P * (0.73 * P +  21000)
           else if(P < 1000000)  1/P * (0.72 * P +  25000)
           else                  1/P * (0.68 * P +  65000)
           , 2.105)
}

hosei[["H16"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.30 * P +   2900)
           else if(P <   12000)  1/P * (1.33 * P +   2660)
           else if(P <   20000)  1/P * (1.26 * P +   3500)
           else if(P <   30000)  1/P * (1.11 * P +   6500)
           else if(P <  100000)  1/P * (0.86 * P +  14000)
           else if(P <  250000)  1/P * (0.68 * P +  32000)
           else if(P <  400000)  1/P * (0.72 * P +  22000)
           else if(P < 1000000)  1/P * (0.72 * P +  22000)
           else                  1/P * (0.67 * P +  72000)
           , 2.025)
}

hosei[["H17"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.29 * P +   2920)
           else if(P <   12000)  1/P * (1.32 * P +   2680)
           else if(P <   20000)  1/P * (1.26 * P +   3400)
           else if(P <   30000)  1/P * (1.12 * P +   6200)
           else if(P <  100000)  1/P * (0.86 * P +  14000)
           else if(P <  250000)  1/P * (0.68 * P +  32000)
           else if(P <  400000)  1/P * (0.72 * P +  22000)
           else if(P < 1000000)  1/P * (0.72 * P +  22000)
           else                  1/P * (0.67 * P +  72000)
           , 2.020)
}

hosei[["H18"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.29 * P +   2920)
           else if(P <   12000)  1/P * (1.32 * P +   2680)
           else if(P <   20000)  1/P * (1.26 * P +   3400)
           else if(P <   30000)  1/P * (1.05 * P +   7600)
           else if(P <  100000)  1/P * (0.87 * P +  13000)
           else if(P <  250000)  1/P * (0.67 * P +  33000)
           else if(P <  400000)  1/P * (0.71 * P +  23000)
           else if(P < 1000000)  1/P * (0.71 * P +  23000)
           else                  1/P * (0.67 * P +  63000)
           , 2.020)
}

hosei[["H19"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.33 * P +   2880)
           else if(P <   12000)  1/P * (1.34 * P +   2800)
           else if(P <   20000)  1/P * (1.29 * P +   3400)
           else if(P <   30000)  1/P * (1.06 * P +   8000)
           else if(P <  100000)  1/P * (0.86 * P +  13000)
           else if(P <  250000)  1/P * (0.67 * P +  33000)
           else if(P <  400000)  1/P * (0.70 * P +  25500)
           else if(P < 1000000)  1/P * (0.71 * P +  21500)
           else                  1/P * (0.66 * P +  71500)
           , 2.050)
}

hosei[["H20"]]$othereducation.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.37 * P +   2980)
           else if(P <   12000)  1/P * (1.39 * P +   2820)
           else if(P <   20000)  1/P * (1.20 * P +   5100)
           else if(P <   30000)  1/P * (1.07 * P +   7700)
           else if(P <  100000)  1/P * (0.86 * P +  14000)
           else if(P <  250000)  1/P * (0.66 * P +  34000)
           else if(P <  400000)  1/P * (0.71 * P +  21500)
           else if(P < 1000000)  1/P * (0.71 * P +  21500)
           else                  1/P * (0.66 * P +  71500)
           , 2.115)
}

hosei[["S43"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.02
        + max(0,    -50 + min(M, 100)) *  0.10
        + max(0,   -100 + min(M, 150)) *  0.04
        + max(0,   -150 +     M      ) * -0.06
        ) / P
}

hosei[["S47"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.02
        + max(0,    -50 + min(M, 100)) *  0.11
        + max(0,   -100 + min(M, 150)) *  0.00
        + max(0,   -150 +     M      ) * -0.04
        ) / P
}

hosei[["H3"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.02
        + max(0,    -50 + min(M, 100)) *  0.14
        + max(0,   -100 + min(M, 150)) *  0.00
        + max(0,   -150 +     M      ) * -0.08
        ) / P
}

hosei[["H4"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.98 * P +  4.0)
    else if(P > 100) 1/P * (0.86 * P + 22.0)
    else if(P >  50) 1/P * (1.00 * P +  8.0)
    else             1/P * (1.07 * P +  4.5)
  }
}

hosei[["H9"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.98 * P +  4.0)
    else if(P > 100) 1/P * (0.88 * P + 19.0)
    else if(P >  50) 1/P * (1.00 * P +  7.0)
    else             1/P * (1.06 * P +  4.0)
  }
}

hosei[["H13"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.96 * P +  8.0)
    else if(P > 100) 1/P * (0.92 * P + 14.0)
    else if(P >  50) 1/P * (0.95 * P + 11.0)
    else             1/P * (1.08 * P +  4.5)
  }
}

hosei[["H14"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.97 * P +  6.0)
    else if(P > 100) 1/P * (0.93 * P + 12.0)
    else if(P >  50) 1/P * (0.94 * P + 11.0)
    else             1/P * (1.08 * P +  4.0)
  }
}

hosei[["H15"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.97 * P +  6.0)
    else if(P > 100) 1/P * (0.93 * P + 12.0)
    else if(P >  50) 1/P * (0.95 * P + 10.0)
    else             1/P * (1.07 * P +  4.0)
  }
}

hosei[["H16"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.97 * P +  6.0)
    else if(P > 100) 1/P * (0.94 * P + 10.5)
    else if(P >  50) 1/P * (0.95 * P +  9.5)
    else             1/P * (1.06 * P +  4.0)
  }
}

hosei[["H17"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.97 * P +  6.0)
    else if(P > 100) 1/P * (0.93 * P + 12.0)
    else if(P >  50) 1/P * (0.96 * P +  9.0)
    else             1/P * (1.07 * P +  3.5)
  }
}

hosei[["H18"]]$othereducation.density <- hosei[["H17"]]$othereducation.density

hosei[["H19"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.96 * P +  8.0)
    else if(P > 100) 1/P * (0.94 * P + 11.0)
    else if(P >  50) 1/P * (0.96 * P +  9.0)
    else             1/P * (1.06 * P +  4.0)
  }
}

hosei[["H20"]]$othereducation.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P > 200)                      1
    else if(P > 150) 1/P * (0.97 * P +  6.0)
    else if(P > 100) 1/P * (0.93 * P + 12.0)
    else if(P >  50) 1/P * (0.95 * P + 10.0)
    else             1/P * (1.07 * P +  4.0)
  }
}

hosei[["S43"]]$othereducation.investment.adj <- function(A) 1  #combined with current expenses, though...

hosei[["H3"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.4 + 0.60

hosei[["S47"]]$othereducation.investment.adj <- hosei[["H3"]]$othereducation.investment.adj

hosei[["H4"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.38 + 0.62

hosei[["H9"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.37 + 0.63

hosei[["H13"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.25 + 0.75

hosei[["H14"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.23 + 0.77

hosei[["H15"]]$othereducation.investment.adj <- function(A)
  100000/A * 0.22 + 0.78

hosei[["H16"]]$othereducation.investment.adj <- hosei[["H15"]]$othereducation.investment.adj
hosei[["H17"]]$othereducation.investment.adj <- hosei[["H16"]]$othereducation.investment.adj
hosei[["H18"]]$othereducation.investment.adj <- hosei[["H17"]]$othereducation.investment.adj
hosei[["H19"]]$othereducation.investment.adj <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$othereducation.investment.adj <- function(A) if(is.na(A)) NA else 0


### Welfare

hosei[["S43"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  0.94
     + max(0,  -150000 + min(P,  250000)) *  0.73
     + max(0,  -250000 + min(P,  400000)) *  0.65
     + max(0, -1000000 +     P          ) *  0.50)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.17
     + max(0,   -40000 + min(M, 60000))   * -0.11
     + max(0,   -60000 + min(M, 80000))   * -0.08
     + max(0,   -80000 + min(M, 84000))   * -0.15
     + max(0,   -84000 + min(M, 88000))   *  0.04
     + max(0,   -88000 + min(M, 92000))   *  0.03
     + max(0,   -92000 +     M        )   * -0.19)
} / P

hosei[["S47"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.78
     + max(0,  -250000 + min(P,  400000)) *  0.64
     + max(0,  -400000 + min(P, 1000000)) *  0.56
     + max(0, -1000000 +     P          ) *  0.55)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.06
     + max(0,   -70000 + min(M, 80000))   *  0.07
     + max(0,   -80000 + min(M, 88000))   *  0.08
     + max(0,   -88000 + min(M, 96000))   *  0.14
     + max(0,   -96000 +     M        )   *  0.15)
} / P

hosei[["H3"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.86
     + max(0,  -250000 + min(P,  400000)) *  0.77
     + max(0,  -400000 + min(P, 1000000)) *  0.75
     + max(0, -1000000 +     P          ) *  0.70)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.03
     + max(0,   -70000 + min(M, 80000))   *  0.04
     + max(0,   -80000 + min(M, 88000))   * -0.02
     + max(0,   -88000 + min(M, 96000))   * -0.07
     + max(0,   -96000 +     M        )   * -0.13)
} / P

hosei[["H4"]]$welfare.pop <- function(P) {
  if     (P <    4000)  1/P * (1.16 * P +   1240)
  else if(P <    8000)  1/P * (1.13 * P +   1360)
  else if(P <   12000)  1/P * (1.01 * P +   2320)
  else if(P <   20000)  1/P * (1.02 * P +   2200)
  else if(P <   30000)  1/P * (1.02 * P +   2200)
  else if(P <  100000)  1/P * (0.96 * P +   4000)
  else if(P <  250000)  1/P * (0.85 * P +  15000)
  else if(P <  400000)  1/P * (0.78 * P +  32500)
  else if(P < 1000000)  1/P * (0.76 * P +  40500)
  else                  1/P * (0.71 * P +  90500)
}

hosei[["H9"]]$welfare.pop <- function(P) {
  if     (P <    4000)  1/P * (1.58 * P +    520)
  else if(P <    8000)  1/P * (1.08 * P +   2520)
  else if(P <   12000)  1/P * (1.03 * P +   2920)
  else if(P <   20000)  1/P * (1.04 * P +   2800)
  else if(P <   30000)  1/P * (0.99 * P +   3800)
  else if(P <  100000)  1/P * (0.95 * P +   5000)
  else if(P <  250000)  1/P * (0.82 * P +  18000)
  else if(P <  400000)  1/P * (0.75 * P +  35500)
  else if(P < 1000000)  1/P * (0.72 * P +  47500)
  else                  1/P * (0.68 * P +  87500)
}

#reg <- nls(log(hosei[["H9"]]$welfare.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .85 * P + 4223
#coef(reg)[2] / coef(reg)[1]  # 4948

hosei[["H13"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.05 * P +   2720)
           else if(P <   12000)  1/P * (1.00 * P +   3120)
           else if(P <   20000)  1/P * (1.06 * P +   2400)
           else if(P <   30000)  1/P * (0.99 * P +   3800)
           else if(P <  100000)  1/P * (0.95 * P +   5000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P <  400000)  1/P * (0.79 * P +  28500)
           else if(P < 1000000)  1/P * (0.76 * P +  40500)
           else                  1/P * (0.72 * P +  80500)
           , 1.730)
}

hosei[["H14"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.07 * P +   2580)
           else if(P <   12000)  1/P * (0.99 * P +   3220)
           else if(P <   20000)  1/P * (1.05 * P +   2500)
           else if(P <   30000)  1/P * (1.00 * P +   3500)
           else if(P <  100000)  1/P * (0.95 * P +   5000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P <  400000)  1/P * (0.79 * P +  28500)
           else if(P < 1000000)  1/P * (0.76 * P +  40500)
           else                  1/P * (0.72 * P +  80500)
           , 1.715)
}

hosei[["H15"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.07 * P +   2560)
           else if(P <   12000)  1/P * (0.97 * P +   3360)
           else if(P <   20000)  1/P * (1.05 * P +   2400)
           else if(P <   30000)  1/P * (1.01 * P +   3200)
           else if(P <  100000)  1/P * (0.95 * P +   5000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P <  400000)  1/P * (0.79 * P +  28500)
           else if(P < 1000000)  1/P * (0.76 * P +  40500)
           else                  1/P * (0.72 * P +  80500)
           , 1.710)
}

hosei[["H16"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.07 * P +   2160)
           else if(P <   12000)  1/P * (0.96 * P +   3040)
           else if(P <   20000)  1/P * (1.03 * P +   2200)
           else if(P <   30000)  1/P * (1.00 * P +   2800)
           else if(P <  100000)  1/P * (0.96 * P +   4000)
           else if(P <  250000)  1/P * (0.85 * P +  15000)
           else if(P <  400000)  1/P * (0.81 * P +  25000)
           else if(P < 1000000)  1/P * (0.78 * P +  37000)
           else                  1/P * (0.75 * P +  67000)
           , 1.610)
}

hosei[["H17"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.10 * P +   2180)
           else if(P <   12000)  1/P * (0.95 * P +   3380)
           else if(P <   20000)  1/P * (1.04 * P +   2300)
           else if(P <   30000)  1/P * (0.97 * P +   3700)
           else if(P <  100000)  1/P * (0.96 * P +   4000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P <  400000)  1/P * (0.80 * P +  26000)
           else if(P < 1000000)  1/P * (0.77 * P +  38000)
           else                  1/P * (0.74 * P +  68000)
           , 1.645)
}

hosei[["H18"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.06 * P +   1680)
           else if(P <   12000)  1/P * (0.97 * P +   2400)
           else if(P <   20000)  1/P * (1.02 * P +   1800)
           else if(P <   30000)  1/P * (0.99 * P +   2400)
           else if(P <  100000)  1/P * (0.97 * P +   3000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.85 * P +  21000)
           else if(P < 1000000)  1/P * (0.83 * P +  29000)
           else                  1/P * (0.81 * P +  49000)
           , 1.515)
}

hosei[["H19"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.06 * P +   1620)
           else if(P <   12000)  1/P * (0.98 * P +   2260)
           else if(P <   20000)  1/P * (1.01 * P +   1900)
           else if(P <   30000)  1/P * (1.00 * P +   2100)
           else if(P <  100000)  1/P * (0.97 * P +   3000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.86 * P +  18500)
           else if(P < 1000000)  1/P * (0.84 * P +  26500)
           else                  1/P * (0.82 * P +  46500)
           , 1.465)
}

hosei[["H20"]]$welfare.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.06 * P +   1540)
           else if(P <   12000)  1/P * (0.98 * P +   2180)
           else if(P <   20000)  1/P * (1.02 * P +   1700)
           else if(P <   30000)  1/P * (1.00 * P +   2100)
           else if(P <  100000)  1/P * (0.97 * P +   3000)
           else if(P <  250000)  1/P * (0.90 * P +  10000)
           else if(P <  400000)  1/P * (0.86 * P +  20000)
           else if(P < 1000000)  1/P * (0.84 * P +  28000)
           else                  1/P * (0.82 * P +  48000)
           , 1.445)
}

hosei[["S43"]]$welfare.investment.adj <- function(A) 1 #appears to be a prefectural responsibility

hosei[["S47"]]$welfare.investment.adj <- function(A)
  100000/A * 0.35 + 0.65 # * B

hosei[["H3"]]$welfare.investment.adj <- function(A)
  100000/A * 0.35 + 0.65 # * B

hosei[["H4"]]$welfare.investment.adj <- function(A)
  100000/A * 0.33 + 0.67 # * B

hosei[["H4"]]$welfare.investment.adj <- function(A)
  100000/A * 0.3 + 0.7 # * B

hosei[["H13"]]$welfare.investment.adj <- function(A)
  100000/A * 0.26 + 0.74 # * B

hosei[["H14"]]$welfare.investment.adj <- function(A)
  100000/A * 0.24 + 0.76

hosei[["H15"]]$welfare.investment.adj <- hosei[["H15"]]$othereducation.investment.adj
hosei[["H16"]]$welfare.investment.adj <- hosei[["H15"]]$welfare.investment.adj
hosei[["H17"]]$welfare.investment.adj <- hosei[["H17"]]$othereducation.investment.adj
hosei[["H18"]]$welfare.investment.adj <- hosei[["H18"]]$othereducation.investment.adj

hosei[["H19"]]$welfare.investment.adj <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$welfare.investment.adj <- function(A) if(is.na(A)) NA else 0


### Hygiene

hosei[["S43"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  0.79
     + max(0,  -100000 + min(P,  250000)) *  0.80
     + max(0,  -250000 + min(P,  400000)) *  0.79
     + max(0,  -400000 +     P          ) *  0.54) #plus designated cities
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.31
     + max(0,   -40000 + min(M, 60000))   *  0.22
     + max(0,   -60000 + min(M, 80000))   * -0.17
     + max(0,   -80000 + min(M, 84000))   * -0.45
     + max(0,   -84000 + min(M, 88000))   * -0.38
     + max(0,   -88000 + min(M, 92000))   * -0.10
     + max(0,   -92000 +     M        )   * -0.26)
} / P

hosei[["S47"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.85
     + max(0,  -250000 + min(P,  400000)) *  0.78
     + max(0,  -400000 +     P          ) *  0.73) #plus designated cities
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.26
     + max(0,   -70000 + min(M, 80000))   * -0.29
     + max(0,   -80000 + min(M, 88000))   * -0.16
     + max(0,   -88000 + min(M, 96000))   * -0.39
     + max(0,   -96000 +     M        )   * -2.72)
} / P

hosei[["H3"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.89
     + max(0,  -250000 + min(P,  400000)) *  0.86
     + max(0,  -400000 +     P          ) *  0.84) #plus designated cities
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.17
     + max(0,   -70000 + min(M, 80000))   * -0.03
     + max(0,   -80000 + min(M, 88000))   * -0.26
     + max(0,   -88000 + min(M, 96000))   * -0.14
     + max(0,   -96000 +     M        )   * -1.43)
} / P

hosei[["H4"]]$hygiene.pop <- function(P) {
  if(P > 100000) {
      if     (P <  250000)  1/P * (0.91 * P +  9000)
      else if(P <  400000)  1/P * (0.88 * P + 16500)
      else                  1/P * (0.86 * P + 24500)  #plus designated cities
    } else {
      if     (P >  30000)  1/P * (0.85 * P +  15000)
      else if(P >  20000)  1/P * (1.05 * P +   9000)
      else if(P >  12000)  1/P * (1.24 * P +   5200)
      else if(P >   8000)  1/P * (1.09 * P +   7000)
      else if(P >   4000)  1/P * (1.04 * P +   7400)
      else                 1/P * (2.26 * P +   2520)
    }
}

hosei[["H9"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000) {
    if     (P <  250000)  1/P * (0.91 * P +  9000)
    else if(P <  400000)  1/P * (0.87 * P + 19000)
    else                  1/P * (0.90 * P +  7000)  #plus designated cities
  } else {
    if     (P >  30000)  1/P * (0.87 * P +  13000)
    else if(P >  20000)  1/P * (1.17 * P +   4000)
    else if(P >  12000)  1/P * (1.20 * P +   3400)
    else if(P >   8000)  1/P * (0.97 * P +   6160)
    else if(P >   4000)  1/P * (1.14 * P +   4800)
    else                 1/P * (1.71 * P +   2520)
  }
}

#reg <- nls(log(hosei[["H9"]]$hygiene.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .94 * P + 6349
#coef(reg)[2] / coef(reg)[1]  # 6757


hosei[["H13"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.12 * P +   4780)
           else if(P <   12000)  1/P * (1.11 * P +   4860)
           else if(P <   20000)  1/P * (1.09 * P +   5100)
           else if(P <   30000)  1/P * (1.01 * P +   6700)
           else if(P <  100000)  1/P * (0.90 * P +  10000)
           else if(P <  250000)  1/P * (0.91 * P +   9000)
           else if(P <  400000)  1/P * (0.87 * P +  19000)
           else if(P < 1000000)  1/P * (0.88 * P +  15000)
           else                  1/P * (0.88 * P +  15000)
           , 2.315)
}

hosei[["H14"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.07 * P +   4820)
           else if(P <   12000)  1/P * (1.09 * P +   4660)
           else if(P <   20000)  1/P * (1.07 * P +   4900)
           else if(P <   30000)  1/P * (1.07 * P +   4900)
           else if(P <  100000)  1/P * (0.90 * P +  10000)
           else if(P <  250000)  1/P * (0.90 * P +  10000)
           else if(P <  400000)  1/P * (0.87 * P +  17500)
           else if(P < 1000000)  1/P * (0.88 * P +  13500)
           else                  1/P * (0.87 * P +  23500)
           , 2.275)
}

hosei[["H15"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.02 * P +   4840)
           else if(P <   12000)  1/P * (1.08 * P +   4360)
           else if(P <   20000)  1/P * (1.06 * P +   4600)
           else if(P <   30000)  1/P * (1.05 * P +   4800)
           else if(P <  100000)  1/P * (0.91 * P +   9000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.87 * P +  16000)
           else if(P < 1000000)  1/P * (0.88 * P +  12000)
           else                  1/P * (0.87 * P +  22000)
           , 2.230)
}

hosei[["H16"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.97 * P +   4900)
           else if(P <   12000)  1/P * (1.06 * P +   4180)
           else if(P <   20000)  1/P * (1.05 * P +   4300)
           else if(P <   30000)  1/P * (1.03 * P +   4700)
           else if(P <  100000)  1/P * (0.92 * P +   8000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.86 * P +  18500)
           else if(P < 1000000)  1/P * (0.87 * P +  14500)
           else                  1/P * (0.87 * P +  14500)
           , 2.195)
}

hosei[["H17"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.97 * P +   4840)
           else if(P <   12000)  1/P * (1.05 * P +   4200)
           else if(P <   20000)  1/P * (1.05 * P +   4200)
           else if(P <   30000)  1/P * (1.04 * P +   4400)
           else if(P <  100000)  1/P * (0.92 * P +   8000)
           else if(P <  250000)  1/P * (0.88 * P +  12000)
           else if(P <  400000)  1/P * (0.87 * P +  14500)
           else if(P < 1000000)  1/P * (0.87 * P +  14500)
           else                  1/P * (0.87 * P +  14500)
           , 2.180)
}

hosei[["H18"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.96 * P +   4760)
           else if(P <   12000)  1/P * (1.06 * P +   3960)
           else if(P <   20000)  1/P * (1.04 * P +   4200)
           else if(P <   30000)  1/P * (0.99 * P +   5200)
           else if(P <  100000)  1/P * (0.93 * P +   7000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.86 * P +  18500)
           else if(P < 1000000)  1/P * (0.88 * P +  10500)
           else                  1/P * (0.87 * P +  20500)
           , 2.150)
}

hosei[["H19"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.98 * P +   4760)
           else if(P <   12000)  1/P * (1.05 * P +   4200)
           else if(P <   20000)  1/P * (1.05 * P +   4200)
           else if(P <   30000)  1/P * (1.04 * P +   4400)
           else if(P <  100000)  1/P * (0.92 * P +   8000)
           else if(P <  250000)  1/P * (0.89 * P +  11000)
           else if(P <  400000)  1/P * (0.86 * P +  18500)
           else if(P < 1000000)  1/P * (0.87 * P +  14500)
           else                  1/P * (0.87 * P +  14500)
           , 2.170)
}

hosei[["H20"]]$hygiene.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.95 * P +   5760)
           else if(P <   12000)  1/P * (1.03 * P +   5120)
           else if(P <   20000)  1/P * (1.04 * P +   5000)
           else if(P <   30000)  1/P * (0.98 * P +   6200)
           else if(P <  100000)  1/P * (0.92 * P +   8000)
           else if(P <  250000)  1/P * (0.88 * P +  12000)
           else if(P <  400000)  1/P * (0.85 * P +  19500)
           else if(P < 1000000)  1/P * (0.86 * P +  15500)
           else                  1/P * (0.86 * P +  15500)
           , 2.390)
}


### Elderly

##FIXME: am I missing earlier ones here?

hosei[["H9"]]$over65.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 18000) {
    if     (P <  45000)  1/P * (0.90 * P +  1800)
    else if(P <  72000)  1/P * (0.84 * P +  4500)
    else if(P < 180000)  1/P * (0.84 * P +  4500)
    else                 1/P * (0.78 * P + 15300)
  } else {
    if     (P >   5400)  1/P * (0.94 * P +  1080)
    else if(P >   3600)  1/P * (1.02 * P +   648)
    else if(P >   2200)  1/P * (1.03 * P +   612)
    else if(P >   1400)  1/P * (0.99 * P +   700)
    else if(P >    720)  1/P * (1.06 * P +   602)
    else                 1/P * (1.49 * P +   292)
  }
}

#reg <- nls(log(hosei[["H9"]]$over65.pop(muni.points.pop * 18000/100000)) ~ log(a * muni.points.pop * 18000/100000 + b) - log(muni.points.pop * 18000/100000))  # .91 * P + 802
#coef(reg)[2] / coef(reg)[1] * 100000/18000  # 4906

hosei[["H13"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 18000) {
      if     (P <  45000)  1/P * (0.84 * P +  2880)
      else if(P <  72000)  1/P * (0.75 * P +  6930)
      else if(P < 180000)  1/P * (0.75 * P +  6930)
      else                 1/P * (0.64 * P + 26730)
    } else {
      if     (P >   5400)  1/P * (0.93 * P +  1260)
      else if(P >   3600)  1/P * (1.02 * P +   774)
      else if(P >   2200)  1/P * (1.01 * P +   810)
      else if(P >   1400)  1/P * (0.99 * P +   854)
      else if(P >    720)  1/P * (0.97 * P +   882)
      else                 1/P * (1.66 * P +   385.2)
    }
  if(tmp < 2.195) return(tmp) else return((tmp - 2.195) * 0.6 + 2.195)
}

hosei[["H14"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 21000) {
      if     (P <  52000)  1/P * (0.83 * P +  3570)
      else if(P <  84000)  1/P * (0.76 * P +  7210)
      else if(P < 210000)  1/P * (0.75 * P +  8050)
      else                 1/P * (0.64 * P + 31150)
    } else {
      if     (P >   6300)  1/P * (0.93 * P +  1470)
      else if(P >   4200)  1/P * (1.02 * P +   903)
      else if(P >   2500)  1/P * (1.03 * P +   861)
      else if(P >   1700)  1/P * (0.94 * P +  1086)
      else if(P >    840)  1/P * (1.03 * P +   933)
      else                 1/P * (1.64 * P +   420.6)
    }
  if(tmp < 2.141) return(tmp) else return((tmp - 2.141) * 0.4 + 2.141)
}

hosei[["H15"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 21000) {
      if     (P <  52000)  1/P * (0.83 * P +  3570)
      else if(P <  84000)  1/P * (0.75 * P +  7730)
      else if(P < 210000)  1/P * (0.75 * P +  7730)
      else                 1/P * (0.64 * P + 30830)
    } else {
      if     (P >   6300)  1/P * (0.93 * P +  1470)
      else if(P >   4200)  1/P * (1.02 * P +   903)
      else if(P >   2500)  1/P * (1.03 * P +   861)
      else if(P >   1700)  1/P * (0.98 * P +   986)
      else if(P >    840)  1/P * (1.05 * P +   867)
      else                 1/P * (1.61 * P +   396.6)
    }
  if(tmp < 2.082) return(tmp) else return((tmp - 2.082) * 0.2 + 2.082)
}

hosei[["H16"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 21000) {
      if     (P <  52000)  1/P * (0.83 * P +  3570)
      else if(P <  84000)  1/P * (0.76 * P +  7210)
      else if(P < 210000)  1/P * (0.75 * P +  8050)
      else                 1/P * (0.69 * P + 20650)
    } else {
      if     (P >   6300)  1/P * (0.93 * P +  1470)
      else if(P >   4200)  1/P * (1.02 * P +   903)
      else if(P >   2500)  1/P * (1.04 * P +   819)
      else if(P >   1700)  1/P * (1.01 * P +   894)
      else if(P >    840)  1/P * (1.07 * P +   792)
      else                 1/P * (1.59 * P +   355.2)
    }
  if(tmp < 2.013) return(tmp) else return(2.013)
}

hosei[["H17"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 21000) {
      if     (P <  52000)  1/P * (0.83 * P +  3570)
      else if(P <  84000)  1/P * (0.77 * P +  6690)
      else if(P < 210000)  1/P * (0.76 * P +  7530)
      else                 1/P * (0.70 * P + 20130)
    } else {
      if     (P >   6300)  1/P * (0.93 * P +  1470)
      else if(P >   4200)  1/P * (1.04 * P +   777)
      else if(P >   2500)  1/P * (1.04 * P +   777)
      else if(P >   1700)  1/P * (1.00 * P +   877)
      else                 1/P * (1.06 * P +   775)
    }
  if(tmp < 1.983) return(tmp) else return(1.983)
}

hosei[["H18"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 21000) {
      if     (P <  52000)  1/P * (0.84 * P +  3360)
      else if(P <  84000)  1/P * (0.77 * P +  7000)
      else if(P < 210000)  1/P * (0.77 * P +  7000)
      else                 1/P * (0.71 * P + 19600)
    } else {
      if     (P >   6300)  1/P * (0.93 * P +  1470)
      else if(P >   4200)  1/P * (1.07 * P +   588)
      else if(P >   2500)  1/P * (1.03 * P +   756)
      else if(P >   1700)  1/P * (1.01 * P +   806)
      else                 1/P * (1.06 * P +   721)
    }
  if(tmp < 1.918) return(tmp) else return(1.918)
}

hosei[["H19"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 24000) {
      if     (P <  60000)  1/P * (0.84 * P +  3840)
      else if(P <  98000)  1/P * (0.76 * P +  8640)
      else if(P < 245000)  1/P * (0.77 * P +  7660)
      else                 1/P * (0.71 * P + 22360)
    } else {
      if     (P >   7400)  1/P * (0.94 * P +  1440)
      else if(P >   4900)  1/P * (1.02 * P +   848)
      else if(P >   2900)  1/P * (1.00 * P +   946)
      else if(P >   2000)  1/P * (1.01 * P +   917)
      else                 1/P * (1.04 * P +   857)
    }
  if(tmp < 1.992) return(tmp) else return(1.992)
}

hosei[["H20"]]$over65.pop <- function(P) {
  if(is.na(P)) return(NA)
  else 
    tmp <- if(P > 24000) {
      if     (P <  60000)  1/P * (0.84 * P +  3840)
      else if(P <  98000)  1/P * (0.78 * P +  7440)
      else if(P < 245000)  1/P * (0.78 * P +  7440)
      else                 1/P * (0.72 * P + 22140)
    } else {
      if     (P >   7400)  1/P * (0.94 * P +  1440)
      else if(P >   4900)  1/P * (1.01 * P +   922)
      else if(P >   2900)  1/P * (1.01 * P +   922)
      else if(P >   2000)  1/P * (1.03 * P +   864)
      else                 1/P * (1.05 * P +   824)
    }
  if(tmp < 1.966) return(tmp) else return(1.966)
}

hosei[["H9"]]$elderly.investment.adj <- function(A)
  18000/A * 0.3 + 0.7 # * B

hosei[["H13"]]$elderly.investment.adj <- function(A)
  18000/A * 0.26 + 0.74 # * B

hosei[["H14"]]$elderly.investment.adj <- function(A)
  21000/A * 0.24 + 0.76 # * B

hosei[["H15"]]$elderly.investment.adj <- function(A)
  21000/A * 0.22 + 0.78 # * B

hosei[["H16"]]$elderly.investment.adj <- hosei[["H15"]]$elderly.investment.adj
hosei[["H17"]]$elderly.investment.adj <- hosei[["H16"]]$elderly.investment.adj
hosei[["H18"]]$elderly.investment.adj <- hosei[["H17"]]$elderly.investment.adj
hosei[["H19"]]$elderly.investment.adj <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$elderly.investment.adj <- function(A) if(is.na(A)) NA else 0


### Agriculture

hosei[["S43"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 4600)
    (                           4600   *  1.00
     + max(0,  -4600 + min(P,   6000)) *  0.79
     + max(0,  -6000 + min(P,   8000)) *  0.88
     + max(0,  -8000 + min(P,  12000)) *  0.89
     + max(0, -12000 +     P         ) *  0.90)
  else
    (      P                           *  1.00
     + min(M <- 4600 - P,     1600)    *  0.08
     + max(0,  -1600 + min(M, 3100))   *  0.13
     + max(0,  -3100 + min(M, 3900))   * -0.06
     + max(0,  -3900 +     M       )   * -0.06)
} / P

hosei[["S47"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 4550)
    (                           4550   *  1.00
     + max(0,  -4550 + min(P,   6000)) *  0.82
     + max(0,  -6000 + min(P,  12000)) *  0.90
     + max(0, -12000 +     P         ) *  0.83)
  else
    (      P                           *  1.00
     + min(M <- 4550 - P,     1600)    *  0.10
     + max(0,  -1600 + min(M, 3100))   *  0.09
     + max(0,  -3100 + min(M, 3900))   * -0.01
     + max(0,  -3900 +     M       )   *  0.02)
} / P

hosei[["H3"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 4500)
    (                           4500   *  1.00
     + max(0,  -4500 + min(P,   6000)) *  0.84
     + max(0,  -6000 + min(P,   8000)) *  0.91
     + max(0,  -8000 + min(P,  12000)) *  0.90
     + max(0, -12000 +     P         ) *  0.87)
  else
    (      P                           *  1.00
     + min(M <- 4500 - P,     1500)    *  0.14
     + max(0,  -1500 + min(M, 3000))   *  0.09
     + max(0,  -3000 + min(M, 3800))   * -0.02
     + max(0,  -3800 +     M       )   *  0.01)
} / P

hosei[["H4"]]$agriculture.pop <- function(P) {
  if     (P <   700) 1/P * (0.98 * P + 329)
  else if(P <  1500) 1/P * (1.00 * P + 315)
  else if(P <  3000) 1/P * (0.93 * P + 420)
  else if(P <  4500) 1/P * (0.86 * P + 630)
  else if(P <  6000) 1/P * (0.91 * P + 405)
  else if(P <  8000) 1/P * (0.91 * P + 405)
  else if(P < 12000) 1/P * (0.92 * P + 325)
  else               1/P * (0.92 * P + 325)
}

hosei[["H9"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <   700) 1/P * (0.93 * P + 283)
  else if(P <  1500) 1/P * (0.97 * P + 255)
  else if(P <  2500) 1/P * (0.94 * P + 300)
  else if(P <  4000) 1/P * (0.90 * P + 400)
  else if(P <  5500) 1/P * (0.83 * P + 680)
  else if(P <  7500) 1/P * (0.87 * P + 460)
  else if(P < 10000) 1/P * (0.88 * P + 385)
  else               1/P * (0.87 * P + 485)
}

#reg <- nls(log(hosei[["H9"]]$agriculture.pop(muni.points.pop * 4000/100000)) ~ log(a * muni.points.pop * 4000/100000 + b) - log(muni.points.pop * 4000/100000))  # .89 * P + 298
#coef(reg)[2] / coef(reg)[1] * 100000/4000  # 8325

hosei[["H13"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  600) 1/P * (1.00 * P + 254)
    else if(P < 1300) 1/P * (0.89 * P + 320)
    else if(P < 2000) 1/P * (0.94 * P + 255)
    else if(P < 3500) 1/P * (0.91 * P + 315)
    else if(P < 5000) 1/P * (0.87 * P + 455)
    else if(P < 6500) 1/P * (0.79 * P + 855)
    else if(P < 9000) 1/P * (0.81 * P + 725)
    else              1/P * (0.84 * P + 455)
  , 2.800)
}

hosei[["H14"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  600) 1/P * (1.04 * P + 217)
    else if(P < 1300) 1/P * (0.90 * P + 301)
    else if(P < 2000) 1/P * (0.97 * P + 210)
    else if(P < 3500) 1/P * (0.90 * P + 350)
    else if(P < 5000) 1/P * (0.83 * P + 595)
    else if(P < 6500) 1/P * (0.79 * P + 795)
    else if(P < 9000) 1/P * (0.80 * P + 730)
    else              1/P * (0.83 * P + 460)
  , 2.487)
}

hosei[["H15"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  600) 1/P * (1.08 * P + 178)
    else if(P < 1300) 1/P * (0.91 * P + 280)
    else if(P < 2000) 1/P * (0.96 * P + 215)
    else if(P < 3500) 1/P * (0.91 * P + 315)
    else if(P < 5000) 1/P * (0.80 * P + 700)
    else if(P < 6500) 1/P * (0.77 * P + 850)
    else if(P < 9000) 1/P * (0.79 * P + 720)
    else              1/P * (0.81 * P + 540)
  , 2.267)
}

hosei[["H16"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  600) 1/P * (1.12 * P + 140)
    else if(P < 1300) 1/P * (0.92 * P + 260)
    else if(P < 2000) 1/P * (0.97 * P + 195)
    else if(P < 3500) 1/P * (0.91 * P + 315)
    else if(P < 5000) 1/P * (0.75 * P + 875)
    else if(P < 6500) 1/P * (0.77 * P + 775)
    else if(P < 9000) 1/P * (0.78 * P + 710)
    else              1/P * (0.81 * P + 440)
  , 2.053)
}

hosei[["H17"]]$agriculture.pop <- hosei[["H16"]]$agriculture.pop

hosei[["H18"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  500) 1/P * (0.95 * P + 215)
    else if(P < 1100) 1/P * (0.93 * P + 225)
    else if(P < 1700) 1/P * (0.97 * P + 181)
    else if(P < 3000) 1/P * (0.90 * P + 300)
    else if(P < 4500) 1/P * (0.73 * P + 810)
    else if(P < 5500) 1/P * (0.76 * P + 675)
    else if(P < 7500) 1/P * (0.72 * P + 895)
    else              1/P * (0.81 * P + 220)
  , 2.383)
}

hosei[["H19"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  500) 1/P * (0.97 * P + 167)
    else if(P < 1100) 1/P * (0.94 * P + 182)
    else if(P < 1700) 1/P * (0.98 * P + 138)
    else if(P < 3000) 1/P * (0.92 * P + 240)
    else if(P < 4500) 1/P * (0.79 * P + 630)
    else if(P < 5500) 1/P * (0.81 * P + 540)
    else if(P < 7500) 1/P * (0.78 * P + 705)
    else              1/P * (0.85 * P + 180)
  , 2.383)
}

hosei[["H20"]]$agriculture.pop <- function(P) {
  if(is.na(P)) NA
  else min(
    if     (P <  500) 1/P * (1.00 * P + 173)
    else if(P < 1100) 1/P * (0.97 * P + 188)
    else if(P < 1700) 1/P * (0.85 * P + 320)
    else if(P < 3000) 1/P * (0.95 * P + 150)
    else if(P < 4500) 1/P * (0.80 * P + 600)
    else if(P < 5500) 1/P * (0.83 * P + 465)
    else if(P < 7500) 1/P * (0.76 * P + 850)
    else              1/P * (0.85 * P + 175)
  , 2.383)
}


### Commerce


hosei[["S47"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.86
     + max(0,  -250000 +     P          ) *  0.82)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.27
     + max(0,   -70000 + min(M, 80000))   * -0.23
     + max(0,   -80000 + min(M, 88000))   * -0.16
     + max(0,   -88000 + min(M, 96000))   * -0.96
     + max(0,   -96000 +     M        )   * -0.96)
} / P

hosei[["S43"]]$commerce.pop <- hosei[["S47"]]$commerce.pop #FIXME:  uses number of commercial/industrial employees - do I have this?

hosei[["H3"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.90
     + max(0,  -250000 + min(P,  400000)) *  0.76
     + max(0,  -400000 + min(P, 1000000)) *  0.83
     + max(0, -1000000 +     P          ) *  0.83)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.29
     + max(0,   -70000 + min(M, 80000))   * -0.16
     + max(0,   -80000 + min(M, 88000))   * -0.18
     + max(0,   -88000 +     M        )   * -0.95)
} / P

hosei[["H4"]]$commerce.pop <- function(P) {
  if     (P <    4000)  1/P * (1.98 * P +   5960)
  else if(P <    8000)  1/P * (1.99 * P +   5920)
  else if(P <   12000)  1/P * (1.98 * P +   6000)
  else if(P <   20000)  1/P * (1.08 * P +  16800)
  else if(P <   30000)  1/P * (1.12 * P +  16000)
  else if(P <  100000)  1/P * (0.72 * P +  28000)
  else if(P <  250000)  1/P * (0.90 * P +  10000)
  else if(P <  400000)  1/P * (0.76 * P +  45000)
  else if(P < 1000000)  1/P * (0.82 * P +  21000)
  else                  1/P * (0.83 * P +  11000)
}

hosei[["H9"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (2.03 * P +   6120)
  else if(P <    8000)  1/P * (2.07 * P +   5960)
  else if(P <   12000)  1/P * (1.98 * P +   6680)
  else if(P <   20000)  1/P * (1.02 * P +  18200)
  else if(P <   30000)  1/P * (1.10 * P +  16600)
  else if(P <  100000)  1/P * (0.72 * P +  28000)
  else if(P <  250000)  1/P * (0.89 * P +  11000)
  else if(P <  400000)  1/P * (0.75 * P +  46000)
  else if(P < 1000000)  1/P * (0.82 * P +  18000)
  else                  1/P * (0.83 * P +   8000)
}

#reg <- nls(log(hosei[["H9"]]$commerce.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .88 * P + 15360
#coef(reg)[2] / coef(reg)[1]  # 17493

hosei[["H13"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (2.06 * P +   5680)
           else if(P <   12000)  1/P * (1.95 * P +   6560)
           else if(P <   20000)  1/P * (1.03 * P +  17600)
           else if(P <   30000)  1/P * (1.07 * P +  16800)
           else if(P <  100000)  1/P * (0.73 * P +  27000)
           else if(P <  250000)  1/P * (0.90 * P +  10000)
           else if(P <  400000)  1/P * (0.76 * P +  45000)
           else if(P < 1000000)  1/P * (0.82 * P +  21000)
           else                  1/P * (0.83 * P +  11000)
           , 3.480)
}

hosei[["H14"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.97 * P +   4580)
           else if(P <   12000)  1/P * (1.86 * P +   5460)
           else if(P <   20000)  1/P * (1.14 * P +  14100)
           else if(P <   30000)  1/P * (1.13 * P +  14300)
           else if(P <  100000)  1/P * (0.74 * P +  26000)
           else if(P <  250000)  1/P * (0.87 * P +  13000)
           else if(P <  400000)  1/P * (0.74 * P +  45500)
           else if(P < 1000000)  1/P * (0.81 * P +  17500)
           else                  1/P * (0.81 * P +  17500)
           , 3.120)
}

hosei[["H15"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.89 * P +   3440)
           else if(P <   12000)  1/P * (1.76 * P +   4480)
           else if(P <   20000)  1/P * (1.25 * P +  10600)
           else if(P <   30000)  1/P * (1.19 * P +  11800)
           else if(P <  100000)  1/P * (0.75 * P +  25000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P <  400000)  1/P * (0.72 * P +  46000)
           else if(P < 1000000)  1/P * (0.79 * P +  18000)
           else                  1/P * (0.80 * P +   8000)
           , 2.750)
}

hosei[["H16"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.80 * P +   2360)
           else if(P <   12000)  1/P * (1.67 * P +   3400)
           else if(P <   20000)  1/P * (1.37 * P +   7000)
           else if(P <   30000)  1/P * (1.24 * P +   9600)
           else if(P <  100000)  1/P * (0.76 * P +  24000)
           else if(P <  250000)  1/P * (0.81 * P +  19000)
           else if(P <  400000)  1/P * (0.71 * P +  44000)
           else if(P < 1000000)  1/P * (0.77 * P +  20000)
           else                  1/P * (0.79 * P +      0)
           , 2.390)
}

hosei[["H17"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.80 * P +   2280)
           else if(P <   12000)  1/P * (1.66 * P +   3400)
           else if(P <   20000)  1/P * (1.36 * P +   7000)
           else if(P <   30000)  1/P * (1.19 * P +  10400)
           else if(P <  100000)  1/P * (0.77 * P +  23000)
           else if(P <  250000)  1/P * (0.80 * P +  20000)
           else if(P <  400000)  1/P * (0.71 * P +  42500)
           else if(P < 1000000)  1/P * (0.77 * P +  18500)
           else                  1/P * (0.78 * P +   8500)
           , 2.370)
}

hosei[["H18"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.81 * P +   2620)
           else if(P <   12000)  1/P * (1.55 * P +   4700)
           else if(P <   20000)  1/P * (1.35 * P +   7100)
           else if(P <   30000)  1/P * (1.20 * P +  10100)
           else if(P <  100000)  1/P * (0.77 * P +  23000)
           else if(P <  250000)  1/P * (0.80 * P +  20000)
           else if(P <  400000)  1/P * (0.71 * P +  42500)
           else if(P < 1000000)  1/P * (0.77 * P +  18500)
           else                  1/P * (0.78 * P +   8500)
           , 2.465)
}

hosei[["H19"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.80 * P +   2680)
           else if(P <   12000)  1/P * (1.55 * P +   4680)
           else if(P <   20000)  1/P * (1.34 * P +   7200)
           else if(P <   30000)  1/P * (1.21 * P +   9800)
           else if(P <  100000)  1/P * (0.77 * P +  23000)
           else if(P <  250000)  1/P * (0.80 * P +  20000)
           else if(P <  400000)  1/P * (0.71 * P +  42500)
           else if(P < 1000000)  1/P * (0.77 * P +  18500)
           else                  1/P * (0.78 * P +   8500)
           , 2.470)
}

hosei[["H20"]]$commerce.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (1.80 * P +   2700)
           else if(P <   12000)  1/P * (1.55 * P +   4700)
           else if(P <   20000)  1/P * (1.35 * P +   7100)
           else if(P <   30000)  1/P * (1.20 * P +  10100)
           else if(P <  100000)  1/P * (0.77 * P +  23000)
           else if(P <  250000)  1/P * (0.81 * P +  19000)
           else if(P <  400000)  1/P * (0.71 * P +  44000)
           else if(P < 1000000)  1/P * (0.77 * P +  20000)
           else                  1/P * (0.78 * P +  10000)
           , 2.475)
}

hosei[["S43"]]$primary.type <- function(A, B, C, D) 1
hosei[["S47"]]$primary.type <- function(A, B, C, D) 1
hosei[["H3"]]$primary.type <- function(A, B, C, D) 1
  
hosei[["H4"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 2.88 + C * 0.59 + D * 0.20) * 0.35 + 0.65 else 1

hosei[["H9"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.52 + C * 0.43 + D * 0.03) else 1

hosei[["H13"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.87 + C * 0.33 + D * 0.02) else 1

hosei[["H14"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.63 + C * 0.30 + D * 0.02) else 1

hosei[["H15"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.64 + C * 0.30 + D * 0.02) else 1

hosei[["H16"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.52 + C * 0.29 + D * 0.01) else 1

hosei[["H17"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.37 + C * 0.28 + D * 0.01) else 1

hosei[["H18"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.29 + C * 0.26 + D * 0.01) else 1

hosei[["H19"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.09 + C * 0.30) else 1

hosei[["H20"]]$primary.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.10 + C * 0.29) else 1

hosei[["S43"]]$primary.investment.type <- function(A, B, C, D) 1  #is this a prefectural function?

hosei[["S47"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) max(B/A, 0.220) * 1.2 + max(C/A, 0.500) * 1.1 + max(D/A, 0.280) * 1.3 - 1.178 else 1

hosei[["H3"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * ((B * 3.05 * 0.81 + C * 0.47 * 1.07 + D * 0.40 * 1.07) * 0.65 + 0.35) * 0.86 else 1

hosei[["H4"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.56 + C * 0.36 + D * 0.36) * 0.5 + 0.5 else 1

hosei[["H9"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.57 + C * 0.36 + D * 0.36) else 1

hosei[["H13"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.04 + C * 0.24 + D * 0.24) else 1

hosei[["H14"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.55 + C * 0.27 + D * 0.27) else 1 

hosei[["H15"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.51 + C * 0.27 + D * 0.27) else 1

hosei[["H16"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 4.01 + C * 0.35 + D * 0.26) else 1

hosei[["H17"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.94 + C * 0.35 + D * 0.18) else 1

hosei[["H18"]]$primary.investment.type <- function(A, B, C, D)
  if(A > 0) 1/A * (B * 3.90 + C * 0.36 + D * 0.10) else 1

hosei[["H19"]]$primary.investment.type <- function(A, B, C, D) 0
hosei[["H20"]]$primary.investment.type <- function(A, B, C, D) 0


### Planning


hosei[["S43"]]$planning.pop <- function(P) if(is.na(P)) NA else 0
hosei[["S47"]]$planning.pop <- function(P) if(is.na(P)) NA else 0
hosei[["H3"]]$planning.pop <- function(P) if(is.na(P)) NA else 0

hosei[["H4"]]$planning.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (3.05 * P +  3300)
  else if(P <    8000)  1/P * (0.85 * P + 12100)
  else if(P <   12000)  1/P * (-0.01 * P + 18980)
  else if(P <   20000)  1/P * (0.68 * P + 10700)
  else if(P <   30000)  1/P * (0.85 * P +  7300)
  else if(P <  100000)  1/P * (0.96 * P +  4000)
  else if(P <  250000)  1/P * (0.91 * P +  9000)
  else if(P <  400000)  1/P * (0.80 * P + 36500)
  else if(P < 1000000)  1/P * (0.68 * P + 84500)
  else                  1/P * (0.74 * P + 24500)
}

hosei[["H9"]]$planning.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (3.00 * P +  3280)
  else if(P <    8000)  1/P * (0.87 * P + 11800)
  else if(P <   12000)  1/P * (0.06 * P + 18280)
  else if(P <   20000)  1/P * (0.90 * P +  8200)
  else if(P <   30000)  1/P * (0.87 * P +  8800)
  else if(P <  100000)  1/P * (0.93 * P +  7000)
  else if(P <  250000)  1/P * (0.89 * P + 11000)
  else if(P <  400000)  1/P * (0.78 * P + 38500)
  else if(P < 1000000)  1/P * (0.67 * P + 82500)
  else                  1/P * (0.72 * P + 32500)
}

#reg <- nls(log(hosei[["H9"]]$planning.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .80 * P + 11450
#coef(reg)[2] / coef(reg)[1]  # 14305

hosei[["H13"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.80 * P + 11980)
           else if(P <   12000)  1/P * (0.39 * P + 15260)
           else if(P <   20000)  1/P * (0.82 * P + 10100)
           else if(P <   30000)  1/P * (0.84 * P +  9700)
           else if(P <  100000)  1/P * (0.93 * P +  7000)
           else if(P <  250000)  1/P * (0.88 * P + 12000)
           else if(P <  400000)  1/P * (0.78 * P + 37000)
           else if(P < 1000000)  1/P * (0.68 * P + 77000)
           else                  1/P * (0.73 * P + 27000)
           , 3.795)
}

hosei[["H14"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.85 * P + 11320)
           else if(P <   12000)  1/P * (0.38 * P + 15080)
           else if(P <   20000)  1/P * (0.82 * P +  9800)
           else if(P <   30000)  1/P * (0.87 * P +  8800)
           else if(P <  100000)  1/P * (0.93 * P +  7000)
           else if(P <  250000)  1/P * (0.89 * P + 11000)
           else if(P <  400000)  1/P * (0.79 * P + 36000)
           else if(P < 1000000)  1/P * (0.68 * P + 80000)
           else                  1/P * (0.74 * P + 20000)
           , 3.680)
}

hosei[["H15"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.92 * P + 10560)
           else if(P <   12000)  1/P * (0.35 * P + 15120)
           else if(P <   20000)  1/P * (0.81 * P +  9600)
           else if(P <   30000)  1/P * (0.84 * P +  9000)
           else if(P <  100000)  1/P * (0.94 * P +  6000)
           else if(P <  250000)  1/P * (0.88 * P + 12000)
           else if(P <  400000)  1/P * (0.79 * P + 34500)
           else if(P < 1000000)  1/P * (0.68 * P + 78500)
           else                  1/P * (0.73 * P + 28500)
           , 3.560)
}

hosei[["H16"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.97 * P +  9920)
           else if(P <   12000)  1/P * (0.35 * P + 14880)
           else if(P <   20000)  1/P * (0.79 * P +  9600)
           else if(P <   30000)  1/P * (0.88 * P +  7800)
           else if(P <  100000)  1/P * (0.94 * P +  6000)
           else if(P <  250000)  1/P * (0.87 * P + 13000)
           else if(P <  400000)  1/P * (0.78 * P + 35500)
           else if(P < 1000000)  1/P * (0.68 * P + 75500)
           else                  1/P * (0.73 * P + 25500)
           , 3.450)
}

hosei[["H17"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.98 * P +  9760)
           else if(P <   12000)  1/P * (0.35 * P + 14800)
           else if(P <   20000)  1/P * (0.80 * P +  9400)
           else if(P <   30000)  1/P * (0.88 * P +  7800)
           else if(P <  100000)  1/P * (0.94 * P +  6000)
           else if(P <  250000)  1/P * (0.87 * P + 13000)
           else if(P <  400000)  1/P * (0.78 * P + 35500)
           else if(P < 1000000)  1/P * (0.68 * P + 75500)
           else                  1/P * (0.73 * P + 25500)
           , 3.420)
}

hosei[["H18"]]$planning.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <    8000)  1/P * (0.98 * P +  9800)
           else if(P <   12000)  1/P * (0.34 * P + 14920)
           else if(P <   20000)  1/P * (0.80 * P +  9400)
           else if(P <   30000)  1/P * (0.88 * P +  7800)
           else if(P <  100000)  1/P * (0.94 * P +  6000)
           else if(P <  250000)  1/P * (0.86 * P + 14000)
           else if(P <  400000)  1/P * (0.78 * P + 34000)
           else if(P < 1000000)  1/P * (0.68 * P + 74000)
           else                  1/P * (0.72 * P + 34000)
           , 3.420)
}

hosei[["H19"]]$planning.pop <- function(P) if(is.na(P)) NA else 0
hosei[["H20"]]$planning.pop <- function(P) if(is.na(P)) NA else 0

hosei[["S43"]]$planning.density <- function(P) if(is.na(P)) NA else 0
hosei[["S47"]]$planning.density <- function(P) if(is.na(P)) NA else 0
hosei[["H3"]]$planning.density <- function(P) if(is.na(P)) NA else 0

hosei[["H4"]]$planning.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.02 * P +  1.0)
    else if(P < 100) 1/P * (0.99 * P +  2.5)
    else if(P < 150) 1/P * (0.98 * P +  3.5)
    else if(P < 200) 1/P * (0.99 * P +  2.0)
    else                                1
  }
}

hosei[["H9"]]$planning.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.01 * P +  0.5)
    else if(P < 100) 1/P * (1.01 * P +  0.5)
    else if(P < 150) 1/P * (0.99 * P +  2.5)
    else if(P < 200) 1/P * (0.98 * P +  4.0)
    else                                1
  }
}

hosei[["S43"]]$planning.investment.adj <- function(A, x) if(is.na(A)) NA else 0
hosei[["S47"]]$planning.investment.adj <- function(A, x) if(is.na(A)) NA else 0
hosei[["H3"]]$planning.investment.adj <- function(A, x) if(is.na(A)) NA else 0

hosei[["H4"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.054 + 9.355)
    else if(A < 5000)   (100000/A * 0.107 + 3.987)
    else if(A < 10000)  (100000/A * 0.215 + 1.837)
    else if(A < 50000)  (100000/A * 0.236 + 1.625)
    else if(A < 100000) (100000/A * 0.299 + 1.501)
    else if(A < 300000) (100000/A * 1.400 + 0.400)
    else if(A < 500000) (100000/A * 1.393 + 0.403)
    else                (100000/A * 1.393 + 0.403)
  } * max(B/0.120 * 0.25 + 0.75, 1))
}

hosei[["H9"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.054 + 9.716)
    else if(A < 5000)   (100000/A * 0.110 + 4.116)
    else if(A < 10000)  (100000/A * 0.221 + 1.896)
    else if(A < 50000)  (100000/A * 0.243 + 1.676)
    else if(A < 100000) (100000/A * 0.308 + 1.546)
    else if(A < 300000) (100000/A * 1.440 + 0.414)
    else if(A < 500000) (100000/A * 1.440 + 0.414)
    else                (100000/A * 1.545 + 0.393)
  } * max(B/0.145 * 0.25 + 0.75, 1))
}

hosei[["H13"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.044 + 7.714)
    else if(A < 10000)  (100000/A * 0.096 + 2.514)
    else if(A < 100000) (100000/A * 0.195 + 1.524)
    else                (100000/A * 1.389 + 0.330)
  } * max(B/0.145 * 0.25 + 0.75, 1))
}

hosei[["H14"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.051 + 8.917)
    else if(A < 10000)  (100000/A * 0.111 + 2.917)
    else if(A < 100000) (100000/A * 0.226 + 1.767)
    else                (100000/A * 1.611 + 0.382)
  } * max(B/0.173 * 0.25 + 0.75, 1))
}

hosei[["H15"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.043 + 7.672)
    else if(A < 10000)  (100000/A * 0.095 + 2.472)
    else if(A < 100000) (100000/A * 0.192 + 1.502)
    else                (100000/A * 1.369 + 0.325)
  } * max(B/0.173 * 0.25 + 0.75, 1))
}

hosei[["H16"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.034 + 6.182)
    else if(A < 10000)  (100000/A * 0.076 + 1.982)
    else if(A < 100000) (100000/A * 0.154 + 1.202)
    else                (100000/A * 1.096 + 0.260)
  } * max(B/0.173 * 0.25 + 0.75, 1))
}

hosei[["H17"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.027 + 4.981)
    else if(A < 10000)  (100000/A * 0.061 + 1.581)
    else if(A < 100000) (100000/A * 0.123 + 0.961)
    else                (100000/A * 0.876 + 0.208)
  } * max(B/0.173 * 0.25 + 0.75, 1))
}

hosei[["H18"]]$planning.investment.adj <- function(A, x) {
  B <- x/A # fraction over 65
  if(is.na(A)) return(NA)
  else return({
    if(A < 1000)        (100000/A * 0.027 + 4.357)
    else if(A < 10000)  (100000/A * 0.056 + 1.457)
    else if(A < 100000) (100000/A * 0.113 + 0.887)
    else                (100000/A * 0.809 + 0.191)
  } * max(B/0.173 * 0.25 + 0.75, 1))
}

hosei[["H19"]]$planning.investment.adj <- function(A, x) if(is.na(A)) NA else 0
hosei[["H20"]]$planning.investment.adj <- function(A, x) if(is.na(A)) NA else 0


### Tax collection


hosei[["S47"]]$taxcollection.pop <- function(P) {  #FIXME:  should actually be on tax money collected...
  if(is.na(P)) NA
  else if(P > 31000)
    (                            31000   *  1.00
     + max(0,  -31000 + min(P,  100000)) *  0.98
     + max(0, -100000 +     P          ) *  0.96)
  else
    (      P                             *  1.00
     + min(M <- 31000 - P,     28000)    *  0.02
     + max(0,  -28000 +     M        )   *  0.03)
} / P

hosei[["S43"]]$taxcollection.pop <- hosei[["S47"]]$taxcollection.pop #FIXME: there were actually changes

hosei[["H3"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 31000)
    (                            31000   *  1.00
     + max(0,  -31000 + min(P,  100000)) *  0.82
     + max(0, -100000 +     P          ) *  0.88)
  else
    (      P                             *  1.00
     + min(M <- 31000 - P,     21000)    *  0.08
     + max(0,  -21000 + min(M, 28000))   * -0.03
     + max(0,  -28000 +     M        )   * -0.29)
} / P

hosei[["H4"]]$taxcollection.pop <- function(P) {
  if     (P <   3000) 1/P * (1.36 * P +   590)
  else if(P <  10000) 1/P * (1.09 * P +  1400)
  else if(P <  33000) 1/P * (0.90 * P +  3300)
  else if(P < 100000) 1/P * (0.83 * P +  5610)
  else if(P < 300000) 1/P * (0.88 * P +   610)
  else                1/P * (0.88 * P +   610)
}

hosei[["H9"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <   3000) 1/P * (1.36 * P +   760)
  else if(P <  10000) 1/P * (1.13 * P +  1450)
  else if(P <  33000) 1/P * (0.89 * P +  3850)
  else if(P < 100000) 1/P * (0.81 * P +  6650)
  else if(P < 300000) 1/P * (0.86 * P +  1650)
  else                1/P * (0.83 * P + 10650)
}

#reg <- nls(log(hosei[["H9"]]$taxcollection.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .87 * P + 3081
#coef(reg)[2] / coef(reg)[1]  # 3553

hosei[["H13"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.39 * P +   710)
           else if(P <  10000) 1/P * (1.16 * P +  1400)
           else if(P <  35000) 1/P * (0.88 * P +  4200)
           else if(P < 100000) 1/P * (0.79 * P +  7350)
           else if(P < 300000) 1/P * (0.85 * P +  1350)
           else                1/P * (0.80 * P + 16350)
           , 2.100)
}

hosei[["H14"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.31 * P +   710)
           else if(P <  11000) 1/P * (1.12 * P +  1280)
           else if(P <  37000) 1/P * (0.90 * P +  3700)
           else if(P < 106000) 1/P * (0.78 * P +  8140)
           else if(P < 317000) 1/P * (0.84 * P +  1780)
           else                1/P * (0.79 * P + 17630)
           , 2.020)
}

hosei[["H15"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.24 * P +   700)
           else if(P <  11000) 1/P * (1.05 * P +  1270)
           else if(P <  37000) 1/P * (0.93 * P +  2590)
           else if(P < 106000) 1/P * (0.76 * P +  8800)
           else if(P < 317000) 1/P * (0.83 * P +  1460)
           else                1/P * (0.78 * P + 17310)
           , 1.940)
}

hosei[["H16"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.17 * P +   690)
           else if(P <  11000) 1/P * (0.98 * P +  1260)
           else if(P <  37000) 1/P * (0.96 * P +  1480)
           else if(P < 106000) 1/P * (0.74 * P +  9620)
           else if(P < 317000) 1/P * (0.81 * P +  2200)
           else                1/P * (0.78 * P + 11710)
           , 1.860)
}

hosei[["H17"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.13 * P +   710)
           else if(P <  11000) 1/P * (0.96 * P +  1220)
           else if(P <  37000) 1/P * (0.97 * P +  1110)
           else if(P < 106000) 1/P * (0.74 * P +  9620)
           else if(P < 317000) 1/P * (0.82 * P +  1140)
           else                1/P * (0.77 * P + 16990)
           , 1.840)
}
###FIXME: deleted the h18 table by accident, I think...
hosei[["H18"]]$taxcollection.pop <- hosei[["H17"]]$taxcollection.pop

hosei[["H19"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.17 * P +   750)
           else if(P <  12000) 1/P * (0.92 * P +  1500)
           else if(P <  39000) 1/P * (0.98 * P +   780)
           else if(P < 112000) 1/P * (0.72 * P + 10920)
           else if(P < 334000) 1/P * (0.78 * P +  4200)
           else                1/P * (0.77 * P +  7540)
           , 1.920)
}

hosei[["H20"]]$taxcollection.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.17 * P +   750)
           else if(P <  12000) 1/P * (0.92 * P +  1500)
           else if(P <  39000) 1/P * (0.98 * P +   780)
           else if(P < 112000) 1/P * (0.70 * P + 11700)
           else if(P < 334000) 1/P * (0.77 * P +  3860)
           else                1/P * (0.76 * P +  7200)
           , 1.920)
}

hosei[["S43"]]$taxcollection.density <- function(P) {    #also tax base and family density adjustments...
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.12
        + max(0,    -50 + min(M, 100)) *  0.15
        + max(0,   -100 + min(M, 150)) *  0.02
        + max(0,   -150 +     M      ) * -0.14
        ) / P
}

hosei[["S47"]]$taxcollection.density <- function(P) {    #also tax base and family density adjustments...
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.14
        + max(0,    -50 + min(M, 100)) *  0.16
        + max(0,   -100 + min(M, 150)) *  0.01
        + max(0,   -150 +     M      ) * -0.15
        ) / P
}

hosei[["H3"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.12
        + max(0,    -50 + min(M, 100)) *  0.19
        + max(0,   -100 + min(M, 150)) *  0.06
        + max(0,   -150 +     M      ) * -0.28
        ) / P
}

hosei[["H4"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.27 * P +  4.5)
    else if(P < 100) 1/P * (0.94 * P + 21.0)
    else if(P < 150) 1/P * (0.82 * P + 33.0)
    else if(P < 200) 1/P * (0.88 * P + 24.0)
    else                                1
  }
}

hosei[["H9"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.27 * P +  4.0)
    else if(P < 100) 1/P * (0.95 * P + 20.0)
    else if(P < 150) 1/P * (0.82 * P + 33.0)
    else if(P < 200) 1/P * (0.88 * P + 24.0)
    else                                1
  }
}

hosei[["H13"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.21 * P +  3.5)
    else if(P < 100) 1/P * (0.97 * P + 15.5)
    else if(P < 150) 1/P * (0.83 * P + 29.5)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}

hosei[["H14"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.23 * P +  3.0)
    else if(P < 100) 1/P * (0.97 * P + 16.0)
    else if(P < 150) 1/P * (0.82 * P + 31.0)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}

hosei[["H15"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.24 * P +  2.5)
    else if(P < 100) 1/P * (0.97 * P + 16.0)
    else if(P < 150) 1/P * (0.82 * P + 31.0)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}

hosei[["H16"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.23 * P +  2.5)
    else if(P < 100) 1/P * (0.98 * P + 15.0)
    else if(P < 150) 1/P * (0.82 * P + 31.0)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}

hosei[["H17"]]$taxcollection.density <- hosei[["H16"]]$taxcollection.density
hosei[["H18"]]$taxcollection.density <- hosei[["H17"]]$taxcollection.density

hosei[["H19"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.23 * P +  2.5)
    else if(P < 100) 1/P * (0.99 * P + 14.5)
    else if(P < 150) 1/P * (0.81 * P + 32.5)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}

hosei[["H20"]]$taxcollection.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.21 * P +  2.5)
    else if(P < 100) 1/P * (1.00 * P + 13.0)
    else if(P < 150) 1/P * (0.82 * P + 31.0)
    else if(P < 200) 1/P * (0.92 * P + 16.0)
    else                                1
  }
}


### Resident registration

## FIXME:  am I missing the earlier ones here, or was the item just added "late"?

hosei[["H13"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3300) 1/P * (1.32 * P +   380)
           else if(P <   5500) 1/P * (0.87 * P +  1865)
           else if(P <  11000) 1/P * (1.04 * P +   930)
           else if(P <  22000) 1/P * (1.05 * P +   820)
           else if(P <  38000) 1/P * (0.88 * P +  4560)
           else if(P <  55000) 1/P * (0.80 * P +  7600)
           else if(P < 110000) 1/P * (0.86 * P +  4300)
           else if(P < 330000) 1/P * (0.80 * P + 10900)
           else                1/P * (0.74 * P + 30700)
           , 1.665)
}

hosei[["H14"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3400) 1/P * (1.33 * P +   257)
           else if(P <   5600) 1/P * (0.91 * P +  1685)
           else if(P <  11300) 1/P * (1.03 * P +  1013)
           else if(P <  22600) 1/P * (1.04 * P +   900)
           else if(P <  39000) 1/P * (0.89 * P +  4290)
           else if(P <  56000) 1/P * (0.79 * P +  8190)
           else if(P < 113000) 1/P * (0.86 * P +  4270)
           else if(P < 339000) 1/P * (0.79 * P + 12180)
           else                1/P * (0.74 * P + 29130)
           , 1.564)
}

hosei[["H15"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3400) 1/P * (1.33 * P +   161)
           else if(P <   5600) 1/P * (0.93 * P +  1521)
           else if(P <  11300) 1/P * (1.05 * P +   849)
           else if(P <  22600) 1/P * (1.02 * P +  1188)
           else if(P <  39000) 1/P * (0.90 * P +  3900)
           else if(P <  56000) 1/P * (0.78 * P +  8580)
           else if(P < 113000) 1/P * (0.86 * P +  4100)
           else if(P < 339000) 1/P * (0.79 * P + 12010)
           else                1/P * (0.74 * P + 28960)
           , 1.476)
}

hosei[["H16"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3400) 1/P * (1.33 * P +    57)
           else if(P <   5600) 1/P * (0.98 * P +  1247)
           else if(P <  11300) 1/P * (1.04 * P +   911)
           else if(P <  22600) 1/P * (1.01 * P +  1250)
           else if(P <  39000) 1/P * (0.91 * P +  3510)
           else if(P <  56000) 1/P * (0.77 * P +  8970)
           else if(P < 113000) 1/P * (0.85 * P +  4490)
           else if(P < 339000) 1/P * (0.79 * P + 11270)
           else                1/P * (0.74 * P + 28220)
           , 1.382)
}

hosei[["H17"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3400) 1/P * (1.33 * P +    50)
           else if(P <   5600) 1/P * (0.96 * P +  1308)
           else if(P <  11300) 1/P * (1.04 * P +   860)
           else if(P <  22600) 1/P * (1.00 * P +  1312)
           else if(P <  39000) 1/P * (0.92 * P +  3120)
           else if(P <  56000) 1/P * (0.79 * P +  8190)
           else if(P < 113000) 1/P * (0.86 * P +  4270)
           else if(P < 339000) 1/P * (0.79 * P + 12180)
           else                1/P * (0.74 * P + 29130)
           , 1.375)
}

hosei[["H18"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3400) 1/P * (1.35 * P +    62)
           else if(P <   5600) 1/P * (0.97 * P +  1354)
           else if(P <  11300) 1/P * (1.04 * P +   962)
           else if(P <  22600) 1/P * (1.02 * P +  1188)
           else if(P <  39000) 1/P * (0.90 * P +  3900)
           else if(P <  56000) 1/P * (0.78 * P +  8580)
           else if(P < 113000) 1/P * (0.85 * P +  4660)
           else if(P < 339000) 1/P * (0.79 * P + 11440)
           else                1/P * (0.74 * P + 28390)
           , 1.406)
}

hosei[["H19"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3500) 1/P * (1.24 * P +   147)
           else if(P <   5700) 1/P * (1.13 * P +   532)
           else if(P <  11600) 1/P * (1.01 * P +  1216)
           else if(P <  23200) 1/P * (1.03 * P +   984)
           else if(P <  40000) 1/P * (0.90 * P +  4000)
           else if(P <  57000) 1/P * (0.80 * P +  8000)
           else if(P < 116000) 1/P * (0.84 * P +  5720)
           else if(P < 348000) 1/P * (0.79 * P + 11520)
           else                1/P * (0.74 * P + 28920)
           , 1.374)
}

hosei[["H20"]]$registration.pop.koseki <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3500) 1/P * (1.25 * P +   156)
           else if(P <   5700) 1/P * (1.11 * P +   646)
           else if(P <  11600) 1/P * (1.01 * P +  1216)
           else if(P <  23200) 1/P * (1.03 * P +   984)
           else if(P <  40000) 1/P * (0.90 * P +  4000)
           else if(P <  57000) 1/P * (0.80 * P +  8000)
           else if(P < 116000) 1/P * (0.84 * P +  5720)
           else if(P < 348000) 1/P * (0.79 * P + 11520)
           else                1/P * (0.73 * P + 32400)
           , 1.392)
}

hosei[["H13"]]$registration.density.koseki <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.13 * P +  1.0)
    else if(P < 100) 1/P * (1.11 * P +  2.0)
    else if(P < 150) 1/P * (1.06 * P +  7.0)
    else if(P < 200) 1/P * (1.02 * P + 13.0)
    else if(P < 300) 1/P * (0.95 * P + 27.0)
    else if(P < 400) 1/P * (0.88 * P + 48.0)
    else                                1
  }
}

hosei[["H14"]]$registration.density.koseki <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.13 * P +  1.0)
    else if(P < 100) 1/P * (1.11 * P +  2.0)
    else if(P < 150) 1/P * (1.07 * P +  6.0)
    else if(P < 200) 1/P * (1.01 * P + 15.0)
    else if(P < 300) 1/P * (0.96 * P + 25.0)
    else if(P < 400) 1/P * (0.87 * P + 52.0)
    else                                1
  }
}

hosei[["H15"]]$registration.density.koseki <- hosei[["H14"]]$registration.density.koseki

hosei[["H16"]]$registration.density.koseki <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.13 * P +  1.0)
    else if(P < 100) 1/P * (1.11 * P +  2.5)
    else if(P < 150) 1/P * (1.05 * P +  7.5)
    else if(P < 200) 1/P * (1.00 * P + 15.0)
    else if(P < 300) 1/P * (0.96 * P + 23.0)
    else if(P < 400) 1/P * (0.89 * P + 44.0)
    else                                1
  }
}

hosei[["H17"]]$registration.density.koseki <- hosei[["H16"]]$registration.density.koseki
hosei[["H18"]]$registration.density.koseki <- hosei[["H17"]]$registration.density.koseki

hosei[["H19"]]$registration.density.koseki <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.13 * P +  1.0)
    else if(P < 100) 1/P * (1.10 * P +  2.5)
    else if(P < 150) 1/P * (1.05 * P +  7.5)
    else if(P < 200) 1/P * (1.00 * P + 15.0)
    else if(P < 300) 1/P * (0.96 * P + 23.0)
    else if(P < 400) 1/P * (0.89 * P + 44.0)
    else                                1
  }
}

hosei[["H20"]]$registration.density.koseki <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.14 * P +  0.5)
    else if(P < 100) 1/P * (1.09 * P +  3.0)
    else if(P < 150) 1/P * (1.05 * P +  7.0)
    else if(P < 200) 1/P * (0.99 * P + 16.0)
    else if(P < 300) 1/P * (0.96 * P + 22.0)
    else if(P < 400) 1/P * (0.90 * P + 40.0)
    else                                1
  }
}

hosei[["S43"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else if(P > 24000)
    (                            24000   *  1.00
     + max(0,  -24000 + min(P,   33000)) *  0.82
     + max(0,  -33000 + min(P,   55000)) *  0.88
     + max(0,  -55000 + min(P,   88000)) *  0.87
     + max(0,  -88000 + min(P,  288000)) *  0.89
     + max(0, -288000 +     P          ) *  0.86)
  else
    (      P                             *  1.00
     + min(M <- 24000 - P,      8000)    *  0.09
     + max(0,   -8000 + min(M, 12000))   *  0.07
     + max(0,  -12000 + min(M, 16000))   *  0.06
     + max(0,  -16000 + min(M, 20000))   * -0.08
     + max(0,  -20000 + min(M, 22000))   * -0.09
     + max(0,  -22000 + min(M, 23000))   * -0.29
     + max(0,  -23000 +     M        )   * -0.10)
} / P

hosei[["S47"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else if(P > 27000)
    (                            27000   *  1.00
     + max(0,  -27000 + min(P,   50000)) *  0.79
     + max(0,  -50000 + min(P,  100000)) *  0.76
     + max(0, -100000 +     P          ) *  0.80)
  else
    (      P                             *  1.00
     + min(M <- 27000 - P,      7000)    *  0.11
     + max(0,   -7000 + min(M, 17000))   *  0.10
     + max(0,  -17000 + min(M, 22000))   *  0.04
     + max(0,  -22000 + min(M, 24000))   * -0.22
     + max(0,  -24000 +     M        )   * -0.19)
} / P

hosei[["H3"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else if(P > 31000)
    (                            31000   *  1.00
     + max(0,  -31000 + min(P,   50000)) *  0.77
     + max(0,  -50000 + min(P,  100000)) *  0.82
     + max(0, -100000 +     P          ) *  0.77)
  else
    (      P                             *  1.00
     + min(M <- 31000 - P,     11000)    *  0.14
     + max(0,  -11000 + min(M, 21000))   *  0.03
     + max(0,  -21000 + min(M, 26000))   * -0.03
     + max(0,  -26000 + min(M, 28000))   * -0.25
     + max(0,  -28000 +     M        )   * -0.11)
} / P

hosei[["H4"]]$registration.pop.setai <- function(P) {
  if     (P <   3000) 1/P * (1.20 * P +   920)
  else if(P <   5000) 1/P * (1.15 * P +  1070)
  else if(P <  10000) 1/P * (1.06 * P +  1520)
  else if(P <  20000) 1/P * (0.97 * P +  2420)
  else if(P <  33000) 1/P * (0.86 * P +  4620)
  else if(P <  50000) 1/P * (0.85 * P +  4950)
  else if(P < 100000) 1/P * (0.89 * P +  2950)
  else if(P < 300000) 1/P * (0.84 * P +  7950)
  else                1/P * (0.79 * P + 22950)
}

hosei[["H9"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else if(P <   3000) 1/P * (1.10 * P +   650)
  else if(P <   5000) 1/P * (1.28 * P +   110)
  else if(P <  10000) 1/P * (1.09 * P +  1060)
  else if(P <  20000) 1/P * (0.96 * P +  2360)
  else if(P <  33000) 1/P * (0.88 * P +  4200)
  else if(P <  50000) 1/P * (0.85 * P +  5250)
  else if(P < 100000) 1/P * (0.89 * P +  3250)
  else if(P < 300000) 1/P * (0.83 * P +  9250)
  else                1/P * (0.78 * P + 24250)
}

#reg <- nls(log(hosei[["H9"]]$registration.pop.setai(muni.points.pop * 33000/100000)) ~ log(a * muni.points.pop * 33000/100000 + b) - log(muni.points.pop * 33000/100000))  # .93 * P + 1116
#coef(reg)[2] / coef(reg)[1] * 100000/33000  # 3635

hosei[["H13"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.34 * P +  1250)
           else if(P <   5000) 1/P * (1.34 * P +  1250)
           else if(P <  10000) 1/P * (1.11 * P +  2400)
           else if(P <  20000) 1/P * (0.89 * P +  4600)
           else if(P <  35000) 1/P * (0.84 * P +  5600)
           else if(P <  50000) 1/P * (0.76 * P +  8400)
           else if(P < 100000) 1/P * (0.83 * P +  4900)
           else if(P < 300000) 1/P * (0.82 * P +  5900)
           else                1/P * (0.68 * P + 47900)
           , 2.590)
}

hosei[["H14"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.36 * P +  1100)
           else if(P <   5000) 1/P * (1.36 * P +  1100)
           else if(P <  11000) 1/P * (1.16 * P +  2100)
           else if(P <  21000) 1/P * (0.87 * P +  5290)
           else if(P <  37000) 1/P * (0.84 * P +  5920)
           else if(P <  53000) 1/P * (0.75 * P +  9250)
           else if(P < 106000) 1/P * (0.83 * P +  5010)
           else if(P < 317000) 1/P * (0.82 * P +  6070)
           else                1/P * (0.68 * P + 50450)
           , 2.460)
}

hosei[["H15"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.39 * P +   910)
           else if(P <   5000) 1/P * (1.41 * P +   850)
           else if(P <  11000) 1/P * (1.16 * P +  2100)
           else if(P <  21000) 1/P * (0.87 * P +  5290)
           else if(P <  37000) 1/P * (0.84 * P +  5920)
           else if(P <  53000) 1/P * (0.74 * P +  9620)
           else if(P < 106000) 1/P * (0.82 * P +  5380)
           else if(P < 317000) 1/P * (0.82 * P +  5380)
           else                1/P * (0.67 * P + 52930)
           , 2.300)
}

hosei[["H16"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.40 * P +   760)
           else if(P <   5000) 1/P * (1.44 * P +   640)
           else if(P <  11000) 1/P * (1.17 * P +  1990)
           else if(P <  21000) 1/P * (0.87 * P +  5290)
           else if(P <  37000) 1/P * (0.84 * P +  5920)
           else if(P <  53000) 1/P * (0.72 * P + 10360)
           else if(P < 106000) 1/P * (0.82 * P +  5060)
           else if(P < 317000) 1/P * (0.81 * P +  6120)
           else                1/P * (0.67 * P + 50500)
           , 2.160)
}

hosei[["H17"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.39 * P +   750)
           else if(P <   5000) 1/P * (1.43 * P +   630)
           else if(P <  11000) 1/P * (1.16 * P +  1980)
           else if(P <  21000) 1/P * (0.85 * P +  5390)
           else if(P <  37000) 1/P * (0.86 * P +  5180)
           else if(P <  53000) 1/P * (0.71 * P + 10730)
           else if(P < 106000) 1/P * (0.82 * P +  4900)
           else if(P < 317000) 1/P * (0.81 * P +  5960)
           else                1/P * (0.67 * P + 50340)
           , 2.140)
}

hosei[["H18"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.37 * P +   730)
           else if(P <   5000) 1/P * (1.40 * P +   640)
           else if(P <  11000) 1/P * (1.15 * P +  1890)
           else if(P <  21000) 1/P * (0.87 * P +  4970)
           else if(P <  37000) 1/P * (0.86 * P +  5180)
           else if(P <  53000) 1/P * (0.72 * P + 10360)
           else if(P < 106000) 1/P * (0.82 * P +  5060)
           else if(P < 317000) 1/P * (0.82 * P +  5060)
           else                1/P * (0.68 * P + 49440)
           , 2.100)
}

hosei[["H19"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.44 * P +   720)
           else if(P <   5000) 1/P * (1.24 * P +  1320)
           else if(P <  12000) 1/P * (1.09 * P +  2070)
           else if(P <  22000) 1/P * (0.94 * P +  3870)
           else if(P <  39000) 1/P * (0.85 * P +  5850)
           else if(P <  56000) 1/P * (0.71 * P + 11310)
           else if(P < 112000) 1/P * (0.82 * P +  5150)
           else if(P < 334000) 1/P * (0.81 * P +  6270)
           else                1/P * (0.70 * P + 43010)
           , 2.160)
}

hosei[["H20"]]$registration.pop.setai <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <   3000) 1/P * (1.38 * P +   600)
           else if(P <   5000) 1/P * (1.16 * P +  1260)
           else if(P <  12000) 1/P * (1.06 * P +  1760)
           else if(P <  22000) 1/P * (0.99 * P +  2600)
           else if(P <  39000) 1/P * (0.86 * P +  5460)
           else if(P <  56000) 1/P * (0.72 * P + 10920)
           else if(P < 112000) 1/P * (0.82 * P +  5320)
           else if(P < 334000) 1/P * (0.81 * P +  6440)
           else                1/P * (0.71 * P + 39840)
           , 1.980)
}

hosei[["S47"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else if (P > 400) 1 
  else (P                              *  1.00
        + min(M <-  400 - P,     100)  *  0.18
        + max(0,   -100 + min(M, 200)) * -0.01
        + max(0,   -200 + min(M, 250)) * -0.03
        + max(0,   -250 + min(M, 300)) *  0.06
        + max(0,   -300 + min(M, 350)) * -0.02
        + max(0,   -350 +     M      ) * -0.18
        ) / P
}

hosei[["H3"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else if (P > 400) 1 
  else (P                              *  1.00
        + min(M <-  400 - P,     100)  *  0.13
        + max(0,   -100 + min(M, 200)) *  0.05
        + max(0,   -200 + min(M, 250)) * -0.03
        + max(0,   -250 + min(M, 300)) * -0.02
        + max(0,   -300 + min(M, 350)) *  0.02
        + max(0,   -350 +     M      ) * -0.19
        ) / P
}

hosei[["H4"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.15 * P +  6.5)
    else if(P < 100) 1/P * (0.98 * P + 15.0)
    else if(P < 150) 1/P * (1.07 * P +  6.0)
    else if(P < 200) 1/P * (1.03 * P + 12.0)
    else if(P < 300) 1/P * (0.95 * P + 28.0)
    else if(P < 400) 1/P * (0.87 * P + 52.0)
    else                                1
  }
}

hosei[["H9"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.08 * P +  4.5)
    else if(P < 100) 1/P * (1.09 * P +  4.0)
    else if(P < 150) 1/P * (1.07 * P +  6.0)
    else if(P < 200) 1/P * (1.01 * P + 15.0)
    else if(P < 300) 1/P * (0.96 * P + 25.0)
    else if(P < 400) 1/P * (0.87 * P + 52.0)
    else                                1
  }
}

hosei[["H13"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.14 * P +  0.5)
    else if(P < 100) 1/P * (1.11 * P +  2.0)
    else if(P < 150) 1/P * (1.06 * P +  7.0)
    else if(P < 200) 1/P * (1.02 * P + 13.0)
    else if(P < 300) 1/P * (0.96 * P + 25.0)
    else if(P < 400) 1/P * (0.87 * P + 52.0)
    else                                1
  }
}

hosei[["H14"]]$registration.density.setai <- hosei[["H13"]]$registration.density.setai
hosei[["H15"]]$registration.density.setai <- hosei[["H14"]]$registration.density.setai
hosei[["H16"]]$registration.density.setai <- hosei[["H15"]]$registration.density.setai
hosei[["H17"]]$registration.density.setai <- hosei[["H16"]]$registration.density.setai
hosei[["H18"]]$registration.density.setai <- hosei[["H17"]]$registration.density.setai
hosei[["H19"]]$registration.density.setai <- hosei[["H18"]]$registration.density.setai

hosei[["H20"]]$registration.density.setai <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.14 * P +  0.5)
    else if(P < 100) 1/P * (1.10 * P +  2.5)
    else if(P < 150) 1/P * (1.07 * P +  5.5)
    else if(P < 200) 1/P * (1.02 * P + 13.0)
    else if(P < 300) 1/P * (0.96 * P + 25.0)
    else if(P < 400) 1/P * (0.87 * P + 52.0)
    else                                1
  }
}


### Other



hosei[["S43"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  150000)) *  0.76
     + max(0,  -150000 + min(P,  250000)) *  0.58
     + max(0,  -250000 + min(P,  400000)) *  0.46
     + max(0,  -400000 +     P          ) *  0.44)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     40000)    *  0.12
     + max(0,   -40000 + min(M, 60000))   *  0.08
     + max(0,   -60000 + min(M, 80000))   * -0.04
     + max(0,   -80000 + min(M, 84000))   *  0.06
     + max(0,   -84000 + min(M, 88000))   *  0.12
     + max(0,   -88000 + min(M, 92000))   *  0.16
     + max(0,   -92000 +     M        )   * -0.37)
} / P

hosei[["S47"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.77
     + max(0,  -250000 + min(P,  400000)) *  0.64
     + max(0,  -400000 + min(P, 1000000)) *  0.49
     + max(0, -1000000 +     P          ) *  0.50)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.12
     + max(0,   -70000 + min(M, 80000))   * -0.11
     + max(0,   -80000 + min(M, 88000))   *  0.03
     + max(0,   -88000 + min(M, 96000))   * -0.16
     + max(0,   -96000 +     M        )   * -1.53)
} / P

hosei[["H3"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else if(P > 100000)
    (                            100000   *  1.00
     + max(0,  -100000 + min(P,  250000)) *  0.74
     + max(0,  -250000 + min(P, 1000000)) *  0.60
     + max(0, -1000000 +     P          ) *  0.52)
  else
    (      P                              *  1.00
     + min(M <- 100000 - P,     70000)    *  0.14
     + max(0,   -70000 + min(M, 80000))   *  0.03
     + max(0,   -80000 + min(M, 88000))   *  0.11
     + max(0,   -88000 + min(M, 96000))   * -0.27
     + max(0,   -96000 +     M        )   * -2.16)
} / P

hosei[["H4"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (3.22 * P +    180)
    else if(P <    8000)  1/P * (1.72 * P +   6180)
    else if(P <   12000)  1/P * (0.98 * P +  12100)
    else if(P <   20000)  1/P * (0.83 * P +  13900)
    else if(P <   30000)  1/P * (1.00 * P +  10500)
    else if(P <  100000)  1/P * (0.85 * P +  15000)
    else if(P <  250000)  1/P * (0.72 * P +  28000)
    else if(P <  400000)  1/P * (0.66 * P +  43000)
    else if(P < 1000000)  1/P * (0.59 * P +  71000)
    else                  1/P * (0.52 * P + 141000)
  }
}

hosei[["H9"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else if(P <    4000)  1/P * (3.04 * P +    200)
  else if(P <    8000)  1/P * (1.68 * P +   5640)
  else if(P <   12000)  1/P * (0.94 * P +  11560)
  else if(P <   20000)  1/P * (0.82 * P +  13000)
  else if(P <   30000)  1/P * (0.97 * P +  10000)
  else if(P <  100000)  1/P * (0.87 * P +  13000)
  else if(P <  250000)  1/P * (0.72 * P +  28000)
  else if(P <  400000)  1/P * (0.67 * P +  40500)
  else if(P < 1000000)  1/P * (0.58 * P +  76500)
  else                  1/P * (0.53 * P + 126500)
}

#reg <- nls(log(hosei[["H9"]]$other.pop(muni.points.pop)) ~ log(a * muni.points.pop + b) - log(muni.points.pop))  # .73 * P + 12490
#coef(reg)[2] / coef(reg)[1]  # 17106

hosei[["H13"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.52 * P +   1760)
    else if(P <    8000)  1/P * (1.61 * P +   5400)
    else if(P <   12000)  1/P * (0.93 * P +  10840)
    else if(P <   20000)  1/P * (0.85 * P +  11800)
    else if(P <   30000)  1/P * (0.96 * P +   9600)
    else if(P <  100000)  1/P * (0.88 * P +  12000)
    else if(P <  250000)  1/P * (0.77 * P +  23000)
    else if(P <  400000)  1/P * (0.69 * P +  43000)
    else if(P < 1000000)  1/P * (0.61 * P +  75000)
    else                  1/P * (0.56 * P + 125000)
  }
}

hosei[["H14"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.46 * P +   1700)
    else if(P <    8000)  1/P * (1.56 * P +   5300)
    else if(P <   12000)  1/P * (0.89 * P +  10600)
    else if(P <   20000)  1/P * (0.82 * P +  11500)
    else if(P <   30000)  1/P * (0.91 * P +   9700)
    else if(P <  100000)  1/P * (0.90 * P +  10000)
    else if(P <  250000)  1/P * (0.75 * P +  25000)
    else if(P <  400000)  1/P * (0.68 * P +  42500)
    else if(P < 1000000)  1/P * (0.61 * P +  70500)
    else                  1/P * (0.55 * P + 130500)
  }
}

hosei[["H15"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.39 * P +   1660)
    else if(P <    8000)  1/P * (1.51 * P +   5180)
    else if(P <   12000)  1/P * (0.86 * P +  10380)
    else if(P <   20000)  1/P * (0.80 * P +  11100)
    else if(P <   30000)  1/P * (0.92 * P +   8700)
    else if(P <  100000)  1/P * (0.91 * P +   9000)
    else if(P <  250000)  1/P * (0.74 * P +  26000)
    else if(P <  400000)  1/P * (0.68 * P +  41000)
    else if(P < 1000000)  1/P * (0.60 * P +  73000)
    else                  1/P * (0.55 * P + 123000)
  }
}

hosei[["H16"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.33 * P +   1660)
    else if(P <    8000)  1/P * (1.45 * P +   5120)
    else if(P <   12000)  1/P * (0.81 * P +  10240)
    else if(P <   20000)  1/P * (0.78 * P +  10600)
    else if(P <   30000)  1/P * (0.94 * P +   7400)
    else if(P <  100000)  1/P * (0.92 * P +   8000)
    else if(P <  250000)  1/P * (0.73 * P +  27000)
    else if(P <  400000)  1/P * (0.66 * P +  44500)
    else if(P < 1000000)  1/P * (0.59 * P +  72500)
    else                  1/P * (0.55 * P + 112500)
  }
}

hosei[["H17"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.31 * P +   1600)
    else if(P <    8000)  1/P * (1.45 * P +   5040)
    else if(P <   12000)  1/P * (0.83 * P +  10000)
    else if(P <   20000)  1/P * (0.78 * P +  10600)
    else if(P <   30000)  1/P * (0.87 * P +   8800)
    else if(P <  100000)  1/P * (0.93 * P +   7000)
    else if(P <  250000)  1/P * (0.73 * P +  27000)
    else if(P <  400000)  1/P * (0.66 * P +  44500)
    else if(P < 1000000)  1/P * (0.59 * P +  72500)
    else                  1/P * (0.55 * P + 112500)
  }
}

hosei[["H18"]]$other.pop <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.34 * P +   1620)
    else if(P <    8000)  1/P * (1.47 * P +   5100)
    else if(P <   12000)  1/P * (0.83 * P +  10220)
    else if(P <   20000)  1/P * (0.79 * P +  10700)
    else if(P <   30000)  1/P * (0.77 * P +  11100)
    else if(P <  100000)  1/P * (0.94 * P +   6000)
    else if(P <  250000)  1/P * (0.73 * P +  27000)
    else if(P <  400000)  1/P * (0.67 * P +  42000)
    else if(P < 1000000)  1/P * (0.60 * P +  70000)
    else                  1/P * (0.55 * P + 120000)
  }
}

hosei[["H19"]]$other.pop <- function(P) {  #technically now "development"
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.07 * P +   2700)
    else if(P <    8000)  1/P * (1.47 * P +   5100)
    else if(P <   12000)  1/P * (0.83 * P +  10220)
    else if(P <   20000)  1/P * (0.79 * P +  10700)
    else if(P <   30000)  1/P * (0.77 * P +  11100)
    else if(P <  100000)  1/P * (0.94 * P +   6000)
    else if(P <  250000)  1/P * (0.73 * P +  27000)
    else if(P <  400000)  1/P * (0.78 * P +  14500)
    else if(P < 1000000)  1/P * (0.57 * P +  98500)
    else                  1/P * (0.55 * P + 118500)
  }
}

hosei[["H20"]]$other.pop <- function(P) {  #technically now "development"
  if(is.na(P)) NA
  else {
    if     (P <    4000)  1/P * (2.07 * P +   2720)
    else if(P <    8000)  1/P * (1.48 * P +   5080)
    else if(P <   12000)  1/P * (0.82 * P +  10360)
    else if(P <   20000)  1/P * (0.80 * P +  10600)
    else if(P <   30000)  1/P * (0.76 * P +  11400)
    else if(P <  100000)  1/P * (0.94 * P +   6000)
    else if(P <  250000)  1/P * (0.73 * P +  27000)
    else if(P <  400000)  1/P * (0.78 * P +  14500)
    else if(P < 1000000)  1/P * (0.57 * P +  98500)
    else                  1/P * (0.55 * P + 118500)
  }
}

hosei[["S43"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.01
        + max(0,    -50 + min(M, 100)) *  0.06
        + max(0,   -100 + min(M, 150)) *  0.02
        + max(0,   -150 +     M      ) * -0.01
        ) / P
}

hosei[["S47"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.01
        + max(0,    -50 + min(M, 100)) *  0.06
        + max(0,   -100 + min(M, 150)) *  0.03
        + max(0,   -150 +     M      ) * -0.01
        ) / P
}

hosei[["H3"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else if (P > 200) 1 
  else (P                              *  1.00
        + min(M <-  200 - P,      50)  *  0.03
        + max(0,    -50 + min(M, 100)) *  0.09
        + max(0,   -100 + min(M, 150)) *  0.00
        + max(0,   -150 +     M      ) * -0.02
        ) / P
}

hosei[["H4"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.02 * P +  5.5)
    else if(P < 100) 1/P * (0.99 * P +  7.0)
    else if(P < 150) 1/P * (0.90 * P + 16.0)
    else if(P < 200) 1/P * (0.98 * P +  4.0)
    else                                1
  }
}

hosei[["H9"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.02 * P +  5.0)
    else if(P < 100) 1/P * (0.98 * P +  7.0)
    else if(P < 150) 1/P * (0.90 * P + 15.0)
    else if(P < 200) 1/P * (1.00 * P +  0.0)
    else                                1
  }
}

hosei[["H13"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.03 * P +  4.5)
    else if(P < 100) 1/P * (0.98 * P +  7.0)
    else if(P < 150) 1/P * (0.93 * P + 12.0)
    else if(P < 200) 1/P * (0.97 * P +  6.0)
    else                                1
  }
}

hosei[["H14"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.03 * P +  4.5)
    else if(P < 100) 1/P * (0.98 * P +  7.0)
    else if(P < 150) 1/P * (0.92 * P + 13.0)
    else if(P < 200) 1/P * (0.98 * P +  4.0)
    else                                1
  }
}

hosei[["H15"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.02 * P +  4.5)
    else if(P < 100) 1/P * (0.97 * P +  7.0)
    else if(P < 150) 1/P * (0.94 * P + 10.0)
    else if(P < 200) 1/P * (0.98 * P +  4.0)
    else                                1
  }
}

hosei[["H16"]]$other.density <- function(P) {
  if(is.na(P)) NA
  else {
    if     (P <  50) 1/P * (1.02 * P +  4.5)
    else if(P < 100) 1/P * (0.97 * P +  7.0)
    else if(P < 150) 1/P * (0.92 * P + 12.0)
    else if(P < 200) 1/P * (1.00 * P +  0.0)
    else                                1
  }
}

hosei[["H17"]]$other.density <- hosei[["H16"]]$other.density
hosei[["H18"]]$other.density <- hosei[["H17"]]$other.density
hosei[["H19"]]$other.density <- function(P) if(is.na(P)) NA else 1
hosei[["H20"]]$other.density <- function(P) if(is.na(P)) NA else 1

hosei[["S43"]]$other.investment.adj <- function(A) if(is.na(A)) NA else 1 #FIXME: there does seem to be investment going on here...
  
hosei[["S47"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else if (A < 100000) 100000/A *  93.6 / 520 + 634 / 520
  else                 100000/A * 572   / 520 + 156 / 520
}

hosei[["H3"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A <   5000) 100000/A * 0.180 + 1.816
    else if(A <  10000) 100000/A * 0.189 + 1.629
    else if(A <  50000) 100000/A * 0.208 + 1.442
    else if(A < 100000) 100000/A * 0.263 + 1.331
    else if(A < 300000) 100000/A * 1.238 + 0.356
    else if(A < 500000) 100000/A * 1.231 + 0.412
    else                100000/A * 1.231 + 0.487
  }
}

hosei[["H4"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A <   5000) 100000/A * 0.226 + 2.330
    else if(A <  10000) 100000/A * 0.238 + 2.090
    else if(A <  50000) 100000/A * 0.262 + 1.850
    else if(A < 100000) 100000/A * 0.330 + 1.713
    else if(A < 300000) 100000/A * 1.554 + 0.489
    else if(A < 500000) 100000/A * 1.546 + 0.582
    else                100000/A * 1.546 + 0.694
  }
}

hosei[["H9"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A <   5000) 100000/A * 0.227 + 2.367
    else if(A <  10000) 100000/A * 0.240 + 2.107
    else if(A <  50000) 100000/A * 0.264 + 1.867
    else if(A < 100000) 100000/A * 0.332 + 1.731
    else if(A < 300000) 100000/A * 1.569 + 0.494
    else if(A < 500000) 100000/A * 1.133 + 0.729
    else                100000/A * 0.990 + 0.758
  }
}

### "broken":  discontinuous in original
# (0.667 - 0.772) * 3 + 1.405 = 1.09
#
hosei[["H13"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A < 100000) 100000/A * 0.199 + 1.873
    else if(A < 300000) 100000/A * 1.405 + 0.667
    else if(A < 500000) 100000/A * 1.09 + 0.772
#    else if(A < 500000) 100000/A * 1.382 + 0.772
#    else                100000/A * 1.581 + 0.750
    else                100000/A * 1.2 + 0.750
  }
}

hosei[["H14"]]$other.investment.adj <- hosei[["H13"]]$other.investment.adj

hosei[["H15"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A < 100000) 100000/A * 0.200 + 1.820
    else if(A < 300000) 100000/A * 1.327 + 0.693
    else if(A < 500000) 100000/A * 1.327 + 0.783
    else                100000/A * 1.327 + 0.801
  }
}

hosei[["H16"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A < 100000) 100000/A * 0.200 + 1.766
    else if(A < 300000) 100000/A * 1.327 + 0.638
    else if(A < 500000) 100000/A * 1.327 + 0.740
    else                100000/A * 1.327 + 0.746
  }
}

hosei[["H17"]]$other.investment.adj <- function(A) hosei[["H16"]]$other.investment.adj(A) * 0.9674 + 0.0326

hosei[["H18"]]$other.investment.adj <- function(A) {
  if(is.na(A)) NA
  else {
    if     (A < 100000) 100000/A * 0.168 + 1.489
    else if(A < 300000) 100000/A * 1.119 + 0.538
    else if(A < 500000) 100000/A * 1.064 + 0.593
    else                100000/A * 1.061 + 0.596
  } * 0.8967 + 0.1033
}

hosei[["H19"]]$other.investment.adj <- function(A) if(is.na(A)) NA else 0
hosei[["H20"]]$other.investment.adj <- function(A) if(is.na(A)) NA else 0

### Urban renewal (?)


hosei[["H13"]]$revival.pop <- function(P) if(is.na(P)) NA else 0
hosei[["H19"]]$revival.pop <- hosei[["H18"]]$revival.pop <- hosei[["H17"]]$revival.pop <- hosei[["H16"]]$revival.pop <- hosei[["H15"]]$revival.pop <- hosei[["H14"]]$revival.pop <- hosei[["H13"]]$revival.pop

hosei[["H20"]]$revival.pop <- function(P) {
  if(is.na(P)) NA 
  else min(
           if     (P <   12000)  1/P * (0.54 * P +  11660)
           else if(P <   20000)  1/P * (0.87 * P +   7700)
           else if(P <   30000)  1/P * (0.91 * P +   6900)
           else if(P <  100000)  1/P * (0.94 * P +   6000)
           else if(P <  250000)  1/P * (0.84 * P +  16000)
           else if(P < 1000000)  1/P * (0.27 * P + 158500)
           else                  1/P * (0.07 * P + 358500)
           , 15.000)
}

hosei[["H13"]]$revival.type <- function(employees.primary, over65, pop) if(is.na(employees.primary) || is.na(over65) || is.na(pop)) NA else 0
hosei[["H19"]]$revival.type <- hosei[["H18"]]$revival.type <- hosei[["H17"]]$revival.type <- hosei[["H16"]]$revival.type <- hosei[["H15"]]$revival.type <- hosei[["H14"]]$revival.type <- hosei[["H13"]]$revival.type

hosei[["H20"]]$revival.type <- function(employees.primary, over65, pop) {
  A <- employees.primary / pop - 0.023
  B <- over65 / pop - 0.201
  return(min(A * 0.40 + B * 0.40 + 0.20, 2.00))
}


### New style

 
hosei[["H13"]]$general.pop <- function(P) if(is.na(P)) NA else 0
hosei[["H18"]]$general.pop <- hosei[["H17"]]$general.pop <- hosei[["H16"]]$general.pop <- hosei[["H15"]]$general.pop <- hosei[["H14"]]$general.pop <- hosei[["H13"]]$general.pop

hosei[["H19"]]$general.pop <- function(P) {
  if(is.na(P)) NA
  else min(
           if     (P <     500)  1/P * (3.41 * P +   2550)
           else if(P <    2000)  1/P * (2.83 * P +   2840)
           else if(P <    4000)  1/P * (2.35 * P +   3800)
           else if(P <    8000)  1/P * (0.94 * P +   9440)
           else if(P <   12000)  1/P * (0.86 * P +  10080)
           else if(P <   20000)  1/P * (0.85 * P +  10200)
           else if(P <   30000)  1/P * (0.91 * P +   9000)
           else if(P <  100000)  1/P * (0.91 * P +   9000)
           else if(P <  250000)  1/P * (0.75 * P +  25000)
           else if(P <  400000)  1/P * (0.66 * P +  47500)
           else if(P < 1000000)  1/P * (0.66 * P +  47500)
           else                  1/P * (0.63 * P +  77500)
           , 15.000)
}

hosei[["H20"]]$general.pop <- hosei[["H19"]]$general.pop


## note:  the above is not complete for years before H13 (not sure about H9)
stopifnot(names(hosei[["H14"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H15"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H16"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H17"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H18"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H19"]]) == names(hosei[["H13"]]))
stopifnot(names(hosei[["H20"]]) == names(hosei[["H13"]]))
